/**
  ******************************************************************************
  * @file    fm33g0xx_aes.h
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file contains all the functions prototypes for the AES firmware library.  
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __FM33G0XX_AES_H
#define __FM33G0XX_AES_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "FM33G0XX.h"
	 
/** @addtogroup FM33G0xx_StdPeriph_Driver
  * @{
  */
typedef struct
{
	uint32_t	KEYLEN;			//AESԿȣAESEN=1ʱ޸
	uint32_t	CHMOD;			//AESģʽAESEN=1ʱ޸
	uint32_t	MODE;			//AESģʽAESEN=1ʱ޸
	uint32_t	DATATYP;		//ѡͣAESEN=1ʱ޸ġ彻ɲοAES½	
	FunState	DMAOEN;			//DMAԶʹ
	FunState	DMAIEN;			//DMAԶдʹ
	FunState	ERRIE;			//־RDERRWRERRжʹ
	FunState	CCFIE;			//CCF־жʹ
	FunState	AESEN;			//AESʹ 
	
}AES_InitTypeDef;
	 
	 



#define	AES_AESCR_KEYLEN_Pos	13	/* AESԿȣAESEN=1ʱ޸ */
#define	AES_AESCR_KEYLEN_Msk	(0x3U << AES_AESCR_KEYLEN_Pos)
#define	AES_AESCR_KEYLEN_128BIT	(0x0U << AES_AESCR_KEYLEN_Pos)	/* 00128bit */
#define	AES_AESCR_KEYLEN_192BIT	(0x1U << AES_AESCR_KEYLEN_Pos)	/* 01192bit */
#define	AES_AESCR_KEYLEN_256BIT	(0x2U << AES_AESCR_KEYLEN_Pos)	/* 10256bit */

#define	AES_AESCR_DMAOEN_Pos	12	/* DMAԶʹ */
#define	AES_AESCR_DMAOEN_Msk	(0x1U << AES_AESCR_DMAOEN_Pos)
	/* 0 */
	/* 1 */

#define	AES_AESCR_DMAIEN_Pos	11	/* DMAԶдʹ */
#define	AES_AESCR_DMAIEN_Msk	(0x1U << AES_AESCR_DMAIEN_Pos)
	/* 0 */
	/* 1 */

#define	AES_AESCR_ERRIE_Pos	10	/* ־RDERRWRERRжʹ */
#define	AES_AESCR_ERRIE_Msk	(0x1U << AES_AESCR_ERRIE_Pos)
	/* 0ʹ */
	/* 1ʹ */

#define	AES_AESCR_CCFIE_Pos	9	/* CCF־жʹ */
#define	AES_AESCR_CCFIE_Msk	(0x1U << AES_AESCR_CCFIE_Pos)
	/* 0ʹ */
	/* 1ʹ */

#define	AES_AESCR_ERRC_Pos	8	/* ־д1WRERRRDERR־ */
#define	AES_AESCR_ERRC_Msk	(0x1U << AES_AESCR_ERRC_Pos)

#define	AES_AESCR_CCFC_Pos	7	/* CCF־д1CCF־
 */
#define	AES_AESCR_CCFC_Msk	(0x1U << AES_AESCR_CCFC_Pos)

#define	AES_AESCR_CHMOD_Pos	5	/* AESģʽAESEN=1ʱ޸ */
#define	AES_AESCR_CHMOD_Msk	(0x3U << AES_AESCR_CHMOD_Pos)
#define	AES_AESCR_CHMOD_ECB	(0x0U << AES_AESCR_CHMOD_Pos)	/* 00ECB */
#define	AES_AESCR_CHMOD_CBC	(0x1U << AES_AESCR_CHMOD_Pos)	/* 01CBC */
#define	AES_AESCR_CHMOD_CTR	(0x2U << AES_AESCR_CHMOD_Pos)	/* 10CTR */
#define	AES_AESCR_CHMOD_MULTH	(0x3U << AES_AESCR_CHMOD_Pos)	/* 11ʹMultHģ */

#define	AES_AESCR_MODE_Pos	3	/* AESģʽAESEN=1ʱ޸ */
#define	AES_AESCR_MODE_Msk	(0x3U << AES_AESCR_MODE_Pos)
#define	AES_AESCR_MODE_ENCRYPT	(0x0U << AES_AESCR_MODE_Pos)	/* 00ģʽ1 */
#define	AES_AESCR_MODE_KEYEXP	(0x1U << AES_AESCR_MODE_Pos)	/* 01ģʽ2Կչ */
#define	AES_AESCR_MODE_DECRYPT	(0x2U << AES_AESCR_MODE_Pos)	/* 10ģʽ3 */
#define	AES_AESCR_MODE_KEYEXPDECRYPT	(0x3U << AES_AESCR_MODE_Pos)	/* 11ģʽ4Կչ+ */

#define	AES_AESCR_DATATYP_Pos	1	/* ѡͣAESEN=1ʱ޸ */
#define	AES_AESCR_DATATYP_Msk	(0x3U << AES_AESCR_DATATYP_Pos)
#define	AES_AESCR_DATATYP_32BITNOEX	(0x0U << AES_AESCR_DATATYP_Pos)	/* 0032bitݲ */
#define	AES_AESCR_DATATYP_16BITEX	(0x1U << AES_AESCR_DATATYP_Pos)	/* 0116bitݰֽ */
#define	AES_AESCR_DATATYP_8BITEX	(0x2U << AES_AESCR_DATATYP_Pos)	/* 108bitֽڽ */
#define	AES_AESCR_DATATYP_1BITEX	(0x3U << AES_AESCR_DATATYP_Pos)	/* 111bitݱؽ */

#define	AES_AESCR_AESEN_Pos	0	/* AESʹ,κʱAESENλܹλAESģ */
#define	AES_AESCR_AESEN_Msk	(0x1U << AES_AESCR_AESEN_Pos)
	/* 0ʹ */
	/* 1ʹ */

#define	AES_AESIF_WRERR_Pos	2	/* д־ڼ׶ηдʱλERRCĴд1 */
#define	AES_AESIF_WRERR_Msk	(0x1U << AES_AESIF_WRERR_Pos)

#define	AES_AESIF_RDERR_Pos	1	/* ־ڼ׶ηʱλERRCĴд1 */
#define	AES_AESIF_RDERR_Msk	(0x1U << AES_AESIF_RDERR_Pos)

#define	AES_AESIF_CCF_Pos	0	/* AESɱ־ͨCCFC1жϱ־ */
#define	AES_AESIF_CCF_Msk	(0x1U << AES_AESIF_CCF_Pos)

#define	AES_AESDIN_AESDIN_Pos	0	/* ĴAESҪӽʱӦüĴд4 */
#define	AES_AESDIN_AESDIN_Msk	(0xffffffffU << AES_AESDIN_AESDIN_Pos)

#define	AES_AESDOUT_AESDOUT_Pos	0	/* ĴAESɺ󣬿ԷĴζӽܵĽ */
#define	AES_AESDOUT_AESDOUT_Msk	(0xffffffffU << AES_AESDOUT_AESDOUT_Pos)


//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void AES_Deinit(void);

/* AESԿȣAESEN=1ʱ޸ غ */
extern void AES_AESCR_KEYLEN_Set(uint32_t SetValue);
extern uint32_t AES_AESCR_KEYLEN_Get(void);

/* DMAԶʹ غ */
extern void AES_AESCR_DMAOEN_Setable(FunState NewState);
extern FunState AES_AESCR_DMAOEN_Getable(void);

/* DMAԶдʹ غ */
extern void AES_AESCR_DMAIEN_Setable(FunState NewState);
extern FunState AES_AESCR_DMAIEN_Getable(void);

/* ־RDERRWRERRжʹ غ */
extern void AES_AESCR_ERRIE_Setable(FunState NewState);
extern FunState AES_AESCR_ERRIE_Getable(void);

/* CCF־жʹ غ */
extern void AES_AESCR_CCFIE_Setable(FunState NewState);
extern FunState AES_AESCR_CCFIE_Getable(void);

/* ־д1WRERRRDERR־ غ */
extern void AES_AESCR_ERRC_Clr(void);

/* CCF־д1CCF־
 غ */
extern void AES_AESCR_CCFC_Clr(void);

/* AESģʽAESEN=1ʱ޸ غ */
extern void AES_AESCR_CHMOD_Set(uint32_t SetValue);
extern uint32_t AES_AESCR_CHMOD_Get(void);

/* AESģʽAESEN=1ʱ޸ غ */
extern void AES_AESCR_MODE_Set(uint32_t SetValue);
extern uint32_t AES_AESCR_MODE_Get(void);

/* ѡͣAESEN=1ʱ޸ غ */
extern void AES_AESCR_DATATYP_Set(uint32_t SetValue);
extern uint32_t AES_AESCR_DATATYP_Get(void);

/* AESʹ,κʱAESENλܹλAESģ غ */
extern void AES_AESCR_AESEN_Setable(FunState NewState);
extern FunState AES_AESCR_AESEN_Getable(void);

/* д־ڼ׶ηдʱλERRCĴд1 غ */
extern FlagStatus AES_AESIF_WRERR_Chk(void);

/* ־ڼ׶ηʱλERRCĴд1 غ */
extern FlagStatus AES_AESIF_RDERR_Chk(void);

/* AESɱ־ͨCCFC1жϱ־ غ */
extern FlagStatus AES_AESIF_CCF_Chk(void);

/* ĴAESҪӽʱӦüĴд4 غ */
extern void AES_AESDIN_Write(uint32_t SetValue);
extern uint32_t AES_AESDIN_Read(void);

/* ĴAESɺ󣬿ԷĴζӽܵĽ غ */
extern void AES_AESDOUT_Write(uint32_t SetValue);
extern uint32_t AES_AESDOUT_Read(void);
//Announce_End

/*ӽԿ룬key0Կ32bit */
extern void AES_AESKEY_WriteEx(uint8_t *KeyIn, uint8_t Len);

/*ӽԿһִԿ32bit  */
extern void AES_AESKEY_ReadEx(uint8_t *KeyOut, uint8_t Len);

/*ʼ */
extern void AES_AESIVR_WriteEx(uint8_t *IVRIn);

/*ʼȡ */
extern void AES_AESIVR_ReadEx(uint8_t *IVROut);

/*ӽ룬16ֽڣ128bit  */
extern void AES_AESDIN_GroupWrite_128BIT(uint8_t *DataIn);
   						
/*ӽ16ֽڣ128bit  */
extern void AES_AESDOUT_GroupRead_128BIT(uint8_t *DataOut);

extern uint8_t AES_GroupWriteAndRead_128BIT(uint8_t *DataIn, uint8_t *DataOut);

/* AESģʼ */
extern void AES_Init(AES_InitTypeDef* para);

#ifdef __cplusplus
}
#endif

#endif



/************************ (C) COPYRIGHT FMSHelectronics *****END OF FILE****/



