/**
  ******************************************************************************
  * @file    fm33g0xx_anac.h
  * @author  FM33g0xx Application Team
  * @version V0.3.02G
  * @date    01-21-2019
  * @brief   This file contains all the functions prototypes for the ANAC firmware library.  
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __FM33G0XX_ANAC_H
#define __FM33G0XX_ANAC_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "FM33G0XX.h"
	 
/** @addtogroup FM33G0xx_StdPeriph_Driver
  * @{
  */

/** @addtogroup ANAC
  * @{
  */ 

	 
/* Exported constants --------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
typedef struct
{
	uint32_t	SVDMOD;		/*!<SVDģʽѡ  */
	uint32_t	SVDITVL;	/*!<SVDЪʹܼ  */
	uint32_t	SVDLVL;		/*!<SVDֵ  */
	FunState	DFEN;		/*!<SVD˲SVDMODE=1ʱ1  */
	FunState	PFIE;		/*!<SVDԴж  */
	FunState	PRIE;		/*!<SVDԴָж  */
	FunState	SVDEN;		/*!<SVDʹ  */
	
}ANAC_SVD_InitTypeDef;


typedef struct
{
	uint32_t	ADC_TRIM;	/*!<ЧοѹУĴ,תѹʱΪ0x3FF,ת¶ʱΪ0x6400x4FB(Զ²)  */
	uint32_t	ADC_VANA_EN;/*!<ڲͨⲿͨѡ  */
	uint32_t	BUFSEL;		/*!<ADCͨѡ  */
	FunState	BUFEN;		/*!<  */
	FunState	BUFBYP;		/*!<ADCBuffer BypassʹADCⲿźʱرbypass ʹADCڲźʱ뽫λ1bypass */
	FunState	ADC_IE;		/*!<ADCжʹ  */
	FunState	ADC_EN;		/*!<ADCʹ  */
	
}ANAC_ADC_InitTypeDef;


typedef struct
{
	uint32_t	COMPx;		/*!<Ƚ1/2ѡ12  */
	uint32_t	VxPSEL;		/*!<Ƚxѡ */
	uint32_t	VxNSEL;		/*!<Ƚxѡ */
	uint32_t	CMPxSEL;	/*!<ȽxжԴѡ */
	FunState	CMPxIE;		/*!<xжʹ */
	FunState	CMPxDF;		/*!<Ƚx˲ʹ */
//	FunState	BUFBYP;		Ƚ12һbufferbufferⲿýṹ
//	FunState	BUFENB;
	FunState	CMPxEN;		/*!<Ƚxʹ */
	
}ANAC_COMPx_InitTypeDef;

/* Exported macro ------------------------------------------------------------*/
//0x811800ʼᱣϢ
#define const_temp_TestA 	(*((uint8_t *)(0x1FFFFC90)))	//ʱ¶λ
#define const_temp_TestB 	(*((uint8_t *)(0x1FFFFC91)))	//ʱ¶Сλ
#define const_adc_Test	 	(*((uint16_t *)(0x1FFFFC92)))	//ʱPTAT ADCֵ
#define const_adc_Slope 	(*((uint16_t *)(0x1FFFFC54)))	//ADCбʣ1000ʹãλԼ2.2mV/lsb
#define const_adc_Offset 	(*((int16_t *)(0x1FFFFC56)))	//ADCؾ࣬100ʹãλmV
#define const_adc_Slope_3FF 	(*((uint16_t *)(0x1FFFFC54)))	//ADCбʣ1000ʹãλԼ2.2mV/lsb
#define const_adc_Offset_3FF 	(*((int16_t *)(0x1FFFFC56)))	//ADCؾ࣬100ʹãλmV
#define const_adc_Slope_1FF 	(*((uint16_t *)(0x1FFFFD50)))	//ADCбʣ1000ʹãλԼ4.4mV/lsb
#define const_adc_Offset_1FF 	(*((int16_t *)(0x1FFFFD52)))	//ADCؾ࣬100ʹãλmV
#define const_adc_Slope_0FF 	(*((uint16_t *)(0x1FFFFD58)))	//ADCбʣ1000ʹãλԼ8.8mV/lsb
#define const_adc_Offset_0FF 	(*((int16_t *)(0x1FFFFD5A)))	//ADCؾ࣬100ʹãλmV
#define const_ptat_Offset3V	(*((uint8_t *)(0x1FFFFC94)))	//ptat 5v3vֵ
#define const_adc_temp30H	(*((uint8_t *)(0x1FFFFC96)))	//30ȶֵλ
#define const_adc_temp30L	(*((uint8_t *)(0x1FFFFC97)))	//30ȶֵλ

#define const_adc_TrimV ((uint16_t)0x03FF)		//ѹʱʹ
#define const_adc_TrimV_3FF ((uint16_t)0x03FF)		//ѹʱʹ adcƵ1M ʱ ʱ2ms
#define const_adc_TrimV_1FF ((uint16_t)0x01FF)		//ѹʱʹ adcƵ1M ʱ ʱ1ms
#define const_adc_TrimV_0FF ((uint16_t)0x00FF)		//ѹʱʹ adcƵ1M ʱ ʱ0.5ms
#define const_adc_TrimT ((uint16_t)0x0640)		//¶ʱʹ
#define const_adc_TrimT_Auto ((uint16_t)0x04FB)		//¶ʱʹ(Զ²)
#define const_TmpsL		5.0379					//¶ADCбʵ¶
#define const_TmpsH		5.0379					//¶ADCбʸ¶
#define const_T_Offset5V	(-3.0)				//оƬ@8M
#define const_T_Offset3V	(-2.0)				//оƬ
#define const_xtl_top	25.0					//嶥¶

#define CH_PTAT_Auto	0//¶ȴ,Զ²
#define CH_PTAT	      10//¶ȴ²
#define CH_VDD	1//Դѹ
#define CH_IN1	2//PC12
#define CH_IN2	3//PC13()
#define CH_IN3	4//PD0
#define CH_IN4	5//PD1
#define CH_IN5	6//PF6
#define CH_IN6	7//PC15
#define CH_IN7	8//PB2
#define CH_IN8	9//PB3

/* Exported functions --------------------------------------------------------*/ 



#define	ANAC_PDRCON_PDRCFG_Pos	1	/* PDRµ縴λѹ */
#define	ANAC_PDRCON_PDRCFG_Msk	(0x3U << ANAC_PDRCON_PDRCFG_Pos)
#define	ANAC_PDRCON_PDRCFG_1P5V	(0x0U << ANAC_PDRCON_PDRCFG_Pos)	/* 001.5V */
#define	ANAC_PDRCON_PDRCFG_1P25V	(0x1U << ANAC_PDRCON_PDRCFG_Pos)	/* 011.25VĬϣ */
#define	ANAC_PDRCON_PDRCFG_1P35V	(0x2U << ANAC_PDRCON_PDRCFG_Pos)	/* 101.35V */
#define	ANAC_PDRCON_PDRCFG_1P4V	(0x3U << ANAC_PDRCON_PDRCFG_Pos)	/* 111.4V */

#define	ANAC_PDRCON_PDREN_Pos	0	/* PDRµ縴λʹ */
#define	ANAC_PDRCON_PDREN_Msk	(0x1U << ANAC_PDRCON_PDREN_Pos)
	/* 0رµ縴λ */
	/* 1ʹµ縴λ */

#define	ANAC_BORCON_BOR_PDRCFG_Pos	1	/* BORµ縴λѹ */
#define	ANAC_BORCON_BOR_PDRCFG_Msk	(0x3U << ANAC_BORCON_BOR_PDRCFG_Pos)
#define	ANAC_BORCON_BOR_PDRCFG_1P7V	(0x0U << ANAC_BORCON_BOR_PDRCFG_Pos)	/* 001.7V */
#define	ANAC_BORCON_BOR_PDRCFG_1P6V	(0x1U << ANAC_BORCON_BOR_PDRCFG_Pos)	/* 011.6VĬϣ */
#define	ANAC_BORCON_BOR_PDRCFG_1P65V	(0x2U << ANAC_BORCON_BOR_PDRCFG_Pos)	/* 101.65V */
#define	ANAC_BORCON_BOR_PDRCFG_1P75V	(0x3U << ANAC_BORCON_BOR_PDRCFG_Pos)	/* 111.75V */

#define	ANAC_BORCON_OFF_BOR_Pos	0	/* BORرտƼĴ */
#define	ANAC_BORCON_OFF_BOR_Msk	(0x1U << ANAC_BORCON_OFF_BOR_Pos)
	/* 0رBORرգBOR */
	/* 1ʹBORر */

#define	ANAC_SVDCFG_PFIE_Pos	9	/* SVDԴжʹ */
#define	ANAC_SVDCFG_PFIE_Msk	(0x1U << ANAC_SVDCFG_PFIE_Pos)
	/* 0ֹԴж */
	/* 1ʹܵԴж */

#define	ANAC_SVDCFG_PRIE_Pos	8	/* SVDԴָжʹ */
#define	ANAC_SVDCFG_PRIE_Msk	(0x1U << ANAC_SVDCFG_PRIE_Pos)
	/* 0ֹԴָж */
	/* 1ʹܵԴָж */

#define	ANAC_SVDCFG_SVDLVL_Pos	4	/* SVDֵ */
#define	ANAC_SVDCFG_SVDLVL_Msk	(0xfU << ANAC_SVDCFG_SVDLVL_Pos)
#define	ANAC_SVDCFG_SVDLVL_1P800V	(0x0U << ANAC_SVDCFG_SVDLVL_Pos)	/* 0000_1.800V_1.900VSVDLVL_½ֵ_ֵ */
#define	ANAC_SVDCFG_SVDLVL_2P014V	(0x1U << ANAC_SVDCFG_SVDLVL_Pos)	/* 0001_2.014V_2.114V */
#define	ANAC_SVDCFG_SVDLVL_2P229V	(0x2U << ANAC_SVDCFG_SVDLVL_Pos)	/* 0010_2.229V_2.329V */
#define	ANAC_SVDCFG_SVDLVL_2P443V	(0x3U << ANAC_SVDCFG_SVDLVL_Pos)	/* 0011_2.443V_2.543V */
#define	ANAC_SVDCFG_SVDLVL_2P657V	(0x4U << ANAC_SVDCFG_SVDLVL_Pos)	/* 0100_2.657V_2.757V */
#define	ANAC_SVDCFG_SVDLVL_2P871V	(0x5U << ANAC_SVDCFG_SVDLVL_Pos)	/* 0101_2.871V_2.971V */
#define	ANAC_SVDCFG_SVDLVL_3P086V	(0x6U << ANAC_SVDCFG_SVDLVL_Pos)	/* 0110_3.086V_3.186V */
#define	ANAC_SVDCFG_SVDLVL_3P300V	(0x7U << ANAC_SVDCFG_SVDLVL_Pos)	/* 0111_3.300V_3.400V */
#define	ANAC_SVDCFG_SVDLVL_3P514V	(0x8U << ANAC_SVDCFG_SVDLVL_Pos)	/* 1000_3.514V_3.614V */
#define	ANAC_SVDCFG_SVDLVL_3P729V	(0x9U << ANAC_SVDCFG_SVDLVL_Pos)	/* 1001_3.729V_3.829V */
#define	ANAC_SVDCFG_SVDLVL_3P943V	(0xaU << ANAC_SVDCFG_SVDLVL_Pos)	/* 1010_3.943V_4.043V */
#define	ANAC_SVDCFG_SVDLVL_4P157V	(0xbU << ANAC_SVDCFG_SVDLVL_Pos)	/* 1011_4.157V_4.257V */
#define	ANAC_SVDCFG_SVDLVL_4P371V	(0xcU << ANAC_SVDCFG_SVDLVL_Pos)	/* 1100_4.371V_4.471V */
#define	ANAC_SVDCFG_SVDLVL_4P586V	(0xdU << ANAC_SVDCFG_SVDLVL_Pos)	/* 1101_4.586V_4.686V */
#define	ANAC_SVDCFG_SVDLVL_4P800V	(0xeU << ANAC_SVDCFG_SVDLVL_Pos)	/* 1110_4.800V_4.900V */
#define	ANAC_SVDCFG_SVDLVL_SVS	(0xfU << ANAC_SVDCFG_SVDLVL_Pos)	/* 1111_SVS_SVS  ̶0.8V  */

#define	ANAC_SVDCFG_DFEN_Pos	3	/* ˲ʹܣSVDMODE=1ʱ1 */
#define	ANAC_SVDCFG_DFEN_Msk	(0x1U << ANAC_SVDCFG_DFEN_Pos)
	/* 0رSVD˲ */
	/* 1SVD˲ */

#define	ANAC_SVDCFG_SVDMOD_Pos	2	/* SVDģʽѡ */
#define	ANAC_SVDCFG_SVDMOD_Msk	(0x1U << ANAC_SVDCFG_SVDMOD_Pos)
#define	ANAC_SVDCFG_SVDMOD_ALWAYSON	(0x0U << ANAC_SVDCFG_SVDMOD_Pos)	/* 0ʹģʽ */
#define	ANAC_SVDCFG_SVDMOD_INTERVAL	(0x1U << ANAC_SVDCFG_SVDMOD_Pos)	/* 1Ъʹģʽ */

#define	ANAC_SVDCFG_SVDITVL_Pos	0	/* SVDЪʹܼ */
#define	ANAC_SVDCFG_SVDITVL_Msk	(0x3U << ANAC_SVDCFG_SVDITVL_Pos)
#define	ANAC_SVDCFG_SVDITVL_15P625MS	(0x0U << ANAC_SVDCFG_SVDITVL_Pos)	/* 0015.625ms */
#define	ANAC_SVDCFG_SVDITVL_62P5MS	(0x1U << ANAC_SVDCFG_SVDITVL_Pos)	/* 0162.5ms */
#define	ANAC_SVDCFG_SVDITVL_256MS	(0x2U << ANAC_SVDCFG_SVDITVL_Pos)	/* 10256ms */
#define	ANAC_SVDCFG_SVDITVL_1S	(0x3U << ANAC_SVDCFG_SVDITVL_Pos)	/* 111s */

#define	ANAC_SVDCON_SVDTE_Pos	8	/* SVDʹܣΪ0 */
#define	ANAC_SVDCON_SVDTE_Msk	(0x1U << ANAC_SVDCON_SVDTE_Pos)

#define	ANAC_SVDCON_SVDEN_Pos	0	/* SVDʹ */
#define	ANAC_SVDCON_SVDEN_Msk	(0x1U << ANAC_SVDCON_SVDEN_Pos)
	/* 0رSVD */
	/* 1SVD */

#define	ANAC_SVDSIF_SVDO_Pos	8	/* SVDԴ(ģģֱź,SVDʱɲѯ) */
#define	ANAC_SVDSIF_SVDO_Msk	(0x1U << ANAC_SVDSIF_SVDO_Pos)

#define	ANAC_SVDSIF_SVDR_Pos	7	/* SVDԴ,ڿ˲вο */
#define	ANAC_SVDSIF_SVDR_Msk	(0x1U << ANAC_SVDSIF_SVDR_Pos)

#define	ANAC_SVDSIF_PFF_Pos	1	/* Դжϱ־ĴԴѹ䵽SVDֵ֮ʱλд1 */
#define	ANAC_SVDSIF_PFF_Msk	(0x1U << ANAC_SVDSIF_PFF_Pos)

#define	ANAC_SVDSIF_PRF_Pos	0	/* Դָжϱ־ĴԴѹSVDֵ֮ʱλд1 */
#define	ANAC_SVDSIF_PRF_Msk	(0x1U << ANAC_SVDSIF_PRF_Pos)

#define	ANAC_SVDVOL_V0P8EN_Pos	2	/*0.8V׼ʹź */
#define	ANAC_SVDVOL_V0P8EN_Msk	(0x1U << ANAC_SVDVOL_V0P8EN_Pos)

#define	ANAC_SVDVOL_V0P75EN_Pos	1	/*0.75V׼ʹź */
#define	ANAC_SVDVOL_V0P75EN_Msk	(0x1U << ANAC_SVDVOL_V0P75EN_Pos)

#define	ANAC_SVDVOL_V0P7EN_Pos	0	/*0.7V׼ʹź */
#define	ANAC_SVDVOL_V0P7EN_Msk	(0x1U << ANAC_SVDVOL_V0P7EN_Pos)

#define	ANAC_FDETIE_FDET_IE_Pos	0	/* XTLFͣⱨжʹ,ϵĬϹرգϵʱδ񴥷ж*/
#define	ANAC_FDETIE_FDET_IE_Msk	(0x1U << ANAC_FDETIE_FDET_IE_Pos)

#define	ANAC_FDETIF_FDETO_Pos	6	/* ͣģ */
#define	ANAC_FDETIF_FDETO_Msk	(0x1U << ANAC_FDETIF_FDETO_Pos)

#define	ANAC_FDETIF_FDETIF_Pos	0	/* ͣжϱ־ĴXTLFͣʱӲ첽λд1㣻ֻFDETOΪ0²ܹ˼Ĵ */
#define	ANAC_FDETIF_FDETIF_Msk	(0x1U << ANAC_FDETIF_FDETIF_Pos)

#define	ANAC_ADCCON_ADC_IE_Pos	7	/* ADCжʹ */
#define	ANAC_ADCCON_ADC_IE_Msk	(0x1U << ANAC_ADCCON_ADC_IE_Pos)

#define	ANAC_ADCCON_ADC_VANA_EN_Pos	1	/* ADCͨѡ */
#define	ANAC_ADCCON_ADC_VANA_EN_Msk	(0x1U << ANAC_ADCCON_ADC_VANA_EN_Pos)
#define	ANAC_ADCCON_ADC_VANA_EN_PTAT	(0x0U << ANAC_ADCCON_ADC_VANA_EN_Pos)	/* 0ADC¶ȴ */
#define	ANAC_ADCCON_ADC_VANA_EN_VOLTAGE	(0x1U << ANAC_ADCCON_ADC_VANA_EN_Pos)	/* 1ADCڲⲿѹ */

#define	ANAC_ADCCON_ADC_EN_Pos	0	/* ADCʹź */
#define	ANAC_ADCCON_ADC_EN_Msk	(0x1U << ANAC_ADCCON_ADC_EN_Pos)
	/* 0ADCʹ */
	/* 1ADCʹ */

#define	ANAC_ADCTRIM_ADC_TRIM_Pos	0	/* ADC TRIMֵ,ӳȡ */
#define	ANAC_ADCTRIM_ADC_TRIM_Msk	(0x7ffU << ANAC_ADCTRIM_ADC_TRIM_Pos)

#define	ANAC_ADCDATA_ADC_DATA_Pos	0	/* ADCݼĴ */
#define	ANAC_ADCDATA_ADC_DATA_Msk	(0x7ffU << ANAC_ADCDATA_ADC_DATA_Pos)

#define	ANAC_ADCIF_ADC_DONE_Pos	1	/* ADCתֻرADCŻ0 */
#define	ANAC_ADCIF_ADC_DONE_Msk	(0x1U << ANAC_ADCIF_ADC_DONE_Pos)

#define	ANAC_ADCIF_ADC_IF_Pos	0	/* ADCתжϱ־Ӳλд1㣬д0Ч */
#define	ANAC_ADCIF_ADC_IF_Msk	(0x1U << ANAC_ADCIF_ADC_IF_Pos)

#define	ANAC_ADCINSEL_BUFEN_Pos	5	/* ADCͨBufferʹ */
#define	ANAC_ADCINSEL_BUFEN_Msk	(0x1U << ANAC_ADCINSEL_BUFEN_Pos)

#define	ANAC_ADCINSEL_BUFBYP_Pos	4	/* ADCBuffer Bypass */
#define	ANAC_ADCINSEL_BUFBYP_Msk	(0x1U << ANAC_ADCINSEL_BUFBYP_Pos)
	/* ʹADCⲿźʱҪBypass Buffer */
	/* ʹADCԴѹʱ뽫λ1 */

#define	ANAC_ADCINSEL_BUFSEL_Pos	0	/* ADCͨѡ */
#define	ANAC_ADCINSEL_BUFSEL_Msk	(0xfU << ANAC_ADCINSEL_BUFSEL_Pos)
#define	ANAC_ADCINSEL_BUFSEL_VDD	(0x6U << ANAC_ADCINSEL_BUFSEL_Pos)	/* VDDԴ */
#define	ANAC_ADCINSEL_BUFSEL_ADC_IN1	(0x8U << ANAC_ADCINSEL_BUFSEL_Pos)	/* 1000ADC_IN1 (PC12) */
#define	ANAC_ADCINSEL_BUFSEL_ADC_IN2	(0x9U << ANAC_ADCINSEL_BUFSEL_Pos)	/* 1001ADC_IN2 (PC13) */
#define	ANAC_ADCINSEL_BUFSEL_ADC_IN3	(0xaU << ANAC_ADCINSEL_BUFSEL_Pos)	/* 1010ADC_IN3 (PD0) */
#define	ANAC_ADCINSEL_BUFSEL_ADC_IN4	(0xbU << ANAC_ADCINSEL_BUFSEL_Pos)	/* 1011ADC_IN4 (PD1) */
#define	ANAC_ADCINSEL_BUFSEL_ADC_IN5	(0xcU << ANAC_ADCINSEL_BUFSEL_Pos)	/* 1100ADC_IN5 (PF6) */
#define	ANAC_ADCINSEL_BUFSEL_ADC_IN6	(0xdU << ANAC_ADCINSEL_BUFSEL_Pos)	/* 1101ADC_IN6 (PC15) */
#define	ANAC_ADCINSEL_BUFSEL_ADC_IN7	(0xeU << ANAC_ADCINSEL_BUFSEL_Pos)	/* 1110ADC_IN7 (PB2) */
#define	ANAC_ADCINSEL_BUFSEL_ADC_IN8	(0xfU << ANAC_ADCINSEL_BUFSEL_Pos)	/* 1111ADC_IN8 (PB3) */

#define	ANAC_TRNGCON_TRNGEN_Pos	0	/* TRNG */
#define	ANAC_TRNGCON_TRNGEN_Msk	(0x1U << ANAC_TRNGCON_TRNGEN_Pos)
	/* 0رTRNG */
	/* 1TRNG */

#define	ANAC_COMP1CR_CMP1O_Pos	8	/* Ƚ1ֻ */
#define	ANAC_COMP1CR_CMP1O_Msk	(0x1U << ANAC_COMP1CR_CMP1O_Pos)

#define	ANAC_COMP1CR_V1PSEL_Pos	3	/* Ƚ1ѡ */
#define	ANAC_COMP1CR_V1PSEL_Msk	(0x3U << ANAC_COMP1CR_V1PSEL_Pos)
#define	ANAC_COMP1CR_V1PSEL_PF6	(0x0U << ANAC_COMP1CR_V1PSEL_Pos)	/* 00PF6 */
#define	ANAC_COMP1CR_V1PSEL_PF1	(0x1U << ANAC_COMP1CR_V1PSEL_Pos)	/* 01PF1 */
#define	ANAC_COMP1CR_V1PSEL_PG2	(0x2U << ANAC_COMP1CR_V1PSEL_Pos)	/* 10PG2 */
#define	ANAC_COMP1CR_V1PSEL_PG3	(0x3U << ANAC_COMP1CR_V1PSEL_Pos)	/* 11PG3 */

#define	ANAC_COMP1CR_V1NSEL_Pos	1	/* Ƚ1ѡ */
#define	ANAC_COMP1CR_V1NSEL_Msk	(0x3U << ANAC_COMP1CR_V1NSEL_Pos)
#define	ANAC_COMP1CR_V1NSEL_PF5	(0x0U << ANAC_COMP1CR_V1NSEL_Pos)	/* 00PF5 */
#define	ANAC_COMP1CR_V1NSEL_PF1	(0x1U << ANAC_COMP1CR_V1NSEL_Pos)	/* 01PF1 */
#define	ANAC_COMP1CR_V1NSEL_VREF0P8V	(0x2U << ANAC_COMP1CR_V1NSEL_Pos)	/* 10Vref 0.8V */
#define	ANAC_COMP1CR_V1NSEL_VREF0P4V	(0x3U << ANAC_COMP1CR_V1NSEL_Pos)	/* 11Vref/2 0.4V */

#define	ANAC_COMP1CR_CMP1EN_Pos	0	/* Ƚ1ʹλ */
#define	ANAC_COMP1CR_CMP1EN_Msk	(0x1U << ANAC_COMP1CR_CMP1EN_Pos)
	/* 0رձȽ1 */
	/* 1ʹܱȽ1 */

#define	ANAC_COMP2CR_CMP2O_Pos	8	/* Ƚ2ֻ */
#define	ANAC_COMP2CR_CMP2O_Msk	(0x1U << ANAC_COMP2CR_CMP2O_Pos)

#define	ANAC_COMP2CR_V2PSEL_Pos	3	/* Ƚ2ѡ */
#define	ANAC_COMP2CR_V2PSEL_Msk	(0x1U << ANAC_COMP2CR_V2PSEL_Pos)
#define	ANAC_COMP2CR_V2PSEL_PC15	(0x0U << ANAC_COMP2CR_V2PSEL_Pos)	/* 0PC15 */
#define	ANAC_COMP2CR_V2PSEL_PE4	(0x1U << ANAC_COMP2CR_V2PSEL_Pos)	/* 1PE4 */

#define	ANAC_COMP2CR_V2NSEL_Pos	1	/* Ƚ2ѡ */
#define	ANAC_COMP2CR_V2NSEL_Msk	(0x3U << ANAC_COMP2CR_V2NSEL_Pos)
#define	ANAC_COMP2CR_V2NSEL_PC14	(0x0U << ANAC_COMP2CR_V2NSEL_Pos)	/* 00PC14 */
#define	ANAC_COMP2CR_V2NSEL_PE3	(0x1U << ANAC_COMP2CR_V2NSEL_Pos)	/* 01PE3 */
#define	ANAC_COMP2CR_V2NSEL_VREF0P8V	(0x2U << ANAC_COMP2CR_V2NSEL_Pos)	/* 10Vref 0.8V */
#define	ANAC_COMP2CR_V2NSEL_VREF0P4V	(0x3U << ANAC_COMP2CR_V2NSEL_Pos)	/* 11Vref/2 0.4V */

#define	ANAC_COMP2CR_CMP2EN_Pos	0	/* Ƚ2ʹλ */
#define	ANAC_COMP2CR_CMP2EN_Msk	(0x1U << ANAC_COMP2CR_CMP2EN_Pos)
	/* 0رձȽ1 */
	/* 1ʹܱȽ1 */

#define	ANAC_COMPICR_CMP2DF_Pos	9	/* Ƚ2˲ʹ */
#define	ANAC_COMPICR_CMP2DF_Msk	(0x1U << ANAC_COMPICR_CMP2DF_Pos)
	/* 0ֹ˲ */
	/* 1ʹ˲ */

#define	ANAC_COMPICR_CMP1DF_Pos	8	/* Ƚ1˲ʹ */
#define	ANAC_COMPICR_CMP1DF_Msk	(0x1U << ANAC_COMPICR_CMP1DF_Pos)
	/* 0ֹ˲ */
	/* 1ʹ˲ */

#define	ANAC_COMPICR_BUFBYP_Pos	7	/* ȽBuffer Bypass */
#define	ANAC_COMPICR_BUFBYP_Msk	(0x1U << ANAC_COMPICR_BUFBYP_Pos)
	/* 0BypassȽBuffer */
	/* 1BypassȽBuffer */

#define	ANAC_COMPICR_BUFENB_Pos	6	/* ȽBufferʹ */
#define	ANAC_COMPICR_BUFENB_Msk	(0x1U << ANAC_COMPICR_BUFENB_Pos)
	/* 0ʹܱȽBuffer */
	/* 1ֹȽBuffer */

#define	ANAC_COMPICR_CMP2SEL_Pos	4	/* Ƚ2жԴѡ */
#define	ANAC_COMPICR_CMP2SEL_Msk	(0x3U << ANAC_COMPICR_CMP2SEL_Pos)
#define	ANAC_COMPICR_CMP2SEL_OUTBOTH	(0x0U << ANAC_COMPICR_CMP2SEL_Pos)	/* 00/11Ƚ2½زж */
#define	ANAC_COMPICR_CMP2SEL_OUTRISE	(0x1U << ANAC_COMPICR_CMP2SEL_Pos)	/* 01Ƚ2زж */
#define	ANAC_COMPICR_CMP2SEL_OUTFALL	(0x2U << ANAC_COMPICR_CMP2SEL_Pos)	/* 10Ƚ2½زж */

#define	ANAC_COMPICR_CMP1SEL_Pos	2	/* Ƚ1жԴѡ */
#define	ANAC_COMPICR_CMP1SEL_Msk	(0x3U << ANAC_COMPICR_CMP1SEL_Pos)
#define	ANAC_COMPICR_CMP1SEL_OUTBOTH	(0x0U << ANAC_COMPICR_CMP1SEL_Pos)	/* 00/11Ƚ1½زж */
#define	ANAC_COMPICR_CMP1SEL_OUTRISE	(0x1U << ANAC_COMPICR_CMP1SEL_Pos)	/* 01Ƚ1زж */
#define	ANAC_COMPICR_CMP1SEL_OUTFALL	(0x2U << ANAC_COMPICR_CMP1SEL_Pos)	/* 10Ƚ1½زж */

#define	ANAC_COMPICR_CMP2IE_Pos	1	/* Ƚ2жʹ */
#define	ANAC_COMPICR_CMP2IE_Msk	(0x1U << ANAC_COMPICR_CMP2IE_Pos)

#define	ANAC_COMPICR_CMP1IE_Pos	0	/* Ƚ1жʹ */
#define	ANAC_COMPICR_CMP1IE_Msk	(0x1U << ANAC_COMPICR_CMP1IE_Pos)

#define	ANAC_COMPIF_CMP2IF_Pos	1	/* Ƚ2жϱ־Ӳλд1 */
#define	ANAC_COMPIF_CMP2IF_Msk	(0x1U << ANAC_COMPIF_CMP2IF_Pos)

#define	ANAC_COMPIF_CMP1IF_Pos	0	/* Ƚ1жϱ־Ӳλд1 */
#define	ANAC_COMPIF_CMP1IF_Msk	(0x1U << ANAC_COMPIF_CMP1IF_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void ANAC_Deinit(void);

/* PDRµ縴λѹ غ */
extern void ANAC_PDRCON_PDRCFG_Set(uint32_t SetValue);
extern uint32_t ANAC_PDRCON_PDRCFG_Get(void);

/* PDRµ縴λʹ غ */
extern void ANAC_PDRCON_PDREN_Setable(FunState NewState);
extern FunState ANAC_PDRCON_PDREN_Getable(void);

/* BORµ縴λѹ غ */
extern void ANAC_BORCON_BOR_PDRCFG_Set(uint32_t SetValue);
extern uint32_t ANAC_BORCON_BOR_PDRCFG_Get(void);

/* BORرտƼĴ غ */
extern void ANAC_BORCON_OFF_BOR_Setable(FunState NewState);
extern FunState ANAC_BORCON_OFF_BOR_Getable(void);

/* SVDԴжʹ غ */
extern void ANAC_SVDCFG_PFIE_Setable(FunState NewState);
extern FunState ANAC_SVDCFG_PFIE_Getable(void);

/* SVDԴָжʹ غ */
extern void ANAC_SVDCFG_PRIE_Setable(FunState NewState);
extern FunState ANAC_SVDCFG_PRIE_Getable(void);

/* SVDֵ غ */
extern void ANAC_SVDCFG_SVDLVL_Set(uint32_t SetValue);
extern uint32_t ANAC_SVDCFG_SVDLVL_Get(void);

/* ˲ʹܣSVDMODE=1ʱ1 غ */
extern void ANAC_SVDCFG_DFEN_Setable(FunState NewState);
extern FunState ANAC_SVDCFG_DFEN_Getable(void);

/* SVDģʽѡ غ */
extern void ANAC_SVDCFG_SVDMOD_Set(uint32_t SetValue);
extern uint32_t ANAC_SVDCFG_SVDMOD_Get(void);

/* SVDЪʹܼ غ */
extern void ANAC_SVDCFG_SVDITVL_Set(uint32_t SetValue);
extern uint32_t ANAC_SVDCFG_SVDITVL_Get(void);

/* SVDʹܣΪ0 غ */
extern void ANAC_SVDCON_SVDTE_Setable(FunState NewState);
extern FunState ANAC_SVDCON_SVDTE_Getable(void);

/* SVDʹ غ */
extern void ANAC_SVDCON_SVDEN_Setable(FunState NewState);
extern FunState ANAC_SVDCON_SVDEN_Getable(void);

/* SVDԴ(ģģֱź,SVDʱɲѯ) غ */
extern FlagStatus ANAC_SVDSIF_SVDO_Chk(void);

/* Դжϱ־ĴԴѹ䵽SVDֵ֮ʱλд1 غ */
extern void ANAC_SVDSIF_PFF_Clr(void);
extern FlagStatus ANAC_SVDSIF_PFF_Chk(void);

/* Դָжϱ־ĴԴѹSVDֵ֮ʱλд1 غ */
extern void ANAC_SVDSIF_PRF_Clr(void);
extern FlagStatus ANAC_SVDSIF_PRF_Chk(void);

/* SVDڲ˲ĵѹ־Ĵ״̬ */
extern FlagStatus ANAC_SVDSIF_SVDR_Chk(void);

/*SVD׼ѹ */
extern void ANAC_SVDVOL_CFG(uint32_t SetValue);

/*SVDڲ˲ĵѹ־Ĵ״̬*/
extern FlagStatus ANAC_SVDSIF_SVDR_Chk(void);
 
/*SVD׼ѹ*/
extern void ANAC_SVDVOL_CFG(uint32_t SetValue);

/*SVDοѹѡĴ*/
extern uint32_t ANAC_SVDVOL_Get(void);

/* XTLFͣⱨжʹ,ϵĬϹرգϵʱδ񴥷ж
 غ */
extern void ANAC_FDETIE_FDET_IE_Setable(FunState NewState);
extern FunState ANAC_FDETIE_FDET_IE_Getable(void);

/* ͣģ غ */
extern FlagStatus ANAC_FDETIF_FDETO_Chk(void);

/* ͣжϱ־ĴXTLFͣʱӲ첽λд1㣻ֻFDETOΪ0²ܹ˼Ĵ غ */
extern void ANAC_FDETIF_FDETIF_Clr(void);
extern FlagStatus ANAC_FDETIF_FDETIF_Chk(void);

/* ADCжʹ غ */
extern void ANAC_ADCCON_ADC_IE_Setable(FunState NewState);
extern FunState ANAC_ADCCON_ADC_IE_Getable(void);

/* ADCͨѡ غ */
extern void ANAC_ADCCON_ADC_VANA_EN_Set(uint32_t SetValue);
extern uint32_t ANAC_ADCCON_ADC_VANA_EN_Get(void);

/* ADCʹź غ */
extern void ANAC_ADCCON_ADC_EN_Setable(FunState NewState);
extern FunState ANAC_ADCCON_ADC_EN_Getable(void);

/* ADC TRIMֵ,ӳȡ غ */
extern void ANAC_ADCTRIM_Write(uint32_t SetValue);
extern uint32_t ANAC_ADCTRIM_Read(void);

/* ADCݼĴ غ */
extern uint32_t ANAC_ADCDATA_Read(void);

/* ADCת־ */
extern FlagStatus ANAC_ADCIF_ADC_DONE_Chk(void);

/* ADCתжϱ־Ӳλд1㣬д0Ч غ */
extern void ANAC_ADCIF_ADC_IF_Clr(void);
extern FlagStatus ANAC_ADCIF_ADC_IF_Chk(void);

/* ADCͨBufferʹ غ */
extern void ANAC_ADCINSEL_BUFEN_Setable(FunState NewState);
extern FunState ANAC_ADCINSEL_BUFEN_Getable(void);

/* ADCBuffer Bypass غ */
extern void ANAC_ADCINSEL_BUFBYP_Setable(FunState NewState);
extern FunState ANAC_ADCINSEL_BUFBYP_Getable(void);

/* ADCͨѡ غ */
extern void ANAC_ADCINSEL_BUFSEL_Set(uint32_t SetValue);
extern uint32_t ANAC_ADCINSEL_BUFSEL_Get(void);

/* TRNG غ */
extern void ANAC_TRNGCON_TRNGEN_Setable(FunState NewState);
extern FunState ANAC_TRNGCON_TRNGEN_Getable(void);

/* Ƚ1ֻ غ */
extern FlagStatus ANAC_COMP1CR_CMP1O_Chk(void);

/* Ƚ1ѡ غ */
extern void ANAC_COMP1CR_V1PSEL_Set(uint32_t SetValue);
extern uint32_t ANAC_COMP1CR_V1PSEL_Get(void);

/* Ƚ1ѡ غ */
extern void ANAC_COMP1CR_V1NSEL_Set(uint32_t SetValue);
extern uint32_t ANAC_COMP1CR_V1NSEL_Get(void);

/* Ƚ1ʹλ غ */
extern void ANAC_COMP1CR_CMP1EN_Setable(FunState NewState);
extern FunState ANAC_COMP1CR_CMP1EN_Getable(void);

/* Ƚ2ֻ غ */
extern FlagStatus ANAC_COMP2CR_CMP2O_Chk(void);

/* Ƚ2ѡ غ */
extern void ANAC_COMP2CR_V2PSEL_Set(uint32_t SetValue);
extern uint32_t ANAC_COMP2CR_V2PSEL_Get(void);

/* Ƚ2ѡ غ */
extern void ANAC_COMP2CR_V2NSEL_Set(uint32_t SetValue);
extern uint32_t ANAC_COMP2CR_V2NSEL_Get(void);

/* Ƚ2ʹλ غ */
extern void ANAC_COMP2CR_CMP2EN_Setable(FunState NewState);
extern FunState ANAC_COMP2CR_CMP2EN_Getable(void);

/* Ƚ2˲ʹ غ */
extern void ANAC_COMPICR_CMP2DF_Setable(FunState NewState);
extern FunState ANAC_COMPICR_CMP2DF_Getable(void);

/* Ƚ1˲ʹ غ */
extern void ANAC_COMPICR_CMP1DF_Setable(FunState NewState);
extern FunState ANAC_COMPICR_CMP1DF_Getable(void);

/* ȽBuffer Bypass غ */
extern void ANAC_COMPICR_BUFBYP_Setable(FunState NewState);
extern FunState ANAC_COMPICR_BUFBYP_Getable(void);

/* ȽBufferʹ غ */
extern void ANAC_COMPICR_BUFENB_Setable(FunState NewState);
extern FunState ANAC_COMPICR_BUFENB_Getable(void);

/* Ƚ2жԴѡ غ */
extern void ANAC_COMPICR_CMP2SEL_Set(uint32_t SetValue);
extern uint32_t ANAC_COMPICR_CMP2SEL_Get(void);

/* Ƚ1жԴѡ غ */
extern void ANAC_COMPICR_CMP1SEL_Set(uint32_t SetValue);
extern uint32_t ANAC_COMPICR_CMP1SEL_Get(void);

/* Ƚ2жʹ غ */
extern void ANAC_COMPICR_CMP2IE_Setable(FunState NewState);
extern FunState ANAC_COMPICR_CMP2IE_Getable(void);

/* Ƚ1жʹ غ */
extern void ANAC_COMPICR_CMP1IE_Setable(FunState NewState);
extern FunState ANAC_COMPICR_CMP1IE_Getable(void);

/* Ƚ2жϱ־Ӳλд1 غ */
extern void ANAC_COMPIF_CMP2IF_Clr(void);
extern FlagStatus ANAC_COMPIF_CMP2IF_Chk(void);

/* Ƚ1жϱ־Ӳλд1 غ */
extern void ANAC_COMPIF_CMP1IF_Clr(void);
extern FlagStatus ANAC_COMPIF_CMP1IF_Chk(void);
//Announce_End
	 

/*SVD ʼú*/
extern void ANAC_SVD_Init(ANAC_SVD_InitTypeDef* para);

/*ADC ʼú*/
void ANAC_ADC_Init(ANAC_ADC_InitTypeDef* para);

/*ADC ͨú*/
void ANAC_ADC_Channel_SetEx(uint8_t ChSel_def);

/*ADC ѹ㺯
	룺ADֵѹֵ53
	ѹ@mV 
*/
uint32_t ANAC_ADC_VoltageCalc(uint32_t fADCData,uint8_t Vdd);
/*ADC ¶ȼ㺯
	룺ADֵѹֵ53
	¶@ 
*/
float ANAC_ADC_TemperatureCalc(float fADCData ,uint8_t Vdd);

/*COMP ʼú*/
void ANAC_COMPx_Init(ANAC_COMPx_InitTypeDef* para);

#ifdef __cplusplus
}
#endif

#endif /* __FM33G0XX_ANAC_H */



/************************ (C) COPYRIGHT FMSHelectronics *****END OF FILE****/



