/**
  ******************************************************************************
  * @file    fm33g0xx_crc.h
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file contains all the functions prototypes for the  firmware library.  
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __FM33G0XX_CRC_H
#define __FM33G0XX_CRC_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "FM33G0XX.h"
	 
/** @addtogroup fm33g0xx_StdPeriph_Driver
  * @{
  */

/** @addtogroup CRC
  * @{
  */ 

/* Exported constants --------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
typedef struct
{       	
	uint32_t			CRCSEL;		/*!<CRCУʽѡ*/
	FunState			RFLTIN;		/*!<CRC뷴ת*/
	FunState			RFLTO;		/*!<CRCת*/
	FunState			XOR;		/*!<ʹ*/
	uint32_t			CRC_XOR;	/*!<Ĵ*/

}CRC_InitTypeDef;

/* Exported macro ------------------------------------------------------------*/




#define	CRC_CRCDR_CRCDR_Pos	0	/* CRCݼĴ */
#define	CRC_CRCDR_CRCDR_Msk	(0xffffU << CRC_CRCDR_CRCDR_Pos)

#define	CRC_CRCCR_RFLTIN_Pos	6	/* CRC뷴ת */
#define	CRC_CRCCR_RFLTIN_Msk	(0x1U << CRC_CRCCR_RFLTIN_Pos)
	/* 0벻ת */
	/* 1밴ֽڷת */

#define	CRC_CRCCR_RFLTO_Pos	5	/* CRCת */
#define	CRC_CRCCR_RFLTO_Msk	(0x1U << CRC_CRCCR_RFLTO_Pos)
	/* 0벻ת */
	/* 1밴ֽڷת */

#define	CRC_CRCCR_RES_Pos	4	/* CRC־λֻ */
#define	CRC_CRCCR_RES_Msk	(0x1U << CRC_CRCCR_RES_Pos)

#define	CRC_CRCCR_BUSY_Pos	3	/* CRC־λֻ */
#define	CRC_CRCCR_BUSY_Msk	(0x1U << CRC_CRCCR_BUSY_Pos)

#define	CRC_CRCCR_XOR_Pos	2	/* ʹ */
#define	CRC_CRCCR_XOR_Msk	(0x1U << CRC_CRCCR_XOR_Pos)
	/* 0CRC_XORĴ */
	/* 1CRC_XORĴ */

#define	CRC_CRCCR_CRCSEL_Pos	0	/* CRCУʽѡ */
#define	CRC_CRCCR_CRCSEL_Msk	(0x3U << CRC_CRCCR_CRCSEL_Pos)
#define	CRC_CRCCR_CRCSEL_CRC16	(0x0U << CRC_CRCCR_CRCSEL_Pos)	/* 00CRC16 */
#define	CRC_CRCCR_CRCSEL_CRC8	(0x1U << CRC_CRCCR_CRCSEL_Pos)	/* 01CRC8 */
#define	CRC_CRCCR_CRCSEL_CCITT	(0x2U << CRC_CRCCR_CRCSEL_Pos)	/* 10/11CCITT */

#define	CRC_CRCLFSR_LFSR_Pos	0	/* CRCĴ */
#define	CRC_CRCLFSR_LFSR_Msk	(0xffffU << CRC_CRCLFSR_LFSR_Pos)

#define	CRC_CRCXOR_CRC_XOR_Pos	0	/* CRCĴ */
#define	CRC_CRCXOR_CRC_XOR_Msk	(0xffffU << CRC_CRCXOR_CRC_XOR_Pos)

#define	CRC_CRCFLSEN_FLSCRCEN_Pos	0	/* FlashCRCУʹ */
#define	CRC_CRCFLSEN_FLSCRCEN_Msk	(0x1U << CRC_CRCFLSEN_FLSCRCEN_Pos)
	/* 0ʹFlash CRCУ */
	/* 1Flash CRCУ */

#define	CRC_CRCFLSAD_FLSAD_Pos	0	/* FlashУʼַWordַ */
#define	CRC_CRCFLSAD_FLSAD_Msk	(0x1ffffU << CRC_CRCFLSAD_FLSAD_Pos)

#define	CRC_CRCFLSSIZE_FLSS_Pos	0	/* CRC FlashУݳȣWordȣ */
#define	CRC_CRCFLSSIZE_FLSS_Msk	(0x1ffffU << CRC_CRCFLSSIZE_FLSS_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void CRC_Deinit(void);

/* CRCݼĴ غ */
extern void CRC_CRCDR_Write(uint32_t SetValue);
extern uint32_t CRC_CRCDR_Read(void);

/* CRC뷴ת غ */
extern void CRC_CRCCR_RFLTIN_Setable(FunState NewState);
extern FunState CRC_CRCCR_RFLTIN_Getable(void);

/* CRCת غ */
extern void CRC_CRCCR_RFLTO_Setable(FunState NewState);
extern FunState CRC_CRCCR_RFLTO_Getable(void);

/* CRC־λֻ غ */
extern FlagStatus CRC_CRCCR_RES_Chk(void);

/* CRC־λֻ غ */
extern FlagStatus CRC_CRCCR_BUSY_Chk(void);

/* ʹ غ */
extern void CRC_CRCCR_XOR_Setable(FunState NewState);
extern FunState CRC_CRCCR_XOR_Getable(void);

/* CRCУʽѡ غ */
extern void CRC_CRCCR_CRCSEL_Set(uint32_t SetValue);
extern uint32_t CRC_CRCCR_CRCSEL_Get(void);

/* CRCĴ غ */
extern void CRC_CRCLFSR_Write(uint32_t SetValue);
extern uint32_t CRC_CRCLFSR_Read(void);

/* CRCĴ غ */
extern void CRC_CRCXOR_Write(uint32_t SetValue);
extern uint32_t CRC_CRCXOR_Read(void);

/* FlashCRCУʹ غ */
extern void CRC_CRCFLSEN_FLSCRCEN_Setable(FunState NewState);
extern FunState CRC_CRCFLSEN_FLSCRCEN_Getable(void);

/* FlashУʼַWordַ غ */
extern void CRC_CRCFLSAD_Write(uint32_t SetValue);
extern uint32_t CRC_CRCFLSAD_Read(void);

/* CRC FlashУݳȣWordȣ غ */
extern void CRC_CRCFLSSIZE_Write(uint32_t SetValue);
extern uint32_t CRC_CRCFLSSIZE_Read(void);
//Announce_End


/* CRCʼú*/
void CRC_Init(CRC_InitTypeDef* para);
	
#ifdef __cplusplus
}
#endif

#endif



/************************ (C) COPYRIGHT FMSHelectronics *****END OF FILE****/



