/**
  ******************************************************************************
  * @file    fm33g0xx_dma.h
  * @author  FM33g0x Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file contains all the functions prototypes for the DMA firmware library.  
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __FM33G0XX_DMA_H
#define __FM33G0XX_DMA_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "FM33G0XX.h"


typedef enum {
DMA_CH0 = 0, DMA_CH1 = 1, DMA_CH2 = 2, DMA_CH3 = 3, DMA_CH4 = 4, DMA_CH5 = 5, DMA_CH6 = 6, DMA_CH7 = 7	
}DMA_CH_Type;


typedef struct
{
	DMA_CH_Type CHx;			//DMAͨ
	uint32_t CHxTSIZE;          //ͨ䳤
	uint32_t CHxPRI;            //ͨȼ
	uint32_t CHxINC;            //CH0~CH6ַͨ,CH7
	uint32_t CHxSSEL;           //CH0~CH6ͨѡ,CH7䷽ʽѡ
	FunState CHxFTIE;           //ͨжʹ
	FunState CHxHTIE;           //ͨжʹ
	FunState CHxEN;             //ͨʹ
	uint32_t CHxRAMAD;          //CH0~CH7ͨRAMַָ,עCH7ʹõwordַѴˣ

	uint32_t CH7FLSAD;			//ͨFLASHַָͨ7	
}DMA_InitTypeDef;




#define	DMA_GLOBALCTRL_DMAEN_Pos	0	/* DMAȫʹ */
#define	DMA_GLOBALCTRL_DMAEN_Msk	(0x1U << DMA_GLOBALCTRL_DMAEN_Pos)
	/* 0DMAر */
	/* 1DMAʹ */


#define	DMA_CHxCTRL_TSIZE_Pos	16	/* Channelx䳤 */
#define	DMA_CHxCTRL_TSIZE_Msk	(0x1fffU << DMA_CHxCTRL_TSIZE_Pos)

#define	DMA_CHxCTRL_PRI_Pos	12	/* Channelxȼ */
#define	DMA_CHxCTRL_PRI_Msk	(0x3U << DMA_CHxCTRL_PRI_Pos)
#define	DMA_CHxCTRL_PRI_LOW	(0x0U << DMA_CHxCTRL_PRI_Pos)	/* ȼ */
#define	DMA_CHxCTRL_PRI_MEDIUM	(0x1U << DMA_CHxCTRL_PRI_Pos)	/* ȼ */
#define	DMA_CHxCTRL_PRI_HIGH	(0x2U << DMA_CHxCTRL_PRI_Pos)	/* ȼ */
#define	DMA_CHxCTRL_PRI_VERY_HIGH	(0x3U << DMA_CHxCTRL_PRI_Pos)	/* ȼ */

#define	DMA_CHxCTRL_INC_Pos	11	/* RAMַ */
#define	DMA_CHxCTRL_INC_Msk	(0x1U << DMA_CHxCTRL_INC_Pos)
#define	DMA_CHxCTRL_INC_DEC	(0x0U << DMA_CHxCTRL_INC_Pos)	/* ַݼ */
#define	DMA_CHxCTRL_INC_INC	(0x1U << DMA_CHxCTRL_INC_Pos)	/* ַ */

#define	DMA_CHxCTRL_FTIE_Pos	2	/* Channelxжʹ */
#define	DMA_CHxCTRL_FTIE_Msk	(0x1U << DMA_CHxCTRL_FTIE_Pos)
	/* 0رմж */
	/* 1ʹܴж */

#define	DMA_CHxCTRL_HTIE_Pos	1	/* Channelx̴жʹ */
#define	DMA_CHxCTRL_HTIE_Msk	(0x1U << DMA_CHxCTRL_HTIE_Pos)
	/* 0رհж */
	/* 1ʹܰж */

#define	DMA_CHxCTRL_EN_Pos	0	/* Channelxʹ */
#define	DMA_CHxCTRL_EN_Msk	(0x1U << DMA_CHxCTRL_EN_Pos)
	/* 0رͨ0 */
	/* 1ʹͨ0 */

#define	DMA_CHxRAMAD_RAMAD_Pos	0	/* ChannelxָĴ */
#define	DMA_CHxRAMAD_RAMAD_Msk	(0x7fffU << DMA_CHxRAMAD_RAMAD_Pos)


#define	DMA_CHxCTRL_SSEL_Pos	8	/* Channel0ͨѡ */
#define	DMA_CHxCTRL_SSEL_Msk	(0x7U << DMA_CH0CTRL_CH0SSEL_Pos)

#define	DMA_CH0CTRL_CH0SSEL_Pos	8	/* Channel0ͨѡ */
#define	DMA_CH0CTRL_CH0SSEL_Msk	(0x7U << DMA_CH0CTRL_CH0SSEL_Pos)
#define	DMA_CH0CTRL_CH0SSEL_ET4_CAP	(0x0U << DMA_CH0CTRL_CH0SSEL_Pos)
#define	DMA_CH0CTRL_CH0SSEL_ET2_CAP	(0x1U << DMA_CH0CTRL_CH0SSEL_Pos)
#define	DMA_CH0CTRL_CH0SSEL_BT2_CAP	(0x2U << DMA_CH0CTRL_CH0SSEL_Pos)
#define	DMA_CH0CTRL_CH0SSEL_ET3_CAP	(0x3U << DMA_CH0CTRL_CH0SSEL_Pos)
#define	DMA_CH0CTRL_CH0SSEL_BT1_CAP	(0x4U << DMA_CH0CTRL_CH0SSEL_Pos)
#define	DMA_CH0CTRL_CH0SSEL_CRC_OUT	(0x5U << DMA_CH0CTRL_CH0SSEL_Pos)
#define	DMA_CH0CTRL_CH0SSEL_AES_IN	(0x6U << DMA_CH0CTRL_CH0SSEL_Pos)
#define	DMA_CH0CTRL_CH0SSEL_ADC_OUT	(0x7U << DMA_CH0CTRL_CH0SSEL_Pos)

#define	DMA_CH1CTRL_CH1SSEL_Pos	8	/* Channel1ͨѡ */
#define	DMA_CH1CTRL_CH1SSEL_Msk	(0x7U << DMA_CH1CTRL_CH1SSEL_Pos)
#define	DMA_CH1CTRL_CH1SSEL_ET1_CAP	(0x0U << DMA_CH1CTRL_CH1SSEL_Pos)
#define	DMA_CH1CTRL_CH1SSEL_AES_OUT	(0x1U << DMA_CH1CTRL_CH1SSEL_Pos)
#define	DMA_CH1CTRL_CH1SSEL_I2C_RX	(0x2U << DMA_CH1CTRL_CH1SSEL_Pos)
#define	DMA_CH1CTRL_CH1SSEL_U78160_RX	(0x3U << DMA_CH1CTRL_CH1SSEL_Pos)
#define	DMA_CH1CTRL_CH1SSEL_UART3_RX	(0x4U << DMA_CH1CTRL_CH1SSEL_Pos)
#define	DMA_CH1CTRL_CH1SSEL_UART0_RX	(0x5U << DMA_CH1CTRL_CH1SSEL_Pos)
#define	DMA_CH1CTRL_CH1SSEL_HSPI_RX	(0x6U << DMA_CH1CTRL_CH1SSEL_Pos)
#define	DMA_CH1CTRL_CH1SSEL_ADC_OUT	(0x7U << DMA_CH1CTRL_CH1SSEL_Pos)

#define	DMA_CH2CTRL_CH2SSEL_Pos	8	/* Channel2ͨѡ */
#define	DMA_CH2CTRL_CH2SSEL_Msk	(0x7U << DMA_CH2CTRL_CH2SSEL_Pos)
#define	DMA_CH2CTRL_CH2SSEL_ET3_CAP	(0x0U << DMA_CH2CTRL_CH2SSEL_Pos)
#define	DMA_CH2CTRL_CH2SSEL_BT1_CAP	(0x1U << DMA_CH2CTRL_CH2SSEL_Pos)
#define	DMA_CH2CTRL_CH2SSEL_AES_OUT	(0x2U << DMA_CH2CTRL_CH2SSEL_Pos)
#define	DMA_CH2CTRL_CH2SSEL_I2C_TX	(0x3U << DMA_CH2CTRL_CH2SSEL_Pos)
#define	DMA_CH2CTRL_CH2SSEL_U78160_TX	(0x4U << DMA_CH2CTRL_CH2SSEL_Pos)
#define	DMA_CH2CTRL_CH2SSEL_UART3_TX	(0x5U << DMA_CH2CTRL_CH2SSEL_Pos)
#define	DMA_CH2CTRL_CH2SSEL_UART0_TX	(0x6U << DMA_CH2CTRL_CH2SSEL_Pos)
#define	DMA_CH2CTRL_CH2SSEL_HSPI_TX	(0x7U << DMA_CH2CTRL_CH2SSEL_Pos)

#define	DMA_CH3CTRL_CH3SSEL_Pos	8	/* Channel3ͨѡ */
#define	DMA_CH3CTRL_CH3SSEL_Msk	(0x7U << DMA_CH3CTRL_CH3SSEL_Pos)
#define	DMA_CH3CTRL_CH3SSEL_BT2_CAP	(0x0U << DMA_CH3CTRL_CH3SSEL_Pos)
#define	DMA_CH3CTRL_CH3SSEL_ET1_CAP	(0x1U << DMA_CH3CTRL_CH3SSEL_Pos)
#define	DMA_CH3CTRL_CH3SSEL_I2C_TX	(0x2U << DMA_CH3CTRL_CH3SSEL_Pos)
#define	DMA_CH3CTRL_CH3SSEL_U78161_RX	(0x3U << DMA_CH3CTRL_CH3SSEL_Pos)
#define	DMA_CH3CTRL_CH3SSEL_UART4_RX	(0x4U << DMA_CH3CTRL_CH3SSEL_Pos)
#define	DMA_CH3CTRL_CH3SSEL_UART1_RX	(0x5U << DMA_CH3CTRL_CH3SSEL_Pos)
#define	DMA_CH3CTRL_CH3SSEL_UART0_RX	(0x6U << DMA_CH3CTRL_CH3SSEL_Pos)
#define	DMA_CH3CTRL_CH3SSEL_SPI1_RX	(0x7U << DMA_CH3CTRL_CH3SSEL_Pos)

#define	DMA_CH4CTRL_CH4SSEL_Pos	8	/* Channel4ͨѡ */
#define	DMA_CH4CTRL_CH4SSEL_Msk	(0x7U << DMA_CH4CTRL_CH4SSEL_Pos)
#define	DMA_CH4CTRL_CH4SSEL_ET2_CAP	(0x0U << DMA_CH4CTRL_CH4SSEL_Pos)
#define	DMA_CH4CTRL_CH4SSEL_AES_IN	(0x1U << DMA_CH4CTRL_CH4SSEL_Pos)
#define	DMA_CH4CTRL_CH4SSEL_I2C_RX	(0x2U << DMA_CH4CTRL_CH4SSEL_Pos)
#define	DMA_CH4CTRL_CH4SSEL_U78161_TX	(0x3U << DMA_CH4CTRL_CH4SSEL_Pos)
#define	DMA_CH4CTRL_CH4SSEL_UART4_TX	(0x4U << DMA_CH4CTRL_CH4SSEL_Pos)
#define	DMA_CH4CTRL_CH4SSEL_UART1_TX	(0x5U << DMA_CH4CTRL_CH4SSEL_Pos)
#define	DMA_CH4CTRL_CH4SSEL_UART0_TX	(0x6U << DMA_CH4CTRL_CH4SSEL_Pos)
#define	DMA_CH4CTRL_CH4SSEL_SPI1_TX	(0x7U << DMA_CH4CTRL_CH4SSEL_Pos)

#define	DMA_CH5CTRL_CH5SSEL_Pos	8	/* Channel5ͨѡ */
#define	DMA_CH5CTRL_CH5SSEL_Msk	(0x7U << DMA_CH5CTRL_CH5SSEL_Pos)
#define	DMA_CH5CTRL_CH5SSEL_LPUART_RX	(0x0U << DMA_CH5CTRL_CH5SSEL_Pos)
#define	DMA_CH5CTRL_CH5SSEL_U78161_RX	(0x1U << DMA_CH5CTRL_CH5SSEL_Pos)
#define	DMA_CH5CTRL_CH5SSEL_U78160_RX	(0x2U << DMA_CH5CTRL_CH5SSEL_Pos)
#define	DMA_CH5CTRL_CH5SSEL_UART5_RX	(0x3U << DMA_CH5CTRL_CH5SSEL_Pos)
#define	DMA_CH5CTRL_CH5SSEL_UART2_RX	(0x4U << DMA_CH5CTRL_CH5SSEL_Pos)
#define	DMA_CH5CTRL_CH5SSEL_UART1_RX	(0x5U << DMA_CH5CTRL_CH5SSEL_Pos)
#define	DMA_CH5CTRL_CH5SSEL_SPI2_RX	(0x6U << DMA_CH5CTRL_CH5SSEL_Pos)
#define	DMA_CH5CTRL_CH5SSEL_HSPI_RX	(0x7U << DMA_CH5CTRL_CH5SSEL_Pos)

#define	DMA_CH6CTRL_CH6SSEL_Pos	8	/* Channel5ͨѡ */
#define	DMA_CH6CTRL_CH6SSEL_Msk	(0x7U << DMA_CH6CTRL_CH6SSEL_Pos)
#define	DMA_CH6CTRL_CH6SSEL_LPUART_TX	(0x0U << DMA_CH6CTRL_CH6SSEL_Pos)
#define	DMA_CH6CTRL_CH6SSEL_U78161_TX	(0x1U << DMA_CH6CTRL_CH6SSEL_Pos)
#define	DMA_CH6CTRL_CH6SSEL_U78160_TX	(0x2U << DMA_CH6CTRL_CH6SSEL_Pos)
#define	DMA_CH6CTRL_CH6SSEL_UART5_TX	(0x3U << DMA_CH6CTRL_CH6SSEL_Pos)
#define	DMA_CH6CTRL_CH6SSEL_UART2_TX	(0x4U << DMA_CH6CTRL_CH6SSEL_Pos)
#define	DMA_CH6CTRL_CH6SSEL_UART1_TX	(0x5U << DMA_CH6CTRL_CH6SSEL_Pos)
#define	DMA_CH6CTRL_CH6SSEL_SPI2_TX	(0x6U << DMA_CH6CTRL_CH6SSEL_Pos)
#define	DMA_CH6CTRL_CH6SSEL_HSPI_TX	(0x7U << DMA_CH6CTRL_CH6SSEL_Pos)


//BIT10	CH7DIR	Channel7䷽
//1Flash->RAM
//0RAM->Flash
//BIT9	CH7RI	Channel7 RAMַãFlash->RAMЧ
//1RAMַ
//0RAMַݼ
//BIT8	CH7FI	Channel7 FlashַãFlash->RAMЧ
//1Flashַ
//0Flashַݼ
#define	DMA_CH7CTRL_CH7SSEL_Pos	8	/* Channel7ͨѡ */
#define	DMA_CH7CTRL_CH7SSEL_Msk	(0x7U << DMA_CH7CTRL_CH7SSEL_Pos)
#define	DMA_CH7CTRL_CH7SSEL_RFRMFM	(0x0U << DMA_CH7CTRL_CH7SSEL_Pos)	/* Channel7 RAM->FLASH RAMַݼ FLASHַݼ */
#define	DMA_CH7CTRL_CH7SSEL_RFRMFP	(0x1U << DMA_CH7CTRL_CH7SSEL_Pos)	/* Channel7 RAM->FLASH RAMַݼ FLASHַ */
#define	DMA_CH7CTRL_CH7SSEL_RFRPFM	(0x2U << DMA_CH7CTRL_CH7SSEL_Pos)	/* Channel7 RAM->FLASH RAMַ FLASHַݼ */
#define	DMA_CH7CTRL_CH7SSEL_RFRPFP	(0x3U << DMA_CH7CTRL_CH7SSEL_Pos)	/* Channel7 RAM->FLASH RAMַ FLASHַ */
#define	DMA_CH7CTRL_CH7SSEL_FRRMFM	(0x4U << DMA_CH7CTRL_CH7SSEL_Pos)	/* Channel7 FLASH->RAM RAMַݼ FLASHַݼ */
#define	DMA_CH7CTRL_CH7SSEL_FRRMFP	(0x5U << DMA_CH7CTRL_CH7SSEL_Pos)	/* Channel7 FLASH->RAM RAMַݼ FLASHַ */
#define	DMA_CH7CTRL_CH7SSEL_FRRPFM	(0x6U << DMA_CH7CTRL_CH7SSEL_Pos)	/* Channel7 FLASH->RAM RAMַ FLASHַݼ */
#define	DMA_CH7CTRL_CH7SSEL_FRRPFP	(0x7U << DMA_CH7CTRL_CH7SSEL_Pos)	/* Channel7 FLASH->RAM RAMַ FLASHַ */

//#define	DMA_CH7CTRL_CH7DIR_Pos	10	/* Channel7䷽ */
//#define	DMA_CH7CTRL_CH7DIR_Msk	(0x1U << DMA_CH7CTRL_CH7DIR_Pos)
//#define	DMA_CH7CTRL_CH7DIR_RAM2FLASH	(0x0U << DMA_CH7CTRL_CH7DIR_Pos)	/* RAM->FLASH */
//#define	DMA_CH7CTRL_CH7DIR_FLASH2RAM	(0x1U << DMA_CH7CTRL_CH7DIR_Pos)	/* FLASH->RAM */

//#define	DMA_CH7CTRL_CH7RI_Pos	9	/* Channel7RAMַ */
//#define	DMA_CH7CTRL_CH7RI_Msk	(0x1U << DMA_CH7CTRL_CH7RI_Pos)
//#define	DMA_CH7CTRL_CH7RI_DEC	(0x0U << DMA_CH7CTRL_CH7RI_Pos)	/* RAMַݼ */
//#define	DMA_CH7CTRL_CH7RI_INC	(0x1U << DMA_CH7CTRL_CH7RI_Pos)	/* RAMַ */

//#define	DMA_CH7CTRL_CH7FI_Pos	8	/* Channel7FLASHַ */
//#define	DMA_CH7CTRL_CH7FI_Msk	(0x1U << DMA_CH7CTRL_CH7FI_Pos)
//#define	DMA_CH7CTRL_CH7FI_DEC	(0x0U << DMA_CH7CTRL_CH7FI_Pos)	/* FLASHַݼ */
//#define	DMA_CH7CTRL_CH7FI_INC	(0x1U << DMA_CH7CTRL_CH7FI_Pos)	/* FLASHַ */



#define	DMA_CH7FLSAD_CH7FLSAD_Pos	0	/* Channel7FLASHַָ */
#define	DMA_CH7FLSAD_CH7FLSAD_Msk	(0xffffU << DMA_CH7FLSAD_CH7FLSAD_Pos)

#define	DMA_CH7RAMAD_CH7RAMAD_Pos	0	/* Channel7RAMַָ */
#define	DMA_CH7RAMAD_CH7RAMAD_Msk	(0x1fffU << DMA_CH7RAMAD_CH7RAMAD_Pos)


//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void DMA_Deinit(void);

/* DMAȫʹ غ */
extern void DMA_GLOBALCTRL_DMAEN_Setable(FunState NewState);
extern FunState DMA_GLOBALCTRL_DMAEN_Getable(void);


//Announce_End

/* Channelx䳤 غ */
extern void DMA_CHxCTRL_TSIZE_Set(DMA_CH_Type CHx, uint32_t SetValue);
extern uint32_t DMA_CHxCTRL_TSIZE_Get(DMA_CH_Type CHx);

/* Channelxȼ غ */
extern void DMA_CHxCTRL_PRI_Set(DMA_CH_Type CHx, uint32_t SetValue);
extern uint32_t DMA_CHxCTRL_PRI_Get(DMA_CH_Type CHx);

/* Channelx RAMַ غ */
extern void DMA_CHxCTRL_INC_Set(DMA_CH_Type CHx, uint32_t SetValue);
extern uint32_t DMA_CHxCTRL_INC_Get(DMA_CH_Type CHx);

/* Channelxͨѡ غ */
extern void DMA_CHxCTRL_SSEL_Set(DMA_CH_Type CHx, uint32_t SetValue);
extern uint32_t DMA_CHxCTRL_SSEL_Get(DMA_CH_Type CHx);

/* Channelxжʹ غ */
extern void DMA_CHxCTRL_FTIE_Setable(DMA_CH_Type CHx, FunState NewState);
extern FunState DMA_CHxCTRL_FTIE_Getable(DMA_CH_Type CHx);

/* Channelx̴жʹ غ */
extern void DMA_CHxCTRL_HTIE_Setable(DMA_CH_Type CHx, FunState NewState);
extern FunState DMA_CHxCTRL_HTIE_Getable(DMA_CH_Type CHx);

/* Channelxʹ غ */
extern void DMA_CHxCTRL_EN_Setable(DMA_CH_Type CHx, FunState NewState);

/* ChannelxָĴ غ */
extern void DMA_CHxRAMAD_Write(DMA_CH_Type CHx, uint32_t SetValue);
extern uint32_t DMA_CHxRAMAD_Read(DMA_CH_Type CHx);

/* Channel7FLASHַָ غ */
extern void DMA_CH7FLSAD_Write(uint32_t SetValue);
extern uint32_t DMA_CH7FLSAD_Read(void);

/* Channel7RAMַָ غ */
extern void DMA_CH7RAMAD_Write(uint32_t SetValue);
extern uint32_t DMA_CH7RAMAD_Read(void);

/* Channelx̱־ غ */
extern void DMA_CHSTATUS_DMACHxHT_Clr(DMA_CH_Type CHx);
extern FlagStatus DMA_CHSTATUS_DMACHxHT_Chk(DMA_CH_Type CHx);

/* Channelxɱ־ غ */
extern void DMA_CHSTATUS_DMACHxFT_Clr(DMA_CH_Type CHx);
extern FlagStatus DMA_CHSTATUS_DMACHxFT_Chk(DMA_CH_Type CHx);

/* DMAʼ */
extern void DMA_Init(DMA_InitTypeDef* para);



#ifdef __cplusplus
}
#endif

#endif /* __FM33G0XX_DMA_H */



/************************ (C) COPYRIGHT FMSHelectronics *****END OF FILE****/




