/**
  ******************************************************************************
  * @file    fm33g0xx_hspi.h
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file contains all the functions prototypes for the SPI firmware library.  
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __FM33G0XX_HSPI_H
#define __FM33G0XX_HSPI_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
//#include "FM33G0XX_define_all.h"
#include "FM33G0XX.h" 

/** @addtogroup FM33g0xx_StdPeriph_Driver
  * @{
  */

/** @addtogroup SPI
  * @{
  */ 

/* Exported constants --------------------------------------------------------*/

/** @defgroup SPI_Exported_Constants
  * @{
  */

typedef struct
{
	//uint32_t DELAY_CFG;       //slaveģʽ¶Էλеʹøλֵ/* SETTING SENING AHESD HALF CYCLE */
	//FunState FLTEN;             //slaveģʽʹ4ns˲/* SET PAD(SSN/SCK/MOSI) FILTER ENABLE AT SLAVE  */	
	uint32_t LSBF;             	//ȷ͸λbitǵλbit/* SETTING 1 FOR LSB */		
    uint32_t CPHOL;			    //ʱӼѡ/* SETTING 1 FOR CLK STOP AT HIGH*/	
	uint32_t CPHA;				//ʱλѡ/* SETTING 1 FOR START AT SECOND CLK EDGE AND 0 FOR FIRST */
}HSPI_Slave_SInitTypeDef;

typedef struct
{
	uint32_t DELAY_CFG;         //slaveģʽ¶Էλе
	FunState FLTEN;             //slaveģʽʹ4ns˲
	uint32_t LSBF;             	//ȷ͸λbitǵλbit/* SETTING 1 FOR LSB */		
    uint32_t CPHOL;			    //ʱӼѡ/* SETTING 1 FOR CLK STOP AT HIGH*/	
	uint32_t CPHA;				//ʱλѡ/* SETTING 1 FOR START AT SECOND CLK EDGE AND 0 FOR FIRST */
	FunState TXO;               //TXONLYģʽ
	uint32_t TXO_AC;            //TXONLYӲԶ

	FunState HSPIEN;             //SPIʹܣʼʱдΪDISABLE
	FunState ERRIE;             //SPIжʹܣʼʱдΪDISABLE
	FunState TXIE;              //SPIжʹܣʼʱдΪDISABLE
	FunState RXIE;              //SPIжʹܣʼʱдΪDISABLE
}HSPI_Slave_InitTypeDef;

typedef struct
{
	//uint32_t DELAY_CFG        //masterģʽ¶Բλеʹøλֵ
	uint32_t BAUD_RATE;         ///* SETTING BAUD_RATE */	
    uint32_t LSBF;             	//ȷ͸λbitǵλbit/* SETTING 1 FOR LSB */		
    uint32_t CPHOL;			    //ʱӼѡ/* SETTING 1 FOR CLK STOP AT HIGH*/	
	uint32_t CPHA;				//ʱλѡ/* SETTING 1 FOR START AT SECOND CLK EDGE AND 0 FOR FIRST */
	uint32_t SSNM;				//ÿη8bit󱣳SSNΪͻߣSSNӲģʽЧ/* SETTING SSN AFTER SENDING */	
	uint32_t SSNSEN;			//SSNӲƻ/* SETTING 1 FOR CONTROL SSN BY SOFTWARE */

}HSPI_Master_SInitTypeDef;

typedef struct
{
	uint32_t DELAY_CFG;         //masterģʽ¶Բλе
	uint32_t WAIT;              //masterģʽ£ÿη8bitټ뼸sckڵĵȴʱ
	uint32_t BAUD_RATE;         ///* SETTING BAUD_RATE */	
    uint32_t LSBF;             	//ȷ͸λbitǵλbit/* SETTING 1 FOR LSB */		
    uint32_t CPHOL;			    //ʱӼѡ/* SETTING 1 FOR CLK STOP AT HIGH*/	
	uint32_t CPHA;				//ʱλѡ/* SETTING 1 FOR START AT SECOND CLK EDGE AND 0 FOR FIRST */
	FunState TXO;               //TXONLYģʽ
	uint32_t TXO_AC;            //TXONLYӲԶ
    uint32_t SSNM;				//ÿη8bit󱣳SSNΪͻߣSSNӲģʽЧ/* SETTING SSN AFTER SENDING */ 
	uint32_t SSNSEN;			//SSNӲƻ/* SETTING 1 FOR CONTROL SSN BY SOFTWARE */

	FunState HSPIEN;             //SPIʹܣʼʱдΪDISABLE
	FunState ERRIE;             //SPIжʹܣʼʱдΪDISABLE
	FunState TXIE;              //SPIжʹܣʼʱдΪDISABLE
	FunState RXIE;              //SPIжʹܣʼʱдΪDISABLE
}HSPI_Master_InitTypeDef;



#define	HSPI_SPICR1_DELAY_CFG_Pos	9	/* Masterģʽ£ڵղλSlaveģʽ£ڵλ */
#define	HSPI_SPICR1_DELAY_CFG_Msk	(0x7U << HSPI_SPICR1_DELAY_CFG_Pos)
#define	HSPI_SPICR1_DELAY_CFG_MASTER_NO_DELAY	(0x0U << HSPI_SPICR1_DELAY_CFG_Pos)	/* Masterģʽӳ */
#define	HSPI_SPICR1_DELAY_CFG_SLAVE_NORMAL	(0x0U << HSPI_SPICR1_DELAY_CFG_Pos)	/* Slaveģʽ */
#define	HSPI_SPICR1_DELAY_CFG_MASTER_DLY_L1	(0x1U << HSPI_SPICR1_DELAY_CFG_Pos)	/* Masterģʽ1ӳ */
#define	HSPI_SPICR1_DELAY_CFG_SLAVE_PHASE_1	(0x1U << HSPI_SPICR1_DELAY_CFG_Pos)	/* Slaveģʽλ1 */
#define	HSPI_SPICR1_DELAY_CFG_MASTER_DLY_L2	(0x2U << HSPI_SPICR1_DELAY_CFG_Pos)	/* Masterģʽ2ӳ */
#define	HSPI_SPICR1_DELAY_CFG_SLAVE_PHASE_2	(0x2U << HSPI_SPICR1_DELAY_CFG_Pos)	/* Slaveģʽλ2 */
#define	HSPI_SPICR1_DELAY_CFG_MASTER_DLY_L3	(0x3U << HSPI_SPICR1_DELAY_CFG_Pos)	/* Masterģʽ3ӳ */
#define	HSPI_SPICR1_DELAY_CFG_SLAVE_PHASE_3	(0x3U << HSPI_SPICR1_DELAY_CFG_Pos)	/* Slaveģʽλ3 */
#define	HSPI_SPICR1_DELAY_CFG_MASTER_DLY_L4	(0x4U << HSPI_SPICR1_DELAY_CFG_Pos)	/* Masterģʽ4ӳ */
#define	HSPI_SPICR1_DELAY_CFG_SLAVE_PHASE_4	(0x4U << HSPI_SPICR1_DELAY_CFG_Pos)	/* Slaveģʽλ4 */

#define	HSPI_SPICR1_MM_Pos	8	/* MASTER/SLAVEģʽѡ */
#define	HSPI_SPICR1_MM_Msk	(0x1U << HSPI_SPICR1_MM_Pos)
#define	HSPI_SPICR1_MM_SLAVE	(0x0U << HSPI_SPICR1_MM_Pos)	/* Slaveģʽ */
#define	HSPI_SPICR1_MM_MASTER	(0x1U << HSPI_SPICR1_MM_Pos)	/* Masterģʽ */

#define	HSPI_SPICR1_WAIT_Pos	6
#define	HSPI_SPICR1_WAIT_Msk	(0x3U << HSPI_SPICR1_WAIT_Pos)
#define	HSPI_SPICR1_WAIT_WAIT_1	(0x0U << HSPI_SPICR1_WAIT_Pos)	/* ÿ8bitټ1sckڵȴʱٴһ8Bit */
#define	HSPI_SPICR1_WAIT_WAIT_2	(0x1U << HSPI_SPICR1_WAIT_Pos)	/* ÿ8bitټ2sckڵȴʱٴһ8Bit */
#define	HSPI_SPICR1_WAIT_WAIT_3	(0x2U << HSPI_SPICR1_WAIT_Pos)	/* ÿ8bitټ3sckڵȴʱٴһ8Bit */
#define	HSPI_SPICR1_WAIT_WAIT_4	(0x3U << HSPI_SPICR1_WAIT_Pos)	/* ÿ8bitټ4sckڵȴʱٴһ8Bit */

#define	HSPI_SPICR1_BAUD_Pos	3	/* MASTERģʽ */
#define	HSPI_SPICR1_BAUD_Msk	(0x7U << HSPI_SPICR1_BAUD_Pos)
#define	HSPI_SPICR1_BAUD_PCLK	(0x0U << HSPI_SPICR1_BAUD_Pos)	/* ʱӲƵ */
#define	HSPI_SPICR1_BAUD_PCLK_2	(0x1U << HSPI_SPICR1_BAUD_Pos)	/* ʱ2Ƶ */
#define	HSPI_SPICR1_BAUD_PCLK_4	(0x2U << HSPI_SPICR1_BAUD_Pos)	/* ʱ4Ƶ */
#define	HSPI_SPICR1_BAUD_PCLK_8	(0x3U << HSPI_SPICR1_BAUD_Pos)	/* ʱ8Ƶ */
#define	HSPI_SPICR1_BAUD_PCLK_16	(0x4U << HSPI_SPICR1_BAUD_Pos)	/* ʱ16Ƶ */
#define	HSPI_SPICR1_BAUD_PCLK_32	(0x5U << HSPI_SPICR1_BAUD_Pos)	/* ʱ32Ƶ */
#define	HSPI_SPICR1_BAUD_PCLK_64	(0x6U << HSPI_SPICR1_BAUD_Pos)	/* ʱ64Ƶ */
#define	HSPI_SPICR1_BAUD_PCLK_128	(0x7U << HSPI_SPICR1_BAUD_Pos)	/* ʱ128Ƶ */

#define	HSPI_SPICR1_LSBF_Pos	2	/* ֡ʽ */
#define	HSPI_SPICR1_LSBF_Msk	(0x1U << HSPI_SPICR1_LSBF_Pos)
#define	HSPI_SPICR1_LSBF_MSB	(0x0U << HSPI_SPICR1_LSBF_Pos)	/* ȷMSB */
#define	HSPI_SPICR1_LSBF_LSB	(0x1U << HSPI_SPICR1_LSBF_Pos)	/* ȷLSB */

#define	HSPI_SPICR1_CPHOL_Pos	1	/* ʱӼѡ */
#define	HSPI_SPICR1_CPHOL_Msk	(0x1U << HSPI_SPICR1_CPHOL_Pos)
#define	HSPI_SPICR1_CPHOL_LOW	(0x0U << HSPI_SPICR1_CPHOL_Pos)	/* ʱֹͣڵ͵ƽ */
#define	HSPI_SPICR1_CPHOL_HIGH	(0x1U << HSPI_SPICR1_CPHOL_Pos)	/* ʱֹͣڸߵƽ */

#define	HSPI_SPICR1_CPHA_Pos	0	/* ʱλѡ */
#define	HSPI_SPICR1_CPHA_Msk	(0x1U << HSPI_SPICR1_CPHA_Pos)
#define	HSPI_SPICR1_CPHA_FIRST	(0x0U << HSPI_SPICR1_CPHA_Pos)	/* һʱӱǵһ׽ */
#define	HSPI_SPICR1_CPHA_SECOND	(0x1U << HSPI_SPICR1_CPHA_Pos)	/* ڶʱӱǵһ׽ */

#define	HSPI_SPICR2_FLTEN_Pos	6	/* Slaveܽ˲ʹܣSSN/SCK/MOSI */
#define	HSPI_SPICR2_FLTEN_Msk	(0x1U << HSPI_SPICR2_FLTEN_Pos)
	/* 0ʹ4ns˲ */
	/* 1ʹ4ns˲ */

#define	HSPI_SPICR2_SSNM_Pos	5	/* MasterģʽSSNģʽѡ */
#define	HSPI_SPICR2_SSNM_Msk	(0x1U << HSPI_SPICR2_SSNM_Pos)
#define	HSPI_SPICR2_SSNM_LOW	(0x0U << HSPI_SPICR2_SSNM_Pos)	/* ÿ8bitMasterSSNΪ */
#define	HSPI_SPICR2_SSNM_HIGH	(0x1U << HSPI_SPICR2_SSNM_Pos)	/* ÿ8bitMasterSSNάָߵƽʱWAITĴ */

#define	HSPI_SPICR2_TXO_AC_Pos	4	/* TXONLYӲԶյʹ */
#define	HSPI_SPICR2_TXO_AC_Msk	(0x1U << HSPI_SPICR2_TXO_AC_Pos)
#define	HSPI_SPICR2_TXO_AC_CLR_AT_CLOSE	(0x0U << HSPI_SPICR2_TXO_AC_Pos)	/* رTXONLYӲԶ */
#define	HSPI_SPICR2_TXO_AC_CLR_AT_TX	(0x1U << HSPI_SPICR2_TXO_AC_Pos)	/* TXONLYӲԶЧʹTXO󣬵ȴϺӲ */

#define	HSPI_SPICR2_TXO_Pos	3	/* TXONLYλ */
#define	HSPI_SPICR2_TXO_Msk	(0x1U << HSPI_SPICR2_TXO_Pos)
	/* 0رMasterĵģʽ */
	/* 1Masterĵģʽ */

#define	HSPI_SPICR2_SSN_Pos	2	/* Masterģʽ£ͨλSSNƽ */
#define	HSPI_SPICR2_SSN_Msk	(0x1U << HSPI_SPICR2_SSN_Pos)
#define	HSPI_SPICR2_SSN_LOW	(0x0U << HSPI_SPICR2_SSN_Pos)	/* SSN͵ƽ */
#define	HSPI_SPICR2_SSN_HIGH	(0x1U << HSPI_SPICR2_SSN_Pos)	/* SSNߵƽ */

#define	HSPI_SPICR2_SSNSEN_Pos	1	/* Masterģʽ£SSNĿƷʽ */
#define	HSPI_SPICR2_SSNSEN_Msk	(0x1U << HSPI_SPICR2_SSNSEN_Pos)
#define	HSPI_SPICR2_SSNSEN_HARD	(0x0U << HSPI_SPICR2_SSNSEN_Pos)	/* MasterģʽSSNӲԶ */
#define	HSPI_SPICR2_SSNSEN_SOFT	(0x1U << HSPI_SPICR2_SSNSEN_Pos)	/* MasterģʽSSN */

#define	HSPI_SPICR2_HSPIEN_Pos	0	/* HSPIʹ */
#define	HSPI_SPICR2_HSPIEN_Msk	(0x1U << HSPI_SPICR2_HSPIEN_Pos)
	/* 0رHSPI */
	/* 1ʹHSPI */

#define	HSPI_SPICR3_TXBFC_Pos	3
#define	HSPI_SPICR3_TXBFC_Msk	(0x1U << HSPI_SPICR3_TXBFC_Pos)

#define	HSPI_SPICR3_RXBFC_Pos	2
#define	HSPI_SPICR3_RXBFC_Msk	(0x1U << HSPI_SPICR3_RXBFC_Pos)

#define	HSPI_SPICR3_MERRC_Pos	1
#define	HSPI_SPICR3_MERRC_Msk	(0x1U << HSPI_SPICR3_MERRC_Pos)

#define	HSPI_SPICR3_SERRC_Pos	0
#define	HSPI_SPICR3_SERRC_Msk	(0x1U << HSPI_SPICR3_SERRC_Pos)

#define	HSPI_SPIIE_ERRIE_Pos	2
#define	HSPI_SPIIE_ERRIE_Msk	(0x1U << HSPI_SPIIE_ERRIE_Pos)
	/* 0HSPIжϲʹ */
	/* 1HSPIжʹ */

#define	HSPI_SPIIE_TXIE_Pos	1
#define	HSPI_SPIIE_TXIE_Msk	(0x1U << HSPI_SPIIE_TXIE_Pos)
	/* 0жϲʹ */
	/* 1жʹ */

#define	HSPI_SPIIE_RXIE_Pos	0
#define	HSPI_SPIIE_RXIE_Msk	(0x1U << HSPI_SPIIE_RXIE_Pos)
	/* 0жϲʹ */

#define	HSPI_SPIIF_MERR_Pos	6	/* Master Error־ */
#define	HSPI_SPIIF_MERR_Msk	(0x1U << HSPI_SPIIF_MERR_Pos)

#define	HSPI_SPIIF_SERR_Pos	5	/* Slave Error־ */
#define	HSPI_SPIIF_SERR_Msk	(0x1U << HSPI_SPIIF_SERR_Pos)

#define	HSPI_SPIIF_RXCOL_Pos	4	/* ջд1 */
#define	HSPI_SPIIF_RXCOL_Msk	(0x1U << HSPI_SPIIF_RXCOL_Pos)

#define	HSPI_SPIIF_TXCOL_Pos	3	/* ͻд1 */
#define	HSPI_SPIIF_TXCOL_Msk	(0x1U << HSPI_SPIIF_TXCOL_Pos)

#define	HSPI_SPIIF_BUSY_Pos	2	/* HSPIб־ֻ */
#define	HSPI_SPIIF_BUSY_Msk	(0x1U << HSPI_SPIIF_BUSY_Pos)

#define	HSPI_SPIIF_TXBE_Pos	1	/* TX Buffer Empty־λ */
#define	HSPI_SPIIF_TXBE_Msk	(0x1U << HSPI_SPIIF_TXBE_Pos)

#define	HSPI_SPIIF_RXBF_Pos	0	/* RX Buffer Full־λ */
#define	HSPI_SPIIF_RXBF_Msk	(0x1U << HSPI_SPIIF_RXBF_Pos)

#define	HSPI_SPITXBUF_TXBUF_Pos	0	/* SPIͻ */
#define	HSPI_SPITXBUF_TXBUF_Msk	(0xffU << HSPI_SPITXBUF_TXBUF_Pos)

#define	HSPI_SPIRXBUF_RXBUF_Pos	0	/* SPIջ */
#define	HSPI_SPIRXBUF_RXBUF_Msk	(0xffU << HSPI_SPIRXBUF_RXBUF_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void HSPI_Deinit(void);

/* Masterģʽ£ڵղλSlaveģʽ£ڵλ غ */
extern void HSPI_SPICR1_DELAY_CFG_Set(uint32_t SetValue);
extern uint32_t HSPI_SPICR1_DELAY_CFG_Get(void);

/* MASTER/SLAVEģʽѡ غ */
extern void HSPI_SPICR1_MM_Set(uint32_t SetValue);
extern uint32_t HSPI_SPICR1_MM_Get(void);
extern void HSPI_SPICR1_WAIT_Set(uint32_t SetValue);
extern uint32_t HSPI_SPICR1_WAIT_Get(void);

/* MASTERģʽ غ */
extern void HSPI_SPICR1_BAUD_Set(uint32_t SetValue);
extern uint32_t HSPI_SPICR1_BAUD_Get(void);

/* ֡ʽ غ */
extern void HSPI_SPICR1_LSBF_Set(uint32_t SetValue);
extern uint32_t HSPI_SPICR1_LSBF_Get(void);

/* ʱӼѡ غ */
extern void HSPI_SPICR1_CPHOL_Set(uint32_t SetValue);
extern uint32_t HSPI_SPICR1_CPHOL_Get(void);

/* ʱλѡ غ */
extern void HSPI_SPICR1_CPHA_Set(uint32_t SetValue);
extern uint32_t HSPI_SPICR1_CPHA_Get(void);

/* Slaveܽ˲ʹܣSSN/SCK/MOSI غ */
extern void HSPI_SPICR2_FLTEN_Setable(FunState NewState);
extern FunState HSPI_SPICR2_FLTEN_Getable(void);

/* MasterģʽSSNģʽѡ غ */
extern void HSPI_SPICR2_SSNM_Set(uint32_t SetValue);
extern uint32_t HSPI_SPICR2_SSNM_Get(void);

/* TXONLYӲԶյʹ غ */
extern void HSPI_SPICR2_TXO_AC_Set(uint32_t SetValue);
extern uint32_t HSPI_SPICR2_TXO_AC_Get(void);

/* TXONLYλ غ */
extern void HSPI_SPICR2_TXO_Setable(FunState NewState);
extern FunState HSPI_SPICR2_TXO_Getable(void);

/* Masterģʽ£ͨλSSNƽ غ */
extern void HSPI_SPICR2_SSN_Set(uint32_t SetValue);
extern uint32_t HSPI_SPICR2_SSN_Get(void);

/* Masterģʽ£SSNĿƷʽ غ */
extern void HSPI_SPICR2_SSNSEN_Set(uint32_t SetValue);
extern uint32_t HSPI_SPICR2_SSNSEN_Get(void);

/* HSPIʹ غ */
extern void HSPI_SPICR2_HSPIEN_Setable(FunState NewState);
extern FunState HSPI_SPICR2_HSPIEN_Getable(void);
extern void HSPI_SPICR3_TXBFC_Clr(void);
extern void HSPI_SPICR3_RXBFC_Clr(void);
extern void HSPI_SPICR3_MERRC_Clr(void);
extern void HSPI_SPICR3_SERRC_Clr(void);
extern void HSPI_SPIIE_ERRIE_Setable(FunState NewState);
extern FunState HSPI_SPIIE_ERRIE_Getable(void);
extern void HSPI_SPIIE_TXIE_Setable(FunState NewState);
extern FunState HSPI_SPIIE_TXIE_Getable(void);
extern void HSPI_SPIIE_RXIE_Setable(FunState NewState);
extern FunState HSPI_SPIIE_RXIE_Getable(void);

/* Master Error־ غ */
extern FlagStatus HSPI_SPIIF_MERR_Chk(void);

/* Slave Error־ غ */
extern FlagStatus HSPI_SPIIF_SERR_Chk(void);

/* ջд1 غ */
extern void HSPI_SPIIF_RXCOL_Clr(void);
extern FlagStatus HSPI_SPIIF_RXCOL_Chk(void);

/* ͻд1 غ */
extern void HSPI_SPIIF_TXCOL_Clr(void);
extern FlagStatus HSPI_SPIIF_TXCOL_Chk(void);

/* HSPIб־ֻ غ */
extern FlagStatus HSPI_SPIIF_BUSY_Chk(void);

/* TX Buffer Empty־λ غ */
extern FlagStatus HSPI_SPIIF_TXBE_Chk(void);

/* RX Buffer Full־λ غ */
extern FlagStatus HSPI_SPIIF_RXBF_Chk(void);

/* SPIͻ غ */
extern void HSPI_SPITXBUF_Write(uint32_t SetValue);
extern uint32_t HSPI_SPITXBUF_Read(void);

/* SPIջ غ */
extern void HSPI_SPIRXBUF_Write(uint32_t SetValue);
extern uint32_t HSPI_SPIRXBUF_Read(void);
//Announce_End

//Code_Start_HandBy
extern void HSPI_Master_Init(HSPI_Master_SInitTypeDef* para);

extern void HSPI_Slave_Init(HSPI_Slave_SInitTypeDef* para);

extern void HSPI_SSN_Set_Low(void);//

extern void HSPI_SSN_Set_High(void);//

extern uint8_t HSPI_Recv_Byte(void);//HSPIһֽ
extern void HSPI_Send_Byte(uint8_t data);//HSPIһֽ
extern uint8_t HSPI_RW_Byte(uint8_t data);//SPIͲһֽ

#ifdef __cplusplus
  }
#endif
  
#endif /* __FM33G0XX_SPI_H */
  
  
  
  /************************ (C) COPYRIGHT FMSHelectronics *****END OF FILE****/
  
  
  

