
/**
  ******************************************************************************
  * @file    fm33g0xx_lptim.h
  * @author  FM33g0xx Application Team
  * @version V0.3.01G
  * @date    01-21-2019
  * @brief   This file contains all the functions prototypes for the LPTIM firmware library.  
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __FM33G0XX_LPTIM_H
#define __FM33G0XX_LPTIM_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "FM33G0XX.h"
	 
/** @addtogroup FM33g0xx_StdPeriph_Driver
  * @{
  */

/** @addtogroup LPTIM
  * @{
  */ 

/* Exported constants --------------------------------------------------------*/

/** @defgroup LPTIM_Exported_Constants
  * @{
  */

/* Exported types ------------------------------------------------------------*/

/** 
  * @brief  LPTIM Init Structure definition  
  */ 

typedef struct
{
	uint32_t LPTIM_TMODE;  //ģʽ
	uint32_t LPTIM_MODE;  //ģʽ

	uint32_t LPTIM_PWM;   //ģʽ
	uint32_t LPTIM_POLAR; //ʱӼѡ

	uint32_t LPTIM_TRIG_CFG;  //ⲿѡ
	FunState LPTIM_FLTEN;  //ⲿ˲ʹ
	
	uint32_t LPTIM_LPTIN_EDGE;//LPTINѡ

	uint32_t LPTIM_CLK_SEL;  //ʱԴѡ
	uint32_t LPTIM_CLK_DIV;  //ʱӷƵѡ

	uint32_t LPTIM_compare_value;  //Ƚֵ
	uint32_t LPTIM_target_value;  //Ŀֵ

}LPTIM_InitTypeDef;



#define	LPTIM_LPTCFG_FLTEN_Pos	15	/* ⲿTrigger˲ʹ */
#define	LPTIM_LPTCFG_FLTEN_Msk	(0x1U << LPTIM_LPTCFG_FLTEN_Pos)
	/* 0˲ */
	/* 1˲ */

#define	LPTIM_LPTCFG_DIVSEL_Pos	10	/* ʱӷƵѡ */
#define	LPTIM_LPTCFG_DIVSEL_Msk	(0x7U << LPTIM_LPTCFG_DIVSEL_Pos)
#define	LPTIM_LPTCFG_DIVSEL_1	(0x0U << LPTIM_LPTCFG_DIVSEL_Pos)	/* ʱ1Ƶ */
#define	LPTIM_LPTCFG_DIVSEL_2	(0x1U << LPTIM_LPTCFG_DIVSEL_Pos)	/* ʱ2Ƶ */
#define	LPTIM_LPTCFG_DIVSEL_4	(0x2U << LPTIM_LPTCFG_DIVSEL_Pos)	/* ʱ4Ƶ */
#define	LPTIM_LPTCFG_DIVSEL_8	(0x3U << LPTIM_LPTCFG_DIVSEL_Pos)	/* ʱ8Ƶ */
#define	LPTIM_LPTCFG_DIVSEL_16	(0x4U << LPTIM_LPTCFG_DIVSEL_Pos)	/* ʱ16Ƶ */
#define	LPTIM_LPTCFG_DIVSEL_32	(0x5U << LPTIM_LPTCFG_DIVSEL_Pos)	/* ʱ32Ƶ */
#define	LPTIM_LPTCFG_DIVSEL_64	(0x6U << LPTIM_LPTCFG_DIVSEL_Pos)	/* ʱ64Ƶ */
#define	LPTIM_LPTCFG_DIVSEL_128	(0x7U << LPTIM_LPTCFG_DIVSEL_Pos)	/* ʱ128Ƶ */

#define	LPTIM_LPTCFG_CLKSEL_Pos	8	/* ʱԴѡ */
#define	LPTIM_LPTCFG_CLKSEL_Msk	(0x3U << LPTIM_LPTCFG_CLKSEL_Pos)
#define	LPTIM_LPTCFG_CLKSEL_LSCLK	(0x0U << LPTIM_LPTCFG_CLKSEL_Pos)	/* ʱԴѡLSCLKΪʱ */
#define	LPTIM_LPTCFG_CLKSEL_RCLP	(0x1U << LPTIM_LPTCFG_CLKSEL_Pos)	/* ʱԴѡRCLPΪʱ */
#define	LPTIM_LPTCFG_CLKSEL_PCLK	(0x2U << LPTIM_LPTCFG_CLKSEL_Pos)	/* ʱԴѡPCLKΪʱ */
#define	LPTIM_LPTCFG_CLKSEL_LPTIN	(0x3U << LPTIM_LPTCFG_CLKSEL_Pos)	/* ʱԴѡLPTINΪʱ */

#define	LPTIM_LPTCFG_EDGESEL_Pos	7	/* LPTINѡ */
#define	LPTIM_LPTCFG_EDGESEL_Msk	(0x1U << LPTIM_LPTCFG_EDGESEL_Pos)
#define	LPTIM_LPTCFG_EDGESEL_POS	(0x0U << LPTIM_LPTCFG_EDGESEL_Pos)	/* LPTINؼ */
#define	LPTIM_LPTCFG_EDGESEL_NEG	(0x1U << LPTIM_LPTCFG_EDGESEL_Pos)	/* LPTIN½ؼ */

#define	LPTIM_LPTCFG_TRIGCFG_Pos	5	/* ⲿѡ */
#define	LPTIM_LPTCFG_TRIGCFG_Msk	(0x3U << LPTIM_LPTCFG_TRIGCFG_Pos)
#define	LPTIM_LPTCFG_TRIGCFG_POS	(0x0U << LPTIM_LPTCFG_TRIGCFG_Pos)	/* ⲿźtrigger */
#define	LPTIM_LPTCFG_TRIGCFG_NEG	(0x1U << LPTIM_LPTCFG_TRIGCFG_Pos)	/* ⲿź½trigger */
#define	LPTIM_LPTCFG_TRIGCFG_POS_NEG	(0x2U << LPTIM_LPTCFG_TRIGCFG_Pos)	/* ⲿź½trigger */

#define	LPTIM_LPTCFG_POLARITY_Pos	4	/* μѡ */
#define	LPTIM_LPTCFG_POLARITY_Msk	(0x1U << LPTIM_LPTCFG_POLARITY_Pos)
#define	LPTIM_LPTCFG_POLARITY_POS	(0x0U << LPTIM_LPTCFG_POLARITY_Pos)	/* һμֵ=Ƚֵʱ */
#define	LPTIM_LPTCFG_POLARITY_NEG	(0x1U << LPTIM_LPTCFG_POLARITY_Pos)	/* һμֵ=Ƚֵʱ½ */

#define	LPTIM_LPTCFG_PWM_Pos	3	/* ģʽ */
#define	LPTIM_LPTCFG_PWM_Msk	(0x1U << LPTIM_LPTCFG_PWM_Pos)
#define	LPTIM_LPTCFG_PWM_TOGGLE	(0x0U << LPTIM_LPTCFG_PWM_Pos)	/* ڷģʽ */
#define	LPTIM_LPTCFG_PWM_PWM	(0x1U << LPTIM_LPTCFG_PWM_Pos)	/* PWMģʽ */

#define	LPTIM_LPTCFG_MODE_Pos	2	/* ģʽѡ */
#define	LPTIM_LPTCFG_MODE_Msk	(0x1U << LPTIM_LPTCFG_MODE_Pos)
#define	LPTIM_LPTCFG_MODE_CONTINUE	(0x0U << LPTIM_LPTCFG_MODE_Pos)	/* ģʽ */
#define	LPTIM_LPTCFG_MODE_SINGLE	(0x1U << LPTIM_LPTCFG_MODE_Pos)	/* μģʽ */

#define	LPTIM_LPTCFG_TMODE_Pos	0	/* ģʽѡ */
#define	LPTIM_LPTCFG_TMODE_Msk	(0x3U << LPTIM_LPTCFG_TMODE_Pos)
#define	LPTIM_LPTCFG_TMODE_PWMIM	(0x0U << LPTIM_LPTCFG_TMODE_Pos)	/* ͨʱģʽ */
#define	LPTIM_LPTCFG_TMODE_INTRIGGER	(0x1U << LPTIM_LPTCFG_TMODE_Pos)	/* Trigger崥ģʽ */
#define	LPTIM_LPTCFG_TMODE_EXTRIGGER	(0x2U << LPTIM_LPTCFG_TMODE_Pos)	/* ⲿ첽ģʽ */
#define	LPTIM_LPTCFG_TMODE_TIMEOUT	(0x3U << LPTIM_LPTCFG_TMODE_Pos)	/* Timeoutģʽ */

#define	LPTIM_LPTCNT_CNT16_Pos	0
#define	LPTIM_LPTCNT_CNT16_Msk	(0xffffU << LPTIM_LPTCNT_CNT16_Pos)

#define	LPTIM_LPTCMP_COMPARE_REG_Pos	0
#define	LPTIM_LPTCMP_COMPARE_REG_Msk	(0xffffU << LPTIM_LPTCMP_COMPARE_REG_Pos)

#define	LPTIM_LPTTARGET_TARGET_REG_Pos	0
#define	LPTIM_LPTTARGET_TARGET_REG_Msk	(0xffffU << LPTIM_LPTTARGET_TARGET_REG_Pos)

#define	LPTIM_LPTIE_TRIGIE_Pos	2	/* ⲿж */
#define	LPTIM_LPTIE_TRIGIE_Msk	(0x1U << LPTIM_LPTIE_TRIGIE_Pos)
	/* 0ⲿжϽֹ */
	/* 1ⲿжʹ */

#define	LPTIM_LPTIE_OVIE_Pos	1	/* ж */
#define	LPTIM_LPTIE_OVIE_Msk	(0x1U << LPTIM_LPTIE_OVIE_Pos)
	/* 0жϽֹ */
	/* 1жʹ */

#define	LPTIM_LPTIE_COMPIE_Pos	0	/* Ƚֵƥж */
#define	LPTIM_LPTIE_COMPIE_Msk	(0x1U << LPTIM_LPTIE_COMPIE_Pos)
	/* 0ֵͱȽֵƥжϽֹ */
	/* 1ֵͱȽֵƥжʹ */

#define	LPTIM_LPTIF_TRIGIF_Pos	2	/* ⲿ־ */
#define	LPTIM_LPTIF_TRIGIF_Msk	(0x1U << LPTIM_LPTIF_TRIGIF_Pos)

#define	LPTIM_LPTIF_OVIF_Pos	1	/* ־ */
#define	LPTIM_LPTIF_OVIF_Msk	(0x1U << LPTIM_LPTIF_OVIF_Pos)

#define	LPTIM_LPTIF_COMPIF_Pos	0	/* Ƚֵƥ־ */
#define	LPTIM_LPTIF_COMPIF_Msk	(0x1U << LPTIM_LPTIF_COMPIF_Pos)

#define	LPTIM_LPTCTRL_LPTEN_Pos	0	/* LPTʹ */
#define	LPTIM_LPTCTRL_LPTEN_Msk	(0x1U << LPTIM_LPTCTRL_LPTEN_Pos)
	/* 0ֹ */
	/* 1ʹܼ */
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void LPTIM_Deinit(void);

/* ⲿTrigger˲ʹ غ */
extern void LPTIM_LPTCFG_FLTEN_Setable(FunState NewState);
extern FunState LPTIM_LPTCFG_FLTEN_Getable(void);

/* ʱӷƵѡ غ */
extern void LPTIM_LPTCFG_DIVSEL_Set(uint32_t SetValue);
extern uint32_t LPTIM_LPTCFG_DIVSEL_Get(void);

/* ʱԴѡ غ */
extern void LPTIM_LPTCFG_CLKSEL_Set(uint32_t SetValue);
extern uint32_t LPTIM_LPTCFG_CLKSEL_Get(void);

/* LPTINѡ غ */
extern void LPTIM_LPTCFG_EDGESEL_Set(uint32_t SetValue);
extern uint32_t LPTIM_LPTCFG_EDGESEL_Get(void);

/* ⲿѡ غ */
extern void LPTIM_LPTCFG_TRIGCFG_Set(uint32_t SetValue);
extern uint32_t LPTIM_LPTCFG_TRIGCFG_Get(void);

/* μѡ غ */
extern void LPTIM_LPTCFG_POLARITY_Set(uint32_t SetValue);
extern uint32_t LPTIM_LPTCFG_POLARITY_Get(void);

/* ģʽ غ */
extern void LPTIM_LPTCFG_PWM_Set(uint32_t SetValue);
extern uint32_t LPTIM_LPTCFG_PWM_Get(void);

/* ģʽѡ غ */
extern void LPTIM_LPTCFG_MODE_Set(uint32_t SetValue);
extern uint32_t LPTIM_LPTCFG_MODE_Get(void);

/* ģʽѡ غ */
extern void LPTIM_LPTCFG_TMODE_Set(uint32_t SetValue);
extern uint32_t LPTIM_LPTCFG_TMODE_Get(void);
extern uint32_t LPTIM_LPTCNT_Read(void);
extern void LPTIM_LPTCMP_Write(uint32_t SetValue);
extern uint32_t LPTIM_LPTCMP_Read(void);
extern void LPTIM_LPTTARGET_Write(uint32_t SetValue);
extern uint32_t LPTIM_LPTTARGET_Read(void);

/* ⲿж غ */
extern void LPTIM_LPTIE_TRIGIE_Setable(FunState NewState);
extern FunState LPTIM_LPTIE_TRIGIE_Getable(void);

/* ж غ */
extern void LPTIM_LPTIE_OVIE_Setable(FunState NewState);
extern FunState LPTIM_LPTIE_OVIE_Getable(void);

/* Ƚֵƥж غ */
extern void LPTIM_LPTIE_COMPIE_Setable(FunState NewState);
extern FunState LPTIM_LPTIE_COMPIE_Getable(void);

/* ⲿ־ غ */
extern void LPTIM_LPTIF_TRIGIF_Clr(void);
extern FlagStatus LPTIM_LPTIF_TRIGIF_Chk(void);

/* ־ غ */
extern void LPTIM_LPTIF_OVIF_Clr(void);
extern FlagStatus LPTIM_LPTIF_OVIF_Chk(void);

/* Ƚֵƥ־ غ */
extern void LPTIM_LPTIF_COMPIF_Clr(void);
extern FlagStatus LPTIM_LPTIF_COMPIF_Chk(void);

/* LPTʹ غ */
extern void LPTIM_LPTCTRL_LPTEN_Setable(FunState NewState);
extern FunState LPTIM_LPTCTRL_LPTEN_Getable(void);
//Announce_End



void LPTIM_Init(LPTIM_InitTypeDef* para);



#ifdef __cplusplus
}
#endif

#endif /* __FM33G0XX_LPTIM_H */




