/**
  ******************************************************************************
  * @file    fm33g0xx_scu.h
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file contains all the functions prototypes for the SCU & DCU firmware library.  
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __FM33G0XX_SCU_H
#define __FM33G0XX_SCU_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "FM33G0XX.h"
	 
/** @addtogroup FM33g0xx_StdPeriph_Driver
  * @{
  */

/** @addtogroup SCU
  * @{
  */ 

/* Exported constants --------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
	 


#define	SCU_MCUDBGCR_DBG_ET4_STOP_Pos	13	/* Debug״̬ET4ʹܿ */
#define	SCU_MCUDBGCR_DBG_ET4_STOP_Msk	(0x1U << SCU_MCUDBGCR_DBG_ET4_STOP_Pos)
	/* 0DebugʱET4ԭ״̬ */
	/* 1DebugʱرET4 */

#define	SCU_MCUDBGCR_DBG_ET3_STOP_Pos	12	/* Debug״̬ET3ʹܿ */
#define	SCU_MCUDBGCR_DBG_ET3_STOP_Msk	(0x1U << SCU_MCUDBGCR_DBG_ET3_STOP_Pos)
	/* 0DebugʱET3ԭ״̬ */
	/* 1DebugʱرET3 */

#define	SCU_MCUDBGCR_DBG_ET2_STOP_Pos	11	/* Debug״̬ET2ʹܿ */
#define	SCU_MCUDBGCR_DBG_ET2_STOP_Msk	(0x1U << SCU_MCUDBGCR_DBG_ET2_STOP_Pos)
	/* 0DebugʱET2ԭ״̬ */
	/* 1DebugʱرET2 */

#define	SCU_MCUDBGCR_DBG_ET1_STOP_Pos	10	/* Debug״̬ET1ʹܿ */
#define	SCU_MCUDBGCR_DBG_ET1_STOP_Msk	(0x1U << SCU_MCUDBGCR_DBG_ET1_STOP_Pos)
	/* 0DebugʱET1ԭ״̬ */
	/* 1DebugʱرET1 */

#define	SCU_MCUDBGCR_DBG_BT2_STOP_Pos	9	/* Debug״̬BT2ʹܿ */
#define	SCU_MCUDBGCR_DBG_BT2_STOP_Msk	(0x1U << SCU_MCUDBGCR_DBG_BT2_STOP_Pos)
	/* 0DebugʱBT2ԭ״̬ */
	/* 1DebugʱرBT2 */

#define	SCU_MCUDBGCR_DBG_BT1_STOP_Pos	8	/* Debug״̬BT1ʹܿ */
#define	SCU_MCUDBGCR_DBG_BT1_STOP_Msk	(0x1U << SCU_MCUDBGCR_DBG_BT1_STOP_Pos)
	/* 0DebugʱBT1ԭ״̬ */
	/* 1DebugʱرBT1 */

#define	SCU_MCUDBGCR_DBG_WWDT_STOP_Pos	1	/* Debug״̬WWDTʹܿ */
#define	SCU_MCUDBGCR_DBG_WWDT_STOP_Msk	(0x1U << SCU_MCUDBGCR_DBG_WWDT_STOP_Pos)
	/* 0DebugʱWWDTԭ״̬ */
	/* 1DebugʱرWWDT */

#define	SCU_MCUDBGCR_DBG_IWDT_STOP_Pos	0	/* Debug״̬IWDTʹܿ */
#define	SCU_MCUDBGCR_DBG_IWDT_STOP_Msk	(0x1U << SCU_MCUDBGCR_DBG_IWDT_STOP_Pos)
	/* 0DebugʱIWDT */
	/* 1DebugʱرIWDT */

#define	SCU_HDFFLAG_DABORT_ADDR_FLAG_Pos	6	/* ַǶʴ־ */
#define	SCU_HDFFLAG_DABORT_ADDR_FLAG_Msk	(0x1U << SCU_HDFFLAG_DABORT_ADDR_FLAG_Pos)

#define	SCU_HDFFLAG_DABORT_RESP_FLAG_Pos	5	/* Ƿַʴ־ */
#define	SCU_HDFFLAG_DABORT_RESP_FLAG_Msk	(0x1U << SCU_HDFFLAG_DABORT_RESP_FLAG_Pos)

#define	SCU_HDFFLAG_SVCUNDEF_FLAG_Pos	4	/* SVC instructionsδ־ */
#define	SCU_HDFFLAG_SVCUNDEF_FLAG_Msk	(0x1U << SCU_HDFFLAG_SVCUNDEF_FLAG_Pos)

#define	SCU_HDFFLAG_BKPT_FLAG_Pos	3	/* ִBKPTָ־ */
#define	SCU_HDFFLAG_BKPT_FLAG_Msk	(0x1U << SCU_HDFFLAG_BKPT_FLAG_Pos)

#define	SCU_HDFFLAG_TBIT_FLAG_Pos	2	/* Thumb-State־ */
#define	SCU_HDFFLAG_TBIT_FLAG_Msk	(0x1U << SCU_HDFFLAG_TBIT_FLAG_Pos)

#define	SCU_HDFFLAG_SPECIAL_OP_FLAG_Pos	1	/* ָ־ */
#define	SCU_HDFFLAG_SPECIAL_OP_FLAG_Msk	(0x1U << SCU_HDFFLAG_SPECIAL_OP_FLAG_Pos)

#define	SCU_HDFFLAG_HDF_REQUEST_FLAG_Pos	0	/* hardfault־λ */
#define	SCU_HDFFLAG_HDF_REQUEST_FLAG_Msk	(0x1U << SCU_HDFFLAG_HDF_REQUEST_FLAG_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void SCU_Deinit(void);

/* Debug״̬ET4ʹܿ غ */
extern void SCU_MCUDBGCR_DBG_ET4_STOP_Setable(FunState NewState);
extern FunState SCU_MCUDBGCR_DBG_ET4_STOP_Getable(void);

/* Debug״̬ET3ʹܿ غ */
extern void SCU_MCUDBGCR_DBG_ET3_STOP_Setable(FunState NewState);
extern FunState SCU_MCUDBGCR_DBG_ET3_STOP_Getable(void);

/* Debug״̬ET2ʹܿ غ */
extern void SCU_MCUDBGCR_DBG_ET2_STOP_Setable(FunState NewState);
extern FunState SCU_MCUDBGCR_DBG_ET2_STOP_Getable(void);

/* Debug״̬ET1ʹܿ غ */
extern void SCU_MCUDBGCR_DBG_ET1_STOP_Setable(FunState NewState);
extern FunState SCU_MCUDBGCR_DBG_ET1_STOP_Getable(void);

/* Debug״̬BT2ʹܿ غ */
extern void SCU_MCUDBGCR_DBG_BT2_STOP_Setable(FunState NewState);
extern FunState SCU_MCUDBGCR_DBG_BT2_STOP_Getable(void);

/* Debug״̬BT1ʹܿ غ */
extern void SCU_MCUDBGCR_DBG_BT1_STOP_Setable(FunState NewState);
extern FunState SCU_MCUDBGCR_DBG_BT1_STOP_Getable(void);

/* Debug״̬WWDTʹܿ غ */
extern void SCU_MCUDBGCR_DBG_WWDT_STOP_Setable(FunState NewState);
extern FunState SCU_MCUDBGCR_DBG_WWDT_STOP_Getable(void);

/* Debug״̬IWDTʹܿ غ */
extern void SCU_MCUDBGCR_DBG_IWDT_STOP_Setable(FunState NewState);
extern FunState SCU_MCUDBGCR_DBG_IWDT_STOP_Getable(void);

/* ַǶʴ־ غ */
extern void SCU_HDFFLAG_DABORT_ADDR_FLAG_Clr(void);
extern FlagStatus SCU_HDFFLAG_DABORT_ADDR_FLAG_Chk(void);

/* Ƿַʴ־ غ */
extern void SCU_HDFFLAG_DABORT_RESP_FLAG_Clr(void);
extern FlagStatus SCU_HDFFLAG_DABORT_RESP_FLAG_Chk(void);

/* SVC instructionsδ־ غ */
extern void SCU_HDFFLAG_SVCUNDEF_FLAG_Clr(void);
extern FlagStatus SCU_HDFFLAG_SVCUNDEF_FLAG_Chk(void);

/* ִBKPTָ־ غ */
extern void SCU_HDFFLAG_BKPT_FLAG_Clr(void);
extern FlagStatus SCU_HDFFLAG_BKPT_FLAG_Chk(void);

/* Thumb-State־ غ */
extern void SCU_HDFFLAG_TBIT_FLAG_Clr(void);
extern FlagStatus SCU_HDFFLAG_TBIT_FLAG_Chk(void);

/* ָ־ غ */
extern void SCU_HDFFLAG_SPECIAL_OP_FLAG_Clr(void);
extern FlagStatus SCU_HDFFLAG_SPECIAL_OP_FLAG_Chk(void);

/* hardfault־λ غ */
extern void SCU_HDFFLAG_HDF_REQUEST_FLAG_Clr(void);
extern FlagStatus SCU_HDFFLAG_HDF_REQUEST_FLAG_Chk(void);
//Announce_End



#ifdef __cplusplus
}
#endif

#endif 



/************************ (C) COPYRIGHT FMSHelectronics *****END OF FILE****/



