/**
  ******************************************************************************
  * @file    fm33g0xx_spi.h
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file contains all the functions prototypes for the SPI firmware library.  
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __FM33G0XX_SPI_H
#define __FM33G0XX_SPI_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "FM33G0XX.h" 

/** @addtogroup FM33g0xx_StdPeriph_Driver
  * @{
  */

/** @addtogroup SPI
  * @{
  */ 

/* Exported constants --------------------------------------------------------*/

/** @defgroup SPI_Exported_Constants
  * @{
  */

/* Exported types ------------------------------------------------------------*/

/** 
  * @brief  SPI Init Structure definition  
  */ 


typedef struct
{
	//uint32_t SSPA;              //slaveģʽ¶Էʱеʹøλֵ/* SETTING SENING AHESD HALF CYCLE */
	//FunState FLTEN;             //slaveģʽʹ4ns˲/* SET PAD(SSN/SCK/MOSI) FILTER ENABLE AT SLAVE  */	
	uint32_t LSBF;             	//ȷ͸λbitǵλbit/* SETTING 1 FOR LSB */		
    uint32_t CPHOL;			    //ʱӼѡ/* SETTING 1 FOR CLK STOP AT HIGH*/	
	uint32_t CPHA;				//ʱλѡ/* SETTING 1 FOR START AT SECOND CLK EDGE AND 0 FOR FIRST */
}SPI_Slave_SInitTypeDef;

typedef struct
{
	uint32_t SSPA;				//slaveģʽ¶Էʱеǰ
	FunState FLTEN;             //slaveģʽʹ4ns˲/
	uint32_t LSBF;             	//ȷ͸λbitǵλbit/* SETTING 1 FOR LSB */		
    uint32_t CPHOL;			    //ʱӼѡ/* SETTING 1 FOR CLK STOP AT HIGH*/	
	uint32_t CPHA;				//ʱλѡ/* SETTING 1 FOR START AT SECOND CLK EDGE AND 0 FOR FIRST */
	FunState TXO;               //TXONLYģʽ
	uint32_t TXO_AC;            //TXONLYӲԶ

	FunState SPIEN;             //SPIʹܣʼʱдΪDISABLE
	FunState ERRIE;             //SPIжʹܣʼʱдΪDISABLE
	FunState TXIE;              //SPIжʹܣʼʱдΪDISABLE
	FunState RXIE;              //SPIжʹܣʼʱдΪDISABLE
}SPI_Slave_InitTypeDef;



typedef struct
{
	//uint32_t MSPA;			//masterģʽ¶Բеʹøλֵ/* SETTING SAMPLE DELAY HALF CYCLE */
    //uint32_t WAIT;          	//ÿη8bitټ뼸sckڵĵȴʱ䣬ʹøλֵ/* WAIT CYCLE BETWEEN TWO BYTE SENDING */	
    uint32_t BAUD_RATE;         ///* SETTING BAUD_RATE */	
    uint32_t LSBF;             	//ȷ͸λbitǵλbit/* SETTING 1 FOR LSB */		
    uint32_t CPHOL;			    //ʱӼѡ/* SETTING 1 FOR CLK STOP AT HIGH*/	
	uint32_t CPHA;				//ʱλѡ/* SETTING 1 FOR START AT SECOND CLK EDGE AND 0 FOR FIRST */
	uint32_t SSNM;				//ÿη8bit󱣳SSNΪͻߣSSNӲģʽЧ/* SETTING SSN AFTER SENDING */	
	uint32_t SSNSEN;			//SSNӲƻ/* SETTING 1 FOR CONTROL SSN BY SOFTWARE */

}SPI_Master_SInitTypeDef;

typedef struct
{
	uint32_t MSPA;              //masterģʽ¶Բе(ͺ)ڸͨʱPCBӳ
	uint32_t WAIT;              //masterģʽ£ÿη8bitټ뼸sckڵĵȴʱ
	uint32_t BAUD_RATE; 		///* SETTING BAUD_RATE */	
	uint32_t LSBF;				//ȷ͸λbitǵλbit/* SETTING 1 FOR LSB */		
	uint32_t CPHOL; 			//ʱӼѡ/* SETTING 1 FOR CLK STOP AT HIGH*/ 
	uint32_t CPHA;				//ʱλѡ/* SETTING 1 FOR START AT SECOND CLK EDGE AND 0 FOR FIRST */
	FunState TXO;               //TXONLYģʽ
	uint32_t TXO_AC;            //TXONLYӲԶ
	uint32_t SSNM;				//ÿη8bit󱣳SSNΪͻߣSSNӲģʽЧ/* SETTING SSN AFTER SENDING */ 
	uint32_t SSNSEN;			//SSNӲƻ/* SETTING 1 FOR CONTROL SSN BY SOFTWARE */

	FunState SPIEN;             //SPIʹܣʼʱдΪDISABLE
	FunState ERRIE;             //SPIжʹܣʼʱдΪDISABLE
	FunState TXIE;              //SPIжʹܣʼʱдΪDISABLE
	FunState RXIE;              //SPIжʹܣʼʱдΪDISABLE
	
}SPI_Master_InitTypeDef;





#define	SPIx_SPICR1_MSPA_Pos	10	/* MasterMISOźŵĲλõڸͨʱPCBӳ */
#define	SPIx_SPICR1_MSPA_Msk	(0x1U << SPIx_SPICR1_MSPA_Pos)
#define	SPIx_SPICR1_MSPA_NORMAL	(0x0U << SPIx_SPICR1_MSPA_Pos)	/* 㲻 */
#define	SPIx_SPICR1_MSPA_HALF_DELAY	(0x1U << SPIx_SPICR1_MSPA_Pos)	/* ӳٰSCK */

#define	SPIx_SPICR1_SSPA_Pos	9	/* Slave MISOλõ */
#define	SPIx_SPICR1_SSPA_Msk	(0x1U << SPIx_SPICR1_SSPA_Pos)
#define	SPIx_SPICR1_SSPA_NORMAL	(0x0U << SPIx_SPICR1_SSPA_Pos)	/* Ͳǰ */
#define	SPIx_SPICR1_SSPA_HALF_AHEAD	(0x1U << SPIx_SPICR1_SSPA_Pos)	/* ǰSCKڷ */

#define	SPIx_SPICR1_MM_Pos	8	/* MASTER/SLAVEģʽѡ */
#define	SPIx_SPICR1_MM_Msk	(0x1U << SPIx_SPICR1_MM_Pos)
#define	SPIx_SPICR1_MM_SLAVE	(0x0U << SPIx_SPICR1_MM_Pos)	/* Slaveģʽ */
#define	SPIx_SPICR1_MM_MASTER	(0x1U << SPIx_SPICR1_MM_Pos)	/* Masterģʽ */

#define	SPIx_SPICR1_WAIT_Pos	6
#define	SPIx_SPICR1_WAIT_Msk	(0x3U << SPIx_SPICR1_WAIT_Pos)
#define	SPIx_SPICR1_WAIT_WAIT_1	(0x0U << SPIx_SPICR1_WAIT_Pos)	/* ÿ8bitټ1sckڵȴʱٴһ8Bit */
#define	SPIx_SPICR1_WAIT_WAIT_2	(0x1U << SPIx_SPICR1_WAIT_Pos)	/* ÿ8bitټ2sckڵȴʱٴһ8Bit */
#define	SPIx_SPICR1_WAIT_WAIT_3	(0x2U << SPIx_SPICR1_WAIT_Pos)	/* ÿ8bitټ3sckڵȴʱٴһ8Bit */
#define	SPIx_SPICR1_WAIT_WAIT_4	(0x3U << SPIx_SPICR1_WAIT_Pos)	/* ÿ8bitټ4sckڵȴʱٴһ8Bit */

#define	SPIx_SPICR1_BAUD_Pos	3	/* MASTERģʽ */
#define	SPIx_SPICR1_BAUD_Msk	(0x7U << SPIx_SPICR1_BAUD_Pos)
#define	SPIx_SPICR1_BAUD_PCLK_2	(0x0U << SPIx_SPICR1_BAUD_Pos)	/* ʱ2Ƶ */
#define	SPIx_SPICR1_BAUD_PCLK_4	(0x1U << SPIx_SPICR1_BAUD_Pos)	/* ʱ4Ƶ */
#define	SPIx_SPICR1_BAUD_PCLK_8	(0x2U << SPIx_SPICR1_BAUD_Pos)	/* ʱ8Ƶ */
#define	SPIx_SPICR1_BAUD_PCLK_16	(0x3U << SPIx_SPICR1_BAUD_Pos)	/* ʱ16Ƶ */
#define	SPIx_SPICR1_BAUD_PCLK_32	(0x4U << SPIx_SPICR1_BAUD_Pos)	/* ʱ32Ƶ */
#define	SPIx_SPICR1_BAUD_PCLK_64	(0x5U << SPIx_SPICR1_BAUD_Pos)	/* ʱ64Ƶ */
#define	SPIx_SPICR1_BAUD_PCLK_128	(0x6U << SPIx_SPICR1_BAUD_Pos)	/* ʱ128Ƶ */
#define	SPIx_SPICR1_BAUD_PCLK_256	(0x7U << SPIx_SPICR1_BAUD_Pos)	/* ʱ256Ƶ */

#define	SPIx_SPICR1_LSBF_Pos	2	/* ֡ʽ */
#define	SPIx_SPICR1_LSBF_Msk	(0x1U << SPIx_SPICR1_LSBF_Pos)
#define	SPIx_SPICR1_LSBF_MSB	(0x0U << SPIx_SPICR1_LSBF_Pos)	/* ȷMSB */
#define	SPIx_SPICR1_LSBF_LSB	(0x1U << SPIx_SPICR1_LSBF_Pos)	/* ȷLSB */

#define	SPIx_SPICR1_CPHOL_Pos	1	/* ʱӼѡ */
#define	SPIx_SPICR1_CPHOL_Msk	(0x1U << SPIx_SPICR1_CPHOL_Pos)
#define	SPIx_SPICR1_CPHOL_LOW	(0x0U << SPIx_SPICR1_CPHOL_Pos)	/* ʱֹͣڵ͵ƽ */
#define	SPIx_SPICR1_CPHOL_HIGH	(0x1U << SPIx_SPICR1_CPHOL_Pos)	/* ʱֹͣڸߵƽ */

#define	SPIx_SPICR1_CPHA_Pos	0	/* ʱλѡ */
#define	SPIx_SPICR1_CPHA_Msk	(0x1U << SPIx_SPICR1_CPHA_Pos)
#define	SPIx_SPICR1_CPHA_FIRST	(0x0U << SPIx_SPICR1_CPHA_Pos)	/* һʱӱǵһ׽ */
#define	SPIx_SPICR1_CPHA_SECOND	(0x1U << SPIx_SPICR1_CPHA_Pos)	/* ڶʱӱǵһ׽ */

#define	SPIx_SPICR2_FLTEN_Pos	6	/* Slaveܽ˲ʹܣSSN/SCK/MOSI */
#define	SPIx_SPICR2_FLTEN_Msk	(0x1U << SPIx_SPICR2_FLTEN_Pos)
	/* 0ʹ4ns˲ */
	/* 1ʹ4ns˲ */

#define	SPIx_SPICR2_SSNM_Pos	5	/* MasterģʽSSNģʽѡ */
#define	SPIx_SPICR2_SSNM_Msk	(0x1U << SPIx_SPICR2_SSNM_Pos)
#define	SPIx_SPICR2_SSNM_LOW	(0x0U << SPIx_SPICR2_SSNM_Pos)	/* ÿ8bitMasterSSNΪ */
#define	SPIx_SPICR2_SSNM_HIGH	(0x1U << SPIx_SPICR2_SSNM_Pos)	/* ÿ8bitMasterSSNάָߵƽʱWAITĴ */

#define	SPIx_SPICR2_TXO_AC_Pos	4	/* TXONLYӲԶյʹ */
#define	SPIx_SPICR2_TXO_AC_Msk	(0x1U << SPIx_SPICR2_TXO_AC_Pos)
#define	SPIx_SPICR2_TXO_AC_CLR_AT_CLOSE	(0x0U << SPIx_SPICR2_TXO_AC_Pos)	/* رTXONLYӲԶ */
#define	SPIx_SPICR2_TXO_AC_CLR_AT_TX	(0x1U << SPIx_SPICR2_TXO_AC_Pos)	/* TXONLYӲԶЧʹTXO󣬵ȴϺӲ */

#define	SPIx_SPICR2_TXO_Pos	3	/* TXONLYλ */
#define	SPIx_SPICR2_TXO_Msk	(0x1U << SPIx_SPICR2_TXO_Pos)
	/* 0رMasterĵģʽ */
	/* 1Masterĵģʽ */

#define	SPIx_SPICR2_SSN_Pos	2	/* Masterģʽ£ͨλSSNƽ */
#define	SPIx_SPICR2_SSN_Msk	(0x1U << SPIx_SPICR2_SSN_Pos)
#define	SPIx_SPICR2_SSN_LOW	(0x0U << SPIx_SPICR2_SSN_Pos)	/* SSN͵ƽ */
#define	SPIx_SPICR2_SSN_HIGH	(0x1U << SPIx_SPICR2_SSN_Pos)	/* SSNߵƽ */

#define	SPIx_SPICR2_SSNSEN_Pos	1	/* Masterģʽ£SSNĿƷʽ */
#define	SPIx_SPICR2_SSNSEN_Msk	(0x1U << SPIx_SPICR2_SSNSEN_Pos)
#define	SPIx_SPICR2_SSNSEN_HARD	(0x0U << SPIx_SPICR2_SSNSEN_Pos)	/* MasterģʽSSNӲԶ */
#define	SPIx_SPICR2_SSNSEN_SOFT	(0x1U << SPIx_SPICR2_SSNSEN_Pos)	/* MasterģʽSSN */

#define	SPIx_SPICR2_SPIEN_Pos	0	/* SPIʹ */
#define	SPIx_SPICR2_SPIEN_Msk	(0x1U << SPIx_SPICR2_SPIEN_Pos)
	/* 0رSPI */
	/* 1ʹSPI */

#define	SPIx_SPICR3_TXBFC_Pos	3
#define	SPIx_SPICR3_TXBFC_Msk	(0x1U << SPIx_SPICR3_TXBFC_Pos)

#define	SPIx_SPICR3_RXBFC_Pos	2
#define	SPIx_SPICR3_RXBFC_Msk	(0x1U << SPIx_SPICR3_RXBFC_Pos)

#define	SPIx_SPICR3_MERRC_Pos	1
#define	SPIx_SPICR3_MERRC_Msk	(0x1U << SPIx_SPICR3_MERRC_Pos)

#define	SPIx_SPICR3_SERRC_Pos	0
#define	SPIx_SPICR3_SERRC_Msk	(0x1U << SPIx_SPICR3_SERRC_Pos)

#define	SPIx_SPIIE_ERRIE_Pos	2
#define	SPIx_SPIIE_ERRIE_Msk	(0x1U << SPIx_SPIIE_ERRIE_Pos)
	/* 0HSPIжϲʹ */
	/* 1HSPIжʹ */

#define	SPIx_SPIIE_TXIE_Pos	1
#define	SPIx_SPIIE_TXIE_Msk	(0x1U << SPIx_SPIIE_TXIE_Pos)
	/* 0жϲʹ */
	/* 1жʹ */

#define	SPIx_SPIIE_RXIE_Pos	0
#define	SPIx_SPIIE_RXIE_Msk	(0x1U << SPIx_SPIIE_RXIE_Pos)
	/* 0жϲʹ */
	/* 1жʹ */

#define	SPIx_SPIIF_MERR_Pos	6	/* Master Error־ */
#define	SPIx_SPIIF_MERR_Msk	(0x1U << SPIx_SPIIF_MERR_Pos)

#define	SPIx_SPIIF_SERR_Pos	5	/* Slave Error־ */
#define	SPIx_SPIIF_SERR_Msk	(0x1U << SPIx_SPIIF_SERR_Pos)

#define	SPIx_SPIIF_RXCOL_Pos	4	/* ջд1 */
#define	SPIx_SPIIF_RXCOL_Msk	(0x1U << SPIx_SPIIF_RXCOL_Pos)

#define	SPIx_SPIIF_TXCOL_Pos	3	/* ͻд1 */
#define	SPIx_SPIIF_TXCOL_Msk	(0x1U << SPIx_SPIIF_TXCOL_Pos)

#define	SPIx_SPIIF_BUSY_Pos	2	/* SPIб־ֻ */
#define	SPIx_SPIIF_BUSY_Msk	(0x1U << SPIx_SPIIF_BUSY_Pos)

#define	SPIx_SPIIF_TXBE_Pos	1	/* TX Buffer Empty־λ */
#define	SPIx_SPIIF_TXBE_Msk	(0x1U << SPIx_SPIIF_TXBE_Pos)

#define	SPIx_SPIIF_RXBF_Pos	0	/* RX Buffer Full־λ */
#define	SPIx_SPIIF_RXBF_Msk	(0x1U << SPIx_SPIIF_RXBF_Pos)

#define	SPIx_SPITXBUF_TXBUF_Pos	0	/* SPIͻ */
#define	SPIx_SPITXBUF_TXBUF_Msk	(0xffU << SPIx_SPITXBUF_TXBUF_Pos)

#define	SPIx_SPIRXBUF_RXBUF_Pos	0	/* SPIջ */
#define	SPIx_SPIRXBUF_RXBUF_Msk	(0xffU << SPIx_SPIRXBUF_RXBUF_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void SPIx_Deinit(SPIx_Type* SPIx);

/* MasterMISOźŵĲλõڸͨʱPCBӳ غ */
extern void SPIx_SPICR1_MSPA_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_MSPA_Get(SPIx_Type* SPIx);

/* Slave MISOλõ غ */
extern void SPIx_SPICR1_SSPA_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_SSPA_Get(SPIx_Type* SPIx);

/* MASTER/SLAVEģʽѡ غ */
extern void SPIx_SPICR1_MM_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_MM_Get(SPIx_Type* SPIx);
extern void SPIx_SPICR1_WAIT_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_WAIT_Get(SPIx_Type* SPIx);

/* MASTERģʽ غ */
extern void SPIx_SPICR1_BAUD_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_BAUD_Get(SPIx_Type* SPIx);

/* ֡ʽ غ */
extern void SPIx_SPICR1_LSBF_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_LSBF_Get(SPIx_Type* SPIx);

/* ʱӼѡ غ */
extern void SPIx_SPICR1_CPHOL_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_CPHOL_Get(SPIx_Type* SPIx);

/* ʱλѡ غ */
extern void SPIx_SPICR1_CPHA_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_CPHA_Get(SPIx_Type* SPIx);

/* Slaveܽ˲ʹܣSSN/SCK/MOSI غ */
extern void SPIx_SPICR2_FLTEN_Setable(SPIx_Type* SPIx, FunState NewState);
extern FunState SPIx_SPICR2_FLTEN_Getable(SPIx_Type* SPIx);

/* MasterģʽSSNģʽѡ غ */
extern void SPIx_SPICR2_SSNM_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR2_SSNM_Get(SPIx_Type* SPIx);

/* TXONLYӲԶյʹ غ */
extern void SPIx_SPICR2_TXO_AC_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR2_TXO_AC_Get(SPIx_Type* SPIx);

/* TXONLYλ غ */
extern void SPIx_SPICR2_TXO_Setable(SPIx_Type* SPIx, FunState NewState);
extern FunState SPIx_SPICR2_TXO_Getable(SPIx_Type* SPIx);

/* Masterģʽ£ͨλSSNƽ غ */
extern void SPIx_SPICR2_SSN_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR2_SSN_Get(SPIx_Type* SPIx);

/* Masterģʽ£SSNĿƷʽ غ */
extern void SPIx_SPICR2_SSNSEN_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR2_SSNSEN_Get(SPIx_Type* SPIx);

/* SPIʹ غ */
extern void SPIx_SPICR2_SPIEN_Setable(SPIx_Type* SPIx, FunState NewState);
extern FunState SPIx_SPICR2_SPIEN_Getable(SPIx_Type* SPIx);
extern void SPIx_SPICR3_TXBFC_Clr(SPIx_Type* SPIx);
extern void SPIx_SPICR3_RXBFC_Clr(SPIx_Type* SPIx);
extern void SPIx_SPICR3_MERRC_Clr(SPIx_Type* SPIx);
extern void SPIx_SPICR3_SERRC_Clr(SPIx_Type* SPIx);
extern void SPIx_SPIIE_ERRIE_Setable(SPIx_Type* SPIx, FunState NewState);
extern FunState SPIx_SPIIE_ERRIE_Getable(SPIx_Type* SPIx);
extern void SPIx_SPIIE_TXIE_Setable(SPIx_Type* SPIx, FunState NewState);
extern FunState SPIx_SPIIE_TXIE_Getable(SPIx_Type* SPIx);
extern void SPIx_SPIIE_RXIE_Setable(SPIx_Type* SPIx, FunState NewState);
extern FunState SPIx_SPIIE_RXIE_Getable(SPIx_Type* SPIx);

/* Master Error־ غ */
extern FlagStatus SPIx_SPIIF_MERR_Chk(SPIx_Type* SPIx);

/* Slave Error־ غ */
extern FlagStatus SPIx_SPIIF_SERR_Chk(SPIx_Type* SPIx);

/* ջд1 غ */
extern void SPIx_SPIIF_RXCOL_Clr(SPIx_Type* SPIx);
extern FlagStatus SPIx_SPIIF_RXCOL_Chk(SPIx_Type* SPIx);

/* ͻд1 غ */
extern void SPIx_SPIIF_TXCOL_Clr(SPIx_Type* SPIx);
extern FlagStatus SPIx_SPIIF_TXCOL_Chk(SPIx_Type* SPIx);

/* SPIб־ֻ غ */
extern FlagStatus SPIx_SPIIF_BUSY_Chk(SPIx_Type* SPIx);

/* TX Buffer Empty־λ غ */
extern FlagStatus SPIx_SPIIF_TXBE_Chk(SPIx_Type* SPIx);

/* RX Buffer Full־λ غ */
extern FlagStatus SPIx_SPIIF_RXBF_Chk(SPIx_Type* SPIx);

/* SPIͻ غ */
extern void SPIx_SPITXBUF_Write(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPITXBUF_Read(SPIx_Type* SPIx);

/* SPIջ غ */
extern void SPIx_SPIRXBUF_Write(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPIRXBUF_Read(SPIx_Type* SPIx);
//Announce_End


/* Exported functions --------------------------------------------------------*/ 
extern void SPIx_Deinit(SPIx_Type* SPIx);

/* MasterMISOźŵĲλõڸͨʱPCBӳ غ */
extern void SPIx_SPICR1_MSPA_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_MSPA_Get(SPIx_Type* SPIx);

/* Slave MISOλõ غ */
extern void SPIx_SPICR1_SSPA_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_SSPA_Get(SPIx_Type* SPIx);

/* MASTER/SLAVEģʽѡ غ */
extern void SPIx_SPICR1_MM_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_MM_Get(SPIx_Type* SPIx);
extern void SPIx_SPICR1_WAIT_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_WAIT_Get(SPIx_Type* SPIx);

/* MASTERģʽ غ */
extern void SPIx_SPICR1_BAUD_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_BAUD_Get(SPIx_Type* SPIx);

/* ֡ʽ غ */
extern void SPIx_SPICR1_LSBF_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_LSBF_Get(SPIx_Type* SPIx);

/* ʱӼѡ غ */
extern void SPIx_SPICR1_CPHOL_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_CPHOL_Get(SPIx_Type* SPIx);

/* ʱλѡ غ */
extern void SPIx_SPICR1_CPHA_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR1_CPHA_Get(SPIx_Type* SPIx);

/* Slaveܽ˲ʹܣSSN/SCK/MOSI غ */
extern void SPIx_SPICR2_FLTEN_Setable(SPIx_Type* SPIx, FunState NewState);
extern FunState SPIx_SPICR2_FLTEN_Getable(SPIx_Type* SPIx);

/* MasterģʽSSNģʽѡ غ */
extern void SPIx_SPICR2_SSNM_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR2_SSNM_Get(SPIx_Type* SPIx);

/* TXONLYӲԶյʹ غ */
extern void SPIx_SPICR2_TXO_AC_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR2_TXO_AC_Get(SPIx_Type* SPIx);

/* TXONLYλ غ */
extern void SPIx_SPICR2_TXO_Setable(SPIx_Type* SPIx, FunState NewState);
extern FunState SPIx_SPICR2_TXO_Getable(SPIx_Type* SPIx);

/* Masterģʽ£ͨλSSNƽ غ */
extern void SPIx_SPICR2_SSN_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR2_SSN_Get(SPIx_Type* SPIx);

/* Masterģʽ£SSNĿƷʽ غ */
extern void SPIx_SPICR2_SSNSEN_Set(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPICR2_SSNSEN_Get(SPIx_Type* SPIx);

/* SPIʹ غ */
extern void SPIx_SPICR2_SPIEN_Setable(SPIx_Type* SPIx, FunState NewState);
extern FunState SPIx_SPICR2_SPIEN_Getable(SPIx_Type* SPIx);
extern void SPIx_SPICR3_TXBFC_Clr(SPIx_Type* SPIx);
extern void SPIx_SPICR3_RXBFC_Clr(SPIx_Type* SPIx);
extern void SPIx_SPICR3_MERRC_Clr(SPIx_Type* SPIx);
extern void SPIx_SPICR3_SERRC_Clr(SPIx_Type* SPIx);
extern void SPIx_SPIIE_ERRIE_Setable(SPIx_Type* SPIx, FunState NewState);
extern FunState SPIx_SPIIE_ERRIE_Getable(SPIx_Type* SPIx);
extern void SPIx_SPIIE_TXIE_Setable(SPIx_Type* SPIx, FunState NewState);
extern FunState SPIx_SPIIE_TXIE_Getable(SPIx_Type* SPIx);
extern void SPIx_SPIIE_RXIE_Setable(SPIx_Type* SPIx, FunState NewState);
extern FunState SPIx_SPIIE_RXIE_Getable(SPIx_Type* SPIx);

/* Master Error־ غ */
extern FlagStatus SPIx_SPIIF_MERR_Chk(SPIx_Type* SPIx);

/* Slave Error־ غ */
extern FlagStatus SPIx_SPIIF_SERR_Chk(SPIx_Type* SPIx);

/* ջд1 غ */
extern void SPIx_SPIIF_RXCOL_Clr(SPIx_Type* SPIx);
extern FlagStatus SPIx_SPIIF_RXCOL_Chk(SPIx_Type* SPIx);

/* ͻд1 غ */
extern void SPIx_SPIIF_TXCOL_Clr(SPIx_Type* SPIx);
extern FlagStatus SPIx_SPIIF_TXCOL_Chk(SPIx_Type* SPIx);

/* SPIб־ֻ غ */
extern FlagStatus SPIx_SPIIF_BUSY_Chk(SPIx_Type* SPIx);

/* TX Buffer Empty־λ غ */
extern FlagStatus SPIx_SPIIF_TXBE_Chk(SPIx_Type* SPIx);

/* RX Buffer Full־λ غ */
extern FlagStatus SPIx_SPIIF_RXBF_Chk(SPIx_Type* SPIx);

/* SPIͻ غ */
extern void SPIx_SPITXBUF_Write(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPITXBUF_Read(SPIx_Type* SPIx);

/* SPIջ غ */
extern void SPIx_SPIRXBUF_Write(SPIx_Type* SPIx, uint32_t SetValue);
extern uint32_t SPIx_SPIRXBUF_Read(SPIx_Type* SPIx);
//Announce_End


//Announce_HandBy
extern void SPI_Master_Init(SPIx_Type* SPIx, SPI_Master_SInitTypeDef* para);
extern void SPI_Slave_Init(SPIx_Type* SPIx, SPI_Slave_SInitTypeDef* para);

extern void SPI_SSN_Set_Low(SPIx_Type* SPIx);//SSNõ
extern void SPI_SSN_Set_High(SPIx_Type* SPIx);//SSNø

extern uint8_t SPI_Recv_Byte(SPIx_Type* SPIx);//SPIһֽ
extern void SPI_Send_Byte(SPIx_Type* SPIx, uint8_t data);//SPIһֽ

extern uint8_t SPI_RW_Byte(SPIx_Type* SPIx, uint8_t data);//SPIͲһֽ
//Announce_End


#ifdef __cplusplus
}
#endif

#endif /* __FM33G0XX_SPI_H */



/************************ (C) COPYRIGHT FMSHelectronics *****END OF FILE****/











