/**
  ******************************************************************************
  * @file    fm33g0xx_u7816.h
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file contains all the functions prototypes for the U7816 firmware library.  
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __FM33G0XX_U7816_H
#define __FM33G0XX_U7816_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "FM33G0XX.h"

/** @addtogroup FM33g0xx_StdPeriph_Driver
  * @{
  */


	 
/* Exported constants --------------------------------------------------------*/

/** @defgroup U7816_Exported_Constants
  * @{
  */	 
/* Exported types ------------------------------------------------------------*/


typedef struct
{
	FunState				TXEN;		//ʹ
	FunState				RXEN;		//ʹ
	FunState				CKOEN;		//U7816ʱCLKʹܿ
	FunState				HPUAT;		//U7816ͨݷǿԶЧ
	FunState				HPUEN;		//U7816ͨǿʹܿ
	
	uint32_t				ERSW;		//ERROR SIGNALѡ
	uint32_t				ERSGD;		//ERROR SIGNALGUARDTIMEѡ񣨽ڷʱЧ
	FunState				BGTEN;		//BGTblock guard time
	uint32_t				REP_T;		//ƽżУʱԶط
	uint32_t				PAR;		//żУѡ
	FunState				FREN;		//Guard TimeȿλʱϸЭ2etu
	FunState				TREPEN;		//żУĴʽѡ
	FunState				RREPEN;		//żУĴʽѡ
	FunState				DICONV;		//ʹ
	
	uint32_t				TXEGT;		//ʱEGTʱ䣨ETUΪλ
	uint32_t				CLKDIV;		//U7816ʱƵƼĴ
	uint32_t				PDIV;		//U7816ԤƵƼĴ7816ͨŷƵȣʣ
	
	FunState				RXIE;		//ݽжʹλӦRX_FLAGжϱ־λ
	FunState				TXIE;		//ݷжʹλӦTX_FLAGжϱ־λ
	FunState				LSIE;		//·״̬жʹλӦERROR_FLAGжϱ־λ
	
}U7816_InitTypeDef;



#define	U7816x_U7816CTRL_TXEN_Pos	5	/* U7816ͨʹܿ */
#define	U7816x_U7816CTRL_TXEN_Msk	(0x1U << U7816x_U7816CTRL_TXEN_Pos)
	/* 0 = ͨͽֹɷݣض˿ */
	/* 1 = ͨʹܣɷ */

#define	U7816x_U7816CTRL_RXEN_Pos	4	/* U7816ͨʹܿ */
#define	U7816x_U7816CTRL_RXEN_Msk	(0x1U << U7816x_U7816CTRL_RXEN_Pos)
	/* 0 = ͨսֹɽݣض˿ */
	/* 1 = ͨʹܣɽ */

#define	U7816x_U7816CTRL_CKOEN_Pos	3	/* U7816ʱCLKʹܿ */
#define	U7816x_U7816CTRL_CKOEN_Msk	(0x1U << U7816x_U7816CTRL_CKOEN_Pos)
	/* 0 = 7816ʱֹ */
	/* 1 = 7816ʱʹ */

#define	U7816x_U7816CTRL_HPUAT_Pos	2	/* U7816ͨݷǿԶЧ */
#define	U7816x_U7816CTRL_HPUAT_Msk	(0x1U << U7816x_U7816CTRL_HPUAT_Pos)
	/* 0 = ݷʱԶЧֹܽHPUENLPUEN */
	/* 1 = ݷʱԶЧ̬Ч */

#define	U7816x_U7816CTRL_HPUEN_Pos	1	/* U7816ͨǿʹܿ */
#define	U7816x_U7816CTRL_HPUEN_Msk	(0x1U << U7816x_U7816CTRL_HPUEN_Pos)
	/* 0 = ǿЧ */
	/* 1 = ǿЧ */

#define	U7816x_U7816FRC_ERSW_Pos	9	/* ERROR SIGNALѡ */
#define	U7816x_U7816FRC_ERSW_Msk	(0x3U << U7816x_U7816FRC_ERSW_Pos)
#define	U7816x_U7816FRC_ERSW_1ETU	(0x3U << U7816x_U7816FRC_ERSW_Pos)	/* 11 = ERROR SIGNALΪ1ETU; */
#define	U7816x_U7816FRC_ERSW_1P5ETU	(0x2U << U7816x_U7816FRC_ERSW_Pos)	/* 10 = ERROR SIGNALΪ1.5ETU; */
#define	U7816x_U7816FRC_ERSW_2ETU	(0x0U << U7816x_U7816FRC_ERSW_Pos)	/* 01/00 = ERROR SIGNALΪ2ETU; */

#define	U7816x_U7816FRC_ERSGD_Pos	8	/* ERROR SIGNALGUARDTIMEѡ񣨽ڷʱЧ */
#define	U7816x_U7816FRC_ERSGD_Msk	(0x1U << U7816x_U7816FRC_ERSGD_Pos)
#define	U7816x_U7816FRC_ERSGD_1PETU	(0x1U << U7816x_U7816FRC_ERSGD_Pos)	/* 1 = ERROR SIGNALGUARDTIMEΪ1~1.5ETU */
#define	U7816x_U7816FRC_ERSGD_2PETU	(0x0U << U7816x_U7816FRC_ERSGD_Pos)	/* 0 = ERROR SIGNALGUARDTIMEΪ2~2.5ETU */

#define	U7816x_U7816FRC_BGTEN_Pos	7	/* BGTblock guard time */
#define	U7816x_U7816FRC_BGTEN_Msk	(0x1U << U7816x_U7816FRC_BGTEN_Pos)
	/* 0 = BGTֹBlock guard time(22 etu); */
	/* 1 = BGTʹܣBlock guard time(22 etu); */

#define	U7816x_U7816FRC_REP_T_Pos	6	/* ƽżУʱԶط */
#define	U7816x_U7816FRC_REP_T_Msk	(0x1U << U7816x_U7816FRC_REP_T_Pos)
#define	U7816x_U7816FRC_REP_T_1TIME	(0x0U << U7816x_U7816FRC_REP_T_Pos)	/* 0 = 1 */
#define	U7816x_U7816FRC_REP_T_3TIME	(0x1U << U7816x_U7816FRC_REP_T_Pos)	/* 1 = 3 */

#define	U7816x_U7816FRC_PAR_Pos	4	/* żУѡ */
#define	U7816x_U7816FRC_PAR_Msk	(0x3U << U7816x_U7816FRC_PAR_Pos)
#define	U7816x_U7816FRC_PAR_EVEN	(0x0U << U7816x_U7816FRC_PAR_Pos)	/* 00Even */
#define	U7816x_U7816FRC_PAR_ODD	(0x1U << U7816x_U7816FRC_PAR_Pos)	/* 01Odd */
#define	U7816x_U7816FRC_PAR_ALWAYS1	(0x2U << U7816x_U7816FRC_PAR_Pos)	/* 10Always 1 */
#define	U7816x_U7816FRC_PAR_NONE	(0x3U << U7816x_U7816FRC_PAR_Pos)	/* 11У飬 */

#define	U7816x_U7816FRC_FREN_Pos	3	/* Guard TimeȿλʱϸЭ2etu */
#define	U7816x_U7816FRC_FREN_Msk	(0x1U << U7816x_U7816FRC_FREN_Pos)
	/* 0 = Guard timeΪ2 etu */
	/* 1 = Guard timeΪ1 etu */

#define	U7816x_U7816FRC_TREPEN_Pos	2	/* żУĴʽѡ */
#define	U7816x_U7816FRC_TREPEN_Msk	(0x1U << U7816x_U7816FRC_TREPEN_Pos)
	/* 0 = յError signalʱԶطtx_parity_err־ֱж */
	/* 1 = յżУ־error signalT0ЭԶлطڵһbyteظʹREP_Ttx_parity_err־ж */

#define	U7816x_U7816FRC_RREPEN_Pos	1	/* żУĴʽѡ */
#define	U7816x_U7816FRC_RREPEN_Msk	(0x1U << U7816x_U7816FRC_RREPEN_Pos)
	/* 0 = żУԶERROR SIGNALRX_PARITY_ERR־ж */
	/* 1 = żУT=0ЭԶطERROR SIGNALһBYTEմREP_TRX_PARITY_ERR־ж */

#define	U7816x_U7816FRC_DICONV_Pos	0	/* ʹ */
#define	U7816x_U7816FRC_DICONV_Msk	(0x1U << U7816x_U7816FRC_DICONV_Pos)
	/* 0 = 룬շLSB  (շ+Уλ)߼ƽ */
	/* 1 = 룬շMSB(շ+Уλ)߼ƽ */

#define	U7816x_U7816EGT_TXEGT_Pos	0	/* ʱEGTʱ䣨ETUΪλ */
#define	U7816x_U7816EGT_TXEGT_Msk	(0xffU << U7816x_U7816EGT_TXEGT_Pos)

#define	U7816x_U7816CLKDIV_CLKDIV_Pos	0	/* U7816ʱƵƼĴ */
#define	U7816x_U7816CLKDIV_CLKDIV_Msk	(0x1fU << U7816x_U7816CLKDIV_CLKDIV_Pos)

#define	U7816x_U7816PDIV_PDIV_Pos	0	/* U7816ԤƵƼĴ7816ͨŷƵȣʣ */
#define	U7816x_U7816PDIV_PDIV_Msk	(0xfffU << U7816x_U7816PDIV_PDIV_Pos)

#define	U7816x_U7816RXBUF_RXBUF_Pos	0	/* U7816ݽջĴ */
#define	U7816x_U7816RXBUF_RXBUF_Msk	(0xffU << U7816x_U7816RXBUF_RXBUF_Pos)

#define	U7816x_U7816TXBUF_TXBUF_Pos	0	/* U7816ݷͻĴ */
#define	U7816x_U7816TXBUF_TXBUF_Msk	(0xffU << U7816x_U7816TXBUF_TXBUF_Pos)

#define	U7816x_U7816IE_RXIE_Pos	2	/* ݽжʹλӦRX_FLAGжϱ־λ */
#define	U7816x_U7816IE_RXIE_Msk	(0x1U << U7816x_U7816IE_RXIE_Pos)
	/* 0 = ݽжʹλ */
	/* 1 = ݽжʹλ */

#define	U7816x_U7816IE_TXIE_Pos	1	/* ݷжʹλӦTX_FLAGжϱ־λ */
#define	U7816x_U7816IE_TXIE_Msk	(0x1U << U7816x_U7816IE_TXIE_Pos)
	/* 0 = ݷжϽֹ */
	/* 1 = ݷжʹ */

#define	U7816x_U7816IE_LSIE_Pos	0	/* ·״̬жʹλӦERROR_FLAGжϱ־λ */
#define	U7816x_U7816IE_LSIE_Msk	(0x1U << U7816x_U7816IE_LSIE_Pos)
	/* 0 = ·״̬жϽֹ */
	/* 1 = ·״̬жʹ */

#define	U7816x_U7816IF_ERRIF_Pos	2	/* ־ĴóгӲλU7816ERRӦ־ */
#define	U7816x_U7816IF_ERRIF_Msk	(0x1U << U7816x_U7816IF_ERRIF_Pos)

#define	U7816x_U7816IF_TXIF_Pos	1	/* ͻձ־ */
#define	U7816x_U7816IF_TXIF_Msk	(0x1U << U7816x_U7816IF_TXIF_Pos)

#define	U7816x_U7816IF_RXIF_Pos	0	/* ɱ־ */
#define	U7816x_U7816IF_RXIF_Msk	(0x1U << U7816x_U7816IF_RXIF_Pos)

#define	U7816x_U7816ERR_TPARERR_Pos	3	/* żУ־λ */
#define	U7816x_U7816ERR_TPARERR_Msk	(0x1U << U7816x_U7816ERR_TPARERR_Pos)

#define	U7816x_U7816ERR_RPARERR_Pos	2	/* żУ־λ */
#define	U7816x_U7816ERR_RPARERR_Msk	(0x1U << U7816x_U7816ERR_RPARERR_Pos)

#define	U7816x_U7816ERR_FRERR_Pos	1	/* ֡ʽ־λ */
#define	U7816x_U7816ERR_FRERR_Msk	(0x1U << U7816x_U7816ERR_FRERR_Pos)

#define	U7816x_U7816ERR_OVERR_Pos	0	/* ־λ */
#define	U7816x_U7816ERR_OVERR_Msk	(0x1U << U7816x_U7816ERR_OVERR_Pos)

#define	U7816x_U7816STA_WAIT_RPT_Pos	2	/* U7816ӿڷ˴źţڵȴԷط.״̬뷢ʹź״̬ʱλյʼλ߽뷢״̬ʱӲ;
 */
#define	U7816x_U7816STA_WAIT_RPT_Msk	(0x1U << U7816x_U7816STA_WAIT_RPT_Pos)

#define	U7816x_U7816STA_TXBUSY_Pos	1	/* æ־ */
#define	U7816x_U7816STA_TXBUSY_Msk	(0x1U << U7816x_U7816STA_TXBUSY_Pos)

#define	U7816x_U7816STA_RXBUSY_Pos	0	/* æ־ */
#define	U7816x_U7816STA_RXBUSY_Msk	(0x1U << U7816x_U7816STA_RXBUSY_Pos)
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void U7816x_Deinit(U7816x_Type* U7816x);

/* U7816ͨʹܿ غ */
extern void U7816x_U7816CTRL_TXEN_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816CTRL_TXEN_Getable(U7816x_Type* U7816x);

/* U7816ͨʹܿ غ */
extern void U7816x_U7816CTRL_RXEN_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816CTRL_RXEN_Getable(U7816x_Type* U7816x);

/* U7816ʱCLKʹܿ غ */
extern void U7816x_U7816CTRL_CKOEN_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816CTRL_CKOEN_Getable(U7816x_Type* U7816x);

/* U7816ͨݷǿԶЧ غ */
extern void U7816x_U7816CTRL_HPUAT_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816CTRL_HPUAT_Getable(U7816x_Type* U7816x);

/* U7816ͨǿʹܿ غ */
extern void U7816x_U7816CTRL_HPUEN_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816CTRL_HPUEN_Getable(U7816x_Type* U7816x);

/* ERROR SIGNALѡ غ */
extern void U7816x_U7816FRC_ERSW_Set(U7816x_Type* U7816x, uint32_t SetValue);
extern uint32_t U7816x_U7816FRC_ERSW_Get(U7816x_Type* U7816x);

/* ERROR SIGNALGUARDTIMEѡ񣨽ڷʱЧ غ */
extern void U7816x_U7816FRC_ERSGD_Set(U7816x_Type* U7816x, uint32_t SetValue);
extern uint32_t U7816x_U7816FRC_ERSGD_Get(U7816x_Type* U7816x);

/* BGTblock guard time غ */
extern void U7816x_U7816FRC_BGTEN_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816FRC_BGTEN_Getable(U7816x_Type* U7816x);

/* ƽżУʱԶط غ */
extern void U7816x_U7816FRC_REP_T_Set(U7816x_Type* U7816x, uint32_t SetValue);
extern uint32_t U7816x_U7816FRC_REP_T_Get(U7816x_Type* U7816x);

/* żУѡ غ */
extern void U7816x_U7816FRC_PAR_Set(U7816x_Type* U7816x, uint32_t SetValue);
extern uint32_t U7816x_U7816FRC_PAR_Get(U7816x_Type* U7816x);

/* Guard TimeȿλʱϸЭ2etu غ */
extern void U7816x_U7816FRC_FREN_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816FRC_FREN_Getable(U7816x_Type* U7816x);

/* żУĴʽѡ غ */
extern void U7816x_U7816FRC_TREPEN_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816FRC_TREPEN_Getable(U7816x_Type* U7816x);

/* żУĴʽѡ غ */
extern void U7816x_U7816FRC_RREPEN_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816FRC_RREPEN_Getable(U7816x_Type* U7816x);

/* ʹ غ */
extern void U7816x_U7816FRC_DICONV_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816FRC_DICONV_Getable(U7816x_Type* U7816x);

/* ʱEGTʱ䣨ETUΪλ غ */
extern void U7816x_U7816EGT_Write(U7816x_Type* U7816x, uint32_t SetValue);
extern uint32_t U7816x_U7816EGT_Read(U7816x_Type* U7816x);

/* U7816ʱƵƼĴ غ */
extern void U7816x_U7816CLKDIV_Write(U7816x_Type* U7816x, uint32_t SetValue);
extern uint32_t U7816x_U7816CLKDIV_Read(U7816x_Type* U7816x);

/* U7816ԤƵƼĴ7816ͨŷƵȣʣ غ */
extern void U7816x_U7816PDIV_Write(U7816x_Type* U7816x, uint32_t SetValue);
extern uint32_t U7816x_U7816PDIV_Read(U7816x_Type* U7816x);

/* U7816ݽջĴ غ */
extern uint32_t U7816x_U7816RXBUF_Read(U7816x_Type* U7816x);

/* U7816ݷͻĴ غ */
extern void U7816x_U7816TXBUF_Write(U7816x_Type* U7816x, uint32_t SetValue);

/* ݽжʹλӦRX_FLAGжϱ־λ غ */
extern void U7816x_U7816IE_RXIE_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816IE_RXIE_Getable(U7816x_Type* U7816x);

/* ݷжʹλӦTX_FLAGжϱ־λ غ */
extern void U7816x_U7816IE_TXIE_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816IE_TXIE_Getable(U7816x_Type* U7816x);

/* ·״̬жʹλӦERROR_FLAGжϱ־λ غ */
extern void U7816x_U7816IE_LSIE_Setable(U7816x_Type* U7816x, FunState NewState);
extern FunState U7816x_U7816IE_LSIE_Getable(U7816x_Type* U7816x);

/* ־ĴóгӲλU7816ERRӦ־ غ */
extern FlagStatus U7816x_U7816IF_ERRIF_Chk(U7816x_Type* U7816x);

/* ͻձ־ غ */
extern FlagStatus U7816x_U7816IF_TXIF_Chk(U7816x_Type* U7816x);

/* ɱ־ غ */
extern FlagStatus U7816x_U7816IF_RXIF_Chk(U7816x_Type* U7816x);

/* żУ־λ غ */
extern void U7816x_U7816ERR_TPARERR_Clr(U7816x_Type* U7816x);
extern FlagStatus U7816x_U7816ERR_TPARERR_Chk(U7816x_Type* U7816x);

/* żУ־λ غ */
extern void U7816x_U7816ERR_RPARERR_Clr(U7816x_Type* U7816x);
extern FlagStatus U7816x_U7816ERR_RPARERR_Chk(U7816x_Type* U7816x);

/* ֡ʽ־λ غ */
extern void U7816x_U7816ERR_FRERR_Clr(U7816x_Type* U7816x);
extern FlagStatus U7816x_U7816ERR_FRERR_Chk(U7816x_Type* U7816x);

/* ־λ غ */
extern void U7816x_U7816ERR_OVERR_Clr(U7816x_Type* U7816x);
extern FlagStatus U7816x_U7816ERR_OVERR_Chk(U7816x_Type* U7816x);

/* U7816ӿڷ˴źţڵȴԷط.״̬뷢ʹź״̬ʱλյʼλ߽뷢״̬ʱӲ;
 غ */
extern FlagStatus U7816x_U7816STA_WAIT_RPT_Chk(U7816x_Type* U7816x);

/* æ־ غ */
extern FlagStatus U7816x_U7816STA_TXBUSY_Chk(U7816x_Type* U7816x);

/* æ־ غ */
extern FlagStatus U7816x_U7816STA_RXBUSY_Chk(U7816x_Type* U7816x);
//Announce_End


/* U7816ʼ */
void U7816_Init(U7816x_Type* U7816x, U7816_InitTypeDef* para);



#ifdef __cplusplus
}
#endif

#endif /* __FM33G0XX_U7816_H */



/************************ (C) COPYRIGHT FMSHelectronics *****END OF FILE****/



