/**
  ******************************************************************************
  * @file    fm33g0xx_aes.c
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/

/* Includes ------------------------------------------------------------------*/
#include "fm33g0xx_aes.h" 


/** @addtogroup fm33g0xx_StdPeriph_Driver
  * @{
  */

/** @defgroup AES 
  * @brief AES driver modules
  * @{
  */ 

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/



/********************************
AES ܿƺ
: AESԿ(AESEN=0ʱЧ)
룺AES_AESCR_KEYLEN_128BIT			00128bit
			AES_AESCR_KEYLEN_192BIT			01192bit
			AES_AESCR_KEYLEN_256BIT			10256bit
: 
********************************/
void AES_AESCR_KEYLEN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = AES->AESCR;
	tmpreg &= ~(AES_AESCR_KEYLEN_Msk);
	tmpreg |= (SetValue & AES_AESCR_KEYLEN_Msk);
	AES->AESCR = tmpreg;
}
/********************************
AES ܿƺ
: ȡAESԿ(AESEN=0ʱЧ)
룺
: AES_AESCR_KEYLEN_128BIT			00128bit
			AES_AESCR_KEYLEN_192BIT			01192bit
			AES_AESCR_KEYLEN_256BIT			10256bit
********************************/
uint32_t AES_AESCR_KEYLEN_Get(void)
{
	return (AES->AESCR & AES_AESCR_KEYLEN_Msk);
}

/********************************
AES ܿƺ
: DMAԶʹ(ģʽ1,3,4Ч)
룺ENABLE/DISABLE		ʹ/ֹ
: 
********************************/
void AES_AESCR_DMAOEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		AES->AESCR |= (AES_AESCR_DMAOEN_Msk);
	}
	else
	{
		AES->AESCR &= ~(AES_AESCR_DMAOEN_Msk);
	}
}
/********************************
AES ܿƺ
: ȡDMAԶʹ(ģʽ1,3,4Ч)
룺
: ENABLE/DISABLE		ʹ/ֹ
********************************/
FunState AES_AESCR_DMAOEN_Getable(void)
{
	if (AES->AESCR & (AES_AESCR_DMAOEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
AES ܿƺ
: DMAԶдʹ(ģʽ1,3,4Ч)
룺ENABLE/DISABLE		ʹ/ֹ
: 
********************************/
void AES_AESCR_DMAIEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		AES->AESCR |= (AES_AESCR_DMAIEN_Msk);
	}
	else
	{
		AES->AESCR &= ~(AES_AESCR_DMAIEN_Msk);
	}
}
/********************************
AES ܿƺ
: ȡDMAԶдʹ(ģʽ1,3,4Ч)
룺
: ENABLE/DISABLE		ʹ/ֹ
********************************/
FunState AES_AESCR_DMAIEN_Getable(void)
{
	if (AES->AESCR & (AES_AESCR_DMAIEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
AES ܿƺ
: ô־RDERRWRERRжʹ
룺ENABLE/DISABLE		ʹ/ֹ
: 
********************************/
void AES_AESCR_ERRIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		AES->AESCR |= (AES_AESCR_ERRIE_Msk);
	}
	else
	{
		AES->AESCR &= ~(AES_AESCR_ERRIE_Msk);
	}
}
/********************************
AES ܿƺ
: ȡ־RDERRWRERRжʹ
룺
: ENABLE/DISABLE		ʹ/ֹ
********************************/
FunState AES_AESCR_ERRIE_Getable(void)
{
	if (AES->AESCR & (AES_AESCR_ERRIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
AES ܿƺ
: CCF־жʹ
룺ENABLE/DISABLE		ʹ/ֹ
: 
********************************/
void AES_AESCR_CCFIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		AES->AESCR |= (AES_AESCR_CCFIE_Msk);
	}
	else
	{
		AES->AESCR &= ~(AES_AESCR_CCFIE_Msk);
	}
}
/********************************
AES ܿƺ
: ȡCCF־жʹ
룺
: ENABLE/DISABLE		ʹ/ֹ
********************************/
FunState AES_AESCR_CCFIE_Getable(void)
{
	if (AES->AESCR & (AES_AESCR_CCFIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
AES ܿƺ
: ־
룺
: 
********************************/
void AES_AESCR_ERRC_Clr(void)
{
	AES->AESCR |= AES_AESCR_ERRC_Msk;
}

/********************************
AES ܿƺ
: CCF־
룺
: 
********************************/
void AES_AESCR_CCFC_Clr(void)
{
	AES->AESCR |= AES_AESCR_CCFC_Msk;
}

/********************************
AES ܿƺ
: AESģʽ(AESEN=0ʱЧ)
룺AES_AESCR_CHMOD_ECB		ECB
			AES_AESCR_CHMOD_CBC		CBC
			AES_AESCR_CHMOD_CTR		CTR
			AES_AESCR_CHMOD_MULTH	ʹMultHģ
: 
********************************/
void AES_AESCR_CHMOD_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = AES->AESCR;
	tmpreg &= ~(AES_AESCR_CHMOD_Msk);
	tmpreg |= (SetValue & AES_AESCR_CHMOD_Msk);
	AES->AESCR = tmpreg;
}
/********************************
AES ܿƺ
: ȡAESģʽ
룺
: AES_AESCR_CHMOD_ECB		ECB
			AES_AESCR_CHMOD_CBC		CBC
			AES_AESCR_CHMOD_CTR		CTR
			AES_AESCR_CHMOD_MULTH	ʹMultHģ
********************************/
uint32_t AES_AESCR_CHMOD_Get(void)
{
	return (AES->AESCR & AES_AESCR_CHMOD_Msk);
}

/********************************
AES ܿƺ
: AESģʽ(AESEN=0ʱЧ)
룺AES_AESCR_MODE_ENCRYPT		00ģʽ1
			AES_AESCR_MODE_KEYEXP			01ģʽ2Կչ
			AES_AESCR_MODE_DECRYPT		10ģʽ3
			AES_AESCR_MODE_KEYEXPDECRYPT	11ģʽ4Կչ+
: 
********************************/
void AES_AESCR_MODE_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = AES->AESCR;
	tmpreg &= ~(AES_AESCR_MODE_Msk);
	tmpreg |= (SetValue & AES_AESCR_MODE_Msk);
	AES->AESCR = tmpreg;
}
/********************************
AES ܿƺ
: ȡAESģʽ
룺
: AES_AESCR_MODE_ENCRYPT		00ģʽ1
			AES_AESCR_MODE_KEYEXP			01ģʽ2Կչ
			AES_AESCR_MODE_DECRYPT		10ģʽ3
			AES_AESCR_MODE_KEYEXPDECRYPT	11ģʽ4Կչ+
********************************/
uint32_t AES_AESCR_MODE_Get(void)
{
	return (AES->AESCR & AES_AESCR_MODE_Msk);
}

/********************************
AES ܿƺ
: AES(AESEN=0ʱЧ)
룺AES_AESCR_DATATYP_32BITNOEX			0032bitݲ
			AES_AESCR_DATATYP_16BITEX				0116bitݰֽ
			AES_AESCR_DATATYP_8BITEX				108bitֽڽ
			AES_AESCR_DATATYP_1BITEX				111bitݱؽ
: 
********************************/
void AES_AESCR_DATATYP_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = AES->AESCR;
	tmpreg &= ~(AES_AESCR_DATATYP_Msk);
	tmpreg |= (SetValue & AES_AESCR_DATATYP_Msk);
	AES->AESCR = tmpreg;
}
/********************************
AES ܿƺ
: ȡAES
룺
: AES_AESCR_DATATYP_32BITNOEX			0032bitݲ
			AES_AESCR_DATATYP_16BITEX				0116bitݰֽ
			AES_AESCR_DATATYP_8BITEX				108bitֽڽ
			AES_AESCR_DATATYP_1BITEX				111bitݱؽ
********************************/
uint32_t AES_AESCR_DATATYP_Get(void)
{
	return (AES->AESCR & AES_AESCR_DATATYP_Msk);
}

/********************************
AES ܿƺ
: AESʹ(AESENλܹλAESģ)
룺ENABLE/DISABLE		ʹ/ֹ
: 
********************************/
void AES_AESCR_AESEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		AES->AESCR |= (AES_AESCR_AESEN_Msk);
	}
	else
	{
		AES->AESCR &= ~(AES_AESCR_AESEN_Msk);
	}
}
/********************************
AES ܿƺ
: ȡAESʹ
룺
: ENABLE/DISABLE		ʹ/ֹ
********************************/
FunState AES_AESCR_AESEN_Getable(void)
{
	if (AES->AESCR & (AES_AESCR_AESEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
AES ܿƺ
: ȡAESд־
룺
: SET/RESET		׶ηд/׶δд
********************************/
FlagStatus AES_AESIF_WRERR_Chk(void)
{
	if (AES->AESIF & AES_AESIF_WRERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
AES ܿƺ
: ȡAES־
룺
: SET/RESET		׶η/׶δ
********************************/
FlagStatus AES_AESIF_RDERR_Chk(void)
{
	if (AES->AESIF & AES_AESIF_RDERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}
/********************************
AES ܿƺ
: ȡAESɱ־
룺
: SET/RESET		/û
********************************/
FlagStatus AES_AESIF_CCF_Chk(void)
{
	if (AES->AESIF & AES_AESIF_CCF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
AES ܿƺ
: AESĴAESҪӽʱӦüĴд4 
룺ģʽ1ܣĴMSBLSB4д롣
			ģʽ2ԿչʹĴ
			ģʽ3ģʽ4ܣĴMSBLSB4д롣
			MultHģʽѳACMSBLSB4д
: 
********************************/
void AES_AESDIN_Write(uint32_t SetValue)
{
	AES->AESDIN = (SetValue);
}

/********************************
AES ܿƺ
: ȡAESĴ
룺
: ݼĴֵ
********************************/
uint32_t AES_AESDIN_Read(void)
{
	return (AES->AESDIN);
}

/********************************
AES ܿƺ
: AESĴ
룺
: 
********************************/
void AES_AESDOUT_Write(uint32_t SetValue)
{
	AES->AESDOUT = (SetValue);
}
/********************************
AES ܿƺ
: ȡAESĴ(AESɺ󣬿ԷĴζӽܵĽ)
룺
: ģʽ1ܣĴMSBLSB4ζ
			ģʽ2ԿչʹĴ
			ģʽ3ģʽ4ܣĴMSBLSB4
			MultHģʽ洢IVRĴУȡAES_DOUTRĴ
********************************/
uint32_t AES_AESDOUT_Read(void)
{
	return (AES->AESDOUT);
}

/********************************
AES ܿƺ
: AESΪȱʡֵ
룺
: 
********************************/
void AES_Deinit(void)
{
	AES->AESCR = 0x00000000;
	//AES->AESIF = 0x00000000;
	AES->AESDIN = 0x00000000;
	//AES->AESDOUT = 0x00000000;
	AES->AESKEY0 = 0x00000000;
	AES->AESKEY1 = 0x00000000;
	AES->AESKEY2 = 0x00000000;
	AES->AESKEY3 = 0x00000000;
	AES->AESKEY4 = 0x00000000;
	AES->AESKEY5 = 0x00000000;
	AES->AESKEY6 = 0x00000000;
	AES->AESKEY7 = 0x00000000;
	AES->AESIVR0 = 0x00000000;
	AES->AESIVR1 = 0x00000000;
	AES->AESIVR2 = 0x00000000;
	AES->AESIVR3 = 0x00000000;
}
//Code_End

/********************************
AES ܿƺ
: ӽԿ(key0Կ32bit)
룺Կ	16/24/32ֽڳȵԿ
				16/24/32
: 
********************************/
void AES_AESKEY_WriteEx(uint8_t *KeyIn, uint8_t Len)
{
	uint8_t i;
	__IO uint32_t *PointKeyReg;
	__IO uint32_t Temp32;
	
	if( (Len != 16) && (Len != 24) && (Len != 32) ) return;
	
	PointKeyReg = (&AES->AESKEY0);
	for(i=0; i<Len; i=i+4)
	{
		Temp32 = (KeyIn[0+i]<<24)|(KeyIn[1+i]<<16)|(KeyIn[2+i]<<8)|(KeyIn[3+i]<<0);
		PointKeyReg[(Len-i)/4-1] = Temp32;
	}
}

/*ӽԿһִԿ32bit  */
void AES_AESKEY_ReadEx(uint8_t *KeyOut, uint8_t Len)
{
	uint8_t i;
	__IO uint32_t *PointKeyReg;
	__IO uint32_t Temp32;
	
	if( (Len != 16) && (Len != 24) && (Len != 32) ) return;
	
	PointKeyReg = (&AES->AESKEY0);
	for(i=0; i<Len; i=i+4)
	{
		Temp32 = PointKeyReg[(Len-i)/4-1];
		KeyOut[0+i] = Temp32>>24;
		KeyOut[1+i] = Temp32>>16;
		KeyOut[2+i] = Temp32>>8;
		KeyOut[3+i] = Temp32>>0;
	}
}

/*ʼ */
void AES_AESIVR_WriteEx(uint8_t *IVRIn)
{
	uint8_t i;
	__IO uint32_t *PointIvrReg;
	__IO uint32_t Temp32;
	
	PointIvrReg = (&AES->AESIVR0);
	for(i=0; i<4*4; i=i+4)
	{
		Temp32 = (IVRIn[0+i]<<24)|(IVRIn[1+i]<<16)|(IVRIn[2+i]<<8)|(IVRIn[3+i]<<0);
		PointIvrReg[(16-i)/4-1] = Temp32;
	}
}

/*ʼȡ */
void AES_AESIVR_ReadEx(uint8_t *IVROut)
{
	uint8_t i;
	__IO uint32_t *PointIvrReg;
	__IO uint32_t Temp32;
	
	PointIvrReg = (&AES->AESIVR0);
	for(i=0; i<4*4; i=i+4)
	{
		Temp32 = PointIvrReg[(4*4-i)/4-1];
		IVROut[0+i] = Temp32>>24;
		IVROut[1+i] = Temp32>>16;
		IVROut[2+i] = Temp32>>8;
		IVROut[3+i] = Temp32>>0;	
	}
}

/*ӽ룬16ֽڣ128bit  */
void AES_AESDIN_GroupWrite_128BIT(uint8_t *DataIn)
{
	uint8_t i;
	__IO uint32_t Temp32;

	for(i=0; i<16; i=i+4)
	{
		Temp32 = (DataIn[0+i]<<24)|(DataIn[1+i]<<16)|(DataIn[2+i]<<8)|(DataIn[3+i]<<0);
		AES->AESDIN = Temp32;
	}
}
        						
/*ӽ16ֽڣ128bit  */
void AES_AESDOUT_GroupRead_128BIT(uint8_t *DataOut)
{
	uint8_t i;
	__IO uint32_t Temp32;
	uint8_t Buf[16];
	
	for(i=0; i<16; i=i+4)
	{
		Temp32 = AES->AESDOUT;
		Buf[0+i] = Temp32>>24;
		Buf[1+i] = Temp32>>16;
		Buf[2+i] = Temp32>>8;
		Buf[3+i] = Temp32>>0;
	}
	if( RCC->SYSCLKSEL & (0x07UL << 16))//APBʱзƵ
	{
		for(i=0; i<12; i++)
		{
			DataOut[4+i] = Buf[i];
		}
		for(i=0; i<4; i++)
		{
			DataOut[i] = Buf[12+i];
		}	
	}
	else
	{
		for(i=0; i<16; i++)
		{
			DataOut[i] = Buf[i];
		}
	}
}

uint8_t AES_GroupWriteAndRead_128BIT(uint8_t *DataIn, uint8_t *DataOut)
{	
	uint16_t i;
	
	//ӽ
	AES_AESDIN_GroupWrite_128BIT(DataIn);
	
	//ȴCCF־,ɼԼҪ100ʱ
	for(i=0;i<500;i++)
	{
		if(SET == AES_AESIF_CCF_Chk() ) break;
	}
	//CCF־
	//ȡǰ
	AES_AESCR_CCFC_Clr();
	
	//ȡ
	AES_AESDOUT_GroupRead_128BIT(DataOut);
	
	if(i==500) return 1;
	else return 0;
}

/* AESģʼ */
void AES_Init(AES_InitTypeDef* para)
{
	AES_AESCR_KEYLEN_Set(para->KEYLEN);			//AESԿȣAESEN=1ʱ޸
	AES_AESCR_CHMOD_Set(para->CHMOD);			//AESģʽAESEN=1ʱ޸
	AES_AESCR_MODE_Set(para->MODE);				//AESģʽAESEN=1ʱ޸
	AES_AESCR_DATATYP_Set(para->DATATYP);		//ѡͣAESEN=1ʱ޸ġ彻ɲοAES½	
	AES_AESCR_DMAOEN_Setable(para->DMAOEN);		//DMAԶʹ
	AES_AESCR_DMAIEN_Setable(para->DMAIEN);		//DMAԶдʹ
	AES_AESCR_ERRIE_Setable(para->ERRIE);		//־RDERRWRERRжʹ
	AES_AESCR_CCFIE_Setable(para->CCFIE);		//CCF־жʹ
	AES_AESCR_AESEN_Setable(para->AESEN);		//AESʹ 
}
/******END OF FILE****/



