/**
  ******************************************************************************
  * @file    fm33g0xx_anac.c
  * @author  FM33g0xx Application Team
  * @version V0.3.02G
  * @date    01-21-2019
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/

/* Includes ------------------------------------------------------------------*/
#include "fm33g0xx_anac.h" 


/** @addtogroup fm33g0xx_StdPeriph_Driver
  * @{
  */

/** @defgroup ANAC 
  * @brief ANAC driver modules
  * @{
  */ 

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/



/********************************
PDRµ縴λѹú
:µ縴λѹ
룺µ縴λѹbit2:1
:
********************************/
void ANAC_PDRCON_PDRCFG_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->PDRCON;
	tmpreg &= ~(ANAC_PDRCON_PDRCFG_Msk);
	tmpreg |= (SetValue & ANAC_PDRCON_PDRCFG_Msk);
	ANAC->PDRCON = tmpreg;
}
/********************************
PDRµ縴λĴλ
:PDRµ縴λѹֵĴλ
룺
:PDRĴѹֵ
********************************/
uint32_t ANAC_PDRCON_PDRCFG_Get(void)
{
	return (ANAC->PDRCON & ANAC_PDRCON_PDRCFG_Msk);
}

/*********************************
PDRµ縴λƺ 
ܣPDRµ縴λͣ
: ENABLE µ縴λ
      DISABLE ֹͣµ縴λ
: 
*********************************/
void ANAC_PDRCON_PDREN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->PDRCON |= (ANAC_PDRCON_PDREN_Msk);
	}
	else
	{
		ANAC->PDRCON &= ~(ANAC_PDRCON_PDREN_Msk);
	}
}
/********************************
PDRµ縴λ״̬
:PDRµ縴λ״̬
룺
:ENABLE 
     DISABLE ֹͣ
********************************/
FunState ANAC_PDRCON_PDREN_Getable(void)
{
	if (ANAC->PDRCON & (ANAC_PDRCON_PDREN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
BORµ縴λѹú
:µ縴λѹ
룺BORµ縴λѹbit2:1
:
********************************/
void ANAC_BORCON_BOR_PDRCFG_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->BORCON;
	tmpreg &= ~(ANAC_BORCON_BOR_PDRCFG_Msk);
	tmpreg |= (SetValue & ANAC_BORCON_BOR_PDRCFG_Msk);
	ANAC->BORCON = tmpreg;
}

/********************************
BORµ縴λĴѹֵ
:BORµ縴λѹֵĴλ
룺
:BORĴѹֵ
********************************/
uint32_t ANAC_BORCON_BOR_PDRCFG_Get(void)
{
	return (ANAC->BORCON & ANAC_BORCON_BOR_PDRCFG_Msk);
}


/*********************************
BORµ縴λƺ 
ܣBORµ縴λͣ
: ENABLE µ縴λ
      DISABLE ֹͣµ縴λ
: 
*********************************/
void ANAC_BORCON_OFF_BOR_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->BORCON |= (ANAC_BORCON_OFF_BOR_Msk);
	}
	else
	{
		ANAC->BORCON &= ~(ANAC_BORCON_OFF_BOR_Msk);
	}
}
/********************************
BORµ縴λ״̬
:BORµ縴λ״̬
룺
:ENABLE 
     DISABLE ֹͣ
********************************/
FunState ANAC_BORCON_OFF_BOR_Getable(void)
{
	if (ANAC->BORCON & (ANAC_BORCON_OFF_BOR_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
SVDԴжʹܿƺ 
ܣSVDԴжͣ
: ENABLE SVDԴж
      DISABLE ֹͣSVDԴж
: 
*********************************/
void ANAC_SVDCFG_PFIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->SVDCFG |= (ANAC_SVDCFG_PFIE_Msk);
	}
	else
	{
		ANAC->SVDCFG &= ~(ANAC_SVDCFG_PFIE_Msk);
	}
}
/********************************
SVDԴжϿ״̬
:SVDԴжϿ״̬
룺
:ENABLE 
     DISABLE ֹͣ
********************************/
FunState ANAC_SVDCFG_PFIE_Getable(void)
{
	if (ANAC->SVDCFG & (ANAC_SVDCFG_PFIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/*********************************
SVDԴָжʹܿƺ 
ܣSVDԴָжͣ
: ENABLE SVDԴָж
      DISABLE ֹͣSVDԴָж
: 
*********************************/
void ANAC_SVDCFG_PRIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->SVDCFG |= (ANAC_SVDCFG_PRIE_Msk);
	}
	else
	{
		ANAC->SVDCFG &= ~(ANAC_SVDCFG_PRIE_Msk);
	}
}

/********************************
SVDԴָжϿ״̬
:SVDԴָжϿ״̬
룺
:ENABLE 
     DISABLE ֹͣ
********************************/
FunState ANAC_SVDCFG_PRIE_Getable(void)
{
	if (ANAC->SVDCFG & (ANAC_SVDCFG_PRIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
SVDֵú
:SVDֵѹ
룺ñѹbit7:4
:
********************************/
void ANAC_SVDCFG_SVDLVL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->SVDCFG;
	tmpreg &= ~(ANAC_SVDCFG_SVDLVL_Msk);
	tmpreg |= (SetValue & ANAC_SVDCFG_SVDLVL_Msk);
	ANAC->SVDCFG = tmpreg;
}
/********************************
SVDֵ
:ȡSVDֵ
룺
:SVDֵ
********************************/
uint32_t ANAC_SVDCFG_SVDLVL_Get(void)
{
	return (ANAC->SVDCFG & ANAC_SVDCFG_SVDLVL_Msk);
}

/********************************
SVD˲״̬
:SVDԴָжϿ״̬
룺ENABLE ˲SVDMODE=1ʱ1
      DISABLE ֹͣ˲
: 
********************************/
void ANAC_SVDCFG_DFEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->SVDCFG |= (ANAC_SVDCFG_DFEN_Msk);
	}
	else
	{
		ANAC->SVDCFG &= ~(ANAC_SVDCFG_DFEN_Msk);
	}
}
/********************************
SVD˲״̬
:SVD˲״̬
룺
:ENABLE 
     DISABLE ֹͣ
********************************/
FunState ANAC_SVDCFG_DFEN_Getable(void)
{
	if (ANAC->SVDCFG & (ANAC_SVDCFG_DFEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
SVDģʽѡ
:SVDģʽѡ
룺ANAC_SVDCFG_SVDMOD_INTERVALЪʹģʽЪʹģʽ±뿪˲
      ANAC_SVDCFG_SVDMOD_ALWAYSONʹģʽ
: 
********************************/
void ANAC_SVDCFG_SVDMOD_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->SVDCFG;
	tmpreg &= ~(ANAC_SVDCFG_SVDMOD_Msk);
	tmpreg |= (SetValue & ANAC_SVDCFG_SVDMOD_Msk);
	ANAC->SVDCFG = tmpreg;
}
/********************************
SVDģʽ
:SVDģʽ
룺
:ģʽ״̬λ
********************************/
uint32_t ANAC_SVDCFG_SVDMOD_Get(void)
{
	return (ANAC->SVDCFG & ANAC_SVDCFG_SVDMOD_Msk);
}

/********************************
SVDЪʹܼú
:SVDЪʹܼ
룺0015.625ms
      0162.5ms
      10256ms
      111s
: 
********************************/
void ANAC_SVDCFG_SVDITVL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->SVDCFG;
	tmpreg &= ~(ANAC_SVDCFG_SVDITVL_Msk);
	tmpreg |= (SetValue & ANAC_SVDCFG_SVDITVL_Msk);
	ANAC->SVDCFG = tmpreg;
}
/********************************
SVDЪʹܼʱú
:SVDģʽ
룺
:Ъʹܼʱ״̬λ
********************************/
uint32_t ANAC_SVDCFG_SVDITVL_Get(void)
{
	return (ANAC->SVDCFG & ANAC_SVDCFG_SVDITVL_Msk);
}

/*********************************
SVDʹܿƺ 
ܣSVDʹͣ
: ENABLE SVDʹ
      DISABLE ֹͣSVDʹ
: 
*********************************/
void ANAC_SVDCON_SVDTE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->SVDCON |= (ANAC_SVDCON_SVDTE_Msk);
	}
	else
	{
		ANAC->SVDCON &= ~(ANAC_SVDCON_SVDTE_Msk);
	}
}
/*********************************
SVDʹܿ״̬ 
ܣSVDʹܿ״̬
: 
: ENABLE SVDʹ
      DISABLE ֹͣSVDʹ
*********************************/
FunState ANAC_SVDCON_SVDTE_Getable(void)
{
	if (ANAC->SVDCON & (ANAC_SVDCON_SVDTE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
SVDʹܿƺ 
ܣSVDʹͣ
: ENABLE SVDʹ
      DISABLE ֹͣSVDʹ
: 
*********************************/
void ANAC_SVDCON_SVDEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->SVDCON |= (ANAC_SVDCON_SVDEN_Msk);
	}
	else
	{
		ANAC->SVDCON &= ~(ANAC_SVDCON_SVDEN_Msk);
	}
}

/*********************************
SVDʹܿ״̬ 
ܣSVDʹܿ״̬
: 
: ENABLE SVDʹ
      DISABLE ֹͣSVDʹ
*********************************/
FunState ANAC_SVDCON_SVDEN_Getable(void)
{
	if (ANAC->SVDCON & (ANAC_SVDCON_SVDEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/*********************************
SVDԴ״̬ 
ܣSVDԴ״̬
: 
: SET   ԴѹSVDǰֵ
      RESET ԴѹSVDǰֵ
*********************************/
FlagStatus ANAC_SVDSIF_SVDO_Chk(void)
{
	if (ANAC->SVDSIF & ANAC_SVDSIF_SVDO_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
SVDԴжϱ־Ĵ 
ܣԴжϱ־Դѹ䵽SVDֵ֮ʱλд1
: 
: 
*********************************/
void ANAC_SVDSIF_PFF_Clr(void)
{
	ANAC->SVDSIF = ANAC_SVDSIF_PFF_Msk;
}
/*********************************
SVDԴжϱ־Ĵ״̬ 
ܣSVDԴжϱ־״̬
: 
: SET   ж״̬Ϊ1
      RESET  ж״̬Ϊ0
*********************************/
FlagStatus ANAC_SVDSIF_PFF_Chk(void)
{
	if (ANAC->SVDSIF & ANAC_SVDSIF_PFF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
SVDԴָжϱ־Ĵ 
ܣԴָжϱ־ԴѹSVDֵ֮ʱλд1
: 
: 
*********************************/
void ANAC_SVDSIF_PRF_Clr(void)
{
	ANAC->SVDSIF = ANAC_SVDSIF_PRF_Msk;
}
/*********************************
SVDԴָжϱ־Ĵ״̬ 
ܣSVDԴָжϱ־״̬
: 
: SET   ж״̬Ϊ1
      RESET  ж״̬Ϊ0
*********************************/
FlagStatus ANAC_SVDSIF_PRF_Chk(void)
{
	if (ANAC->SVDSIF & ANAC_SVDSIF_PRF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
SVDڲ˲ĵѹ־Ĵ״̬ 
ܣSVDڲ˲ĵѹ־״̬
: 
: SET   Ƿѹ
      RESET  Ƿѹ
*********************************/
FlagStatus ANAC_SVDSIF_SVDR_Chk(void)
{
	if (ANAC->SVDSIF & ANAC_SVDSIF_SVDR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
SVD׼ѹ
ܣSVD׼ѹΪ0.7V0.75V0.8VѡһĬΪ0.8V
: ANAC_SVDVOL_V0P7EN_MskANAC_SVDVOL_V0P75EN_MskANAC_SVDVOL_V0P8EN_Msk
: 
*********************************/
void ANAC_SVDVOL_CFG(uint32_t SetValue)
{
  if(SetValue==ANAC_SVDVOL_V0P7EN_Msk)
  {
    ANAC->SVDVOL=ANAC_SVDVOL_V0P7EN_Msk;
  }
  if(SetValue==ANAC_SVDVOL_V0P75EN_Msk)
  {
    ANAC->SVDVOL=ANAC_SVDVOL_V0P75EN_Msk;
  }
  else
  {
    ANAC->SVDVOL=ANAC_SVDVOL_V0P8EN_Msk;
  }
}

/********************************
SVDοѹѡĴ
:SVDοѹ
룺
: SVDοѹ
********************************/
uint32_t ANAC_SVDVOL_Get(void)
{
	return (ANAC->SVDVOL );
}

/*********************************
XTLFƵⱨжʹƺ 
ܣXTLFƵⱨжͣ
: ENABLE XTLFƵⱨж
      DISABLE ֹͣXTLFƵⱨж
: 
*********************************/
void ANAC_FDETIE_FDET_IE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->FDETIE |= (ANAC_FDETIE_FDET_IE_Msk);
	}
	else
	{
		ANAC->FDETIE &= ~(ANAC_FDETIE_FDET_IE_Msk);
	}
}
/*********************************
XTLFƵⱨжʹܿλ״̬ȡ 
ܣȡXTLFƵⱨжʹܿ״̬
:
: ENABLE XTLFƵⱨж
      DISABLE XTLFƵⱨжֹͣ
*********************************/
FunState ANAC_FDETIE_FDET_IE_Getable(void)
{
	if (ANAC->FDETIE & (ANAC_FDETIE_FDET_IE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/*********************************
XTLFͣģ״̬ȡ 
ܣȡXTLFͣģ״̬
:
: SET    XTLFδͣ
      RESET  XTLFͣ
*********************************/
FlagStatus ANAC_FDETIF_FDETO_Chk(void)
{
	if (ANAC->FDETIF & ANAC_FDETIF_FDETO_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
XTLFͣжϱ־Ĵ 
ܣXTLFͣжϱ־
: ͣжϱ־ĴXTLFͣʱӲ첽λд1㣻ֻFDETOΪ0²ܹ˼Ĵ
: 
*********************************/
void ANAC_FDETIF_FDETIF_Clr(void)
{
	ANAC->FDETIF = ANAC_FDETIF_FDETIF_Msk;
}
/*********************************
XTLFͣжϱ־ȡ 
ܣXTLFͣжϱ־ȡ
:
: SET   ־
      RESET δ־
*********************************/
FlagStatus ANAC_FDETIF_FDETIF_Chk(void)
{
	if (ANAC->FDETIF & ANAC_FDETIF_FDETIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}
/*********************************
ADCжʹܿƺ 
ܣADCжͣ
: ENABLE λ
      DISABLE ֹͣλ
: 
*********************************/
void ANAC_ADCCON_ADC_IE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->ADCCON |= (ANAC_ADCCON_ADC_IE_Msk);
	}
	else
	{
		ANAC->ADCCON &= ~(ANAC_ADCCON_ADC_IE_Msk);
	}
}
/*********************************
ADCжʹ״̬ȡ 
ܣADCжʹ״̬
: 
: ENABLE   ADCж
      DISABLE  ADCжֹͣ
*********************************/
FunState ANAC_ADCCON_ADC_IE_Getable(void)
{
	if (ANAC->ADCCON & (ANAC_ADCCON_ADC_IE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
ADCⲿѹͨѡ 
ܣADCⲿѹͨѡ
: ANAC_ADCCON_ADC_VANA_EN_PTATADC¶ȴ
      ANAC_ADCCON_ADC_VANA_EN_VOLTAGEADCڲⲿѹ
: 
*********************************/
void ANAC_ADCCON_ADC_VANA_EN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->ADCCON;
	tmpreg &= ~(ANAC_ADCCON_ADC_VANA_EN_Msk);
	tmpreg |= (SetValue & ANAC_ADCCON_ADC_VANA_EN_Msk);
	ANAC->ADCCON = tmpreg;
}
/*********************************
ADCⲿѹͨȡú 
ܣȡADCⲿѹͨģʽ
: 
: ͨĴֵ
*********************************/
uint32_t ANAC_ADCCON_ADC_VANA_EN_Get(void)
{
	return (ANAC->ADCCON & ANAC_ADCCON_ADC_VANA_EN_Msk);
}

/*********************************
ADCʹźź 
ܣADCʹ
:  ENABLE   ADC
       DISABLE  ADCֹͣ
: 
*********************************/
void ANAC_ADCCON_ADC_EN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->ADCCON |= (ANAC_ADCCON_ADC_EN_Msk);
	}
	else
	{
		ANAC->ADCCON &= ~(ANAC_ADCCON_ADC_EN_Msk);
	}
}
/*********************************
ADCʹ״̬ȡ 
ܣȡADCǷʹ
: 
:  ENABLE   ADC
       DISABLE  ADCֹͣ
*********************************/
FunState ANAC_ADCCON_ADC_EN_Getable(void)
{
	if (ANAC->ADCCON & (ANAC_ADCCON_ADC_EN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
ADCTRIMֵú 
ܣADCTRIMֵ
: ADC TRIMֵ
:  
*********************************/
void ANAC_ADCTRIM_Write(uint32_t SetValue)
{
	ANAC->ADCTRIM = (SetValue & ANAC_ADCTRIM_ADC_TRIM_Msk);
}
/*********************************
ȡADCTRIMֵ 
ܣȡADCTRIMֵ
: 
:  ADC TRIMֵ
*********************************/
uint32_t ANAC_ADCTRIM_Read(void)
{
	return (ANAC->ADCTRIM & ANAC_ADCTRIM_ADC_TRIM_Msk);
}

/*********************************
ȡADCֵ 
ܣȡADCֵ
: 
:  ADCֵ
*********************************/
uint32_t ANAC_ADCDATA_Read(void)
{
	return (ANAC->ADCDATA & ANAC_ADCDATA_ADC_DATA_Msk);
}

/*********************************
ADCת־ 
ܣADCת־ӲλADCرղŻ0
: 
:  SET     ADC_DONEλ
       RESET   ADC_DONEΪ0
*********************************/
FlagStatus ANAC_ADCIF_ADC_DONE_Chk(void)
{
	if (ANAC->ADCIF & ANAC_ADCIF_ADC_DONE_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
ADCתжϱ־ 
ܣADCתжϱ־ADCתжϱ־Ӳλд1㣬д0Ч
: 
:  
*********************************/
void ANAC_ADCIF_ADC_IF_Clr(void)
{
	ANAC->ADCIF = ANAC_ADCIF_ADC_IF_Msk;
}

FlagStatus ANAC_ADCIF_ADC_IF_Chk(void)
{
	if (ANAC->ADCIF & ANAC_ADCIF_ADC_IF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
ADCͨbufferʹܺ 
ܣADCͨbufferǷʹ
: ENABLE   buffer
      DISABLE  ֹͣbuffer
: 
*********************************/
void ANAC_ADCINSEL_BUFEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->ADCINSEL |= (ANAC_ADCINSEL_BUFEN_Msk);
	}
	else
	{
		ANAC->ADCINSEL &= ~(ANAC_ADCINSEL_BUFEN_Msk);
	}
}

/*********************************
ADCͨbufferʹ״̬־ȡ 
ܣȡADCͨbufferʹ״̬־
: 
: ENABLE   buffer
      DISABLE  ֹͣbuffer
*********************************/
FunState ANAC_ADCINSEL_BUFEN_Getable(void)
{
	if (ANAC->ADCINSEL & (ANAC_ADCINSEL_BUFEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
ADCͨbuffer Bypass ú 
ܣADCͨbufferǷBypassʹADCⲿźʱҪBypass BufferʹADCԴѹʱ뽫λ1
: ENABLE   Bypass
      DISABLE  ֹͣBypass
: 
*********************************/
void ANAC_ADCINSEL_BUFBYP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->ADCINSEL |= (ANAC_ADCINSEL_BUFBYP_Msk);
	}
	else
	{
		ANAC->ADCINSEL &= ~(ANAC_ADCINSEL_BUFBYP_Msk);
	}
}

/*********************************
ADCͨbuffer Bypass״̬ȡ 
ܣȡADCͨbuffer Bypass״̬
: 
: ENABLE   buffer Bypass
      DISABLE  ֹͣbuffer Bypass
*********************************/
FunState ANAC_ADCINSEL_BUFBYP_Getable(void)
{
	if (ANAC->ADCINSEL & (ANAC_ADCINSEL_BUFBYP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/*********************************
ADCͨѡ 
ܣADCͨѡ
: ADC_IN1ADC_IN8   VDD
: 
*********************************/
void ANAC_ADCINSEL_BUFSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->ADCINSEL;
	tmpreg &= ~(ANAC_ADCINSEL_BUFSEL_Msk);
	tmpreg |= (SetValue & ANAC_ADCINSEL_BUFSEL_Msk);
	ANAC->ADCINSEL = tmpreg;
}


/*********************************
ADCͨѡȡ 
ܣȡADC
: 
: ѡȡADCͨ
*********************************/
uint32_t ANAC_ADCINSEL_BUFSEL_Get(void)
{
	return (ANAC->ADCINSEL & ANAC_ADCINSEL_BUFSEL_Msk);
}

/*********************************
TRNGƺ 
ܣRNGʹܼĴд1Զ
: ENABLE   
      DISABLE  ֹͣ
: 
*********************************/
void ANAC_TRNGCON_TRNGEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->TRNGCON |= (ANAC_TRNGCON_TRNGEN_Msk);
	}
	else
	{
		ANAC->TRNGCON &= ~(ANAC_TRNGCON_TRNGEN_Msk);
	}
}
/*********************************
TRNG״̬ 
ܣȡRNG״̬
: 
: ENABLE   
      DISABLE  ֹͣ
*********************************/
FunState ANAC_TRNGCON_TRNGEN_Getable(void)
{
	if (ANAC->TRNGCON & (ANAC_TRNGCON_TRNGEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
Ƚ1״̬ȡ 
ܣȡȽߵ
: 
: SET   Ƚ
      RESET Ƚ
*********************************/
FlagStatus ANAC_COMP1CR_CMP1O_Chk(void)
{
	if (ANAC->COMP1CR & ANAC_COMP1CR_CMP1O_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
Ƚ1ѡ 
ܣȽ1ѡ
: PF6 PF1 PG2 PG3
: 
*********************************/
void ANAC_COMP1CR_V1PSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->COMP1CR;
	tmpreg &= ~(ANAC_COMP1CR_V1PSEL_Msk);
	tmpreg |= (SetValue & ANAC_COMP1CR_V1PSEL_Msk);
	ANAC->COMP1CR = tmpreg;
}
/*********************************
Ƚ1Դȡ 
ܣȡȽ1Դ
: 
: PF6 PF1 PG2 PG3
*********************************/
uint32_t ANAC_COMP1CR_V1PSEL_Get(void)
{
	return (ANAC->COMP1CR & ANAC_COMP1CR_V1PSEL_Msk);
}

/*********************************
Ƚ1ѡ 
ܣȽ1ѡ
: PF5 PF0   Vref_0.8V  Vref/2_0.4V
: 
*********************************/
void ANAC_COMP1CR_V1NSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->COMP1CR;
	tmpreg &= ~(ANAC_COMP1CR_V1NSEL_Msk);
	tmpreg |= (SetValue & ANAC_COMP1CR_V1NSEL_Msk);
	ANAC->COMP1CR = tmpreg;
}
/*********************************
Ƚ1Դȡ 
ܣȡȽ1Դ
: 
: PF5 PF0   Vref_0.8V  Vref/2_0.4V
*********************************/
uint32_t ANAC_COMP1CR_V1NSEL_Get(void)
{
	return (ANAC->COMP1CR & ANAC_COMP1CR_V1NSEL_Msk);
}

/*********************************
Ƚ1ʹܿƺ 
ܣȽ1ʹ
: ENABLE   Ƚ1
      DISABLE  ֹͣȽ1
: 
*********************************/
void ANAC_COMP1CR_CMP1EN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->COMP1CR |= (ANAC_COMP1CR_CMP1EN_Msk);
	}
	else
	{
		ANAC->COMP1CR &= ~(ANAC_COMP1CR_CMP1EN_Msk);
	}
}
/*********************************
Ƚ1״̬ȡ 
ܣȡȽ1״̬
: 
: ENABLE   Ƚ1
      DISABLE  ֹͣȽ1
*********************************/
FunState ANAC_COMP1CR_CMP1EN_Getable(void)
{
	if (ANAC->COMP1CR & (ANAC_COMP1CR_CMP1EN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/*********************************
Ƚ2״̬ȡ 
ܣȡȽߵ
: 
: SET   Ƚ
      RESET Ƚ
*********************************/
FlagStatus ANAC_COMP2CR_CMP2O_Chk(void)
{
	if (ANAC->COMP2CR & ANAC_COMP2CR_CMP2O_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
Ƚ2ѡ 
ܣȽ2ѡ
: PC15 PE4
: 
*********************************/
void ANAC_COMP2CR_V2PSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->COMP2CR;
	tmpreg &= ~(ANAC_COMP2CR_V2PSEL_Msk);
	tmpreg |= (SetValue & ANAC_COMP2CR_V2PSEL_Msk);
	ANAC->COMP2CR = tmpreg;
}
/*********************************
Ƚ2Դȡ 
ܣȡȽ1Դ
: 
: PC15 PE4
*********************************/
uint32_t ANAC_COMP2CR_V2PSEL_Get(void)
{
	return (ANAC->COMP2CR & ANAC_COMP2CR_V2PSEL_Msk);
}

/*********************************
Ƚ2ѡ 
ܣȽ2ѡ
: PC14 PE3   Vref_0.8V  Vref/2_0.4V
: 
*********************************/
void ANAC_COMP2CR_V2NSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->COMP2CR;
	tmpreg &= ~(ANAC_COMP2CR_V2NSEL_Msk);
	tmpreg |= (SetValue & ANAC_COMP2CR_V2NSEL_Msk);
	ANAC->COMP2CR = tmpreg;
}
/*********************************
Ƚ2Դȡ 
ܣȡȽ1Դ
: 
: PC14 PE3   Vref_0.8V  Vref/2_0.4V
*********************************/
uint32_t ANAC_COMP2CR_V2NSEL_Get(void)
{
	return (ANAC->COMP2CR & ANAC_COMP2CR_V2NSEL_Msk);
}

/*********************************
Ƚ2ʹܿƺ 
ܣȽ2ʹ
: ENABLE   Ƚ2
      DISABLE  ֹͣȽ2
: 
*********************************/
void ANAC_COMP2CR_CMP2EN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->COMP2CR |= (ANAC_COMP2CR_CMP2EN_Msk);
	}
	else
	{
		ANAC->COMP2CR &= ~(ANAC_COMP2CR_CMP2EN_Msk);
	}
}
/*********************************
Ƚ2״̬ȡ 
ܣȡȽ2״̬
: 
: ENABLE   Ƚ2
      DISABLE  ֹͣȽ2
*********************************/
FunState ANAC_COMP2CR_CMP2EN_Getable(void)
{
	if (ANAC->COMP2CR & (ANAC_COMP2CR_CMP2EN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
Ƚ2˲ú 
ܣȽ2˲
: ENABLE   ˲
      DISABLE  ֹͣ˲
: 
*********************************/
void ANAC_COMPICR_CMP2DF_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->COMPICR |= (ANAC_COMPICR_CMP2DF_Msk);
	}
	else
	{
		ANAC->COMPICR &= ~(ANAC_COMPICR_CMP2DF_Msk);
	}
}
/*********************************
Ƚ2˲״̬ȡ 
ܣȡȽ2˲״̬
: 
: ENABLE   Ƚ2˲
      DISABLE  ֹͣȽ2˲
*********************************/
FunState ANAC_COMPICR_CMP2DF_Getable(void)
{
	if (ANAC->COMPICR & (ANAC_COMPICR_CMP2DF_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
Ƚ1˲ú 
ܣȽ1˲
: ENABLE   ˲
      DISABLE  ֹͣ˲
: 
*********************************/
void ANAC_COMPICR_CMP1DF_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->COMPICR |= (ANAC_COMPICR_CMP1DF_Msk);
	}
	else
	{
		ANAC->COMPICR &= ~(ANAC_COMPICR_CMP1DF_Msk);
	}
}
/*********************************
Ƚ1˲״̬ȡ 
ܣȡȽ1˲״̬
: 
: ENABLE   Ƚ1˲
      DISABLE  ֹͣȽ1˲
*********************************/
FunState ANAC_COMPICR_CMP1DF_Getable(void)
{
	if (ANAC->COMPICR & (ANAC_COMPICR_CMP1DF_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
ȽBuffer Bypassƺ 
ܣȽBuffer Bypassѡ
: ENABLE   ȽBuffer Bypass
      DISABLE  ֹͣȽBuffer Bypass
: 
*********************************/
void ANAC_COMPICR_BUFBYP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->COMPICR |= (ANAC_COMPICR_BUFBYP_Msk);
	}
	else
	{
		ANAC->COMPICR &= ~(ANAC_COMPICR_BUFBYP_Msk);
	}
}
/*********************************
ȽBuffer Bypass״̬ȡ 
ܣȡȽBuffer Bypass״̬
: 
: ENABLE   ȽBuffer Bypassʹ
      DISABLE  ȽBuffer Bypassֹ
*********************************/
FunState ANAC_COMPICR_BUFBYP_Getable(void)
{
	if (ANAC->COMPICR & (ANAC_COMPICR_BUFBYP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
ȽBuffer ƺ 
ܣȽBuffer ѡ
: ENABLE   ȽBuffer 
      DISABLE  ֹͣȽBuffer 
: 
*********************************/
void ANAC_COMPICR_BUFENB_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->COMPICR &= ~(ANAC_COMPICR_BUFENB_Msk);
	}
	else
	{
		ANAC->COMPICR |= (ANAC_COMPICR_BUFENB_Msk);
	}
}
/*********************************
ȽBuffer ״̬ȡ 
ܣȡȽBuffer״̬
: 
: ENABLE   ȽBuffer
      DISABLE  ȽBufferֹͣ
*********************************/
FunState ANAC_COMPICR_BUFENB_Getable(void)
{
	if (ANAC->COMPICR & (ANAC_COMPICR_BUFENB_Msk))
	{
		return DISABLE;
	}
	else
	{
		return ENABLE;
	}
}


/*********************************
Ƚ2жԴѡ 
ܣȽ2жԴѡbit[5:4]
: ANAC_COMPICR_CMP2SEL_OUTBOTHȽ2½زж
      ANAC_COMPICR_CMP2SEL_OUTRISEȽ2زж
      ANAC_COMPICR_CMP2SEL_OUTFALLȽ2½زж
: 
*********************************/
void ANAC_COMPICR_CMP2SEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->COMPICR;
	tmpreg &= ~(ANAC_COMPICR_CMP2SEL_Msk);
	tmpreg |= (SetValue & ANAC_COMPICR_CMP2SEL_Msk);
	ANAC->COMPICR = tmpreg;
}
/*********************************
Ƚ2жԴȡ 
ܣȡȽ2жԴbit[5:4]
: 
: ANAC_COMPICR_CMP2SEL_OUTBOTHȽ2½زж
      ANAC_COMPICR_CMP2SEL_OUTRISEȽ2زж
      ANAC_COMPICR_CMP2SEL_OUTFALLȽ2½زж
*********************************/
uint32_t ANAC_COMPICR_CMP2SEL_Get(void)
{
	return (ANAC->COMPICR & ANAC_COMPICR_CMP2SEL_Msk);
}

/*********************************
Ƚ1жԴѡ 
ܣȽ1жԴѡbit[3:2]
: ANAC_COMPICR_CMP1SEL_OUTBOTHȽ1½زж
      ANAC_COMPICR_CMP1SEL_OUTRISEȽ1زж
      ANAC_COMPICR_CMP1SEL_OUTFALLȽ1½زж
: 
*********************************/
void ANAC_COMPICR_CMP1SEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = ANAC->COMPICR;
	tmpreg &= ~(ANAC_COMPICR_CMP1SEL_Msk);
	tmpreg |= (SetValue & ANAC_COMPICR_CMP1SEL_Msk);
	ANAC->COMPICR = tmpreg;
}
/*********************************
Ƚ1жԴȡ 
ܣȡȽ1жԴbit[3:2]
: 
: ANAC_COMPICR_CMP1SEL_OUTBOTHȽ1½زж
      ANAC_COMPICR_CMP1SEL_OUTRISEȽ1زж
      ANAC_COMPICR_CMP1SEL_OUTFALLȽ1½زж
*********************************/
uint32_t ANAC_COMPICR_CMP1SEL_Get(void)
{
	return (ANAC->COMPICR & ANAC_COMPICR_CMP1SEL_Msk);
}

/*********************************
Ƚ2жʹܿƺ 
ܣȽ2жϿƿ
: ENABLE   Ƚ2ж
      DISABLE  ֹͣȽ2жϲ
: 
*********************************/
void ANAC_COMPICR_CMP2IE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->COMPICR |= (ANAC_COMPICR_CMP2IE_Msk);
	}
	else
	{
		ANAC->COMPICR &= ~(ANAC_COMPICR_CMP2IE_Msk);
	}
}

/*********************************
Ƚ2жʹ״̬ 
ܣȡȽ2жϿ״̬
: 
: ENABLE   Ƚ2ж
      DISABLE  Ƚ2жϲֹͣ
*********************************/
FunState ANAC_COMPICR_CMP2IE_Getable(void)
{
	if (ANAC->COMPICR & (ANAC_COMPICR_CMP2IE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
Ƚ1жʹܿƺ 
ܣȽ1жϿƿ
: ENABLE   Ƚ1ж
      DISABLE  ֹͣȽ1жϲ
: 
*********************************/
void ANAC_COMPICR_CMP1IE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		ANAC->COMPICR |= (ANAC_COMPICR_CMP1IE_Msk);
	}
	else
	{
		ANAC->COMPICR &= ~(ANAC_COMPICR_CMP1IE_Msk);
	}
}
/*********************************
Ƚ1жʹ״̬ 
ܣȡȽ1жϿ״̬
: 
: ENABLE   Ƚ1ж
      DISABLE  Ƚ1жϲֹͣ
*********************************/
FunState ANAC_COMPICR_CMP1IE_Getable(void)
{
	if (ANAC->COMPICR & (ANAC_COMPICR_CMP1IE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
Ƚ2жϱ־ƺ 
ܣȽ2жϱ־
: Ӳλд1
: 
*********************************/
void ANAC_COMPIF_CMP2IF_Clr(void)
{
	ANAC->COMPIF = ANAC_COMPIF_CMP2IF_Msk;
}
/*********************************
Ƚ2жϱ־״̬ 
ܣȡȽ2жϱ־״̬
: 
: SET    Ƚ2жϱ־
      RESET  Ƚ2δжϱ־
*********************************/
FlagStatus ANAC_COMPIF_CMP2IF_Chk(void)
{
	if (ANAC->COMPIF & ANAC_COMPIF_CMP2IF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
Ƚ1жϱ־ƺ 
ܣȽ1жϱ־
: Ӳλд1
: 
*********************************/
void ANAC_COMPIF_CMP1IF_Clr(void)
{
	ANAC->COMPIF = ANAC_COMPIF_CMP1IF_Msk;
}
/*********************************
Ƚ1жϱ־״̬ 
ܣȡȽ1жϱ־״̬
: 
: SET    Ƚ1жϱ־
      RESET  Ƚ1δжϱ־
*********************************/
FlagStatus ANAC_COMPIF_CMP1IF_Chk(void)
{
	if (ANAC->COMPIF & ANAC_COMPIF_CMP1IF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

void ANAC_Deinit(void)
{
	ANAC->PDRCON = 0x00000003;
	ANAC->BORCON = 0x00000002;
	ANAC->SVDCFG = 0x00000008;
	ANAC->SVDCON = 0x00000000;
	//ANAC->SVDSIF = ;
	ANAC->FDETIE = 0x00000000;
	//ANAC->FDETIF = ;
	ANAC->ADCCON = 0x00000000;
	ANAC->ADCTRIM = 0x00000000;
	//ANAC->ADCDATA = ;
	//ANAC->ADCIF = ;
	ANAC->ADCINSEL = 0x00000000;
	ANAC->TRNGCON = 0x00000000;
	ANAC->COMP1CR = 0x00000000;
	ANAC->COMP2CR = 0x00000000;
	ANAC->COMPICR = 0x00000040;
	//ANAC->COMPIF = ;
}
//Code_End



/*********************************
SVDʼú 
ܣSVDʼ
: ANAC_SVD_InitTypeDef* paraṹ庯ùģʽֵ˲ȹ
: 
*********************************/
void ANAC_SVD_Init(ANAC_SVD_InitTypeDef* para)
{
	ANAC_SVDCFG_SVDMOD_Set(para->SVDMOD);	//SVDģʽѡ
	ANAC_SVDCFG_SVDITVL_Set(para->SVDITVL);	//SVDЪʹܼ
	ANAC_SVDCFG_SVDLVL_Set(para->SVDLVL);	//SVDֵ
	ANAC_SVDCFG_DFEN_Setable(para->DFEN);	//SVD˲ãSVDMODE=1ʱ1
	ANAC_SVDCFG_PFIE_Setable(para->PFIE);	//SVDԴж
	ANAC_SVDCFG_PRIE_Setable(para->PRIE);	//SVDԴָж
	ANAC_SVDCON_SVDTE_Setable(DISABLE);	//رղԹ
	ANAC_SVDCON_SVDEN_Setable(para->SVDEN);	//SVDʹ
}

/*********************************
ADCʼú 
ܣADCʼ
: ANAC_ADC_InitTypeDef* paraṹ庯ADCTRIMⲿͨbuffȹ
: 
*********************************/
void ANAC_ADC_Init(ANAC_ADC_InitTypeDef* para)
{
	ANAC_ADCTRIM_Write(para->ADC_TRIM);				//<ЧοѹУĴ
	ANAC_ADCCON_ADC_VANA_EN_Set(para->ADC_VANA_EN);	//<ڲͨⲿͨѡ
	ANAC_ADCINSEL_BUFSEL_Set(para->BUFSEL);			//<ADCͨѡ
	ANAC_ADCINSEL_BUFBYP_Setable(para->BUFBYP);		//<ADCBuffer BypassADCBuffer BypassʹADCⲿźʱرbypass ʹADCڲźʱ뽫λ1bypass
	ANAC_ADCINSEL_BUFEN_Setable(para->BUFEN);		//<ADCͨBufferʹܣ
	ANAC_ADCCON_ADC_IE_Setable(para->ADC_IE);		//<ADCжʹ
	ANAC_ADCCON_ADC_EN_Setable(para->ADC_EN);		//<ADCʹ
}

/*********************************
ADCͨú 
ܣADCͨ
: CH_PTAT  CH_VDD  CH_IN1-8
: 
*********************************/
void ANAC_ADC_Channel_SetEx(uint8_t ChSel_def)
{
	switch( ChSel_def )
	{
		case CH_PTAT_Auto://¶ȴͨ,Զ²
			ANAC_ADCCON_ADC_VANA_EN_Set(ANAC_ADCCON_ADC_VANA_EN_PTAT);	//	
			ANAC_ADCTRIM_Write(const_adc_TrimT_Auto);						//òοѹ
			ANAC_ADCINSEL_BUFBYP_Setable(ENABLE);	//ڲźŲbypassbuffer
			ANAC_ADCINSEL_BUFEN_Setable(ENABLE);	//
			break;
    
    case CH_PTAT://¶ȴͨ(Զ²)
			ANAC_ADCCON_ADC_VANA_EN_Set(ANAC_ADCCON_ADC_VANA_EN_PTAT);	//	
			ANAC_ADCTRIM_Write(const_adc_TrimT);						//òοѹ
			ANAC_ADCINSEL_BUFBYP_Setable(ENABLE);	//ڲźŲbypassbuffer
			ANAC_ADCINSEL_BUFEN_Setable(ENABLE);	//
			break;
    
		case CH_VDD://ԴVDDͨ
			ANAC_ADCCON_ADC_VANA_EN_Set(ANAC_ADCCON_ADC_VANA_EN_VOLTAGE);	//VDDѹעADCΪ4.5V2.2mV*0x7FF,4.5Vĵѹ0x7FF
			ANAC_ADCTRIM_Write(const_adc_TrimV);							//òοѹ
			ANAC_ADCINSEL_BUFBYP_Setable(ENABLE);		//ڲ
			ANAC_ADCINSEL_BUFEN_Setable(ENABLE);		//ѹ
			ANAC_ADCINSEL_BUFSEL_Set(ANAC_ADCINSEL_BUFSEL_VDD);//vdd
			break;
		
		case CH_IN1://ⲿͨ
		case CH_IN2:
		case CH_IN3:
		case CH_IN4:
		case CH_IN5:
		case CH_IN6:
		case CH_IN7:
		case CH_IN8:
			ANAC_ADCCON_ADC_VANA_EN_Set(ANAC_ADCCON_ADC_VANA_EN_VOLTAGE);	//ѹѹɸоƬVDDעADCΪ4.5V2.2mV*0x7FF,4.5Vĵѹ0x7FF
			ANAC_ADCTRIM_Write(const_adc_TrimV);							//òοѹ
			ANAC_ADCINSEL_BUFBYP_Setable(DISABLE);	//ⲿźŲرbypassbuffer
			ANAC_ADCINSEL_BUFEN_Setable(ENABLE);	//bufferen
			ANAC_ADCINSEL_BUFSEL_Set((ANAC_ADCINSEL_BUFSEL_ADC_IN1 + (ChSel_def - CH_IN1)));//ͨѡ
			break;
		
		default:
			break;
	}
}


/*ADC ѹ㺯
	룺ADֵԴѹ
	ѹ@mV 
*/
//ѹ100mVԽ̫׼ȷ
//ѹ4.4VԽ̫׼ȷ
//ѹɳԴѹ
//ѹɳ4.5V
/*********************************
ADCѹ㺯 
ܣADCѹֵ
: ADCֵԴѹ
: ѹֵ
*********************************/
uint32_t ANAC_ADC_VoltageCalc(uint32_t fADCData,uint8_t Vdd)
{
	uint32_t fVolt = 0;
	uint32_t AdcTrim = 0;
	AdcTrim = ANAC_ADCTRIM_Read();

	if((AdcTrim == 0x0ff)&&(const_adc_Slope_0FF > 8000) && (const_adc_Slope_0FF < 9600))//adctrim0ffĳɲ
	{
			//ʹóɲ	
			//ADCֵΪѹֵ
			if(fADCData <= 8)
				fVolt = 0;
			else if(fADCData <= 12)
				fVolt = (fADCData-8)*20;
			else if(fADCData <= 37)
				fVolt = fADCData*const_adc_Slope_0FF/1000;
			else if(fADCData <= 125)
				fVolt = (fADCData*98*const_adc_Slope_0FF/100000);
			else
				fVolt = fADCData*const_adc_Slope_0FF/1000+const_adc_Offset_0FF/100;	
	}
	else if((AdcTrim == 0x1ff)&&(const_adc_Slope_1FF > 4000) && (const_adc_Slope_1FF < 4800))//adctrim1ffĳɲ
	{
			//ʹóɲ	
			//ADCֵΪѹֵ
			if(fADCData <= 15)
				fVolt = 0;
			else if(fADCData <= 25)
				fVolt = (fADCData-15)*10;
			else if(fADCData <= 75)
				fVolt = fADCData*const_adc_Slope_1FF/1000;
			else if(fADCData <= 250)
				fVolt = (fADCData*98*const_adc_Slope_1FF/100000);
			else
				fVolt = fADCData*const_adc_Slope_1FF/1000+const_adc_Offset_1FF/100;	
	}
	else
	{
		if(AdcTrim == 0x1ff)
		{
			fADCData*=2;//adcֵ2
		}
		else if(AdcTrim == 0x0ff)
		{
			fADCData*=4;//adcֵ4
		}
		else
		{
			
		}			
		if( (const_adc_Slope > 2000) && (const_adc_Slope < 2400) )
		{
					//ʹóɲ	
					//ADCֵΪѹֵ
					if(fADCData <= 30)
						fVolt = 0;
					else if(fADCData <= 50)
						fVolt = (fADCData-30)*5;
					else if(fADCData <= 150)
						fVolt = fADCData*const_adc_Slope/1000;
					else if(fADCData <= 500)
						fVolt = (fADCData*98*const_adc_Slope/100000);
					else
						fVolt = fADCData*const_adc_Slope/1000+const_adc_Offset/100;	
		}
		else
		{
			//ʱʹ
			fVolt = (fADCData - 10)*2174/1000;
		}	
	}
  if(Vdd==3)
  {
    fVolt=(fVolt*102/100);
  }
	
	return fVolt;
}

/*ADC ¶ȼ㺯
	룺ADֵ	 floatͣ㴦ƽֵ
	룺Դѹ uint08 ֧3/5Vѹ
	¶@ float
*/
/*********************************
ADC¶ȼ㺯 
ܣADC¶ֵ
: ADCֵԴѹ
: ¶ֵ
*********************************/
float ANAC_ADC_TemperatureCalc(float fADCData ,uint8_t Vdd)
{
	float fTestADC, fTestT, fFa;
	float fTemperature;
		
	if( const_temp_TestA == 0x1E )
	{
		//ʹ¶ȶ
		fTestT = const_temp_TestA+(float)(const_temp_TestB/0x80)*0.5;
		if( Vdd == 3 )
		{
			fTestADC = const_adc_Test  - const_T_Offset3V*const_TmpsH;
		}
		else
		{			
			fTestADC = const_adc_Test  - const_T_Offset5V*const_TmpsH;
		}
	}
	else
	{
		//ʱʹ
		fTestT = 30;
		fTestADC = 1500;
	}
	
	if( fADCData > (fTestADC-25) )	//
		fFa = const_TmpsH;
	else
		fFa = const_TmpsL;

	fTemperature = (fADCData - fTestADC)/fFa + fTestT;
	
	return fTemperature;
}

/*ADC ¶ȼ㺯
	룺ADֵ	  uint32_t(ٶȿ)
	룺Դѹ uint08 ֧3/5Vѹ
	¶@ uint32_t
*/
/*********************************
ADC¶ȼ㺯 
ܣADC¶ֵ
: ADCֵԴѹ
: ¶ֵ
*********************************/
int32_t ANAC_ADC_TemperatureCalcInt(uint32_t ADCData ,uint8_t Vdd)
{
	uint32_t TestADC;
	int32_t TestT,Fa;
	int32_t Temperature;
		
	if( const_temp_TestA == 0x1E )
	{
		//ʹ¶ȶ
		TestT = const_temp_TestA;
		if( Vdd == 3 )
		{
			TestADC = (int32_t)const_adc_Test  - (int32_t)const_T_Offset3V*(const_TmpsH*10000)/10000;
		}
		else
		{			
			TestADC = (int32_t)const_adc_Test  - (int32_t)const_T_Offset5V*(const_TmpsH*10000)/10000;
		}
	}
	else
	{
		//ʱʹ
		TestT = 30;
		TestADC = 1500;
	}
	
	if( ADCData > (TestADC-25) )	//
		Fa = const_TmpsH*10000;
	else
		Fa = const_TmpsL*10000;

	Temperature = ((int32_t)(ADCData - TestADC)*10000)/Fa + TestT;
	
	return Temperature;
}
/*********************************
Ƚʼú 
ܣñȽ
: ANAC_COMPx_InitTypeDef* para  Ƚ12 Ĵ롢롢жʹܵȲ
: 
*********************************/
void ANAC_COMPx_Init(ANAC_COMPx_InitTypeDef* para)
{
	if(para->COMPx == 1)//Ƚ1
	{
		ANAC_COMP1CR_V1PSEL_Set(para->VxPSEL);		//Ƚxѡ
		ANAC_COMP1CR_V1NSEL_Set(para->VxNSEL);		//Ƚxѡ
		ANAC_COMPICR_CMP1SEL_Set(para->CMPxSEL);	//ȽxжԴѡ
		ANAC_COMPICR_CMP1IE_Setable(para->CMPxIE);	//xжʹ
		ANAC_COMPICR_CMP1DF_Setable(para->CMPxDF);	//Ƚx˲ʹ
		ANAC_COMP1CR_CMP1EN_Setable(para->CMPxEN);	//Ƚxʹ
	}
	else		//Ƚ2
	{
		ANAC_COMP2CR_V2PSEL_Set(para->VxPSEL);		//Ƚxѡ
		ANAC_COMP2CR_V2NSEL_Set(para->VxNSEL);		//Ƚxѡ
		ANAC_COMPICR_CMP2SEL_Set(para->CMPxSEL);	//ȽxжԴѡ
		ANAC_COMPICR_CMP2IE_Setable(para->CMPxIE);	//xжʹ
		ANAC_COMPICR_CMP2DF_Setable(para->CMPxDF);	//Ƚx˲ʹ
		ANAC_COMP2CR_CMP2EN_Setable(para->CMPxEN);	//Ƚxʹ	
	}
}


/******END OF FILE****/



