/**
  ******************************************************************************
  * @file    fm33g0xx_btim.c
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/

/* Includes ------------------------------------------------------------------*/
#include "fm33g0xx_btim.h"  


/** @addtogroup fm33g0xx_StdPeriph_Driver
  * @{
  */

/** @defgroup BTIM 
  * @brief BTIM driver modules
  * @{
  */ 

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/** @defgroup BTIM_Private_Functions
  * @{
  */ 



/*********************************
basic timerλƺ 
ܣBTλͣ
: ENABLE λ
      DISABLE ֹͣλ
      BTIM1/BTIM2  ʱ
: 
*********************************/
void BTIMx_BTCR1_CHEN_Setable(BTIMx_Type* BTIMx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		BTIMx->BTCR1 |= (BTIMx_BTCR1_CHEN_Msk);
	}
	else
	{
		BTIMx->BTCR1 &= ~(BTIMx_BTCR1_CHEN_Msk);
	}
}
/*********************************
basic timerλλ״̬ȡ 
ܣȡBTλͣ״̬
: BTIM1/BTIM2  ʱ
: ENABLE ǰBTλ
      DISABLE ǰBTλֹͣ
*********************************/
FunState BTIMx_BTCR1_CHEN_Getable(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTCR1 & (BTIMx_BTCR1_CHEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
basic timerλƺ 
ܣBTλͣ
: ENABLE λ
      DISABLE ֹͣλ
      BTIM1/BTIM2  ʱ
: 
*********************************/
void BTIMx_BTCR1_CLEN_Setable(BTIMx_Type* BTIMx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		BTIMx->BTCR1 |= (BTIMx_BTCR1_CLEN_Msk);
	}
	else
	{
		BTIMx->BTCR1 &= ~(BTIMx_BTCR1_CLEN_Msk);
	}
}
/*********************************
basic timerλλ״̬ȡ 
ܣȡBTλͣ״̬
: BTIM1/BTIM2  ʱ
: ENABLE ǰBTλ
      DISABLE ǰBTλֹͣ
*********************************/
FunState BTIMx_BTCR1_CLEN_Getable(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTCR1 & (BTIMx_BTCR1_CLEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
basic timerģʽú 
ܣBTģʽ
: BTIM1/BTIM2  ʱ
      BTIMx_BTCR1_MODE_8BITS_TIM_CNT/BTIMx_BTCR1_MODE_16BITS_CAP 8λ/16λʱ      
: 
*********************************/
void BTIMx_BTCR1_MODE_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCR1;
	tmpreg &= ~(BTIMx_BTCR1_MODE_Msk);
	tmpreg |= (SetValue & BTIMx_BTCR1_MODE_Msk);
	BTIMx->BTCR1 = tmpreg;
}
/*********************************
basic timerȡģʽú 
ܣȡBTģʽ
: BTIM1/BTIM2  ʱ
: BTIMx_BTCR1_MODE_8BITS_TIM_CNT/BTIMx_BTCR1_MODE_16BITS_CAP 8λ/16λʱ
*********************************/
uint32_t BTIMx_BTCR1_MODE_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCR1 & BTIMx_BTCR1_MODE_Msk);
}

/*********************************
basic timerģʽú 
ܣBTļػ׽
: BTIM1/BTIM2  ʱ
      BTIMx_BTCR1_EDGESEL_POS/BTIMx_BTCR1_EDGESEL_NEG ػ׽Ϊ/½      
: 
*********************************/
void BTIMx_BTCR1_EDGESEL_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCR1;
	tmpreg &= ~(BTIMx_BTCR1_EDGESEL_Msk);
	tmpreg |= (SetValue & BTIMx_BTCR1_EDGESEL_Msk);
	BTIMx->BTCR1 = tmpreg;
}
/*********************************
basic timerȡģʽú 
ܣȡBTļػ׽ؾ巽ʽ
: BTIM1/BTIM2  ʱ
: BTIMx_BTCR1_EDGESEL_POS/BTIMx_BTCR1_EDGESEL_NEG ػ׽Ϊ/½ 
*********************************/
uint32_t BTIMx_BTCR1_EDGESEL_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCR1 & BTIMx_BTCR1_EDGESEL_Msk);
}


/*********************************
basic timerģʽú 
ܣBTĲ׽ģʽƣ׽ģʽЧ
: BTIM1/BTIM2  ʱ
      BTIMx_BTCR1_CAPMOD_PAUSE_PERIOD/BTIMx_BTCR1_CAPMOD_PAUSE_WIDTH ڲ׽/Ȳ׽
: 
*********************************/
void BTIMx_BTCR1_CAPMOD_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCR1;
	tmpreg &= ~(BTIMx_BTCR1_CAPMOD_Msk);
	tmpreg |= (SetValue & BTIMx_BTCR1_CAPMOD_Msk);
	BTIMx->BTCR1 = tmpreg;
}
/*********************************
basic timerȡģʽú 
ܣȡBTĲ׽ģʽƣ׽ģʽЧ
: BTIM1/BTIM2  ʱ    
: BTIMx_BTCR1_CAPMOD_PAUSE_PERIOD/BTIMx_BTCR1_CAPMOD_PAUSE_WIDTH ڲ׽/Ȳ׽
*********************************/
uint32_t BTIMx_BTCR1_CAPMOD_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCR1 & BTIMx_BTCR1_CAPMOD_Msk);
}


/*********************************
basic timerģʽú 
ܣBTĴ㲶׽ģʽǷ
: BTIM1/BTIM2  ʱ
      BTIMx_BTCR1_CAPCLR_CAP_CNT_NO_CLR/BTIMx_BTCR1_CAPCLR_CAP_CNT_CLR  ׽/׽    
: 
*********************************/
void BTIMx_BTCR1_CAPCLR_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCR1;
	tmpreg &= ~(BTIMx_BTCR1_CAPCLR_Msk);
	tmpreg |= (SetValue & BTIMx_BTCR1_CAPCLR_Msk);
	BTIMx->BTCR1 = tmpreg;
}
/*********************************
basic timerȡģʽú 
ܣȡBTĲ׽ģʽ
: BTIM1/BTIM2  ʱ    
: BTIMx_BTCR1_CAPCLR_CAP_CNT_NO_CLR/BTIMx_BTCR1_CAPCLR_CAP_CNT_CLR  ׽/׽    
*********************************/
uint32_t BTIMx_BTCR1_CAPCLR_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCR1 & BTIMx_BTCR1_CAPCLR_Msk);
}

/*********************************
basic timerģʽú 
ܣBTǷ񵥴β׽
: BTIM1/BTIM2  ʱ
      BTIMx_BTCR1_CAPONCE_CONTINUE/BTIMx_BTCR1_CAPONCE_SINGLE    ׽/β׽
: 
*********************************/
void BTIMx_BTCR1_CAPONCE_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCR1;
	tmpreg &= ~(BTIMx_BTCR1_CAPONCE_Msk);
	tmpreg |= (SetValue & BTIMx_BTCR1_CAPONCE_Msk);
	BTIMx->BTCR1 = tmpreg;
}
/*********************************
basic timerģʽú 
ܣBTò׽ʽ
: BTIM1/BTIM2  ʱ
: BTIMx_BTCR1_CAPONCE_CONTINUE/BTIMx_BTCR1_CAPONCE_SINGLE    ׽/β׽
*********************************/
uint32_t BTIMx_BTCR1_CAPONCE_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCR1 & BTIMx_BTCR1_CAPONCE_Msk);
}

/*********************************
basic timerģʽú 
ܣBT PWMǷЧ
: BTIM1/BTIM2  ʱ
      ENABLE/DISABLE   PWMģʽЧ/Ч
: 
*********************************/
void BTIMx_BTCR1_PWM_Setable(BTIMx_Type* BTIMx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		BTIMx->BTCR1 |= (BTIMx_BTCR1_PWM_Msk);
	}
	else
	{
		BTIMx->BTCR1 &= ~(BTIMx_BTCR1_PWM_Msk);
	}
}
/*********************************
basic timerģʽú 
ܣBT PWMǷЧ
: BTIM1/BTIM2  ʱ
: ENABLE/DISABLE   PWMģʽЧ/Ч
*********************************/
FunState BTIMx_BTCR1_PWM_Getable(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTCR1 & (BTIMx_BTCR1_PWM_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
basic timerڲԴźѡú 
ܣBT ڲԴźѡ
: BTIM1/BTIM2  ʱ
      BTIMx_BTCR2_SIG2SEL_GROUP1/BTIMx_BTCR2_SIG2SEL_GROUP2 ڲԴѡGroup1/Group2
: 
*********************************/
void BTIMx_BTCR2_SIG2SEL_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCR2;
	tmpreg &= ~(BTIMx_BTCR2_SIG2SEL_Msk);
	tmpreg |= (SetValue & BTIMx_BTCR2_SIG2SEL_Msk);
	BTIMx->BTCR2 = tmpreg;
}
/*********************************
basic timerڲԴźѡú
ܣȡBTڲԴźѡ
: BTIM1/BTIM2  ʱ
: BTIMx_BTCR2_SIG2SEL_GROUP1/BTIMx_BTCR2_SIG2SEL_GROUP2 ڲԴѡGroup1/Group2
*********************************/
uint32_t BTIMx_BTCR2_SIG2SEL_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCR2 & BTIMx_BTCR2_SIG2SEL_Msk);
}

/*********************************
basic timerڲ׽Դźѡú 
ܣBT ڲ׽Դźѡ
: BTIM1/BTIM2  ʱ
      BTIMx_BTCR2_SIG1SEL_GROUP1/BTIMx_BTCR2_SIG1SEL_GROUP2 ڲ׽ԴѡGroup1/Group2
: 
*********************************/
void BTIMx_BTCR2_SIG1SEL_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCR2;
	tmpreg &= ~(BTIMx_BTCR2_SIG1SEL_Msk);
	tmpreg |= (SetValue & BTIMx_BTCR2_SIG1SEL_Msk);
	BTIMx->BTCR2 = tmpreg;
}
/*********************************
basic timerڲ׽Դźѡú
ܣȡBTڲ׽Դźѡ
: BTIM1/BTIM2  ʱ
: BTIMx_BTCR2_SIG1SEL_GROUP1/BTIMx_BTCR2_SIG1SEL_GROUP2 ڲ׽ԴѡGroup1/Group2
*********************************/
uint32_t BTIMx_BTCR2_SIG1SEL_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCR2 & BTIMx_BTCR2_SIG1SEL_Msk);
}

/*********************************
basic timerλԴѡú 
ܣBT λԴѡ
: BTIM1/BTIM2  ʱ
      BTIMx_BTCR2_CNTHSEL_CNTL/BTIMx_BTCR2_CNTHSEL_CAPSRC/BTIMx_BTCR2_CNTHSEL_CNTSRC_DIR λ16λ/ѡڲ׽źԴ/ѡڲźԴⲿDIR
: 
*********************************/
void BTIMx_BTCR2_CNTHSEL_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCR2;
	tmpreg &= ~(BTIMx_BTCR2_CNTHSEL_Msk);
	tmpreg |= (SetValue & BTIMx_BTCR2_CNTHSEL_Msk);
	BTIMx->BTCR2 = tmpreg;
}
/*********************************
basic timerλԴѡú
ܣȡBTλԴѡ
: BTIM1/BTIM2  ʱ
: BTIMx_BTCR2_CNTHSEL_CNTL/BTIMx_BTCR2_CNTHSEL_CAPSRC/BTIMx_BTCR2_CNTHSEL_CNTSRC_DIR λ16λ/ѡڲ׽źԴ/ѡڲźԴⲿDIR
*********************************/
uint32_t BTIMx_BTCR2_CNTHSEL_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCR2 & BTIMx_BTCR2_CNTHSEL_Msk);
}

/*********************************
basic timerⲿDIRú 
ܣBT ⲿDIR
: BTIM1/BTIM2  ʱ
      ENABLE/DISABLE	ⲿDIRЧ/Ч
: 
*********************************/
void BTIMx_BTCR2_DIREN_Setable(BTIMx_Type* BTIMx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		BTIMx->BTCR2 |= (BTIMx_BTCR2_DIREN_Msk);
	}
	else
	{
		BTIMx->BTCR2 &= ~(BTIMx_BTCR2_DIREN_Msk);
	}
}
/*********************************
basic timerⲿDIRú 
ܣȡBTⲿDIR״̬
: BTIM1/BTIM2  ʱ
: NABLE/DISABLE	ⲿDIRЧ/Ч
*********************************/
FunState BTIMx_BTCR2_DIREN_Getable(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTCR2 & (BTIMx_BTCR2_DIREN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
basic timerڲDIRú 
ܣBT ڲDIR
: BTIM1/BTIM2  ʱ
      ENABLE/DISABLE	ڲDIRЧ/Ч
: 
*********************************/
void BTIMx_BTCR2_STDIR_Setable(BTIMx_Type* BTIMx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		BTIMx->BTCR2 |= (BTIMx_BTCR2_STDIR_Msk);
	}
	else
	{
		BTIMx->BTCR2 &= ~(BTIMx_BTCR2_STDIR_Msk);
	}
}
/*********************************
basic timerڲDIRú 
ܣȡBTڲDIR״̬
: BTIM1/BTIM2  ʱ
: NABLE/DISABLE	ڲDIRЧ/Ч
*********************************/
FunState BTIMx_BTCR2_STDIR_Getable(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTCR2 & (BTIMx_BTCR2_STDIR_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
basic timerλƺ 
ܣBT λʹܿѡź
: BTIM1/BTIM2  ʱ
      BTIMx_BTCR2_SRCSEL_STDIR_EXSIG2/BTIMx_BTCR2_SRCSEL_WITHOUT_DIR	λSTDIRⲿEX_SIG2/λDIR
: 
*********************************/
void BTIMx_BTCR2_SRCSEL_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCR2;
	tmpreg &= ~(BTIMx_BTCR2_SRCSEL_Msk);
	tmpreg |= (SetValue & BTIMx_BTCR2_SRCSEL_Msk);
	BTIMx->BTCR2 = tmpreg;
}

/*********************************
basic timerλƺ 
ܣȡBTλʹܿѡź
: BTIM1/BTIM2  ʱ
: BTIMx_BTCR2_SRCSEL_STDIR_EXSIG2/BTIMx_BTCR2_SRCSEL_WITHOUT_DIR	λSTDIRⲿEX_SIG2/λDIR
*********************************/
uint32_t BTIMx_BTCR2_SRCSEL_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCR2 & BTIMx_BTCR2_SRCSEL_Msk);
}

/*********************************
basic timerź2ƺ 
ܣBT ź2
: BTIM1/BTIM2  ʱ
      BTIMx_BTCR2_DIRPO_NO_ANTI/BTIMx_BTCR2_DIRPO_ANTI	ⲿDIRźŲ/ⲿDIRźȡ
: 
*********************************/
void BTIMx_BTCR2_DIRPO_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCR2;
	tmpreg &= ~(BTIMx_BTCR2_DIRPO_Msk);
	tmpreg |= (SetValue & BTIMx_BTCR2_DIRPO_Msk);
	BTIMx->BTCR2 = tmpreg;
}
/*********************************
basic timerź2ƺ 
ܣȡBTź2
: BTIM1/BTIM2  ʱ
: BTIMx_BTCR2_DIRPO_NO_ANTI/BTIMx_BTCR2_DIRPO_ANTI	ⲿDIRźŲ/ⲿDIRźȡ
*********************************/
uint32_t BTIMx_BTCR2_DIRPO_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCR2 & BTIMx_BTCR2_DIRPO_Msk);
}

/*********************************
basic timer RTCOUT2źԴѡ 
ܣBT RTCOUT2źԴ
: BTIM1/BTIM2  ʱ
      BTIMx_BTCFG1_RTCSEL2_RTC_32768/	RTCģ32768Hzź
      BTIMx_BTCFG1_RTCSEL2_RTC_SEC/	RTCģź
      BTIMx_BTCFG1_RTCSEL2_RTC_MIN/	RTCģķź
      BTIMx_BTCFG1_RTCSEL2_LPTIM_OUT	LPTIMģź
: 
*********************************/
void BTIMx_BTCFG1_RTCSEL2_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCFG1;
	tmpreg &= ~(BTIMx_BTCFG1_RTCSEL2_Msk);
	tmpreg |= (SetValue & BTIMx_BTCFG1_RTCSEL2_Msk);
	BTIMx->BTCFG1 = tmpreg;
}
/*********************************
basic timer RTCOUT2źԴѡ 
ܣȡBT RTCOUT2źԴ
: BTIM1/BTIM2  ʱ
: BTIMx_BTCFG1_RTCSEL2_RTC_32768/	RTCģ32768Hzź
      BTIMx_BTCFG1_RTCSEL2_RTC_SEC/	RTCģź
      BTIMx_BTCFG1_RTCSEL2_RTC_MIN/	RTCģķź
      BTIMx_BTCFG1_RTCSEL2_LPTIM_OUT	LPTIMģź
*********************************/
uint32_t BTIMx_BTCFG1_RTCSEL2_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCFG1 & BTIMx_BTCFG1_RTCSEL2_Msk);
}


/*********************************
basic timer RTCOUT1źԴѡ 
ܣBT RTCOUT1źԴ
: BTIM1/BTIM2  ʱ
      BTIMx_BTCFG1_RTCSEL1_RTC_32768/	RTCģ32768Hzź
      BTIMx_BTCFG1_RTCSEL1_RTC_SEC/	RTCģź
      BTIMx_BTCFG1_RTCSEL1_RTC_MIN/	RTCģķź
      BTIMx_BTCFG1_RTCSEL1_LPTIM_OUT	LPTIMģź
: 
*********************************/
void BTIMx_BTCFG1_RTCSEL1_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCFG1;
	tmpreg &= ~(BTIMx_BTCFG1_RTCSEL1_Msk);
	tmpreg |= (SetValue & BTIMx_BTCFG1_RTCSEL1_Msk);
	BTIMx->BTCFG1 = tmpreg;
}
/*********************************
basic timer RTCOUT1źԴѡ  
ܣȡBT RTCOUT1źԴ
: BTIM1/BTIM2  ʱ
: BTIMx_BTCFG1_RTCSEL1_RTC_32768/	RTCģ32768Hzź
      BTIMx_BTCFG1_RTCSEL1_RTC_SEC/	RTCģź
      BTIMx_BTCFG1_RTCSEL1_RTC_MIN/	RTCģķź
      BTIMx_BTCFG1_RTCSEL1_LPTIM_OUT	LPTIMģź
*********************************/
uint32_t BTIMx_BTCFG1_RTCSEL1_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCFG1 & BTIMx_BTCFG1_RTCSEL1_Msk);
}

/*********************************
basic timer Group2źԴѡ 
ܣBT Group2źԴ
: BTIM1/BTIM2  ʱ
      BTIMx_BTCFG1_GRP2SEL_APBCLK/	ϵͳʱAPBCLK
      BTIMx_BTCFG1_GRP2SEL_RTCOUT2/	RTCʱRTCOUT2
      BTIMx_BTCFG1_GRP2SEL_IN_SIG2/	ڲź2
      BTIMx_BTCFG1_GRP2SEL_EX_SIG2	ⲿź2
: 
*********************************/
void BTIMx_BTCFG1_GRP2SEL_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCFG1;
	tmpreg &= ~(BTIMx_BTCFG1_GRP2SEL_Msk);
	tmpreg |= (SetValue & BTIMx_BTCFG1_GRP2SEL_Msk);
	BTIMx->BTCFG1 = tmpreg;
}
/*********************************
basic timer Group2źԴѡ
ܣȡBT Group2źԴ
: BTIM1/BTIM2  ʱ
: BTIMx_BTCFG1_GRP2SEL_APBCLK/	ϵͳʱAPBCLK
      BTIMx_BTCFG1_GRP2SEL_RTCOUT2/	RTCʱRTCOUT2
      BTIMx_BTCFG1_GRP2SEL_IN_SIG2/	ڲź2
      BTIMx_BTCFG1_GRP2SEL_EX_SIG2	ⲿź2
*********************************/
uint32_t BTIMx_BTCFG1_GRP2SEL_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCFG1 & BTIMx_BTCFG1_GRP2SEL_Msk);
}
/*********************************
basic timer Group1źԴѡ 
ܣBT Group1źԴ
: BTIM1/BTIM2  ʱ
      BTIMx_BTCFG1_GRP1SEL_APBCLK/	ϵͳʱAPBCLK
      BTIMx_BTCFG1_GRP1SEL_RTCOUT2/	RTCʱRTCOUT2
      BTIMx_BTCFG1_GRP1SEL_IN_SIG2/	ڲź2
      BTIMx_BTCFG1_GRP1SEL_EX_SIG2	ⲿź2
: 
*********************************/
void BTIMx_BTCFG1_GRP1SEL_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCFG1;
	tmpreg &= ~(BTIMx_BTCFG1_GRP1SEL_Msk);
	tmpreg |= (SetValue & BTIMx_BTCFG1_GRP1SEL_Msk);
	BTIMx->BTCFG1 = tmpreg;
}
/*********************************
basic timer Group1źԴѡ
ܣȡBT Group1źԴ
: BTIM1/BTIM2  ʱ
: BTIMx_BTCFG1_GRP1SEL_APBCLK/	ϵͳʱAPBCLK
      BTIMx_BTCFG1_GRP1SEL_RTCOUT2/	RTCʱRTCOUT2
      BTIMx_BTCFG1_GRP1SEL_IN_SIG2/	ڲź2
      BTIMx_BTCFG1_GRP1SEL_EX_SIG2	ⲿź2
*********************************/
uint32_t BTIMx_BTCFG1_GRP1SEL_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCFG1 & BTIMx_BTCFG1_GRP1SEL_Msk);
}


/*********************************
basic timer ⲿźԴ2ѡ 
ܣBT ⲿźԴ2
: BTIM1/BTIM2  ʱ
      BTIMx_BTCFG2_EXSEL2_BT_IN0	ⲿ1
      BTIMx_BTCFG2_EXSEL2_BT_IN1	ⲿ2
      BTIMx_BTCFG2_EXSEL2_BT_IN2	ⲿ3
      BTIMx_BTCFG2_EXSEL2_BT_IN3	ⲿ4
: 
*********************************/
void BTIMx_BTCFG2_EXSEL2_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCFG2;
	tmpreg &= ~(BTIMx_BTCFG2_EXSEL2_Msk);
	tmpreg |= (SetValue & BTIMx_BTCFG2_EXSEL2_Msk);
	BTIMx->BTCFG2 = tmpreg;
}
/*********************************
basic timer ⲿźԴ2ѡ 
ܣȡBT ⲿźԴ2
: BTIM1/BTIM2  ʱ
: BTIMx_BTCFG2_EXSEL2_BT_IN0	ⲿ1
      BTIMx_BTCFG2_EXSEL2_BT_IN1	ⲿ2
      BTIMx_BTCFG2_EXSEL2_BT_IN2	ⲿ3
      BTIMx_BTCFG2_EXSEL2_BT_IN3	ⲿ4
*********************************/
uint32_t BTIMx_BTCFG2_EXSEL2_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCFG2 & BTIMx_BTCFG2_EXSEL2_Msk);
}

/*********************************
basic timer ⲿźԴ1ѡ 
ܣBT ⲿźԴ1
: BTIM1/BTIM2  ʱ
      BTIMx_BTCFG2_EXSEL1_BT_IN0	ⲿ1
      BTIMx_BTCFG2_EXSEL1_BT_IN1	ⲿ2
      BTIMx_BTCFG2_EXSEL1_BT_IN2	ⲿ3
      BTIMx_BTCFG2_EXSEL1_BT_IN3	ⲿ4
: 
*********************************/
void BTIMx_BTCFG2_EXSEL1_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCFG2;
	tmpreg &= ~(BTIMx_BTCFG2_EXSEL1_Msk);
	tmpreg |= (SetValue & BTIMx_BTCFG2_EXSEL1_Msk);
	BTIMx->BTCFG2 = tmpreg;
}
/*********************************
basic timer ⲿźԴ1ѡ 
ܣȡBT ⲿźԴ1
: BTIM1/BTIM2  ʱ
: BTIMx_BTCFG2_EXSEL1_BT_IN0	ⲿ1
      BTIMx_BTCFG2_EXSEL1_BT_IN1	ⲿ2
      BTIMx_BTCFG2_EXSEL1_BT_IN2	ⲿ3
      BTIMx_BTCFG2_EXSEL1_BT_IN3	ⲿ4
*********************************/
uint32_t BTIMx_BTCFG2_EXSEL1_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCFG2 & BTIMx_BTCFG2_EXSEL1_Msk);
}

/*********************************
basic timer ڲźԴ2ѡ 
ܣBT ڲźԴ2
: BTIM1/BTIM2  ʱ
      BTIMx_BTCFG2_INSEL2_UART_RX3	ѡUART3źźԴ
      BTIMx_BTCFG2_INSEL2_UART_RX4	ѡUART4źźԴ
      BTIMx_BTCFG2_INSEL2_UART_RX5	ѡUART5źźԴ
      BTIMx_BTCFG2_INSEL2_RCLP		ѡRCLPźԴ
      BTIMx_BTCFG2_INSEL2_BT1_OUT	ѡBT1źԴ
: 
*********************************/
void BTIMx_BTCFG2_INSEL2_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCFG2;
	tmpreg &= ~(BTIMx_BTCFG2_INSEL2_Msk);
	tmpreg |= (SetValue & BTIMx_BTCFG2_INSEL2_Msk);
	BTIMx->BTCFG2 = tmpreg;
}
/*********************************
basic timer ڲźԴ2ѡ 
ܣȡBT ڲźԴ2
: BTIM1/BTIM2  ʱ
: BTIMx_BTCFG2_INSEL2_UART_RX3	źԴΪUART3ź
      BTIMx_BTCFG2_INSEL2_UART_RX4	źԴΪUART4ź
      BTIMx_BTCFG2_INSEL2_UART_RX5	źԴΪUART5ź
      BTIMx_BTCFG2_INSEL2_RCLP		źԴΪRCLPźԴ
      BTIMx_BTCFG2_INSEL2_BT1_OUT	źԴΪBT1
*********************************/
uint32_t BTIMx_BTCFG2_INSEL2_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCFG2 & BTIMx_BTCFG2_INSEL2_Msk);
}
/*********************************
basic timer ڲźԴ1ѡ 
ܣBT ڲźԴ1
: BTIM1/BTIM2  ʱ
      BTIMx_BTCFG2_INSEL1_UART_RX0	ѡUART0źźԴ
      BTIMx_BTCFG2_INSEL1_UART_RX1	ѡUART1źźԴ
      BTIMx_BTCFG2_INSEL1_UART_RX2	ѡUART2źźԴ
      BTIMx_BTCFG2_INSEL1_RCLP		ѡRCLPźԴ
: 
*********************************/
void BTIMx_BTCFG2_INSEL1_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTCFG2;
	tmpreg &= ~(BTIMx_BTCFG2_INSEL1_Msk);
	tmpreg |= (SetValue & BTIMx_BTCFG2_INSEL1_Msk);
	BTIMx->BTCFG2 = tmpreg;
}

/*********************************
basic timer ڲźԴ1ѡ 
ܣȡBT ڲźԴ1
: BTIM1/BTIM2  ʱ
: BTIMx_BTCFG2_INSEL1_UART_RX0	źԴΪUART0ź
      BTIMx_BTCFG2_INSEL1_UART_RX1	źԴΪUART1ź
      BTIMx_BTCFG2_INSEL1_UART_RX2	źԴΪUART2ź
      BTIMx_BTCFG2_INSEL1_RCLP		źԴΪRCLPźԴ
*********************************/
uint32_t BTIMx_BTCFG2_INSEL1_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCFG2 & BTIMx_BTCFG2_INSEL1_Msk);
}

/*********************************
basic timer group1ԤƵƺ 
ܣBT group1ԤƵ
: BTIM1/BTIM2  ʱ
      Ƶֵ00-FF00ʾ1ƵFFʾ256Ƶ
: 
*********************************/
void BTIMx_BTPRES_Write(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	BTIMx->BTPRES = (SetValue & BTIMx_BTPRES_PRESCALE_Msk);
}
/*********************************
basic timer group1ԤƵƺ 
ܣȡBT group1ԤƵ
: BTIM1/BTIM2  ʱ
      
: 00-FF 00ʾ1ƵFFʾ256Ƶ
*********************************/
uint32_t BTIMx_BTPRES_Read(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTPRES & BTIMx_BTPRES_PRESCALE_Msk);
}
/*********************************
basic timer group1ؿƺ 
ܣʹBTλ
: BTIM1/BTIM2  ʱ
      ENABLE λ
      DISABLE λֹͣ
: 
*********************************/
void BTIMx_BTLOADCR_LHEN_Setable(BTIMx_Type* BTIMx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		BTIMx->BTLOADCR |= (BTIMx_BTLOADCR_LHEN_Msk);
	}
	else
	{
		BTIMx->BTLOADCR &= ~(BTIMx_BTLOADCR_LHEN_Msk);
	}
}
/*********************************
basic timer group1ؿƺ 
ܣʹBTλ
: BTIM1/BTIM2  ʱ
      ENABLE λ
      DISABLE λֹͣ
: 
*********************************/
void BTIMx_BTLOADCR_LLEN_Setable(BTIMx_Type* BTIMx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		BTIMx->BTLOADCR |= (BTIMx_BTLOADCR_LLEN_Msk);
	}
	else
	{
		BTIMx->BTLOADCR &= ~(BTIMx_BTLOADCR_LLEN_Msk);
	}
}

/*********************************
basic timer ֵغ 
ܣȡλֵ
: BTIM1/BTIM2  ʱ
: 0000-FFFF ֵ
*********************************/
uint32_t BTIMx_BTCNTL_Read(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCNTL & BTIMx_BTCNTL_CNTL_Msk);
}

/*********************************
basic timer ֵغ 
ܣȡλֵ
: BTIM1/BTIM2  ʱ
: 0000-FFFF ֵ
*********************************/
uint32_t BTIMx_BTCNTH_Read(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCNTH & BTIMx_BTCNTH_CNTH_Msk);
}

/*********************************
basic timer Ԥغ 
ܣüλԤ
: BTIM1/BTIM2  ʱ
      0000-FFFF  Ԥֵ
*********************************/
void BTIMx_BTPRESET_PRESETH_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTPRESET;
	tmpreg &= ~(BTIMx_BTPRESET_PRESETH_Msk);
	tmpreg |= (SetValue & BTIMx_BTPRESET_PRESETH_Msk);
	BTIMx->BTPRESET = tmpreg;
}
/*********************************
basic timer Ԥغ 
ܣȡλԤ
: BTIM1/BTIM2  ʱ
: 0000-FFFF  Ԥֵ
*********************************/
uint32_t BTIMx_BTPRESET_PRESETH_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTPRESET & BTIMx_BTPRESET_PRESETH_Msk);
}

/*********************************
basic timer Ԥغ 
ܣüλԤ
: BTIM1/BTIM2  ʱ
      0000-FFFF  Ԥֵ
*********************************/
void BTIMx_BTPRESET_PRESETL_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTPRESET;
	tmpreg &= ~(BTIMx_BTPRESET_PRESETL_Msk);
	tmpreg |= (SetValue & BTIMx_BTPRESET_PRESETL_Msk);
	BTIMx->BTPRESET = tmpreg;
}

/*********************************
basic timer Ԥغ 
ܣȡλԤ
: BTIM1/BTIM2  ʱ
: 0000-FFFF  Ԥֵ
*********************************/
uint32_t BTIMx_BTPRESET_PRESETL_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTPRESET & BTIMx_BTPRESET_PRESETL_Msk);
}

/*********************************
basic timer غ 
ܣüλ
: BTIM1/BTIM2  ʱ
      0000-FFFF  ֵ
*********************************/
void BTIMx_BTLOADL_Write(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	BTIMx->BTLOADL = (SetValue & BTIMx_BTLOADL_LOADL_Msk);
}
/*********************************
basic timer غ 
ܣȡλ
: BTIM1/BTIM2  ʱ
: 0000-FFFF  ֵ
*********************************/
uint32_t BTIMx_BTLOADL_Read(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTLOADL & BTIMx_BTLOADL_LOADL_Msk);
}

/*********************************
basic timer غ 
ܣüλ
: BTIM1/BTIM2  ʱ
      0000-FFFF  ֵ
*********************************/
void BTIMx_BTLOADH_Write(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	BTIMx->BTLOADH = (SetValue & BTIMx_BTLOADH_LOADH_Msk);
}
/*********************************
basic timer غ 
ܣȡλ
: BTIM1/BTIM2  ʱ
: 0000-FFFF  ֵ
*********************************/
uint32_t BTIMx_BTLOADH_Read(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTLOADH & BTIMx_BTLOADH_LOADH_Msk);
}
/*********************************
basic timer Ƚֵغ 
ܣüλȽֵ
: BTIM1/BTIM2  ʱ
      0000-FFFF  Ƚֵ
*********************************/
void BTIMx_BTCMPL_Write(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	BTIMx->BTCMPL = (SetValue & BTIMx_BTCMPL_CMPL_Msk);
}
/*********************************
basic timer Ƚֵغ
ܣȡλȽֵ
: BTIM1/BTIM2  ʱ
: 0000-FFFF  Ƚֵ
*********************************/
uint32_t BTIMx_BTCMPL_Read(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCMPL & BTIMx_BTCMPL_CMPL_Msk);
}

/*********************************
basic timer Ƚֵغ 
ܣüλȽֵ
: BTIM1/BTIM2  ʱ
      0000-FFFF  Ƚֵ
*********************************/
void BTIMx_BTCMPH_Write(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	BTIMx->BTCMPH = (SetValue & BTIMx_BTCMPH_CMPH_Msk);
}
/*********************************
basic timer Ƚֵغ
ܣȡλȽֵ
: BTIM1/BTIM2  ʱ
: 0000-FFFF  Ƚֵ
*********************************/
uint32_t BTIMx_BTCMPH_Read(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTCMPH & BTIMx_BTCMPH_CMPH_Msk);
}

/*********************************
basic timer  
ܣü
: BTIM1/BTIM2  ʱ
      0000-0FFF    Ϊ30.5*(1+SetValue)
*********************************/
void BTIMx_BTOUTCNT_Write(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	BTIMx->BTOUTCNT = (SetValue & BTIMx_BTOUTCNT_OUTCNT_Msk);
}
/*********************************
basic timer  
ܣȡȶ
: BTIM1/BTIM2  ʱ
: 0000-0FFF  Ϊ30.5*(1+ֵ)
*********************************/
uint32_t BTIMx_BTOUTCNT_Read(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTOUTCNT & BTIMx_BTOUTCNT_OUTCNT_Msk);
}

/*********************************
basic timer ƺ 
ܣüǷ
: BTIM1/BTIM2  ʱ
      BTIMx_BTOCR_OUTCLR/BTIMx_BTOCR_OUTCLR_CLR		дЧ/(˷ߣδ)
*********************************/
void BTIMx_BTOCR_OUTCLR_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTOCR;
	tmpreg &= ~(BTIMx_BTOCR_OUTCLR_Msk);
	tmpreg |= (SetValue & BTIMx_BTOCR_OUTCLR_Msk);
	BTIMx->BTOCR = tmpreg;
}
/*********************************
basic timer ƺ 
ܣȡǷ
: BTIM1/BTIM2  ʱ
: BTIMx_BTOCR_OUTCLR/BTIMx_BTOCR_OUTCLR_CLR		дЧ/(˷ߣδ)
*********************************/
uint32_t BTIMx_BTOCR_OUTCLR_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTOCR & BTIMx_BTOCR_OUTCLR_Msk);
}

/*********************************
basic timer ƺ 
ܣüƽ
: BTIM1/BTIM2  ʱ
      BTIMx_BTOCR_OUTINV_NOT_ANTI/BTIMx_BTOCR_OUTINV_ANTI	ƽȡ/ƽȡ
*********************************/
void BTIMx_BTOCR_OUTINV_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTOCR;
	tmpreg &= ~(BTIMx_BTOCR_OUTINV_Msk);
	tmpreg |= (SetValue & BTIMx_BTOCR_OUTINV_Msk);
	BTIMx->BTOCR = tmpreg;
}
/*********************************
basic timer ƺ 
ܣȡƽ
: BTIM1/BTIM2  ʱ
: 	BTIMx_BTOCR_OUTMOD_PULSE/BTIMx_BTOCR_OUTMOD_ANTI_LEVEL	ƽȡ/ƽȡ
*********************************/
uint32_t BTIMx_BTOCR_OUTINV_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTOCR & BTIMx_BTOCR_OUTINV_Msk);
}

/*********************************
basic timer ƺ 
ܣüģʽ
: BTIM1/BTIM2  ʱ
      BTIMx_BTOCR_OUTINV_NOT_ANTI/BTIMx_BTOCR_OUTINV_ANTI	壬ȿɵ/֮ǰķƽ
: 
*********************************/   
void BTIMx_BTOCR_OUTMOD_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTOCR;
	tmpreg &= ~(BTIMx_BTOCR_OUTMOD_Msk);
	tmpreg |= (SetValue & BTIMx_BTOCR_OUTMOD_Msk);
	BTIMx->BTOCR = tmpreg;
}
/*********************************
basic timer ƺ 
ܣȡģʽ
: BTIM1/BTIM2  ʱ
: BTIMx_BTOCR_OUTINV_NOT_ANTI/BTIMx_BTOCR_OUTINV_ANTI	壬ȿɵ/֮ǰķƽ
*********************************/
uint32_t BTIMx_BTOCR_OUTMOD_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTOCR & BTIMx_BTOCR_OUTMOD_Msk);
}

/*********************************
basic timer ƺ 
ܣüźԴ
: BTIM1/BTIM2  ʱ
      BTIMx_BTOCR_OUTSEL_CMPH/		λȽźţģʽЧ
      BTIMx_BTOCR_OUTSEL_CMPL/		λȽźţģʽЧ
      BTIMx_BTOCR_OUTSEL_GROUP1/	Group1źţ׽ģʽЧ	
      BTIMx_BTOCR_OUTSEL_GROUP2/	Group2źţ׽ģʽЧ
      BTIMx_BTOCR_OUTSEL_PWM		PWM
: 
*********************************/  
void BTIMx_BTOCR_OUTSEL_Set(BTIMx_Type* BTIMx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = BTIMx->BTOCR;
	tmpreg &= ~(BTIMx_BTOCR_OUTSEL_Msk);
	tmpreg |= (SetValue & BTIMx_BTOCR_OUTSEL_Msk);
	BTIMx->BTOCR = tmpreg;
}
/*********************************
basic timer ƺ 
ܣȡźԴ
: BTIM1/BTIM2  ʱ
: BTIMx_BTOCR_OUTSEL_CMPH/		λȽźţģʽЧ
      BTIMx_BTOCR_OUTSEL_CMPL/		λȽźţģʽЧ
      BTIMx_BTOCR_OUTSEL_GROUP1/	Group1źţ׽ģʽЧ	
      BTIMx_BTOCR_OUTSEL_GROUP2/	Group2źţ׽ģʽЧ
      BTIMx_BTOCR_OUTSEL_PWM		PWM
*********************************/
uint32_t BTIMx_BTOCR_OUTSEL_Get(BTIMx_Type* BTIMx)
{
	return (BTIMx->BTOCR & BTIMx_BTOCR_OUTSEL_Msk);
}

/*********************************
basic timerжʹܿƺ 
ܣʹBTλȽϷź
: BTIM1/BTIM2  ʱ	 
      ENABLE/DISABLE 			λȽϷźжʹ/λȽϷźжϽֹ
: 
*********************************/
void BTIMx_BTIE_CMPHIE_Setable(BTIMx_Type* BTIMx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		BTIMx->BTIE |= (BTIMx_BTIE_CMPHIE_Msk);
	}
	else
	{
		BTIMx->BTIE &= ~(BTIMx_BTIE_CMPHIE_Msk);
	}
}
/*********************************
basic timerжʹܿƺ 
ܣȡBTλȽϷź״̬
: BTIM1/BTIM2  ʱ	 
: ENABLE/DISABLE 			λȽϷźжʹ/λȽϷźжϽֹ
*********************************/
FunState BTIMx_BTIE_CMPHIE_Getable(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTIE & (BTIMx_BTIE_CMPHIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
basic timerжʹܿƺ 
ܣʹBTλȽϷź
: BTIM1/BTIM2  ʱ	 
      ENABLE/DISABLE 			λȽϷźжʹ/λȽϷźжϽֹ
: 
*********************************/
void BTIMx_BTIE_CMPLIE_Setable(BTIMx_Type* BTIMx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		BTIMx->BTIE |= (BTIMx_BTIE_CMPLIE_Msk);
	}
	else
	{
		BTIMx->BTIE &= ~(BTIMx_BTIE_CMPLIE_Msk);
	}
}
/*********************************
basic timerжʹܿƺ 
ܣȡBTλȽϷź״̬
: BTIM1/BTIM2  ʱ	 
: ENABLE/DISABLE 			λȽϷźжʹ/λȽϷźжϽֹ
*********************************/
FunState BTIMx_BTIE_CMPLIE_Getable(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTIE & (BTIMx_BTIE_CMPLIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/*********************************
basic timerжʹܿƺ 
ܣʹBTλź
: BTIM1/BTIM2  ʱ	 
      ENABLE/DISABLE 			λźжʹ/λźжϽֹ
: 
*********************************/
void BTIMx_BTIE_OVHIE_Setable(BTIMx_Type* BTIMx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		BTIMx->BTIE |= (BTIMx_BTIE_OVHIE_Msk);
	}
	else
	{
		BTIMx->BTIE &= ~(BTIMx_BTIE_OVHIE_Msk);
	}
}
/*********************************
basic timerжʹܿƺ 
ܣȡBTλź״̬
: BTIM1/BTIM2  ʱ	 
: ENABLE/DISABLE 			λźжʹ/λźжϽֹ
*********************************/
FunState BTIMx_BTIE_OVHIE_Getable(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTIE & (BTIMx_BTIE_OVHIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/*********************************
basic timerжʹܿƺ 
ܣʹBTλź
: BTIM1/BTIM2  ʱ	 
      ENABLE/DISABLE 			λźжʹ/λźжϽֹ
: 
*********************************/
void BTIMx_BTIE_OVLIE_Setable(BTIMx_Type* BTIMx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		BTIMx->BTIE |= (BTIMx_BTIE_OVLIE_Msk);
	}
	else
	{
		BTIMx->BTIE &= ~(BTIMx_BTIE_OVLIE_Msk);
	}
}
/*********************************
basic timerжʹܿƺ 
ܣȡBTλź״̬
: BTIM1/BTIM2  ʱ	 
: ENABLE/DISABLE 			λźжʹ/λźжϽֹ
*********************************/
FunState BTIMx_BTIE_OVLIE_Getable(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTIE & (BTIMx_BTIE_OVLIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/*********************************
basic timerжʹܿƺ 
ܣʹBT׽ź
: BTIM1/BTIM2  ʱ	 
      ENABLE/DISABLE 			׽źжʹ/׽źжϽֹ
: 
*********************************/
void BTIMx_BTIE_CAPIE_Setable(BTIMx_Type* BTIMx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		BTIMx->BTIE |= (BTIMx_BTIE_CAPIE_Msk);
	}
	else
	{
		BTIMx->BTIE &= ~(BTIMx_BTIE_CAPIE_Msk);
	}
}
/*********************************
basic timerжʹܿƺ 
ܣȡBT׽ź״̬
: BTIM1/BTIM2  ʱ	 
: ENABLE/DISABLE 			׽źжʹ/׽źжϽֹ
*********************************/
FunState BTIMx_BTIE_CAPIE_Getable(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTIE & (BTIMx_BTIE_CAPIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
basic timerжźź 
ܣBT׽״̬
: BTIM1/BTIM2  ʱ
: 
*********************************/
void BTIMx_BTIF_EDGESTA_Clr(BTIMx_Type* BTIMx)
{
	BTIMx->BTIF = BTIMx_BTIF_EDGESTA_Msk;
}
/*********************************
basic timerжźź 
ܣȡBT׽״̬
: BTIM1/BTIM2  ʱ	 
: SET/RESET 			Ȳ׽ģʽʱʾ׽/Ȳ׽ģʽʱʾ׽
*********************************/
FlagStatus BTIMx_BTIF_EDGESTA_Chk(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTIF & BTIMx_BTIF_EDGESTA_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
basic timerжźź 
ܣBTλȽϷź״̬
: BTIM1/BTIM2  ʱ
: 
*********************************/
void BTIMx_BTIF_CMPHIF_Clr(BTIMx_Type* BTIMx)
{
	BTIMx->BTIF = BTIMx_BTIF_CMPHIF_Msk;
}
/*********************************
basic timerжźź 
ܣȡBTλȽϷź״̬
: BTIM1/BTIM2  ʱ	 
: SET/RESET 			ǰֵڵȹĴֵ/ǰֵСڹĴֵ
*********************************/
FlagStatus BTIMx_BTIF_CMPHIF_Chk(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTIF & BTIMx_BTIF_CMPHIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
basic timerжźź 
ܣBTλȽϷź״̬
: BTIM1/BTIM2  ʱ
: 
*********************************/
void BTIMx_BTIF_CMPLIF_Clr(BTIMx_Type* BTIMx)
{
	BTIMx->BTIF = BTIMx_BTIF_CMPLIF_Msk;
}

/*********************************
basic timerжźź 
ܣȡBTλȽϷź״̬
: BTIM1/BTIM2  ʱ	 
: SET/RESET 			ǰֵڵȹĴֵ/ǰֵСڹĴֵ
*********************************/
FlagStatus BTIMx_BTIF_CMPLIF_Chk(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTIF & BTIMx_BTIF_CMPLIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
basic timerжźź 
ܣBTλź״̬
: BTIM1/BTIM2  ʱ
: 
*********************************/
void BTIMx_BTIF_OVHIF_Clr(BTIMx_Type* BTIMx)
{
	BTIMx->BTIF = BTIMx_BTIF_OVHIF_Msk;
}
/*********************************
basic timerжźź 
ܣȡBTλź״̬
: BTIM1/BTIM2  ʱ	 
: SET/RESET 			/δ
*********************************/
FlagStatus BTIMx_BTIF_OVHIF_Chk(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTIF & BTIMx_BTIF_OVHIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
basic timerжźź 
ܣBTλź״̬
: BTIM1/BTIM2  ʱ
: 
*********************************/
void BTIMx_BTIF_OVLIF_Clr(BTIMx_Type* BTIMx)
{
	BTIMx->BTIF = BTIMx_BTIF_OVLIF_Msk;
}
/*********************************
basic timerжźź 
ܣȡBTλź״̬
: BTIM1/BTIM2  ʱ	 
: SET/RESET 			/δ
*********************************/
FlagStatus BTIMx_BTIF_OVLIF_Chk(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTIF & BTIMx_BTIF_OVLIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}


/*********************************
basic timerжźź 
ܣBT׽ź״̬
: BTIM1/BTIM2  ʱ
: 
*********************************/
void BTIMx_BTIF_CAPIF_Clr(BTIMx_Type* BTIMx)
{
	BTIMx->BTIF = BTIMx_BTIF_CAPIF_Msk;
}
/*********************************
basic timerжźź 
ܣȡBT׽ź״̬
: BTIM1/BTIM2  ʱ	 
: SET/RESET 			׽ָ/δ׽ָ
*********************************/
FlagStatus BTIMx_BTIF_CAPIF_Chk(BTIMx_Type* BTIMx)
{
	if (BTIMx->BTIF & BTIMx_BTIF_CAPIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
basic timer庯 
ܣرBTй(ȱʡ)
: BTIM1/BTIM2  ʱ	 
: 
*********************************/
void BTIMx_Deinit(BTIMx_Type* BTIMx)
{
	BTIMx->BTCR1 = 0x00000000;
	BTIMx->BTCR2 = 0x00000000;
	BTIMx->BTCFG1 = 0x00000000;
	BTIMx->BTCFG2 = 0x00000000;
	BTIMx->BTPRES = 0x00000000;
	BTIMx->BTLOADCR = 0x00000000;
	//BTIMx->BTCNTL = ;
	//BTIMx->BTCNTH = ;
	BTIMx->BTPRESET = 0x00000000;
	BTIMx->BTLOADL = 0x00000000;
	BTIMx->BTLOADH = 0x00000000;
	//BTIMx->BTCMPL = ;
	//BTIMx->BTCMPH = ;
	BTIMx->BTOUTCNT = 0x00000000;
	BTIMx->BTOCR = 0x00000000;
	BTIMx->BTIE = 0x00000000;
	//BTIMx->BTIF = ;
}
//Code_End



void BTIMx_Init(BTIMx_Type* BTIMx, BTIM_InitTypeDef* para)
{
	BTIMx_Deinit(BTIMx);

	//׽ѡ
	BTIMx_BTCR1_CAPMOD_Set(BTIMx, para->cap_para.CAPMOD);//׽ģʽƣȻ
	BTIMx_BTCR1_CAPCLR_Set(BTIMx, para->cap_para.CAPCLR);//׽ǷҪ
	BTIMx_BTCR1_CAPONCE_Set(BTIMx, para->cap_para.CAPONCE);//׽Ƿ񵥴β׽

	//źѡ
	BTIMx_BTCFG1_RTCSEL1_Set(BTIMx, para->sig_src_para.RTCSEL1);//ѡRTCOUT1źѡ
	BTIMx_BTCFG1_RTCSEL2_Set(BTIMx, para->sig_src_para.RTCSEL2);//ѡRTCOUT2źѡ
	BTIMx_BTCFG2_INSEL1_Set(BTIMx, para->sig_src_para.INSEL1);//ѡڲź1
	BTIMx_BTCFG2_INSEL2_Set(BTIMx, para->sig_src_para.INSEL2);//ѡڲź2
    BTIMx_BTCFG2_EXSEL1_Set(BTIMx, para->sig_src_para.EXSEL1);//ѡⲿź1
    BTIMx_BTCFG2_EXSEL2_Set(BTIMx, para->sig_src_para.EXSEL2);//ѡⲿź2
	
	
	BTIMx_BTCFG1_GRP1SEL_Set(BTIMx, para->sig_src_para.GRP1SEL);//ѡGROUP1źѡ
	BTIMx_BTCFG1_GRP2SEL_Set(BTIMx, para->sig_src_para.GRP2SEL);//ѡGROUP2źѡ
	
	BTIMx_BTCR2_SIG2SEL_Set(BTIMx, para->sig_src_para.CNTSRC);//ѡڲԴź
	BTIMx_BTCR2_SIG1SEL_Set(BTIMx, para->sig_src_para.CAPSRC);//ѡڲ׽Դź

	BTIMx_BTCR2_CNTHSEL_Set(BTIMx, para->sig_src_para.CNTHSEL);//λԴѡ
	BTIMx_BTCR2_SRCSEL_Set(BTIMx, para->sig_src_para.SRCSEL);//ѡλǷʹ

	//DIR
	BTIMx_BTCR2_DIREN_Setable(BTIMx, para->dir_para.DIREN);//ⲿdirƻʹ
	//BTIMx_BTCR2_STDIR_Setable(BTIMx, para->dir_para.STDIR);//ڲdirźţӦòҪ
	BTIMx_BTCR2_DIRPO_Set(BTIMx, para->dir_para.DIRPO);//ⲿdirźżѡ


	//
	BTIMx_BTCR1_MODE_Set(BTIMx, para->ctrl_para.MODE);//ģʽ16λ׽8λʱ
	BTIMx_BTCR1_EDGESEL_Set(BTIMx, para->ctrl_para.EDGESEL);//ѡػ½
	BTIMx_BTPRES_Write(BTIMx, para->ctrl_para.PRESCALE);//ѡƵϵ

	BTIMx_BTPRESET_PRESETH_Set(BTIMx, para->ctrl_para.PRESETH);//λԤֵ
	BTIMx_BTPRESET_PRESETL_Set(BTIMx, para->ctrl_para.PRESETL);//λԤֵ

	BTIMx_BTLOADH_Write(BTIMx, para->ctrl_para.LOADH);//λֵ
	BTIMx_BTLOADL_Write(BTIMx, para->ctrl_para.LOADL);//λֵ
	
	//
	BTIMx_BTOCR_OUTMOD_Set(BTIMx, para->out_para.OUTMOD);//ģʽѡ
	BTIMx_BTOCR_OUTSEL_Set(BTIMx, para->out_para.OUTSEL);//źѡ
	BTIMx_BTOUTCNT_Write(BTIMx, para->out_para.OUTCNT);//
	BTIMx_BTOCR_OUTINV_Set(BTIMx, para->out_para.OUTINV);//ƽѡ
	
}


