/**
  ******************************************************************************
  * @file    fm33g0xx_crc.c
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/

/* Includes ------------------------------------------------------------------*/
#include "fm33g0xx_crc.h" 


/** @addtogroup fm33g0xx_StdPeriph_Driver
  * @{
  */

/** @defgroup CRC
  * @brief CRC driver modules
  * @{
  */ 

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


/********************************
CRC ܿƺ
: CRC(16λЧ)
룺CRC
: 
********************************/
void CRC_CRCDR_Write(uint32_t SetValue)
{
	CRC->CRCDR = (SetValue & CRC_CRCDR_CRCDR_Msk);
}
/********************************
CRC ܿƺ
: ȡCRC(16λЧ)
룺
: CRC
********************************/
uint32_t CRC_CRCDR_Read(void)
{
	return (CRC->CRCDR & CRC_CRCDR_CRCDR_Msk);
}

/********************************
CRC ܿƺ
: CRC뷴ת
룺ENABLE/DISABLE			밴ֽڷת/벻ת
: 
********************************/
void CRC_CRCCR_RFLTIN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		CRC->CRCCR |= (CRC_CRCCR_RFLTIN_Msk);
	}
	else
	{
		CRC->CRCCR &= ~(CRC_CRCCR_RFLTIN_Msk);
	}
}
/********************************
CRC ܿƺ
: ȡCRC뷴ת
룺
: ENABLE/DISABLE			밴ֽڷת/벻ת
********************************/
FunState CRC_CRCCR_RFLTIN_Getable(void)
{
	if (CRC->CRCCR & (CRC_CRCCR_RFLTIN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
CRC ܿƺ
: CRCת
룺ENABLE/DISABLE			ֽڷת/ת
: 
********************************/
void CRC_CRCCR_RFLTO_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		CRC->CRCCR |= (CRC_CRCCR_RFLTO_Msk);
	}
	else
	{
		CRC->CRCCR &= ~(CRC_CRCCR_RFLTO_Msk);
	}
}
/********************************
CRC ܿƺ
: ȡCRCת
룺
: ENABLE/DISABLE			ֽڷת/ת
********************************/
FunState CRC_CRCCR_RFLTO_Getable(void)
{
	if (CRC->CRCCR & (CRC_CRCCR_RFLTO_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
CRC ܿƺ
: ȡCRC־λ
룺
:	SET/RESET		CRCȫ0/CRCȫ0
********************************/
FlagStatus CRC_CRCCR_RES_Chk(void)
{
	if (CRC->CRCCR & CRC_CRCCR_RES_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
CRC ܿƺ
: ȡCRC־λ
룺
:	SET/RESET		CRC/CRC
********************************/
FlagStatus CRC_CRCCR_BUSY_Chk(void)
{
	if (CRC->CRCCR & CRC_CRCCR_BUSY_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
CRC ܿƺ
: CRCʹ
룺ENABLE/DISABLE			CRC_XOR/CRC_XOR
: 
********************************/
void CRC_CRCCR_XOR_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		CRC->CRCCR |= (CRC_CRCCR_XOR_Msk);
	}
	else
	{
		CRC->CRCCR &= ~(CRC_CRCCR_XOR_Msk);
	}
}
/********************************
CRC ܿƺ
: ȡCRC
룺
: ENABLE/DISABLE			CRC_XOR/CRC_XOR
********************************/
FunState CRC_CRCCR_XOR_Getable(void)
{
	if (CRC->CRCCR & (CRC_CRCCR_XOR_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
CRC ܿƺ
: CRCУʽѡ
룺CRC_CRCCR_CRCSEL_CRC16			00CRC16
			CRC_CRCCR_CRCSEL_CRC8				01CRC8
			CRC_CRCCR_CRCSEL_CCITT			10/11CCITT
: 
********************************/
void CRC_CRCCR_CRCSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = CRC->CRCCR;
	tmpreg &= ~(CRC_CRCCR_CRCSEL_Msk);
	tmpreg |= (SetValue & CRC_CRCCR_CRCSEL_Msk);
	CRC->CRCCR = tmpreg;
}
/********************************
CRC ܿƺ
: ȡCRCУʽѡ
룺
: CRC_CRCCR_CRCSEL_CRC16			00CRC16
			CRC_CRCCR_CRCSEL_CRC8				01CRC8
			CRC_CRCCR_CRCSEL_CCITT			10/11CCITT
********************************/
uint32_t CRC_CRCCR_CRCSEL_Get(void)
{
	return (CRC->CRCCR & CRC_CRCCR_CRCSEL_Msk);
}

/********************************
CRC ܿƺ
: CRCֵ(ǰ)
룺0x00000000-0x0000ffff
: 
********************************/
void CRC_CRCLFSR_Write(uint32_t SetValue)
{
	CRC->CRCLFSR = (SetValue & CRC_CRCLFSR_LFSR_Msk);
}
/********************************
CRC ܿƺ
: ȡCRCֵ
룺
: CRCֵ
********************************/
uint32_t CRC_CRCLFSR_Read(void)
{
	return (CRC->CRCLFSR & CRC_CRCLFSR_LFSR_Msk);
}

/********************************
CRC ܿƺ
: CRCֵ
룺0x00000000-0x0000ffff
: 
********************************/
void CRC_CRCXOR_Write(uint32_t SetValue)
{
	CRC->CRCXOR = (SetValue & CRC_CRCXOR_CRC_XOR_Msk);
}
/********************************
CRC ܿƺ
: ȡCRCֵ
룺
: 0x00000000-0x0000ffff
********************************/
uint32_t CRC_CRCXOR_Read(void)
{
	return (CRC->CRCXOR & CRC_CRCXOR_CRC_XOR_Msk);
}

/********************************
CRC ܿƺ
: CRCУʹ
룺ENABLE/DISABLE		Flash CRCУ/ʹFlash CRCУ
: 
********************************/
void CRC_CRCFLSEN_FLSCRCEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		CRC->CRCFLSEN |= (CRC_CRCFLSEN_FLSCRCEN_Msk);
	}
	else
	{
		CRC->CRCFLSEN &= ~(CRC_CRCFLSEN_FLSCRCEN_Msk);
	}
}
/********************************
CRC ܿƺ
: ȡCRCУʹ
룺
: ENABLE/DISABLE		Flash CRCУ/ʹFlash CRCУ
********************************/
FunState CRC_CRCFLSEN_FLSCRCEN_Getable(void)
{
	if (CRC->CRCFLSEN & (CRC_CRCFLSEN_FLSCRCEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
CRC ܿƺ
: FLASH CRCУʼַ
룺17λFlashַ(wordַ)
: 
********************************/
void CRC_CRCFLSAD_Write(uint32_t SetValue)
{
	CRC->CRCFLSAD = (SetValue & CRC_CRCFLSAD_FLSAD_Msk);
}
/********************************
CRC ܿƺ
: ȡFLASH CRCУʼַ
룺
: 17λFlashַ(wordַ)
********************************/
uint32_t CRC_CRCFLSAD_Read(void)
{
	return (CRC->CRCFLSAD & CRC_CRCFLSAD_FLSAD_Msk);
}

/********************************
CRC ܿƺ
: FLASH CRCУ鳤
룺17λݳ(wordַ,ʵ㳤Ϊ(FLSS+1)*4ֽ)
: 
********************************/
void CRC_CRCFLSSIZE_Write(uint32_t SetValue)
{
	CRC->CRCFLSSIZE = (SetValue & CRC_CRCFLSSIZE_FLSS_Msk);
}
/********************************
CRC ܿƺ
: ȡFLASH CRCУ鳤
룺
: 17λݳ(wordַ,ʵ㳤Ϊ(FLSS+1)*4ֽ)
********************************/
uint32_t CRC_CRCFLSSIZE_Read(void)
{
	return (CRC->CRCFLSSIZE & CRC_CRCFLSSIZE_FLSS_Msk);
}

/********************************
CRC ܿƺ
: CRC ȱʡ
룺
: 
********************************/
void CRC_Deinit(void)
{
	//CRC->CRCDR = ;
	CRC->CRCCR = 0x00000000;
	CRC->CRCLFSR = 0x0000FFFF;
	CRC->CRCXOR = 0x00000000;
	CRC->CRCFLSEN = 0x00000000;
	CRC->CRCFLSAD = 0x00000000;
	CRC->CRCFLSSIZE = 0x00000000;
}
//Code_End

/* CRCʼú*/
void CRC_Init(CRC_InitTypeDef* para)
{
	CRC_CRCCR_CRCSEL_Set(para->CRCSEL);			/*!<CRCУʽѡ*/
	CRC_CRCCR_RFLTIN_Setable(para->RFLTIN);		/*!<CRC뷴ת*/
	CRC_CRCCR_RFLTO_Setable(para->RFLTO);		/*!<CRCת*/
	CRC_CRCCR_XOR_Setable(para->XOR);			/*!<ʹ*/
	CRC_CRCXOR_Write(para->CRC_XOR);			/*!<Ĵ*/
}

/******END OF FILE****/



