/**
  ******************************************************************************
  * @file    fm33g0xx_flash.c
  * @author  FM33g0xx Application Team
  * @version V3.0.1G
  * @date    10-30-2018
  * @brief   This file provides firmware functions to manage the following 
  *
*/

/* Includes ------------------------------------------------------------------*/
#include "fm33g0xx_flash.h" 

/** @addtogroup fm33g0xx_StdPeriph_Driver
  * @{
  */

/** @defgroup FLASH 
  * @brief FLASH driver modules
  * @{
  */ 

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/** @defgroup FLASH_Private_Functions
  * @{
  */ 


/********************************
FLASHȴú
:FLASHȴãCPUʱӳ24MҪwait1 cycle
룺µ縴λѹbit1:0
      00/110 wait cycle
      011 wait cycle
      102 wait cycles
:
********************************/
void FLASH_FLSRDCON_WAIT_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = FLASH->FLSRDCON;
	tmpreg &= ~(FLASH_FLSRDCON_WAIT_Msk);
	tmpreg |= (SetValue & FLASH_FLSRDCON_WAIT_Msk);
	FLASH->FLSRDCON = tmpreg;
}

/********************************
FLASHȴ״̬
: ȡFLASHȴ
룺
: 00/110 wait cycle
      011 wait cycle
      102 wait cycles
********************************/
uint32_t FLASH_FLSRDCON_WAIT_Get(void)
{
	return (FLASH->FLSRDCON & FLASH_FLSRDCON_WAIT_Msk);
}

/********************************
FLASH DBGƼĴ״̬
: ȡFLASH DBGƼĴ״̬
룺
: SET   MCUDBGCRĴ
      RESET  MCUDBGCRĴʹ
********************************/
FlagStatus FLASH_OPTBR_DBGCFGEN_Chk(void)
{
	if (FLASH->OPTBR & FLASH_OPTBR_DBGCFGEN_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
ȡBootSwapʹ״̬
: ȡBootSwapʹ״̬
룺
: 0BootSwapֹ
      1BootSwapʹ
********************************/
FlagStatus FLASH_OPTBR_BTSEN_Chk(void)
{
	if((FLASH->OPTBR & FLASH_OPTBR_BTSEN_Msk)==(2U<<FLASH_OPTBR_BTSEN_Pos))
  {
    return SET;
  }
  else
	{
		return RESET;
	}	
}

/********************************
FLASH ӦôȨʹ״̬
: ȡFLASH ӦôȨʹ״̬
룺
: 0ACLOCKʹ
      1ACLOCKʹ
********************************/
FlagStatus FLASH_OPTBR_ACLOCKEN_Chk(void)
{
	if((FLASH->OPTBR&FLASH_OPTBR_ACLOCKEN_Msk)==(2U<<FLASH_OPTBR_ACLOCKEN_Pos))
  {
    return SET;
  }
  else
	{
		return RESET;
	}
}
/********************************
FLASH Debug Portȡʹ״̬
: ȡFLASH Debug Portȡʹ״̬
룺
: 00/01/11DBRDPʹ
      10DBRDPʹ
********************************/
FlagStatus FLASH_OPTBR_DBRDPEN_Chk(void)
{
	if (FLASH->OPTBR & FLASH_OPTBR_DBRDPEN_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
FLASH ACLOCK1ú
: ֱڿBlock31~Block0Ӧôд
룺1ȡͲдȨ
      0ȡͲдȨ޷ſ
: 
********************************/
void FLASH_ACLOCK1_Write(uint32_t SetValue)
{
	FLASH->ACLOCK1 = (SetValue);
}

uint32_t FLASH_ACLOCK1_Read(void)
{
	return (FLASH->ACLOCK1);
}

/********************************
FLASH ʽú
:FLASH ʽ
룺
: 
********************************/
void FLASH_EPCON_ERTYPE_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = FLASH->EPCON;
	tmpreg &= ~(FLASH_EPCON_ERTYPE_Msk);
	tmpreg |= (SetValue & FLASH_EPCON_ERTYPE_Msk);
	FLASH->EPCON = tmpreg;
}
/********************************
FLASH ʽ״̬ȡ
:ȡ ʽ״̬
룺
: 
********************************/
uint32_t FLASH_EPCON_ERTYPE_Get(void)
{
	return (FLASH->EPCON & FLASH_EPCON_ERTYPE_Msk);
}
/********************************

:
룺λӲɱ̺Զ
: 
********************************/
void FLASH_EPCON_PREQ_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = FLASH->EPCON;
	tmpreg &= ~(FLASH_EPCON_PREQ_Msk);
	tmpreg |= (SetValue & FLASH_EPCON_PREQ_Msk);
	FLASH->EPCON = tmpreg;
}
/********************************
״̬ȡ
:ȡ ״̬
룺
: 
********************************/
uint32_t FLASH_EPCON_PREQ_Get(void)
{
	return (FLASH->EPCON & FLASH_EPCON_PREQ_Msk);
}
/********************************

:
룺λӲɱ̺Զ
: 
********************************/
void FLASH_EPCON_EREQ_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = FLASH->EPCON;
	tmpreg &= ~(FLASH_EPCON_EREQ_Msk);
	tmpreg |= (SetValue & FLASH_EPCON_EREQ_Msk);
	FLASH->EPCON = tmpreg;
}
/********************************
״̬ȡ
:ȡ״̬
룺
: ɺ0
********************************/
uint32_t FLASH_EPCON_EREQ_Get(void)
{
	return (FLASH->EPCON & FLASH_EPCON_EREQ_Msk);
}

/* FlashдKeyĴSWDдǰȷ˵ַдϷKEYСյַ޼Ĵʵ֡ غ */
void FLASH_FLSKEY_Write(uint32_t SetValue)
{
	FLASH->FLSKEY = (SetValue);
}

/********************************
FlashдKeyĴú
:FlashдKeyʹ
룺ENABLE   FlashдKey
      DISABLE  رFlashдKey
: 
********************************/
void FLASH_FLSIE_AUTHIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		FLASH->FLSIE |= (FLASH_FLSIE_AUTHIE_Msk);
	}
	else
	{
		FLASH->FLSIE &= ~(FLASH_FLSIE_AUTHIE_Msk);
	}
}

/********************************
FLASHдKEY״̬
: ȡFLASHдKEY״̬
룺
: FLASH_FLSIF_KEYSTA_WPFLASHд״̬δKEY
      FLASH_FLSIF_KEYSTA_ALLE_UNLOCKȫ״̬
      FLASH_FLSIF_KEYSTA_SE_UNLOCK״̬
      FLASH_FLSIF_KEYSTA_P_UNLOCK̽״̬
     FLASH_FLSIF_KEYSTA_ERR_LOCKKEY״̬Ҫλܽ   
********************************/
uint32_t FLASH_FLSIF_KEYSTA_Get(void)
{
	return  (FLASH->FLSIF & (FLASH_FLSIF_KEYSTA_Msk));	
}

/********************************
FlashдKeyĴ״̬ȡ
:ȡFlashдKeyĴ״̬
룺
: ENABLE   FlashдKey
      DISABLE  رFlashдKey
********************************/
FunState FLASH_FLSIE_AUTHIE_Getable(void)
{
	if (FLASH->FLSIE & (FLASH_FLSIE_AUTHIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
Flash KEYжʹܿƺ
:Flash KEYжʹ
룺ENABLE   Flash KEYж
      DISABLE  رFlash KEYж
: 
********************************/
void FLASH_FLSIE_KEYIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		FLASH->FLSIE |= (FLASH_FLSIE_KEYIE_Msk);
	}
	else
	{
		FLASH->FLSIE &= ~(FLASH_FLSIE_KEYIE_Msk);
	}
}
/********************************
Flash KEYжϻȡ
:ȡFlash KEYж״̬
룺
: ENABLE   FlashдKeyжϲ
      DISABLE  FlashдKeyжδ
********************************/
FunState FLASH_FLSIE_KEYIE_Getable(void)
{
	if (FLASH->FLSIE & (FLASH_FLSIE_KEYIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
дʱʱӴжʹܿƺ
:дʱʱӴжʹ
룺ENABLE   дʱʱӴжʹ
      DISABLE  رղдʱʱӴжʹ
: 
********************************/
void FLASH_FLSIE_CKIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		FLASH->FLSIE |= (FLASH_FLSIE_CKIE_Msk);
	}
	else
	{
		FLASH->FLSIE &= ~(FLASH_FLSIE_CKIE_Msk);
	}
}
/********************************
дʱʱӴж״̬ȡ
:дʱʱӴжʹ״̬
룺
: ENABLE   дʱʱӴжϲ
      DISABLE  дʱʱӴжδ
********************************/
FunState FLASH_FLSIE_CKIE_Getable(void)
{
	if (FLASH->FLSIE & (FLASH_FLSIE_CKIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
ɱ־жʹܿƺ
:ɱ־жʹ
룺ENABLE   ɱ־жʹ
      DISABLE  رձɱ־жʹ
: 
********************************/
void FLASH_FLSIE_PRDIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		FLASH->FLSIE |= (FLASH_FLSIE_PRDIE_Msk);
	}
	else
	{
		FLASH->FLSIE &= ~(FLASH_FLSIE_PRDIE_Msk);
	}
}
/********************************
ɱ־жʹ״̬ȡ
:ɱ־жʹ
룺
: ENABLE   ɱ־жʹжϲ
      DISABLE  ɱ־жʹжδ
********************************/
FunState FLASH_FLSIE_PRDIE_Getable(void)
{
	if (FLASH->FLSIE & (FLASH_FLSIE_PRDIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
дɱ־жʹܿƺ
:дɱ־жʹ
룺ENABLE   дɱ־жʹ
      DISABLE  رղдɱ־жʹ
: 
********************************/
void FLASH_FLSIE_ERDIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		FLASH->FLSIE |= (FLASH_FLSIE_ERDIE_Msk);
	}
	else
	{
		FLASH->FLSIE &= ~(FLASH_FLSIE_ERDIE_Msk);
	}
}
/********************************
дɱ־жʹ״̬ȡ
:дɱ־жʹ
룺
: ENABLE   дɱ־жʹжϲ
      DISABLE  дɱ־жʹжδ
********************************/
FunState FLASH_FLSIE_ERDIE_Getable(void)
{
	if (FLASH->FLSIE & (FLASH_FLSIE_ERDIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
FlashдȨ޴
:ȡLOCKݻLOCKдʱλд1㡣
룺д1㡣
: 
********************************/
void FLASH_FLSIF_AUTHIF_Clr(void)
{
	FLASH->FLSIF = FLASH_FLSIF_AUTHIF_Msk;
}
/********************************
FlashдȨ޴״̬ȡ
:ȡFlashдȨ޴
룺
: SET    FlashдȨ޴жϲ
      RESET  FlashдȨ޴жδ
********************************/
FlagStatus FLASH_FLSIF_AUTHIF_Chk(void)
{
	if (FLASH->FLSIF & FLASH_FLSIF_AUTHIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}
/********************************
Flash KEY
: Flash KEY
룺Ӳλд1㡣
: 
********************************/
void FLASH_FLSIF_KEYIF_Clr(void)
{
	FLASH->FLSIF = FLASH_FLSIF_KEYIF_Msk;
}
/********************************
Flash KEY״̬ȡ
:ȡFlash KEY
룺
: SET    Flash KEYжϲ
      RESET  Flash KEYжδ
********************************/
FlagStatus FLASH_FLSIF_KEYIF_Chk(void)
{
	if (FLASH->FLSIF & FLASH_FLSIF_KEYIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}
/********************************
дʱʱӴ
: NVMIFдFlashʱAHBCLKֻʹRCHF 8M16MʹʱӲдᴥCKERRд1㡣
룺Flash CK
: 
********************************/
void FLASH_FLSIF_CKIF_Clr(void)
{
	FLASH->FLSIF = FLASH_FLSIF_CKIF_Msk;
}
/********************************
дʱʱӴ״̬ȡ
:ȡFlash дʱʱӴ״̬
룺
: SET    Flash дʱʱӴжϲ
      RESET  Flash дʱʱӴжδ
********************************/
FlagStatus FLASH_FLSIF_CKIF_Chk(void)
{
	if (FLASH->FLSIF & FLASH_FLSIF_CKIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}
/********************************
ɱ־
: Program Doneɱ־Ӳλд1㡣
룺ɱ־
: 
********************************/
void FLASH_FLSIF_PRDIF_Clr(void)
{
	FLASH->FLSIF = FLASH_FLSIF_PRDIF_Msk;
}
/********************************
ɱ־״̬ȡ
:ȡɱ־״̬
룺
: SET    жϲ
      RESET жδ
********************************/
FlagStatus FLASH_FLSIF_PRDIF_Chk(void)
{
	if (FLASH->FLSIF & FLASH_FLSIF_PRDIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}
/********************************
дɱ־
: Erase Doneдɱ־Ӳλд1
룺дɱ־
: 
********************************/
void FLASH_FLSIF_ERDIF_Clr(void)
{
	FLASH->FLSIF = FLASH_FLSIF_ERDIF_Msk;
}
/********************************
дɱ־״̬ȡ
:ȡдɱ־״̬
룺
: SET    джϲ
      RESET джδ
********************************/
FlagStatus FLASH_FLSIF_ERDIF_Chk(void)
{
	if (FLASH->FLSIF & FLASH_FLSIF_ERDIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

void FLASH_Deinit(void)
{
	FLASH->FLSRDCON = 0x00000000;
	//FLASH->OPTBR = 0x00000105;
	//FLASH->ACLOCK1 = ;
	FLASH->EPCON = 0x00000000;
	//FLASH->FLSKEY = ;
	FLASH->FLSIE = 0x00000000;
	//FLASH->FLSIF = 0x00000000;
}
//Code_End


/********************************
ú
:
룺ַ
: 
********************************/
void FLASH_Erase_Sector(uint32_t erase_addr)
{
    //set to sector erase
    FLASH_EPCON_ERTYPE_Set(FLASH_EPCON_ERTYPE_SECTOR);
	
    //SET EREQ
    FLASH_EPCON_EREQ_Set(FLASH_EPCON_EREQ_ERASE);
	
    //write flash key
    FLASH_FLSKEY_Write(flash_sector_erase_key0);
    FLASH_FLSKEY_Write(flash_sector_erase_key1);
	
    //Ҫַд0x1234_ABCD
    *(uint32_t*)erase_addr = flash_erase_data;
	
	//wait for finish
	while(SET != FLASH_FLSIF_ERDIF_Chk()){__NOP();}
	FLASH_FLSIF_ERDIF_Clr();
	
    FLASH_FLSKEY_Write(0x00000000);
}

/********************************
дflash
:дflash
룺дַд
: 
********************************/
void FLASH_Prog_SingleByte(uint32_t prog_addr,uint8_t prog_data)
{
	//set PREQ
    FLASH_EPCON_PREQ_Set(FLASH_EPCON_PREQ_PROG);
	
	//write flash key
    FLASH_FLSKEY_Write(flash_PROG_key0);
    FLASH_FLSKEY_Write(flash_PROG_key1);
	
    *(uint8_t*)prog_addr = prog_data;	

    while(RESET == FLASH_FLSIF_PRDIF_Chk()){__NOP();}
	FLASH_FLSIF_PRDIF_Clr();
	
    FLASH_FLSKEY_Write(0x00000000);
}

/********************************
дflash
:дflash
룺дַдݺͳ
: 
********************************/
void FLASH_Prog_ByteString(uint32_t prog_addr,uint8_t* prog_data, uint16_t Len)
{
	uint16_t i;
	//set PREQ
	FLASH_EPCON_PREQ_Set(FLASH_EPCON_PREQ_PROG);
	
	//write flash key
	FLASH_FLSKEY_Write(flash_PROG_key0);
	FLASH_FLSKEY_Write(flash_PROG_key1);
	
	for(i=0; i<Len; i++)
	{
		FLASH_EPCON_PREQ_Set(FLASH_EPCON_PREQ_PROG);	//set PREQ
		*(uint8_t*)prog_addr = prog_data[i];						//дһֽ
		prog_addr++;
		while(RESET == FLASH_FLSIF_PRDIF_Chk()){__NOP();}//ȴд
		FLASH_FLSIF_PRDIF_Clr();						//джϱ־
	//	delay_50(1);
	}
	
    FLASH_FLSKEY_Write(0x00000000);
}

/******END OF FILE****/






