/**
  ******************************************************************************
  * @file    FM33g0xx_gpio.c
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file provides firmware functions to manage the following 
  *
*/

/* Includes ------------------------------------------------------------------*/
#include "fm33g0xx_gpio.h" 
#include "fm33g0xx_conf.h"	
/** @addtogroup fm33g0xx_StdPeriph_Driver
  * @{
  */

/** @defgroup GPIO 
  * @brief GPIO driver modules
  * @{
  */ 

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/


/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/



/********************************
 PortXݼĴú
: PortX
룺GPIOx_Type* GPIOxܽźţ,  uint32_t SetValueֵ
:
********************************/
void GPIOx_DO_Write(GPIOx_Type* GPIOx, uint32_t SetValue)
{
	GPIOx->DO = (SetValue & GPIOx_DO_DO_Msk);
}
/********************************
PortX״̬
:PortX״̬
룺
:PortXֵ
********************************/
uint32_t GPIOx_DO_Read(GPIOx_Type* GPIOx)
{
	return (GPIOx->DO & GPIOx_DO_DO_Msk);
}

/********************************
PortXλĴ
:PortXλPADSETд0x0000_8000PADO[15]λλֲ䡣
룺GPIOx_Type* GPIOxܽźţ,  uint32_t SetValueֵ
:
********************************/
void GPIOx_DSET_Write(GPIOx_Type* GPIOx, uint32_t SetValue)
{
	GPIOx->DSET = (SetValue & GPIOx_DSET_DSET_Msk);
}

/********************************
PortXݸλĴ
:PortXݸλPADRSTд0x0000_8000PADO[15]㣬λֲ䡣
룺GPIOx_Type* GPIOxܽźţ,  uint32_t SetValueֵ
:
********************************/
void GPIOx_DRESET_Write(GPIOx_Type* GPIOx, uint32_t SetValue)
{
	GPIOx->DRESET = (SetValue & GPIOx_DRESET_DRESET_Msk);
}

/********************************
PortXݼĴ
:PortXݣ˼Ĵռõַռ䣬ʵ֡˼ĴֱӷźţоƬ
룺GPIOx_Type* GPIOxܽźţ,  uint32_t SetValueֵ
:
********************************/
uint32_t GPIOx_DIN_Read(GPIOx_Type* GPIOx)
{
	return (GPIOx->DIN & GPIOx_DIN_DIN_Msk);
}

/********************************
 FOUTú
: FOUT
룺Ƶѡź
:
********************************/
void GPIO_FOUTSEL_FOUTSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = GPIO->FOUTSEL;
	tmpreg &= ~(GPIO_FOUTSEL_FOUTSEL_Msk);
	tmpreg |= (SetValue & GPIO_FOUTSEL_FOUTSEL_Msk);
	GPIO->FOUTSEL = tmpreg;
}
/********************************
FOUT״̬
:FOUT״̬
룺
:FOUTѡֵ
********************************/
uint32_t GPIO_FOUTSEL_FOUTSEL_Get(void)
{
	return (GPIO->FOUTSEL & GPIO_FOUTSEL_FOUTSEL_Msk);
}

/********************************
 PG6ǿʹܺ
: PG6ǿ
룺ENABLE  ʹǿģʽ
      DISABLE رǿģʽ
:
********************************/
void GPIO_HDSEL_PG6HDEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		GPIO->HDSEL |= (GPIO_HDSEL_PG6HDEN_Msk);
	}
	else
	{
		GPIO->HDSEL &= ~(GPIO_HDSEL_PG6HDEN_Msk);
	}
}
/********************************
PG6ǿ״̬
:PG6ǿ״̬
룺
: ENABLE  ǿģʽʹ
      DISABLE ǿģʽѹر
********************************/
FunState GPIO_HDSEL_PG6HDEN_Getable(void)
{
	if (GPIO->HDSEL & (GPIO_HDSEL_PG6HDEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
 PE2ǿʹܺ
: PE2ǿ
룺ENABLE  ʹǿģʽ
      DISABLE رǿģʽ
:
********************************/
void GPIO_HDSEL_PE2HDEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		GPIO->HDSEL |= (GPIO_HDSEL_PE2HDEN_Msk);
	}
	else
	{
		GPIO->HDSEL &= ~(GPIO_HDSEL_PE2HDEN_Msk);
	}
}

/********************************
PE2ǿ״̬
:PE2ǿ״̬
룺
: ENABLE  ǿģʽʹ
      DISABLE ǿģʽѹر
********************************/
FunState GPIO_HDSEL_PE2HDEN_Getable(void)
{
	if (GPIO->HDSEL & (GPIO_HDSEL_PE2HDEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
 PE4ģ⹦ѡ
: PE4ģ⹦ѡ
룺GPIO_ANASEL_PE4ANS_SEG19ѡΪSEG19
      GPIO_ANASEL_PE4ANS_ACMP1_INP1ѡΪACMP1_INP1
:
********************************/
void GPIO_ANASEL_PE4ANS_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = GPIO->ANASEL;
	tmpreg &= ~(GPIO_ANASEL_PE4ANS_Msk);
	tmpreg |= (SetValue & GPIO_ANASEL_PE4ANS_Msk);
	GPIO->ANASEL = tmpreg;
}
/********************************
PE4ģ⹦ѡ״̬
:PE4ģ⹦ѡ״̬
룺
: GPIO_ANASEL_PE4ANS_SEG19ѡSEG19
      GPIO_ANASEL_PE4ANS_ACMP1_INP1ѡACMP1_INP1
********************************/
uint32_t GPIO_ANASEL_PE4ANS_Get(void)
{
	return (GPIO->ANASEL & GPIO_ANASEL_PE4ANS_Msk);
}


/********************************
 PE3ģ⹦ѡ
: PE3ģ⹦ѡ
룺GPIO_ANASEL_PE3ANS_SEG18ѡΪSEG18
      GPIO_ANASEL_PE3ANS_ACMP1_INN1ѡΪACMP1_INN1
:
********************************/
void GPIO_ANASEL_PE3ANS_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = GPIO->ANASEL;
	tmpreg &= ~(GPIO_ANASEL_PE3ANS_Msk);
	tmpreg |= (SetValue & GPIO_ANASEL_PE3ANS_Msk);
	GPIO->ANASEL = tmpreg;
}
/********************************
PE3ģ⹦ѡ״̬
:PE3ģ⹦ѡ״̬
룺
: GPIO_ANASEL_PE3ANS_SEG18ѡSEG18
      GPIO_ANASEL_PE3ANS_ACMP1_INN1ѡACMP1_INN1
********************************/
uint32_t GPIO_ANASEL_PE3ANS_Get(void)
{
	return (GPIO->ANASEL & GPIO_ANASEL_PE3ANS_Msk);
}

/********************************
 PC15ģ⹦ѡ
: PC15ģ⹦ѡ
룺GPIO_ANASEL_PC15ANS_SEG39ѡΪSEG39
      GPIO_ANASEL_PC15ANS_ACMP2_INP0_ADC_IN6ѡΪACMP2_INP0ADC_IN6
:
********************************/
void GPIO_ANASEL_PC15ANS_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = GPIO->ANASEL;
	tmpreg &= ~(GPIO_ANASEL_PC15ANS_Msk);
	tmpreg |= (SetValue & GPIO_ANASEL_PC15ANS_Msk);
	GPIO->ANASEL = tmpreg;
}
/********************************
PC15ģ⹦ѡ״̬
:PC15ģ⹦ѡ״̬
룺
: GPIO_ANASEL_PC15ANS_SEG39ѡSEG39
      GPIO_ANASEL_PC15ANS_ACMP2_INP0_ADC_IN6ѡACMP2_INP0ADC_IN6
********************************/
uint32_t GPIO_ANASEL_PC15ANS_Get(void)
{
	return (GPIO->ANASEL & GPIO_ANASEL_PC15ANS_Msk);
}

/********************************
 PC14ģ⹦ѡ
: PC14ģ⹦ѡ
룺GPIO_ANASEL_PC14ANS_SEG38ѡΪSEG38
      GPIO_ANASEL_PC14ANS_ACMP1_INN0ѡΪACMP1_INN0
:
********************************/
void GPIO_ANASEL_PC14ANS_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = GPIO->ANASEL;
	tmpreg &= ~(GPIO_ANASEL_PC14ANS_Msk);
	tmpreg |= (SetValue & GPIO_ANASEL_PC14ANS_Msk);
	GPIO->ANASEL = tmpreg;
}
/********************************
PC14ģ⹦ѡ״̬
:PC14ģ⹦ѡ״̬
룺
: GPIO_ANASEL_PC14ANS_SEG38ѡSEG38
      GPIO_ANASEL_PC14ANS_ACMP1_INN0ѡACMP1_INN0
********************************/
uint32_t GPIO_ANASEL_PC14ANS_Get(void)
{
	return (GPIO->ANASEL & GPIO_ANASEL_PC14ANS_Msk);
}

/********************************
 PC13ģ⹦ѡ
: PC13ģ⹦ѡ
룺GPIO_ANASEL_PC13ANS_SEG37ѡΪSEG37
      GPIO_ANASEL_PC13ANS_ADC_IN2ѡΪADC_IN2
:
********************************/
void GPIO_ANASEL_PC13ANS_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = GPIO->ANASEL;
	tmpreg &= ~(GPIO_ANASEL_PC13ANS_Msk);
	tmpreg |= (SetValue & GPIO_ANASEL_PC13ANS_Msk);
	GPIO->ANASEL = tmpreg;
}
/********************************
PC13ģ⹦ѡ״̬
:PC13ģ⹦ѡ״̬
룺
: GPIO_ANASEL_PC13ANS_SEG37ѡSEG37
      GPIO_ANASEL_PC13ANS_ADC_IN2ѡADC_IN2
********************************/
uint32_t GPIO_ANASEL_PC13ANS_Get(void)
{
	return (GPIO->ANASEL & GPIO_ANASEL_PC13ANS_Msk);
}
/********************************
 PC12ģ⹦ѡ
: PC12ģ⹦ѡ
룺GPIO_ANASEL_PC12ANS_SEG36ѡΪSEG36
      GPIO_ANASEL_PC12ANS_ADC_IN1ѡΪADC_IN1
:
********************************/
void GPIO_ANASEL_PC12ANS_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = GPIO->ANASEL;
	tmpreg &= ~(GPIO_ANASEL_PC12ANS_Msk);
	tmpreg |= (SetValue & GPIO_ANASEL_PC12ANS_Msk);
	GPIO->ANASEL = tmpreg;
}
/********************************
PC12ģ⹦ѡ״̬
:PC12ģ⹦ѡ״̬
룺
: GPIO_ANASEL_PC12ANS_SEG36ѡSEG36
      GPIO_ANASEL_PC12ANS_ADC_IN1ѡADC_IN1
********************************/
uint32_t GPIO_ANASEL_PC12ANS_Get(void)
{
	return (GPIO->ANASEL & GPIO_ANASEL_PC12ANS_Msk);
}



void GPIOx_Deinit(GPIOx_Type* GPIOx)
{
	GPIOx->INEN = 0x00000000;
	GPIOx->PUEN = 0x00000000;
	GPIOx->ODEN = 0x00000000;
	GPIOx->FCR = 0x00000000;
	GPIOx->DO = 0x00000000;
	//GPIOx->DSET = ;
	//GPIOx->DRESET = ;
	//GPIOx->DIN = ;
}

void GPIO_Deinit(void)
{
	GPIO->EXTI0_SEL = 0xFFFF0000;
	GPIO->EXTI1_SEL = 0xFFFF0000;
	GPIO->EXTI2_SEL = 0xFFFF0000;
	//GPIO->EXTI0IF = ;
	//GPIO->EXTI1IF = ;
	//GPIO->EXTI2IF = ;
	GPIO->FOUTSEL = 0x00000000;
	GPIO->HDSEL = 0x00000000;
	GPIO->ANASEL = 0x00000000;
	GPIO->IODF = 0x00000000;
	GPIO->PINWKEN = 0x00000000;
  GPIO->PF4AFSEL = 0x00000000;
}
//Code_End


void GPIO_ALL_Deinit(void)
{
	GPIO_Deinit();
	GPIOx_Deinit(GPIOA);
	GPIOx_Deinit(GPIOB);
	GPIOx_Deinit(GPIOC);
	GPIOx_Deinit(GPIOD);
	GPIOx_Deinit(GPIOE);
	GPIOx_Deinit(GPIOF);
	GPIOx_Deinit(GPIOG);
}


/********************************
GPIOʼú
:GPIOʼ
룺GPIO˿  GPIO_PIN
: 
********************************/
void GPIO_Init(GPIOx_Type* GPIOx, GPIO_InitTypeDef* para)
{
    uint32_t pinpos = 0x00,pinbit = 0x00,currentpin =0x00;
	uint32_t tmpreg; 

    assert_param(IS_GPIO_ALL_PERIPH(GPIOx));	
	
    for (pinpos = 0; pinpos < 16; pinpos++)
    {
        pinbit = ((uint32_t)0x01) <<pinpos;
        currentpin = (para->Pin) & pinbit;
			
        if (currentpin == pinbit)
        {
			tmpreg = GPIOx->INEN;
            tmpreg &= ~pinbit;
            tmpreg |= (para->PxINEN)<<pinpos;	
			GPIOx->INEN = tmpreg;
			
			tmpreg = GPIOx->PUEN;
			tmpreg &= ~pinbit;
            tmpreg |= (para->PxPUEN)<<pinpos;
			GPIOx->PUEN = tmpreg;
			
			tmpreg = GPIOx->ODEN;
			tmpreg &= ~pinbit;
            tmpreg |= (para->PxODEN)<<pinpos;
			GPIOx->ODEN = tmpreg;

			pinbit = (((uint32_t)0x00000003)) <<(pinpos*2);
			tmpreg = GPIOx->FCR;
            tmpreg &= ~pinbit;
            tmpreg |= (para->PxFCR)<<(pinpos*2);
			GPIOx->FCR = tmpreg;
        }
    }
}

/* ȡһIOڵòṹ 
	עһֻܶȡһIO
*/
/********************************
ȡһIOòṹ庯
:ȡһIOòṹ
룺GPIO˿  GPIO_PIN 
: 
********************************/
void GPIO_Get_InitPara(GPIOx_Type* GPIOx, uint32_t GPIO_Pin, GPIO_InitTypeDef* para)
{
    uint32_t pinbit = 0x00;
    uint32_t i,temp;

	assert_param(IS_GPIO_ALL_PERIPH(GPIOx));	
	
	for (i = 0; i < 16; i++)
	{
		pinbit = GPIO_Pin & (1<<i);
		if(pinbit > 0) break;
	}
	
	if(i < 16)
	{
		pinbit = i;
		para->Pin = GPIO_Pin;
		
		temp = (GPIOx->INEN&GPIO_Pin)>>pinbit;
		if(temp == (uint32_t)GPIO_IN_En)
		{                                         
			para->PxINEN = GPIO_IN_En;
		}
		else
		{
			para->PxINEN = GPIO_IN_Dis;
		}   
		
		temp = (GPIOx->PUEN&GPIO_Pin)>>pinbit;                                    
		if(temp == (uint32_t)GPIO_PU_En)
		{                                         
			para->PxPUEN = GPIO_PU_En;
		}
		else
		{
			para->PxPUEN = GPIO_PU_Dis;
		}   
		
		temp = (GPIOx->ODEN&GPIO_Pin)>>pinbit;                                   
		if(temp == (uint32_t)GPIO_OD_En)
		{                                         
			para->PxODEN = GPIO_OD_En;
		}
		else
		{
			para->PxODEN = GPIO_OD_Dis;
		}  
		
		temp = (GPIOx->FCR>>(pinbit*2))&0x00000003;                                    
		if(temp == (uint32_t)GPIO_FCR_IN)
		{                                         
			para->PxFCR = GPIO_FCR_IN;
		}
		else if(temp == (uint32_t)GPIO_FCR_OUT)
		{
			para->PxFCR = GPIO_FCR_OUT;
		}
		else if(temp == (uint32_t)GPIO_FCR_DIG)
		{                                         
			para->PxFCR = GPIO_FCR_DIG;
		}
		else
		{
			para->PxFCR = GPIO_FCR_ANA;
		}
	}  
}

/********************************
ȡGPIOxݼĴ
:ȡGPIOxݼĴ
룺GPIOx_PIN 
: ݼĴֵ
********************************/
uint32_t GPIO_ReadInputData(GPIOx_Type* GPIOx)
{
	assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
	
//	return(GPIOx_DIN_Read(GPIOx));
	return (GPIOx->DIN);
}

/********************************
ȡGPIOxݼĴbit
:GPIOxݼĴbit
룺GPIO˿  GPIO_PIN 
: bit״̬
********************************/
uint8_t GPIO_ReadInputDataBit(GPIOx_Type* GPIOx, uint32_t GPIO_Pin)
{
    uint8_t bitstatus = 0x00;

	assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
	assert_param(IS_GET_GPIO_PIN(GPIO_Pin));

    if ((GPIOx->DIN & GPIO_Pin) != (uint32_t)Bit_RESET)
    {
        bitstatus = (uint8_t)Bit_SET;
    }
    else
    {
        bitstatus = (uint8_t)Bit_RESET;
    }
    return bitstatus;
}

/********************************
GPIOx1
: GPIOx1
룺GPIO˿  GPIO_PIN 
: 
********************************/
void GPIO_SetBits(GPIOx_Type* GPIOx, uint32_t GPIO_Pin)
{
    assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
    assert_param(IS_GPIO_PIN(GPIO_Pin));

//	GPIOx_DSET_Write(GPIOx, Pin);
    GPIOx->DSET = GPIO_Pin;
}

/********************************
GPIOx0
: GPIOx0
룺GPIO˿  GPIO_PIN 
: 
********************************/
void GPIO_ResetBits(GPIOx_Type* GPIOx, uint32_t GPIO_Pin)
{
    assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
    assert_param(IS_GPIO_PIN(GPIO_Pin));
	
//	GPIOx_DRESET_Write(GPIOx, Pin);
    GPIOx->DRESET = GPIO_Pin;
}

/********************************
GPIOxת
: GPIOx0
룺GPIO˿  GPIO_PIN 
: 
********************************/
void GPIO_ToggleBits(GPIOx_Type* GPIOx, uint32_t GPIO_Pin)
{
    assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
    assert_param(IS_GPIO_PIN(GPIO_Pin));
	
	if(GPIO_Pin&GPIOx->DO)
	{
		//GPIO_ResetBits(GPIOx, GPIO_Pin);
		GPIOx->DRESET = GPIO_Pin;	
	}
	else
	{
		//GPIO_SetBits(GPIOx, GPIO_Pin);	
		GPIOx->DSET = GPIO_Pin;
	}
}

/********************************
ȡGPIOxݼĴ
:ȡGPIOxݼĴ
룺GPIOx_PIN 
: ݼĴֵ
********************************/
uint32_t GPIO_ReadOutputData(GPIOx_Type* GPIOx)
{
	assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
	
//	return(GPIOx_DO_Read(GPIOx));
	return (GPIOx->DO);
}


/********************************
ȡGPIOxݼĴbit
:GPIOxݼĴbit
룺GPIO˿  GPIO_PIN 
: bit״̬
********************************/
uint8_t GPIO_ReadOutputDataBit(GPIOx_Type* GPIOx, uint32_t GPIO_Pin)
{
    uint8_t bitstatus = 0x00;
	
    assert_param(IS_GPIO_ALL_PERIPH(GPIOx));
    assert_param(IS_GET_GPIO_PIN(GPIO_Pin));
	
    if (((GPIOx->DO) & GPIO_Pin) != (uint32_t)Bit_RESET)
    {
        bitstatus = (uint8_t)Bit_SET;
    }
    else
    {
        bitstatus = (uint8_t)Bit_RESET;
    }
    return bitstatus;
}

/********************************
GPIO˲ú
:˲
룺˲GPIO_PIN        
      ENABLE ʹ˲
      DISABLE ر˲
: 
********************************/
void GPIO_IODF_SetableEx(uint32_t DFPinDef, FunState NewState)
{
	if (NewState == ENABLE)
	{
		GPIO->IODF |= ((uint32_t)0x01) << DFPinDef;
	}
	else
	{
		GPIO->IODF &= ~(((uint32_t)0x01) << DFPinDef);
	}
}

/********************************
WKUPú
ܣWKUP
룺WKUP GPIO_PIN        
      ENABLE ʹWKUP
      DISABLE رWKUP
: 
********************************/
void GPIO_PINWKEN_SetableEx(uint32_t NWKPinDef, FunState NewState)
{
	if (NewState == ENABLE)
	{
		GPIO->PINWKEN |= NWKPinDef;
	}
	else
	{
		GPIO->PINWKEN &= ~ NWKPinDef;
	}
}

/********************************
WKUPѡ
ܣWWKUPѡ
룺WKUP GPIO_PIN        
      ENABLE 
      DISABLE ½
: 
********************************/
void GPIO_PINWKSEL_SetableEx(uint32_t NWKPinDef, FunState NewState)
{
	if (NewState == ENABLE)
	{
		GPIO->PINWKEN |= (NWKPinDef<<8);
	}
	else
	{
		GPIO->PINWKEN &= ~ (NWKPinDef<<8);
	}
}

/********************************
WKUPжѡ
ܣWWKUPжѡ
룺GPIO_PINWKEN_WKISEL_NMI: NMIж      
      GPIO_PINWKEN_WKISEL_38#38ж
: 
********************************/
void GPIO_PINWKEN_WKISEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = GPIO->PINWKEN;
	tmpreg &= ~(GPIO_PINWKEN_WKISEL_Msk);
	tmpreg |= (SetValue & GPIO_PINWKEN_WKISEL_Msk);
	GPIO->PINWKEN = tmpreg;
}
/********************************
ȡWKUPжѡ
ܣȡWKUPжѡ
룺     
: GPIO_PINWKEN_WKISEL_NMI: NMIж 
      GPIO_PINWKEN_WKISEL_38#38ж
********************************/
uint32_t GPIO_PINWKEN_WKISEL_Get(void)
{
	return (GPIO->PINWKEN & GPIO_PINWKEN_WKISEL_Msk);
}

/********************************
PF4ùѡ
ܣPF4ùѡ
룺GPIO_PF4AFSEL_PF4AFS_UART0_TXUART_TX
      GPIO_PF4AFSEL_PF4AFS_LPUART_TX: LPUART_TX
      GPIO_PF4AFSEL_PF4AFS_TFO:TFO
:
********************************/
void GPIO_PF4AFSEL_PF4AFS_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = GPIO->PF4AFSEL;
	tmpreg &= ~(GPIO_PF4AFSEL_PF4AFS_Msk);
	tmpreg |= (SetValue & GPIO_PF4AFSEL_PF4AFS_Msk);
	GPIO->PF4AFSEL = tmpreg;
}
/********************************
ȡPF4ùѡ
ܣȡPF4ùѡ
룺
GPIO_PF4AFSEL_PF4AFS_UART0_TXUART_TX
      GPIO_PF4AFSEL_PF4AFS_LPUART_TX: LPUART_TX
      GPIO_PF4AFSEL_PF4AFS_TFO:TFO
********************************/
uint32_t GPIO_PF4AFSEL_PF4AFS_Get(void)
{
	return (GPIO->PF4AFSEL & GPIO_PF4AFSEL_PF4AFS_Msk);
}

/********************************
PF4Ƶźѡ
ܣPF4Ƶźѡ
룺

********************************/
void GPIO_PF4AFSEL_TFOSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = GPIO->PF4AFSEL;
	tmpreg &= ~(GPIO_PF4AFSEL_TFOSEL_Msk);
	tmpreg |= (SetValue & GPIO_PF4AFSEL_TFOSEL_Msk);
	GPIO->PF4AFSEL = tmpreg;
}
/********************************
ȡPF4Ƶźѡ
ܣȡPF4Ƶźѡ
룺

********************************/
uint32_t GPIO_PF4AFSEL_TFOSEL_Get(void)
{
	return (GPIO->PF4AFSEL & GPIO_PF4AFSEL_TFOSEL_Msk);
}
/*************************************************************************
 ƣGPIO_EXTI_Select_Pin
 ˵GPIO EXTI ⲿѡ
 GPIOx ˿ GPIO_Pinpin ˿ 
 
 زw
 *************************************************************************/
void GPIO_EXTI_Select_Pin(GPIOx_Type* GPIOx,uint32_t GPIO_Pin)
{
	uint32_t pin_num = 0,i;	
	uint32_t pin_shift;
	uint32_t tmpreg;
	
	for(i= 0;i<16;i++)
	{
		if(GPIO_Pin&(1<<i))
		{
			pin_num = i;
			break;
		}
	}

	switch((uint32_t)GPIOx)
	{
		case (uint32_t)GPIOA:
		case (uint32_t)GPIOB:
			pin_shift = (pin_num%8)*2;
			tmpreg = GPIO->EXTI0_SEL;
			tmpreg &= (~(0x00000003 << pin_shift));
			if(GPIOx == GPIOA)
			{
				tmpreg |= ((pin_num/8) << pin_shift);
			}
			else
			{
				tmpreg |= (((pin_num/8)+ 2) << pin_shift);
			}
			GPIO->EXTI0_SEL = tmpreg;
			break;

		case (uint32_t)GPIOC:
			pin_shift = (pin_num%8)*2;
			tmpreg = GPIO->EXTI1_SEL;
			tmpreg &= (~(0x00000003 << pin_shift));
			tmpreg |= ((pin_num/8) << pin_shift);
			GPIO->EXTI1_SEL = tmpreg;
			break;

		case (uint32_t)GPIOD://0~10
			if(pin_num <= 10)
			{
				pin_shift = (pin_num%8)*2;
				tmpreg = GPIO->EXTI1_SEL;
				tmpreg &= (~(0x00000003 << pin_shift));
				tmpreg |= (((pin_num/8)+ 2) << pin_shift);
				GPIO->EXTI1_SEL = tmpreg;
			}
			break;

		case (uint32_t)GPIOE://2~9(-2)
			if((pin_num >= 2)&&(pin_num <= 5))//1bit
			{
				pin_shift = pin_num - 2;
				tmpreg = GPIO->EXTI2_SEL;
				tmpreg &= (~(0x00000001 << pin_shift));
				GPIO->EXTI2_SEL = tmpreg;
			}
			else if((pin_num >= 6)&&(pin_num <= 9))//2bit
			{
				pin_shift = 4 + (pin_num - 6)*2;
				tmpreg = GPIO->EXTI2_SEL;
				tmpreg &= (~(0x00000003 << pin_shift));
				GPIO->EXTI2_SEL = tmpreg;
			}
			break;

		case (uint32_t)GPIOF://1~7   8~11(-4)
			if((pin_num >= 1)&&(pin_num <= 3))//1bit
			{
				pin_shift = pin_num;
				tmpreg = GPIO->EXTI2_SEL;
				tmpreg &= (~(0x00000001 << pin_shift));
				tmpreg |= (0x00000001 << pin_shift);
				GPIO->EXTI2_SEL = tmpreg;
			}
			else if((pin_num >= 4)&&(pin_num <= 7))//2bit-a
			{
				pin_shift = 4 + (pin_num - 4)*2;
				tmpreg = GPIO->EXTI2_SEL;
				tmpreg &= (~(0x00000003 << pin_shift));
				tmpreg |= (0x00000001 << pin_shift);
				GPIO->EXTI2_SEL = tmpreg;
			}
			else if((pin_num >= 8)&&(pin_num <= 11))//2bit-b
			{
				pin_shift = 4 + (pin_num - 8)*2;
				tmpreg = GPIO->EXTI2_SEL;
				tmpreg &= (~(0x00000003 << pin_shift));
				tmpreg |= (0x00000002 << pin_shift);
				GPIO->EXTI2_SEL = tmpreg;
			}
			break;

		case (uint32_t)GPIOG://2(+1) 5~8(-1)
			if(pin_num == 2)
			{
				pin_shift = 6;
				tmpreg = GPIO->EXTI1_SEL;
				tmpreg &= (~(0x00000003 << pin_shift));
				tmpreg |= (0x00000003 << pin_shift);
				GPIO->EXTI1_SEL = tmpreg;
			}
			else if((pin_num >= 5)&&(pin_num <= 8))
			{
				pin_shift = (pin_num - 1)*2;
				tmpreg = GPIO->EXTI1_SEL;
				tmpreg &= (~(0x00000003 << pin_shift));
				tmpreg |= (0x00000003 << pin_shift);
				GPIO->EXTI1_SEL = tmpreg;
			}
			break;
		
		default:
			break;
	}
}

/*************************************************************************
 ƣGPIO_EXTI_Select_Edge
 ˵GPIO EXTI_Select_Edge ⲿжϱѡ
 GPIOx ˿ GPIO_Pin ˿ ,edge_select 
 
 زw
 *************************************************************************/
void GPIO_EXTI_Select_Edge(GPIOx_Type* GPIOx,uint32_t GPIO_Pin,GPIOExtiEdge edge_select)
{
	uint32_t pin_num = 0,i;	
	uint32_t pin_shift;
	uint32_t tmpreg;

	for(i= 0;i<16;i++)
	{
		if(GPIO_Pin&(1<<i))
		{
			pin_num = i;
			break;
		}							
	}	
	
	switch((uint32_t)GPIOx)
	{
		case (uint32_t)GPIOA:
		case (uint32_t)GPIOB:
			pin_shift = (pin_num%8)*2 + 16;
			tmpreg = GPIO->EXTI0_SEL;
			tmpreg &= (~(0x00000003 << pin_shift));			  
			tmpreg |= edge_select << pin_shift;
			GPIO->EXTI0_SEL = tmpreg;
			break;

		case (uint32_t)GPIOC:
			pin_shift = (pin_num%8)*2 + 16;
			tmpreg = GPIO->EXTI1_SEL;
			tmpreg &= (~(0x00000003 << pin_shift));			  
			tmpreg |= edge_select << pin_shift;
			GPIO->EXTI1_SEL = tmpreg;
			break;

		case (uint32_t)GPIOD://0~10
			if(pin_num <= 10)
			{
				pin_shift = (pin_num%8)*2 + 16;
				tmpreg = GPIO->EXTI1_SEL;
				tmpreg &= (~(0x00000003 << pin_shift));			  
				tmpreg |= edge_select << pin_shift;
				GPIO->EXTI1_SEL = tmpreg;
			}
			break;

		case (uint32_t)GPIOE://2~9(-2)
			if((pin_num >= 2)&&(pin_num <= 9))
			{
				pin_shift = (pin_num - 2)*2 + 16;
				tmpreg = GPIO->EXTI2_SEL;
				tmpreg &= (~(0x00000003 << pin_shift));
				tmpreg |= edge_select << pin_shift;
				GPIO->EXTI2_SEL = tmpreg;
			}
			break;

		case (uint32_t)GPIOF://1~7   8~11(-4)
			if((pin_num >= 1)&&(pin_num <= 7))
			{
				pin_shift = pin_num*2 + 16;
				tmpreg = GPIO->EXTI2_SEL;
				tmpreg &= (~(0x00000003 << pin_shift));
				tmpreg |= edge_select << pin_shift;
				GPIO->EXTI2_SEL = tmpreg;
			}
			else if((pin_num >= 8)&&(pin_num <= 11))
			{
				pin_shift = ((pin_num - 8)+4)*2 + 16;	
				tmpreg = GPIO->EXTI2_SEL;
				tmpreg &= (~(0x00000003 << pin_shift));
				tmpreg |= edge_select << pin_shift;
				GPIO->EXTI2_SEL = tmpreg;
			}
			break;

		case (uint32_t)GPIOG://2(+1) 5~8(-1)
			if(pin_num == 2)
			{
				pin_shift = (pin_num + 1)*2 + 16;
				tmpreg = GPIO->EXTI1_SEL;
				tmpreg &= (~(0x00000003 << pin_shift));			  
				tmpreg |= edge_select << pin_shift;
				GPIO->EXTI1_SEL = tmpreg;
			}
			else if((pin_num >= 5)&&(pin_num <= 8))
			{
				pin_shift = (pin_num - 1)*2 + 16;
				tmpreg = GPIO->EXTI1_SEL;
				tmpreg &= (~(0x00000003 << pin_shift));
				tmpreg |= edge_select << pin_shift;
				GPIO->EXTI1_SEL = tmpreg;
			}
			break;
		
		default:
			break;
	}
}

/*************************************************************************
 ƣGPIO_EXTI_EXTIxIF_ClrEx
 ˵GPIO_EXTI_EXTIxIF_ClrEx жϱ־
 GPIOx ˿ GPIO_Pin ˿ 
 
 زw
 *************************************************************************/
void GPIO_EXTI_EXTIxIF_ClrEx(GPIOx_Type* GPIOx,uint32_t GPIO_Pin)
{
	uint32_t pin_num = 0,i;	
	
	for(i= 0;i<16;i++)
	{
		if(GPIO_Pin&(1<<i))
		{
			pin_num = i;
			break;
		}							
	}

	switch((uint32_t)GPIOx)
	{
		case (uint32_t)GPIOA:
		case (uint32_t)GPIOB:
			GPIO->EXTI0IF = (0x00000001 << (pin_num&0x07));
			break;

		case (uint32_t)GPIOC:
			GPIO->EXTI1IF = (0x00000001 << (pin_num&0x07));
			break;

		case (uint32_t)GPIOD://0~10
			if(pin_num <= 10)
			{
				GPIO->EXTI1IF = (0x00000001 << (pin_num&0x07));
			}
			break;

		case (uint32_t)GPIOE://2~9(-2)
			if((pin_num >= 2)&&(pin_num <= 9))
			{
				GPIO->EXTI2IF = (0x00000001 << (pin_num - 2));
			}
			break;

		case (uint32_t)GPIOF://1~7   8~11(-4)
			if((pin_num >= 1)&&(pin_num <= 7))
			{
				GPIO->EXTI2IF = (0x00000001 << (pin_num&0x07));
			}
			else if((pin_num >= 8)&&(pin_num <= 11))
			{
				GPIO->EXTI2IF = (0x00000001 << (pin_num - 4));
			}
			break;

		case (uint32_t)GPIOG://2(+1) 5~8(-1)
			if(pin_num == 2)
			{
				GPIO->EXTI1IF = (0x00000001 << (pin_num + 1));
			}
			else if((pin_num >= 5)&&(pin_num <= 8))
			{
				GPIO->EXTI1IF = (0x00000001 << (pin_num - 1));
			}
			break;
		
		default:
			break;
	}
}

/*************************************************************************
 ƣGPIO_EXTI_EXTIxIF_ChkEx
 ˵GPIO_EXTI_EXTIxIF_ChkEx ȡжϱ־״̬
 GPIOx ˿ GPIO_Pin ˿ 
 
 زwFlagStatus жϱ־״̬
 *************************************************************************/
FlagStatus GPIO_EXTI_EXTIxIF_ChkEx(GPIOx_Type* GPIOx,uint32_t GPIO_Pin)
{
	uint32_t pin_num = 0,i;	
	FlagStatus Result = RESET;
	
	for(i= 0;i<16;i++)
	{
		if(GPIO_Pin&(1<<i))
		{
			pin_num = i;
			break;
		}							
	}

	Result = RESET;
	switch((uint32_t)GPIOx)
	{
		case (uint32_t)GPIOA:
		case (uint32_t)GPIOB:
			if(GPIO->EXTI0IF & (0x00000001 << (pin_num&0x07))) Result = SET;
			break;

		case (uint32_t)GPIOC:
			if(GPIO->EXTI1IF & (0x00000001 << (pin_num&0x07))) Result = SET;
			break;

		case (uint32_t)GPIOD://0~10
			if(pin_num <= 10)
			{
				if(GPIO->EXTI1IF & (0x00000001 << (pin_num&0x07))) Result = SET;
			}
			break;

		case (uint32_t)GPIOE://2~9(-2)
			if((pin_num >= 2)&&(pin_num <= 9))
			{
				if(GPIO->EXTI2IF & (0x00000001 << (pin_num - 2))) Result = SET;
			}
			break;

		case (uint32_t)GPIOF://1~7   8~11(-4)
			if((pin_num >= 1)&&(pin_num <= 7))
			{
				if(GPIO->EXTI2IF & (0x00000001 << (pin_num&0x07))) Result = SET;
			}
			else if((pin_num >= 8)&&(pin_num <= 11))
			{
				if(GPIO->EXTI2IF & (0x00000001 << (pin_num - 4))) Result = SET;
			}
			break;

		case (uint32_t)GPIOG://2(+1) 5~8(-1)
			if(pin_num == 2)
			{
				if(GPIO->EXTI1IF & (0x00000001 << (pin_num + 1))) Result = SET;
			}
			else if((pin_num >= 5)&&(pin_num <= 8))
			{
				if(GPIO->EXTI1IF & (0x00000001 << (pin_num - 1))) Result = SET;
			}
			break;
		
		default:
			break;
	}
	
	return Result;
}

/*************************************************************************
 ƣGPIO_EXTI_Init
 ˵GPIO_EXTI_Init ⲿжϳʼ
 port ˿ pin ˿ ,edge 
 
 زw
 *************************************************************************/
//FM33G0XX7GPIOA~GԲ24ⲿжϣIOͬʱжϹ
void GPIO_EXTI_Init(GPIOx_Type* GPIOx,uint32_t GPIO_Pin,GPIOExtiEdge edge_select)
{
	GPIO_EXTI_Select_Edge(GPIOx, GPIO_Pin, EXTI_DISABLE);	//رձش
	GPIO_EXTI_Select_Pin(GPIOx, GPIO_Pin);					//ⲿѡ
	GPIO_EXTI_Select_Edge(GPIOx, GPIO_Pin, edge_select);	//޸ıѡ
	GPIO_EXTI_EXTIxIF_ClrEx(GPIOx, GPIO_Pin);				//жϱ־
}

/*************************************************************************
 ƣGPIO_EXTI_Close
 ˵GPIO_EXTI_Close ⲿжϹر
 port ˿ pin ˿ 
 
 زw
 *************************************************************************/
void GPIO_EXTI_Close(GPIOx_Type* GPIOx,uint32_t GPIO_Pin)
{
	GPIO_EXTI_Select_Edge(GPIOx, GPIO_Pin, EXTI_DISABLE);//رձش
}

/******END OF FILE****/




