/**
  ******************************************************************************
  * @file    fm33g0xx_spi.c
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of SPI:           
  *           
  ******************************************************************************  
  */ 

/* Includes ------------------------------------------------------------------*/ 

#include "fm33g0xx_hspi.h"  



/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/



/********************************
HSPI ƺ
: MasterӳٲʱSlaveǰʱ
룺	HSPI_SPICR1_DELAY_CFG_MASTER_NO_DELAY		Masterģʽӳ *
	HSPI_SPICR1_DELAY_CFG_SLAVE_NORMAL		Slaveģʽ 
	HSPI_SPICR1_DELAY_CFG_MASTER_DLY_L1		Masterģʽ1ӳ 
	HSPI_SPICR1_DELAY_CFG_SLAVE_PHASE_1		Slaveģʽλ1
	HSPI_SPICR1_DELAY_CFG_MASTER_DLY_L2		Masterģʽ2ӳ 
	HSPI_SPICR1_DELAY_CFG_SLAVE_PHASE_2		Slaveģʽλ2
	HSPI_SPICR1_DELAY_CFG_MASTER_DLY_L3		Masterģʽ3ӳ 
	HSPI_SPICR1_DELAY_CFG_SLAVE_PHASE_3		Slaveģʽλ3
	HSPI_SPICR1_DELAY_CFG_MASTER_DLY_L4		Masterģʽ4ӳ 
	HSPI_SPICR1_DELAY_CFG_SLAVE_PHASE_4		Slaveģʽλ4 

:
********************************/
void HSPI_SPICR1_DELAY_CFG_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = HSPI->SPICR1;
	tmpreg &= ~(HSPI_SPICR1_DELAY_CFG_Msk);
	tmpreg |= (SetValue & HSPI_SPICR1_DELAY_CFG_Msk);
	HSPI->SPICR1 = tmpreg;
}
/********************************
HSPI ƺ
: ȡMasterӳٲʱSlaveǰʱ
룺 
:	HSPI_SPICR1_DELAY_CFG_MASTER_NO_DELAY		Masterģʽӳ *
	HSPI_SPICR1_DELAY_CFG_SLAVE_NORMAL		Slaveģʽ 
	HSPI_SPICR1_DELAY_CFG_MASTER_DLY_L1		Masterģʽ1ӳ 
	HSPI_SPICR1_DELAY_CFG_SLAVE_PHASE_1		Slaveģʽλ1
	HSPI_SPICR1_DELAY_CFG_MASTER_DLY_L2		Masterģʽ2ӳ 
	HSPI_SPICR1_DELAY_CFG_SLAVE_PHASE_2		Slaveģʽλ2
	HSPI_SPICR1_DELAY_CFG_MASTER_DLY_L3		Masterģʽ3ӳ 
	HSPI_SPICR1_DELAY_CFG_SLAVE_PHASE_3		Slaveģʽλ3
	HSPI_SPICR1_DELAY_CFG_MASTER_DLY_L4		Masterģʽ4ӳ 
	HSPI_SPICR1_DELAY_CFG_SLAVE_PHASE_4		Slaveģʽλ4
********************************/
uint32_t HSPI_SPICR1_DELAY_CFG_Get(void)
{
	return (HSPI->SPICR1 & HSPI_SPICR1_DELAY_CFG_Msk);
}


/********************************
HSPI ƺ
: ùģʽ
룺	HSPI_SPICR1_MM_SLAVE		SLAVE
	HSPI_SPICR1_MM_MASTER		MASTER

:
********************************/
void HSPI_SPICR1_MM_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = HSPI->SPICR1;
	tmpreg &= ~(HSPI_SPICR1_MM_Msk);
	tmpreg |= (SetValue & HSPI_SPICR1_MM_Msk);
	HSPI->SPICR1 = tmpreg;
}

/********************************
HSPI ƺ
: ȡģʽ
룺 
:	HSPI_SPICR1_MM_SLAVE		SLAVE
	HSPI_SPICR1_MM_MASTER		MASTER
********************************/
uint32_t HSPI_SPICR1_MM_Get(void)
{
	return (HSPI->SPICR1 & HSPI_SPICR1_MM_Msk);
}
/********************************
HSPI ƺ
: ÷ÿbyte֮ĵȴʱ
룺	HSPI_SPICR1_WAIT_WAIT_1		ÿ8bitټ1sckڵȴʱٴһ8Bit		
	HSPI_SPICR1_WAIT_WAIT_2		ÿ8bitټ2sckڵȴʱٴһ8Bit
	HSPI_SPICR1_WAIT_WAIT_3		ÿ8bitټ3sckڵȴʱٴһ8Bit
	HSPI_SPICR1_WAIT_WAIT_4		ÿ8bitټ4sckڵȴʱٴһ8Bit
:
********************************/
void HSPI_SPICR1_WAIT_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = HSPI->SPICR1;
	tmpreg &= ~(HSPI_SPICR1_WAIT_Msk);
	tmpreg |= (SetValue & HSPI_SPICR1_WAIT_Msk);
	HSPI->SPICR1 = tmpreg;
}
/********************************
HSPI ƺ
: ȡÿbyte֮ĵȴʱ
룺 
:	HSPI_SPICR1_WAIT_WAIT_1		ÿ8bitټ1sckڵȴʱٴһ8Bit		
			HSPI_SPICR1_WAIT_WAIT_2		ÿ8bitټ2sckڵȴʱٴһ8Bit
			HSPI_SPICR1_WAIT_WAIT_3		ÿ8bitټ3sckڵȴʱٴһ8Bit
			HSPI_SPICR1_WAIT_WAIT_4		ÿ8bitټ4sckڵȴʱٴһ8Bit
********************************/
uint32_t HSPI_SPICR1_WAIT_Get(void)
{
	return (HSPI->SPICR1 & HSPI_SPICR1_WAIT_Msk);
}

/********************************
HSPI ƺ
: MASTERģʽµĲ
룺HSPI_SPICR1_BAUD_PCLK					ʱӲƵ
			HSPI_SPICR1_BAUD_PCLK_2				ʱ2Ƶ
			HSPI_SPICR1_BAUD_PCLK_4				ʱ4Ƶ
			HSPI_SPICR1_BAUD_PCLK_8				ʱ8Ƶ
			HSPI_SPICR1_BAUD_PCLK_16			ʱ16Ƶ
			HSPI_SPICR1_BAUD_PCLK_32			ʱ32Ƶ
			HSPI_SPICR1_BAUD_PCLK_64			ʱ64Ƶ
			HSPI_SPICR1_BAUD_PCLK_128			ʱ128Ƶ
:
********************************/
void HSPI_SPICR1_BAUD_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = HSPI->SPICR1;
	tmpreg &= ~(HSPI_SPICR1_BAUD_Msk);
	tmpreg |= (SetValue & HSPI_SPICR1_BAUD_Msk);
	HSPI->SPICR1 = tmpreg;
}
/********************************
HSPI ƺ
: ȡMASTERģʽµĲ
룺 
:	HSPI_SPICR1_BAUD_PCLK					ʱӲƵ
			HSPI_SPICR1_BAUD_PCLK_2				ʱ2Ƶ
			HSPI_SPICR1_BAUD_PCLK_4				ʱ4Ƶ
			HSPI_SPICR1_BAUD_PCLK_8				ʱ8Ƶ
			HSPI_SPICR1_BAUD_PCLK_16			ʱ16Ƶ
			HSPI_SPICR1_BAUD_PCLK_32			ʱ32Ƶ
			HSPI_SPICR1_BAUD_PCLK_64			ʱ64Ƶ
			HSPI_SPICR1_BAUD_PCLK_128			ʱ128Ƶ
********************************/
uint32_t HSPI_SPICR1_BAUD_Get(void)
{
	return (HSPI->SPICR1 & HSPI_SPICR1_BAUD_Msk);
}

/********************************
HSPI ƺ
: ֡ʽ
룺HSPI_SPICR1_LSBF_MSB		ȷMSB
			HSPI_SPICR1_LSBF_LSB		ȷLSB
:
********************************/
void HSPI_SPICR1_LSBF_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = HSPI->SPICR1;
	tmpreg &= ~(HSPI_SPICR1_LSBF_Msk);
	tmpreg |= (SetValue & HSPI_SPICR1_LSBF_Msk);
	HSPI->SPICR1 = tmpreg;
}
/********************************
HSPI ƺ
: ȡ֡ʽ
룺 
:	HSPI_SPICR1_LSBF_MSB		ȷMSB
			HSPI_SPICR1_LSBF_LSB		ȷLSB
********************************/
uint32_t HSPI_SPICR1_LSBF_Get(void)
{
	return (HSPI->SPICR1 & HSPI_SPICR1_LSBF_Msk);
}

/********************************
HSPI ƺ
: ʱӼ
룺HSPI_SPICR1_CPHOL_LOW		ʱֹͣڵ͵ƽ
			HSPI_SPICR1_CPHOL_HIGH	ʱֹͣڸߵƽ
:
********************************/
void HSPI_SPICR1_CPHOL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = HSPI->SPICR1;
	tmpreg &= ~(HSPI_SPICR1_CPHOL_Msk);
	tmpreg |= (SetValue & HSPI_SPICR1_CPHOL_Msk);
	HSPI->SPICR1 = tmpreg;
}
/********************************
HSPI ƺ
: ȡʱӼ
룺 
:	HSPI_SPICR1_CPHOL_LOW		ʱֹͣڵ͵ƽ
			HSPI_SPICR1_CPHOL_HIGH	ʱֹͣڸߵƽ
********************************/
uint32_t HSPI_SPICR1_CPHOL_Get(void)
{
	return (HSPI->SPICR1 & HSPI_SPICR1_CPHOL_Msk);
}

/********************************
HSPI ƺ
: ʱλ
룺HSPI_SPICR1_CPHA_FIRST			һʱӱǵһ׽
	    HSPI_SPICR1_CPHA_SECOND			ڶʱӱǵһ׽
:
********************************/
void HSPI_SPICR1_CPHA_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = HSPI->SPICR1;
	tmpreg &= ~(HSPI_SPICR1_CPHA_Msk);
	tmpreg |= (SetValue & HSPI_SPICR1_CPHA_Msk);
	HSPI->SPICR1 = tmpreg;
}
/********************************
HSPI ƺ
: ȡʱλ
룺 
:	HSPI_SPICR1_CPHA_FIRST			һʱӱǵһ׽
	    HSPI_SPICR1_CPHA_SECOND			ڶʱӱǵһ׽
********************************/
uint32_t HSPI_SPICR1_CPHA_Get(void)
{
	return (HSPI->SPICR1 & HSPI_SPICR1_CPHA_Msk);
}

/********************************
HSPI ƺ
: SLAVEܽ˲ʹ
룺ENABLE/DISABLE		ܽ˲/ܽ˲
:
********************************/
void HSPI_SPICR2_FLTEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		HSPI->SPICR2 |= (HSPI_SPICR2_FLTEN_Msk);
	}
	else
	{
		HSPI->SPICR2 &= ~(HSPI_SPICR2_FLTEN_Msk);
	}
}
/********************************
HSPI ƺ
: ȡSLAVEܽ˲Ƿʹ
룺
: ENABLE/DISABLE		ܽ˲/ܽ˲
********************************/
FunState HSPI_SPICR2_FLTEN_Getable(void)
{
	if (HSPI->SPICR2 & (HSPI_SPICR2_FLTEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
HSPI ƺ
: MASTERģʽSSNĿģʽ
룺HSPI_SPICR2_SSNM_LOW			ÿ8bitMasterSSNΪ
      HSPI_SPICR2_SSNM_HIGH			ÿ8bitMasterSSNάָߵƽʱWAITĴ
:
********************************/
void HSPI_SPICR2_SSNM_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = HSPI->SPICR2;
	tmpreg &= ~(HSPI_SPICR2_SSNM_Msk);
	tmpreg |= (SetValue & HSPI_SPICR2_SSNM_Msk);
	HSPI->SPICR2 = tmpreg;
}

/********************************
HSPI ƺ
: ȡMASTERģʽSSNĿģʽ
룺
: HSPI_SPICR2_SSNM_LOW			ÿ8bitMasterSSNΪ
      HSPI_SPICR2_SSNM_HIGH			ÿ8bitMasterSSNάָߵƽʱWAITĴ
********************************/
uint32_t HSPI_SPICR2_SSNM_Get(void)
{
	return (HSPI->SPICR2 & HSPI_SPICR2_SSNM_Msk);
}

/********************************
HSPI ƺ
: TXONLYӲԶյʹ
룺HSPI_SPICR2_TXO_AC_CLR_AT_CLOSE			رTXONLYӲԶ
	    HSPI_SPICR2_TXO_AC_CLR_AT_TX				TXONLYӲԶЧʹTXO󣬵ȴϺӲ
:
********************************/
void HSPI_SPICR2_TXO_AC_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = HSPI->SPICR2;
	tmpreg &= ~(HSPI_SPICR2_TXO_AC_Msk);
	tmpreg |= (SetValue & HSPI_SPICR2_TXO_AC_Msk);
	HSPI->SPICR2 = tmpreg;
}
/********************************
HSPI ƺ
: ȡTXONLYӲԶյʹ
룺
: HSPI_SPICR2_TXO_AC_CLR_AT_CLOSE			رTXONLYӲԶ
	    HSPI_SPICR2_TXO_AC_CLR_AT_TX				TXONLYӲԶЧʹTXO󣬵ȴϺӲ
********************************/
uint32_t HSPI_SPICR2_TXO_AC_Get(void)
{
	return (HSPI->SPICR2 & HSPI_SPICR2_TXO_AC_Msk);
}

/********************************
HSPI ƺ
: TXONLYʹ(MASTERµģʽ)
룺ENABLE/DISABLE		Masterĵģʽ/رյģʽ
:
********************************/
void HSPI_SPICR2_TXO_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		HSPI->SPICR2 |= (HSPI_SPICR2_TXO_Msk);
	}
	else
	{
		HSPI->SPICR2 &= ~(HSPI_SPICR2_TXO_Msk);
	}
}
/********************************
HSPI ƺ
: ȡTXONLYʹ״̬(MASTERµģʽ)
룺
: ENABLE/DISABLE		Masterĵģʽ/رյģʽ
********************************/
FunState HSPI_SPICR2_TXO_Getable(void)
{
	if (HSPI->SPICR2 & (HSPI_SPICR2_TXO_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
HSPI ƺ
: MASTERSSNƽ
룺HSPI_SPICR2_SSN_LOW 	SSN͵ƽ
	    HSPI_SPICR2_SSN_HIGH	SSNߵƽ
:
********************************/
void HSPI_SPICR2_SSN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = HSPI->SPICR2;
	tmpreg &= ~(HSPI_SPICR2_SSN_Msk);
	tmpreg |= (SetValue & HSPI_SPICR2_SSN_Msk);
	HSPI->SPICR2 = tmpreg;
}
/********************************
HSPI ƺ
: ȡMASTERSSNƽ
룺
: HSPI_SPICR2_SSN_LOW 	SSN͵ƽ
	    HSPI_SPICR2_SSN_HIGH	SSNߵƽ
********************************/
uint32_t HSPI_SPICR2_SSN_Get(void)
{
	return (HSPI->SPICR2 & HSPI_SPICR2_SSN_Msk);
}

/********************************
HSPI ƺ
: MASTERSSNĿƷʽ
룺HSPI_SPICR2_SSNSEN_HARD		MasterģʽSSNӲԶ
	    HSPI_SPICR2_SSNSEN_SOFT		MasterģʽSSN
:
********************************/
void HSPI_SPICR2_SSNSEN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = HSPI->SPICR2;
	tmpreg &= ~(HSPI_SPICR2_SSNSEN_Msk);
	tmpreg |= (SetValue & HSPI_SPICR2_SSNSEN_Msk);
	HSPI->SPICR2 = tmpreg;
}
/********************************
HSPI ƺ
: ȡMASTERSSNĿƷʽ
룺
: HSPI_SPICR2_SSNSEN_HARD		MasterģʽSSNӲԶ
	    HSPI_SPICR2_SSNSEN_SOFT		MasterģʽSSN
********************************/
uint32_t HSPI_SPICR2_SSNSEN_Get(void)
{
	return (HSPI->SPICR2 & HSPI_SPICR2_SSNSEN_Msk);
}

/********************************
HSPI ƺ
: HSPIʹܿ
룺ENABLE/DISABLE	HSPIʹ/HSPIֹ
:
********************************/
void HSPI_SPICR2_HSPIEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		HSPI->SPICR2 |= (HSPI_SPICR2_HSPIEN_Msk);
	}
	else
	{
		HSPI->SPICR2 &= ~(HSPI_SPICR2_HSPIEN_Msk);
	}
}
/********************************
HSPI ƺ
: ȡHSPIʹܿ״̬
룺
: ENABLE/DISABLE	HSPIʹ/HSPIֹ
********************************/
FunState HSPI_SPICR2_HSPIEN_Getable(void)
{
	if (HSPI->SPICR2 & (HSPI_SPICR2_HSPIEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
HSPI ƺ
: ͻ
룺
: 
********************************/
void HSPI_SPICR3_TXBFC_Clr(void)
{
	HSPI->SPICR3 = HSPI_SPICR3_TXBFC_Msk;
}
/********************************
HSPI ƺ
: ջ
룺
: 
********************************/
void HSPI_SPICR3_RXBFC_Clr(void)
{
	HSPI->SPICR3 = HSPI_SPICR3_RXBFC_Msk;
}
/********************************
HSPI ƺ
: MASTER ERR־(HSPISTA.MERR)
룺
: 
********************************/
void HSPI_SPICR3_MERRC_Clr(void)
{
	HSPI->SPICR3 = HSPI_SPICR3_MERRC_Msk;
}
/********************************
HSPI ƺ
: SLAVE ERR־(HSPISTA.SERR)
룺HSPI_SPICR3_SERRC_Msk
:
********************************/
void HSPI_SPICR3_SERRC_Clr(void)
{
	HSPI->SPICR3 = HSPI_SPICR3_SERRC_Msk;
}
/********************************
HSPI ƺ
: HSPIжʹ
룺ENABLE/DISABLE			жʹ/жϽֹ
:
********************************/
void HSPI_SPIIE_ERRIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		HSPI->SPIIE |= (HSPI_SPIIE_ERRIE_Msk);
	}
	else
	{
		HSPI->SPIIE &= ~(HSPI_SPIIE_ERRIE_Msk);
	}
}
/********************************
HSPI ƺ
: ȡHSPIжʹ״̬
룺
: ENABLE/DISABLE			жʹ/жϽֹ
********************************/
FunState HSPI_SPIIE_ERRIE_Getable(void)
{
	if (HSPI->SPIIE & (HSPI_SPIIE_ERRIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
HSPI ƺ
: HSPIжʹ
룺ENABLE/DISABLE			жʹ/жϽֹ
:
********************************/
void HSPI_SPIIE_TXIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		HSPI->SPIIE |= (HSPI_SPIIE_TXIE_Msk);
	}
	else
	{
		HSPI->SPIIE &= ~(HSPI_SPIIE_TXIE_Msk);
	}
}
/********************************
HSPI ƺ
: ȡHSPIжʹ״̬
룺
: ENABLE/DISABLE			жʹ/жϽֹ
********************************/
FunState HSPI_SPIIE_TXIE_Getable(void)
{
	if (HSPI->SPIIE & (HSPI_SPIIE_TXIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
HSPI ƺ
: HSPIжʹ
룺ENABLE/DISABLE			жʹ/жϽֹ
:
********************************/
void HSPI_SPIIE_RXIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		HSPI->SPIIE |= (HSPI_SPIIE_RXIE_Msk);
	}
	else
	{
		HSPI->SPIIE &= ~(HSPI_SPIIE_RXIE_Msk);
	}
}
/********************************
HSPI ƺ
: ȡHSPIжʹ״̬
룺
: ENABLE/DISABLE			жʹ/жϽֹ
********************************/
FunState HSPI_SPIIE_RXIE_Getable(void)
{
	if (HSPI->SPIIE & (HSPI_SPIIE_RXIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
HSPI ƺ
: ȡHSPI MASTERжϱ־
룺
: SET/RESET					HSPIMASTERжϷ/HSPI MASTERжδ
********************************/
FlagStatus HSPI_SPIIF_MERR_Chk(void)
{
	if (HSPI->SPIIF & HSPI_SPIIF_MERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
HSPI ƺ
: ȡHSPI SLAVEжϱ־
룺
: SET/RESET					HSPI SLAVEжϷ/HSPI SLAVEжδ
********************************/
FlagStatus HSPI_SPIIF_SERR_Chk(void)
{
	if (HSPI->SPIIF & HSPI_SPIIF_SERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}
/********************************
HSPI ƺ
: ջ
룺
: 
********************************/
void HSPI_SPIIF_RXCOL_Clr(void)
{
	HSPI->SPIIF = HSPI_SPIIF_RXCOL_Msk;
}
/********************************
HSPI ƺ
: ȡջ־
룺
: SET/RESET			ջ/δջ
********************************/
FlagStatus HSPI_SPIIF_RXCOL_Chk(void)
{
	if (HSPI->SPIIF & HSPI_SPIIF_RXCOL_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
HSPI ƺ
: 巢ͻ
룺
: 
********************************/
void HSPI_SPIIF_TXCOL_Clr(void)
{
	HSPI->SPIIF = HSPI_SPIIF_TXCOL_Msk;
}
/********************************
HSPI ƺ
: ȡͻ־
룺
: SET/RESET	ͻ/δͻ
********************************/
FlagStatus HSPI_SPIIF_TXCOL_Chk(void)
{
	if (HSPI->SPIIF & HSPI_SPIIF_TXCOL_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
HSPI ƺ
: ȡHSPIб־
룺
: SET/RESET	HSPI/HSPI
********************************/
FlagStatus HSPI_SPIIF_BUSY_Chk(void)
{
	if (HSPI->SPIIF & HSPI_SPIIF_BUSY_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
HSPI ƺ
: ȡͻTX bufferձ־
룺
: SET/RESET	TX buffer /TX buffer 
********************************/
FlagStatus HSPI_SPIIF_TXBE_Chk(void)
{
	if (HSPI->SPIIF & HSPI_SPIIF_TXBE_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
HSPI ƺ
: ȡջRX buffer־
룺
: SET/RESET	RX buffer /RX buffer 
********************************/
FlagStatus HSPI_SPIIF_RXBF_Chk(void)
{
	if (HSPI->SPIIF & HSPI_SPIIF_RXBF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
HSPI ƺ
: дͻ
룺0x00000000-0x000000ff(Ҫ͵data)
: 
********************************/
void HSPI_SPITXBUF_Write(uint32_t SetValue)
{
	HSPI->SPITXBUF = (SetValue & HSPI_SPITXBUF_TXBUF_Msk);
}
/********************************
HSPI ƺ
: ͻ
룺
: 0x00000000-0x000000ff(Ҫ͵data)
********************************/
uint32_t HSPI_SPITXBUF_Read(void)
{
	return (HSPI->SPITXBUF & HSPI_SPITXBUF_TXBUF_Msk);
}

/********************************
HSPI ƺ
: дջ
룺0x00000000-0x000000ff
: 
********************************/
void HSPI_SPIRXBUF_Write(uint32_t SetValue)
{
	HSPI->SPIRXBUF = (SetValue & HSPI_SPIRXBUF_RXBUF_Msk);
}
/********************************
HSPI ƺ
: ջ
룺
: 0x00000000-0x000000ff(յdata)
********************************/
uint32_t HSPI_SPIRXBUF_Read(void)
{
	return (HSPI->SPIRXBUF & HSPI_SPIRXBUF_RXBUF_Msk);
}

/********************************
HSPI ƺ
: HSPIȱʡ
룺
: 
********************************/
void HSPI_Deinit(void)
{
	HSPI->SPICR1 = 0x00000108;
	HSPI->SPICR2 = 0x00000054;
	HSPI->SPICR3 = 0x00000000;
	HSPI->SPIIE = 0x00000000;
	//HSPI->SPIIF = 0x00000002;
	//HSPI->SPITXBUF = 0x00000000;
	//HSPI->SPIRXBUF = 0x00000000;
}
//Code_End

/********************************
HSPI ƺ
: HSPI MASTERʼ
룺
: 
********************************/
void HSPI_Master_Init(HSPI_Master_SInitTypeDef* para)
{
	HSPI_Master_InitTypeDef init_para;
	HSPI_Deinit();

	init_para.DELAY_CFG = HSPI_SPICR1_DELAY_CFG_MASTER_NO_DELAY;
	init_para.WAIT = HSPI_SPICR1_WAIT_WAIT_1;
	init_para.BAUD_RATE = para->BAUD_RATE;
	init_para.LSBF = para->LSBF;
	init_para.CPHOL = para->CPHOL;
	init_para.CPHA = para->CPHA;
	init_para.SSNM = para->SSNM;
	init_para.TXO = DISABLE;
	init_para.TXO_AC = HSPI_SPICR2_TXO_AC_CLR_AT_CLOSE;
	init_para.SSNSEN = para->SSNSEN;

	init_para.HSPIEN = DISABLE;
	init_para.ERRIE = DISABLE;
	init_para.TXIE = DISABLE;
	init_para.RXIE = DISABLE;

	HSPI_SPICR1_DELAY_CFG_Set(init_para.DELAY_CFG);
	HSPI_SPICR1_WAIT_Set(init_para.WAIT);
	HSPI_SPICR1_BAUD_Set(init_para.BAUD_RATE);
	HSPI_SPICR1_LSBF_Set(init_para.LSBF);
	HSPI_SPICR1_CPHOL_Set(init_para.CPHOL);
	HSPI_SPICR1_CPHA_Set(init_para.CPHA);
	HSPI_SPICR2_SSNM_Set(init_para.SSNM);
	HSPI_SPICR2_TXO_Setable(init_para.TXO);
	HSPI_SPICR2_TXO_AC_Set(init_para.TXO_AC);
	HSPI_SPICR2_SSNSEN_Set(init_para.SSNSEN);

	HSPI_SPICR1_MM_Set(HSPI_SPICR1_MM_MASTER);//óģʽ
}

/********************************
HSPI ƺ
: HSPI SLAVER ʼ
룺
: 
********************************/
void HSPI_Slave_Init(HSPI_Slave_SInitTypeDef* para)
{
	HSPI_Slave_InitTypeDef init_para;
	HSPI_Deinit();

	init_para.DELAY_CFG = HSPI_SPICR1_DELAY_CFG_SLAVE_NORMAL;
	init_para.FLTEN = ENABLE;
	init_para.LSBF = para->LSBF;
	init_para.CPHOL = para->CPHOL;
	init_para.CPHA = para->CPHA;
	init_para.TXO = DISABLE;
	init_para.TXO_AC = HSPI_SPICR2_TXO_AC_CLR_AT_CLOSE;

	init_para.HSPIEN = DISABLE;
	init_para.ERRIE = DISABLE;
	init_para.TXIE = DISABLE;
	init_para.RXIE = DISABLE;

	HSPI_SPICR1_DELAY_CFG_Set(init_para.DELAY_CFG);
	HSPI_SPICR2_FLTEN_Setable(init_para.FLTEN);
	HSPI_SPICR1_LSBF_Set(init_para.LSBF);
	HSPI_SPICR1_CPHOL_Set(init_para.CPHOL);
	HSPI_SPICR1_CPHA_Set(init_para.CPHA);
	HSPI_SPICR2_TXO_Setable(init_para.TXO);
	HSPI_SPICR2_TXO_AC_Set(init_para.TXO_AC);
	
	HSPI_SPICR1_MM_Set(HSPI_SPICR1_MM_SLAVE);//óɴģʽ
}

void HSPI_SSN_Set_Low(void)//
{
	HSPI_SPICR2_SSN_Set(HSPI_SPICR2_SSN_LOW);//SSNź
}

void HSPI_SSN_Set_High(void)//
{
	HSPI_SPICR2_SSN_Set(HSPI_SPICR2_SSN_HIGH);//SSNź
}

uint8_t HSPI_Recv_Byte(void)//HSPIһֽ
{
	return HSPI_SPIRXBUF_Read();
}
void HSPI_Send_Byte(uint8_t data)//HSPIһֽ
{
	HSPI_SPITXBUF_Write(data);
}

uint8_t HSPI_RW_Byte(uint8_t data)//SPIͲһֽ
{
  uint8_t rx_data;
	uint32_t Temp32;
	uint32_t i;

	Temp32 = HSPI_SPICR1_BAUD_Get();
	Temp32 = Temp32>>HSPI_SPICR1_BAUD_Pos;
	Temp32 = 0x1U<<Temp32;
	Temp32 = Temp32*8;
	
    for(i=0; i<Temp32; i++)
    {
    	if (HSPI_SPIIF_TXBE_Chk() == SET)
		{
			break;
		}		
    }
    HSPI_Send_Byte(data);

    for(i=0; i<Temp32; i++)
    {
    	if (HSPI_SPIIF_RXBF_Chk() == SET)
        {
            break;
        }
    }
    rx_data = HSPI_Recv_Byte();
    return rx_data;
}



/******END OF FILE****/

