/**
  ******************************************************************************
  * @file    fm33g0xx_i2c.c
  * @author  FM33g0xx Application Team
  * @version V0.3.01G
  * @date    01-21-2019
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/
/* Includes ------------------------------------------------------------------*/

#include "fm33g0xx_i2c.h" 
#include <string.h>
/** @addtogroup fm33g0xx_StdPeriph_Driver
  * @{
  */

/** @defgroup I2C 
  * @brief I2C driver modules
  * @{
  */ 

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/



/********************************
 I2CģֹʱSCL̶Ϊߵ͵ƽλ
ܣI2CģֹʱSCL̶Ϊߵ͵ƽλ
룺SCL̶Ϊߵ͵ƽλ
1 = SCLźתΪߵƽǱҪ鳣̬Ϊ1
0 = SCLźתΪ͵ƽ
********************************/
void I2C_I2CCTRL_SCLHL_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		I2C->I2CCTRL |= (I2C_I2CCTRL_SCLHL_Msk);
	}
	else
	{
		I2C->I2CCTRL &= ~(I2C_I2CCTRL_SCLHL_Msk);
	}
}
/********************************
ȡSCL̶Ϊߵ͵ƽλ
ܣȡSCL̶Ϊߵ͵ƽλ
SCL̶Ϊߵ͵ƽλ
1 = SCLźתΪߵƽǱҪ鳣̬Ϊ1
0 = SCLźתΪ͵ƽ
********************************/
FunState I2C_I2CCTRL_SCLHL_Getable(void)
{
	if (I2C->I2CCTRL & (I2C_I2CCTRL_SCLHL_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
 I2CģֹʱSDA̶Ϊߵ͵ƽλ
ܣI2CģֹʱSDA̶Ϊߵ͵ƽλ
룺SDA̶Ϊߵ͵ƽλ
1 = SDAźתΪߵƽǱҪ鳣̬Ϊ1
0 = SDAźתΪ͵ƽ
********************************/
void I2C_I2CCTRL_SDAHL_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		I2C->I2CCTRL |= (I2C_I2CCTRL_SDAHL_Msk);
	}
	else
	{
		I2C->I2CCTRL &= ~(I2C_I2CCTRL_SDAHL_Msk);
	}
}
/********************************
ȡSDA̶Ϊߵ͵ƽλ
ܣȡSDA̶Ϊߵ͵ƽλ
SDA̶Ϊߵ͵ƽλ
1 = SDAźתΪߵƽǱҪ鳣̬Ϊ1
0 = SDAźתΪ͵ƽ
********************************/
FunState I2C_I2CCTRL_SDAHL_Getable(void)
{
	if (I2C->I2CCTRL & (I2C_I2CCTRL_SDAHL_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
 ؽģʽ£ӻӦʹλ
ܣؽģʽ£ӻӦʹλ
룺ӻӦʹλ
1 = ͻӦACKDTӻ
0 = Ӧӻ
********************************/
void I2C_I2CCTRL_ACKEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		I2C->I2CCTRL |= (I2C_I2CCTRL_ACKEN_Msk);
	}
	else
	{
		I2C->I2CCTRL &= ~(I2C_I2CCTRL_ACKEN_Msk);
	}
}
/********************************
 ؽģʽ£ȡӻӦʹλĺ
ܣؽģʽ£ȡӻӦʹλ
ӻӦʹλ
1 = ͻӦACKDTӻ
0 = Ӧӻ
********************************/
FunState I2C_I2CCTRL_ACKEN_Getable(void)
{
	if (I2C->I2CCTRL & (I2C_I2CCTRL_ACKEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
 ؽģʽ£ʹλú
ܣؽģʽ£ʹλú
룺ʹλ
1 = ʹ
0 = սֹ
********************************/
void I2C_I2CCTRL_RCEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		I2C->I2CCTRL |= (I2C_I2CCTRL_RCEN_Msk);
	}
	else
	{
		I2C->I2CCTRL &= ~(I2C_I2CCTRL_RCEN_Msk);
	}
}
/********************************
 ؽģʽ£ȡʹλú
ܣؽģʽ£ȡʹλú
ȡʹλ
1 = ʹ
0 = սֹ
********************************/
FunState I2C_I2CCTRL_RCEN_Getable(void)
{
	if (I2C->I2CCTRL & (I2C_I2CCTRL_RCEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
 STOPʱʹܿλú
ܣSTOPʱʹܿλú
룺STOPʱʹܿλ
1 = STOPʱʹ
0 = STOPʱֹ
********************************/
void I2C_I2CCTRL_PEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		I2C->I2CCTRL |= (I2C_I2CCTRL_PEN_Msk);
	}
	else
	{
		I2C->I2CCTRL &= ~(I2C_I2CCTRL_PEN_Msk);
	}
}
/********************************
 Repeated STARTʱʹܿλú
ܣRepeated STARTʱʹܿλú
룺Repeated STARTʱʹܿλ
1 = Repeated STARTʱʹ
0 = Repeated STARTʱֹ
********************************/
void I2C_I2CCTRL_RSEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		I2C->I2CCTRL |= (I2C_I2CCTRL_RSEN_Msk);
	}
	else
	{
		I2C->I2CCTRL &= ~(I2C_I2CCTRL_RSEN_Msk);
	}
}

/********************************
 STARTʱʹܿλú
ܣSTARTʱʹܿλú
룺STARTʱʹܿλ
1 = STARTʱʹ
0 = STARTʱֹ
********************************/
void I2C_I2CCTRL_SEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		I2C->I2CCTRL |= (I2C_I2CCTRL_SEN_Msk);
	}
	else
	{
		I2C->I2CCTRL &= ~(I2C_I2CCTRL_SEN_Msk);
	}
}

/********************************
 I2Cģʹܿλú
ܣI2Cģʹܿλú
룺I2Cģʹܿλ
1 = I2Cʹ
0 = I2Cֹ
********************************/
void I2C_I2CCTRL_I2CEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		I2C->I2CCTRL |= (I2C_I2CCTRL_I2CEN_Msk);
	}
	else
	{
		I2C->I2CCTRL &= ~(I2C_I2CCTRL_I2CEN_Msk);
	}
}
/********************************
 ȡI2Cģʹܿλú
ܣȡI2Cģʹܿλú
I2Cģʹܿλ
1 = I2Cʹ
0 = I2Cֹ
********************************/
FunState I2C_I2CCTRL_I2CEN_Getable(void)
{
	if (I2C->I2CCTRL & (I2C_I2CCTRL_I2CEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
 дͻλĺ
ܣдͻλ
********************************/
void I2C_I2CSTA_WCOL_Clr(void)
{
	I2C->I2CSTA = I2C_I2CSTA_WCOL_Msk;
}

/********************************
 ȡдͻλĺ
ܣȡдͻλ
дͻλ
1 = дͻ
0 = δͻ
********************************/
FlagStatus I2C_I2CSTA_WCOL_Chk(void)
{
	if (I2C->I2CSTA & I2C_I2CSTA_WCOL_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
 ȡI2Cӿ״̬λĺ
ܣȡI2Cӿ״̬
I2Cӿ״̬
1 = ӿڴڶд״̬ڽݴ䣬
0 = ݴ
********************************/
FlagStatus I2C_I2CSTA_RW_Chk(void)
{
	if (I2C->I2CSTA & I2C_I2CSTA_RW_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
 ȡ STOP־λĺ
ܣȡ STOP־λ
STOP־λ
1 = ⵽STOPʱ
0 = δ⵽STOPʱ
********************************/
FlagStatus I2C_I2CSTA_P_Chk(void)
{
	if (I2C->I2CSTA & I2C_I2CSTA_P_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}


/********************************
 ȡ START־λĺ
ܣȡ START־λ
START־λ
1 = ⵽STARTʱ
0 = δ⵽STARTʱ
********************************/
FlagStatus I2C_I2CSTA_S_Chk(void)
{
	if (I2C->I2CSTA & I2C_I2CSTA_S_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
 ȡ ״̬λĺ
ܣȡ ״̬λ
״̬λ
գ
1 = ɣSSPBUF
0 = δɣSSPBUF
ͣ
1 = ڷͣSSPBUF
0 = ɣSSPBUF
********************************/
FlagStatus I2C_I2CSTA_BF_Chk(void)
{
	if (I2C->I2CSTA & I2C_I2CSTA_BF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
 ԴӻĻӦźŵĺ
ܣԴӻĻӦź
********************************/
void I2C_I2CSTA_ACKSTA_Clr(void)
{
	I2C->I2CSTA = I2C_I2CSTA_ACKSTA_Msk;
}
/********************************
 ȡ ԴӻĻӦźŵĺ
ܣȡ ԴӻĻӦź
ԴӻĻӦź
1 = ӻ޻Ӧ
0 = յӻĻӦ0
********************************/
FlagStatus I2C_I2CSTA_ACKSTA_Chk(void)
{
	if (I2C->I2CSTA & I2C_I2CSTA_ACKSTA_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
 Ӧźŵ״̬ú
ܣӦźŵ״̬ú
룺Ӧźŵ״̬
1 = ӻӦ
0 = ӻĻӦΪ0
********************************/
void I2C_I2CSTA_ACKDT_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = I2C->I2CSTA;
	tmpreg &= ~(I2C_I2CSTA_ACKDT_Msk);
	tmpreg |= (SetValue & I2C_I2CSTA_ACKDT_Msk);
	I2C->I2CSTA = tmpreg;
}
/********************************
 ȡӦźŵ״̬ú
ܣȡӦźŵ״̬ú
Ӧźŵ״̬
1 = ӻӦ
0 = ӻĻӦΪ0
********************************/
uint32_t I2C_I2CSTA_ACKDT_Get(void)
{
	return (I2C->I2CSTA & I2C_I2CSTA_ACKDT_Msk);
}

/********************************
 ú
ܣú
룺ʵ
SCLʷƵ
********************************/
void I2C_I2CBRG_Write(uint32_t SetValue)
{
	I2C->I2CBRG = (SetValue & I2C_I2CBRG_SSPBRG_Msk);
}
/********************************
 ȡʺ
ܣȡʺ

********************************/
uint32_t I2C_I2CBRG_Read(void)
{
	return (I2C->I2CBRG & I2C_I2CBRG_SSPBRG_Msk);
}

/********************************
 дշĴ
ܣ дշĴ
룺 ҪдշĴֵ
********************************/
void I2C_I2CBUF_Write(uint32_t SetValue)
{
	I2C->I2CBUF = (SetValue & I2C_I2CBUF_SSPBUF_Msk);
}
/********************************
 շĴ
ܣ շĴ
 շĴֵ
********************************/
uint32_t I2C_I2CBUF_Read(void)
{
	return (I2C->I2CBUF & I2C_I2CBUF_SSPBUF_Msk);
}

/********************************
 I2Cжʹܿλú
ܣI2Cжʹܿλ
룺I2Cжʹܿλ
1 = I2Cжʹ
0 = I2CжϽֹ
********************************/
void I2C_I2CIR_I2CIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		I2C->I2CIR |= (I2C_I2CIR_I2CIE_Msk);
	}
	else
	{
		I2C->I2CIR &= ~(I2C_I2CIR_I2CIE_Msk);
	}
}
/********************************
 ȡI2Cжʹܿλú
ܣȡI2Cжʹܿλ
I2Cжʹܿλ
1 = I2Cжʹ
0 = I2CжϽֹ
********************************/
FunState I2C_I2CIR_I2CIE_Getable(void)
{
	if (I2C->I2CIR & (I2C_I2CIR_I2CIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/********************************
 I2Cжϱ־λĺ
ܣI2Cжϱ־λ
********************************/
void I2C_I2CIR_I2CIF_Clr(void)
{
	if (I2C->I2CIR & (I2C_I2CIR_I2CIE_Msk))
	{
		I2C->I2CIR = (I2C_I2CIR_I2CIE_Msk|I2C_I2CIR_I2CIF_Msk);
	}
	else
	{
		I2C->I2CIR = I2C_I2CIR_I2CIF_Msk;
	}
}
/********************************
 ȡI2Cжϱ־λĺ
ܣȡI2Cжϱ־λ
I2Cжϱ־λ
1 = I2Cж
0 = δI2Cж
********************************/
FlagStatus I2C_I2CIR_I2CIF_Chk(void)
{
	if (I2C->I2CIR & I2C_I2CIR_I2CIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
 ȡI2C״̬ĺ
ܣȡI2C״̬
I2C״̬
********************************/
uint32_t I2C_I2CFSM_I2CFSM_Get(void)
{
	return (I2C->I2CFSM & I2C_I2CFSM_I2CFSM_Msk);
}

/********************************
 ־жʹú
ܣ־жʹ
룺־жʹ
1 = I2Cжʹ
0 = I2CжϽֹ
********************************/
void I2C_I2CERR_ERRIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		I2C->I2CERR |= (I2C_I2CERR_ERRIE_Msk);
	}
	else
	{
		I2C->I2CERR &= ~(I2C_I2CERR_ERRIE_Msk);
	}
}
/********************************
 ȡ־жʹú
ܣȡ־жʹ
־жʹ
1 = I2Cжʹ
0 = I2CжϽֹ
********************************/
FunState I2C_I2CERR_ERRIE_Getable(void)
{
	if (I2C->I2CERR & (I2C_I2CERR_ERRIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/********************************
 OP_IDLE״̬´־λĺ
ܣOP_IDLE״̬´־λ
********************************/
void I2C_I2CERR_OIERR_Clr(void)
{
	if (I2C->I2CERR & (I2C_I2CERR_ERRIE_Msk))
	{
		I2C->I2CERR = (I2C_I2CERR_ERRIE_Msk|I2C_I2CERR_OIERR_Msk);
	}
	else
	{
		I2C->I2CERR = I2C_I2CERR_OIERR_Msk;
	}
}
/********************************
 ȡOP_IDLE״̬´־λĺ
ܣȡOP_IDLE״̬´־λ
OP_IDLE״̬´־λ
********************************/
FlagStatus I2C_I2CERR_OIERR_Chk(void)
{
	if (I2C->I2CERR & I2C_I2CERR_OIERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
 START_DONE״̬´־λĺ
ܣSTART_DONE״̬´־λ
********************************/
void I2C_I2CERR_SDERR_Clr(void)
{
	if (I2C->I2CERR & (I2C_I2CERR_ERRIE_Msk))
	{
		I2C->I2CERR = (I2C_I2CERR_ERRIE_Msk|I2C_I2CERR_SDERR_Msk);
	}
	else
	{
		I2C->I2CERR = I2C_I2CERR_SDERR_Msk;
	}
}
/********************************
 ȡSTART_DONE״̬´־λĺ
ܣȡSTART_DONE״̬´־λ
START_DONE״̬´־λ
********************************/
FlagStatus I2C_I2CERR_SDERR_Chk(void)
{
	if (I2C->I2CERR & I2C_I2CERR_SDERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
 IDLE״̬´־λĺ
ܣIDLE״̬´־λ
********************************/
void I2C_I2CERR_IERR_Clr(void)
{
	if (I2C->I2CERR & (I2C_I2CERR_ERRIE_Msk))
	{
		I2C->I2CERR = (I2C_I2CERR_ERRIE_Msk|I2C_I2CERR_IERR_Msk);
	}
	else
	{
		I2C->I2CERR = I2C_I2CERR_IERR_Msk;
	}
}

/********************************
 ȡIDLE״̬´־λĺ
ܣȡIDLE״̬´־λ
IDLE״̬´־λ
********************************/
FlagStatus I2C_I2CERR_IERR_Chk(void)
{
	if (I2C->I2CERR & I2C_I2CERR_IERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
 I2Cȱʡõĺ
ܣI2Cȱʡ
********************************/
void I2C_Deinit(void)
{
	I2C->I2CCTRL = 0x00006000;
	I2C->I2CSTA = 0x00000000;
	I2C->I2CBRG = 0x00000013;
	//I2C->I2CBUF = ;
	I2C->I2CIR = 0x00000000;
	//I2C->I2CFSM = ;
	I2C->I2CERR = 0x00000000;
}
//Code_End

/********************************
 I2CʼĴֵ㺯
ܣI2CʼĴֵ
룺@Hz APBClk @Hz
I2CBRGӦʵֵ
********************************/
uint32_t I2C_BaudREG_Calc(uint32_t I2CClk, uint32_t APBClk)
{
	uint32_t TempREG;
	
	TempREG = APBClk/(4*I2CClk);
	if( TempREG >= 1 ) TempREG = TempREG - 1;
	
	return TempREG;
}

/********************************
 I2Cģ鸴λ
ܣλI2CָIDEL״̬
********************************/
void I2C_ResetI2C(void)
{
	volatile uint8_t result;

	I2C->I2CIR =0x01;
  I2C->I2CCTRL =0x6000;
  result=(I2C->I2CSTA);
  I2C->I2CSTA = 0x00;
  result = (I2C->I2CBUF);//ɱ־
  I2C->I2CERR =0x07;
	for(result=0x00; result<0x03; result++ );	
}

/******END OF FILE****/
