/**
  ******************************************************************************
  * @file    fm33g0xx_lptim.c
  * @author  FM33g0xx Application Team
  * @version V0.3.01G
  * @date    01-21-2019
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/

/* Includes ------------------------------------------------------------------*/
#include "fm33g0xx_lptim.h" 


/** @addtogroup fm33g0xx_StdPeriph_Driver
  * @{
  */

/** @defgroup LPTIM 
  * @brief LPTIM driver modules
  * @{
  */ 

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/


/********************************
LPTIMⲿTrigger˲ʹܺ
:ⲿTrigger˲ʹ
:ʹ״̬

********************************/
void LPTIM_LPTCFG_FLTEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPTIM->LPTCFG &= ~(LPTIM_LPTCFG_FLTEN_Msk);
	}
	else
	{
		LPTIM->LPTCFG |= (LPTIM_LPTCFG_FLTEN_Msk);
	}
}
/********************************
ȡLPTIMⲿTrigger˲ʹ״̬
:ȡⲿTrigger˲ʹ״̬
:ʹ״̬

********************************/
FunState LPTIM_LPTCFG_FLTEN_Getable(void)
{
	if (LPTIM->LPTCFG & (LPTIM_LPTCFG_FLTEN_Msk))
	{
		return DISABLE;
	}
	else
	{
		return ENABLE;
	}
}

/********************************
LPTIMʱӷƵѡ
:ʱӷƵѡ
:Ƶֵ

********************************/
void LPTIM_LPTCFG_DIVSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPTIM->LPTCFG;
	tmpreg &= ~(LPTIM_LPTCFG_DIVSEL_Msk);
	tmpreg |= (SetValue & LPTIM_LPTCFG_DIVSEL_Msk);
	LPTIM->LPTCFG = tmpreg;
}
/********************************
ȡLPTIMʱӷƵֵ
:ȡʱӷƵֵ
:Ƶֵ

********************************/
uint32_t LPTIM_LPTCFG_DIVSEL_Get(void)
{
	return (LPTIM->LPTCFG & LPTIM_LPTCFG_DIVSEL_Msk);
}

/********************************
LPTIMʱԴѡ
:ʱԴѡ
:ʱԴ

********************************/
void LPTIM_LPTCFG_CLKSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPTIM->LPTCFG;
	tmpreg &= ~(LPTIM_LPTCFG_CLKSEL_Msk);
	tmpreg |= (SetValue & LPTIM_LPTCFG_CLKSEL_Msk);
	LPTIM->LPTCFG = tmpreg;
}
/********************************
ȡLPTIMʱԴ
:ȡʱԴѡ
:ȡʱԴ

********************************/
uint32_t LPTIM_LPTCFG_CLKSEL_Get(void)
{
	return (LPTIM->LPTCFG & LPTIM_LPTCFG_CLKSEL_Msk);
}

/********************************
LPTIMѡ
:ѡ
:ѡ
	0LPTINؼ
	1LPTIN½ؼ
********************************/
void LPTIM_LPTCFG_EDGESEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPTIM->LPTCFG;
	tmpreg &= ~(LPTIM_LPTCFG_EDGESEL_Msk);
	tmpreg |= (SetValue & LPTIM_LPTCFG_EDGESEL_Msk);
	LPTIM->LPTCFG = tmpreg;
}
/********************************
ȡLPTIMѡ
:ȡLPTIMѡ
:ȡLPTIM
	LPTIM_LPTCFG_EDGESEL_POSLPTINؼ
	LPTIM_LPTCFG_EDGESEL_NEGLPTIN½ؼ
********************************/
uint32_t LPTIM_LPTCFG_EDGESEL_Get(void)
{
	return (LPTIM->LPTCFG & LPTIM_LPTCFG_EDGESEL_Msk);
}

/********************************
LPTIMⲿѡ
:ⲿѡ
:ⲿѡ

********************************/
void LPTIM_LPTCFG_TRIGCFG_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPTIM->LPTCFG;
	tmpreg &= ~(LPTIM_LPTCFG_TRIGCFG_Msk);
	tmpreg |= (SetValue & LPTIM_LPTCFG_TRIGCFG_Msk);
	LPTIM->LPTCFG = tmpreg;
}
/********************************
ȡLPTIMⲿѡ
:ȡLPTIMⲿѡ
:ȡLPTIMⲿ

********************************/
uint32_t LPTIM_LPTCFG_TRIGCFG_Get(void)
{
	return (LPTIM->LPTCFG & LPTIM_LPTCFG_TRIGCFG_Msk);
}

/* μѡ غ */
void LPTIM_LPTCFG_POLARITY_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPTIM->LPTCFG;
	tmpreg &= ~(LPTIM_LPTCFG_POLARITY_Msk);
	tmpreg |= (SetValue & LPTIM_LPTCFG_POLARITY_Msk);
	LPTIM->LPTCFG = tmpreg;
}

uint32_t LPTIM_LPTCFG_POLARITY_Get(void)
{
	return (LPTIM->LPTCFG & LPTIM_LPTCFG_POLARITY_Msk);
}

/********************************
LPTIMģʽѡ
:ģʽѡ
:ģʽ
LPTIM_LPTCFG_PWM_TOGGLEڷģʽ
LPTIM_LPTCFG_PWM_PWMPWMģʽ
********************************/
void LPTIM_LPTCFG_PWM_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPTIM->LPTCFG;
	tmpreg &= ~(LPTIM_LPTCFG_PWM_Msk);
	tmpreg |= (SetValue & LPTIM_LPTCFG_PWM_Msk);
	LPTIM->LPTCFG = tmpreg;
}
/********************************
ȡLPTIMģʽѡ
:ȡģʽ
:ȡģʽ
LPTIM_LPTCFG_PWM_TOGGLEڷģʽ
LPTIM_LPTCFG_PWM_PWMPWMģʽ
********************************/
uint32_t LPTIM_LPTCFG_PWM_Get(void)
{
	return (LPTIM->LPTCFG & LPTIM_LPTCFG_PWM_Msk);
}

/********************************
LPTIMģʽѡ
:ģʽѡ
:ģʽѡ
LPTIM_LPTCFG_MODE_CONTINUEģʽ
LPTIM_LPTCFG_MODE_SINGLEμģʽ
********************************/
void LPTIM_LPTCFG_MODE_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPTIM->LPTCFG;
	tmpreg &= ~(LPTIM_LPTCFG_MODE_Msk);
	tmpreg |= (SetValue & LPTIM_LPTCFG_MODE_Msk);
	LPTIM->LPTCFG = tmpreg;
}

/********************************
ȡLPTIMģʽѡ
:ȡģʽѡ
:ģʽѡ
LPTIM_LPTCFG_MODE_CONTINUEģʽ
LPTIM_LPTCFG_MODE_SINGLEμģʽ
********************************/
uint32_t LPTIM_LPTCFG_MODE_Get(void)
{
	return (LPTIM->LPTCFG & LPTIM_LPTCFG_MODE_Msk);
}

/********************************
LPTIMģʽѡ
:ģʽѡ
:ģʽѡ
********************************/
void LPTIM_LPTCFG_TMODE_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPTIM->LPTCFG;
	tmpreg &= ~(LPTIM_LPTCFG_TMODE_Msk);
	tmpreg |= (SetValue & LPTIM_LPTCFG_TMODE_Msk);
	LPTIM->LPTCFG = tmpreg;
}
/********************************
ȡLPTIMģʽѡ
:LPTIMģʽѡ
:ģʽѡ
********************************/
uint32_t LPTIM_LPTCFG_TMODE_Get(void)
{
	return (LPTIM->LPTCFG & LPTIM_LPTCFG_TMODE_Msk);
}

/********************************
ȡLPTIMֵ
:ȡֵ
:ֵ
********************************/
uint32_t LPTIM_LPTCNT_Read(void)
{
	return (LPTIM->LPTCNT & LPTIM_LPTCNT_CNT16_Msk);
}
/********************************
LPTIMдȽֵ
:дȽֵ
:Ƚֵ
********************************/
void LPTIM_LPTCMP_Write(uint32_t SetValue)
{
	LPTIM->LPTCMP = (SetValue & LPTIM_LPTCMP_COMPARE_REG_Msk);
}
/********************************
ȡLPTIMȽֵ
:ȡȽֵ
:Ƚֵ
********************************/
uint32_t LPTIM_LPTCMP_Read(void)
{
	return (LPTIM->LPTCMP & LPTIM_LPTCMP_COMPARE_REG_Msk);
}
/********************************
LPTIMдĿֵ
:дĿֵ
:Ŀֵ
********************************/
void LPTIM_LPTTARGET_Write(uint32_t SetValue)
{
	LPTIM->LPTTARGET = (SetValue & LPTIM_LPTTARGET_TARGET_REG_Msk);
}
/********************************
ȡLPTIMĿֵ
:ȡĿֵ
:Ŀֵ
********************************/
uint32_t LPTIM_LPTTARGET_Read(void)
{
	return (LPTIM->LPTTARGET & LPTIM_LPTTARGET_TARGET_REG_Msk);
}

/********************************
LPTIMⲿжϺ
:ⲿж
:ⲿжϴ
1ⲿжʹ
0ⲿжϽֹ
********************************/
void LPTIM_LPTIE_TRIGIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPTIM->LPTIE |= (LPTIM_LPTIE_TRIGIE_Msk);
	}
	else
	{
		LPTIM->LPTIE &= ~(LPTIM_LPTIE_TRIGIE_Msk);
	}
}
/********************************
ȡLPTIMⲿжϺ
:ȡⲿж
:ⲿжϴ
1ⲿжʹ
0ⲿжϽֹ
********************************/
FunState LPTIM_LPTIE_TRIGIE_Getable(void)
{
	if (LPTIM->LPTIE & (LPTIM_LPTIE_TRIGIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
LPTIMжϺ
:ж
:жϴ
1жʹ
0жϽֹ
********************************/
void LPTIM_LPTIE_OVIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPTIM->LPTIE |= (LPTIM_LPTIE_OVIE_Msk);
	}
	else
	{
		LPTIM->LPTIE &= ~(LPTIM_LPTIE_OVIE_Msk);
	}
}
/********************************
ȡLPTIMжϺ
:ȡж
:жϴ
1жʹ
0жϽֹ
********************************/
FunState LPTIM_LPTIE_OVIE_Getable(void)
{
	if (LPTIM->LPTIE & (LPTIM_LPTIE_OVIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
LPTIMȽֵƥжϺ
:Ƚֵƥж
:Ƚֵƥжϴ
1ֵͱȽֵƥжʹ
0ֵͱȽֵƥжϽֹ
********************************/
void LPTIM_LPTIE_COMPIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPTIM->LPTIE |= (LPTIM_LPTIE_COMPIE_Msk);
	}
	else
	{
		LPTIM->LPTIE &= ~(LPTIM_LPTIE_COMPIE_Msk);
	}
}
/********************************
ȡLPTIMȽֵƥжϺ
:ȡȽֵƥж
:Ƚֵƥжϴ
1ֵͱȽֵƥжʹ
0ֵͱȽֵƥжϽֹ
********************************/
FunState LPTIM_LPTIE_COMPIE_Getable(void)
{
	if (LPTIM->LPTIE & (LPTIM_LPTIE_COMPIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
LPTIMⲿ־
:LPTIMⲿ־
********************************/
void LPTIM_LPTIF_TRIGIF_Clr(void)
{
	LPTIM->LPTIF = LPTIM_LPTIF_TRIGIF_Msk;
}
/********************************
LPTIMⲿ־
:LPTIMⲿ־
LPTIMⲿ־
********************************/
FlagStatus LPTIM_LPTIF_TRIGIF_Chk(void)
{
	if (LPTIM->LPTIF & LPTIM_LPTIF_TRIGIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
LPTIM־
:LPTIM־
********************************/
void LPTIM_LPTIF_OVIF_Clr(void)
{
	LPTIM->LPTIF = LPTIM_LPTIF_OVIF_Msk;
}
/********************************
LPTIM־
:LPTIM־
LPTIM־
********************************/
FlagStatus LPTIM_LPTIF_OVIF_Chk(void)
{
	if (LPTIM->LPTIF & LPTIM_LPTIF_OVIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
LPTIMȽֵƥ־
:LPTIMȽֵƥ־
********************************/
void LPTIM_LPTIF_COMPIF_Clr(void)
{
	LPTIM->LPTIF = LPTIM_LPTIF_COMPIF_Msk;
}
/********************************
LPTIMȽֵƥ־
:LPTIMȽֵƥ־
LPTIMȽֵƥ־
********************************/
FlagStatus LPTIM_LPTIF_COMPIF_Chk(void)
{
	if (LPTIM->LPTIF & LPTIM_LPTIF_COMPIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
LPTIMʹܺ
:LPTIMʹ
룺LPTIMʹܴ
1ʹܼ
0ֹ
********************************/
void LPTIM_LPTCTRL_LPTEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPTIM->LPTCTRL |= (LPTIM_LPTCTRL_LPTEN_Msk);
	}
	else
	{
		LPTIM->LPTCTRL &= ~(LPTIM_LPTCTRL_LPTEN_Msk);
	}
}
/********************************
ȡLPTIMʹܺ
:ȡLPTIMʹ
LPTIMʹܴ
1ʹܼ
0ֹ
********************************/
FunState LPTIM_LPTCTRL_LPTEN_Getable(void)
{
	if (LPTIM->LPTCTRL & (LPTIM_LPTCTRL_LPTEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
LPTIMмĴ㺯
:LPTIMмĴ
********************************/
void LPTIM_Deinit(void)
{
	LPTIM->LPTCFG = 0x00000000;
	LPTIM->LPTCMP = 0x00000000;
	LPTIM->LPTTARGET = 0x00000000;
	LPTIM->LPTIE = 0x00000000;
	//LPTIM->LPTIF = ;
	LPTIM->LPTCTRL = 0x00000000;
}
//Code_End

/********************************
LPTIMʼ
:LPTIMʼ
********************************/
void LPTIM_Init(LPTIM_InitTypeDef* para)
{	
	LPTIM_LPTCFG_FLTEN_Setable(para->LPTIM_FLTEN);
	LPTIM_LPTCFG_DIVSEL_Set(para->LPTIM_CLK_DIV);
	LPTIM_LPTCFG_CLKSEL_Set(para->LPTIM_CLK_SEL);
	LPTIM_LPTCFG_EDGESEL_Set(para->LPTIM_LPTIN_EDGE);
	LPTIM_LPTCFG_TRIGCFG_Set(para->LPTIM_TRIG_CFG);
	LPTIM_LPTCFG_POLARITY_Set(para->LPTIM_POLAR);
	LPTIM_LPTCFG_PWM_Set(para->LPTIM_PWM);
	LPTIM_LPTCFG_MODE_Set(para->LPTIM_MODE);
	LPTIM_LPTCFG_TMODE_Set(para->LPTIM_TMODE);

	LPTIM_LPTCMP_Write(para->LPTIM_compare_value);
	LPTIM_LPTTARGET_Write(para->LPTIM_target_value);
}


/******END OF FILE****/

