/**
  ******************************************************************************
  * @file    fm33g0xx_lpuart.c
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of the Universal synchronous asynchronous receiver
  *          transmitter (UART):           
  *           
  ******************************************************************************  
  */ 

/* Includes ------------------------------------------------------------------*/
#include "fm33g0xx_lpuart.h" 
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/*********************************
LPUART ݺ
ܣLPUARTռĴ
:     
: յ
*********************************/
uint32_t LPUART_LPURXD_Read(void)
{
	return (LPUART->LPURXD);
}

/*********************************
LPUART ݺ
ܣдLPUARTͼĴ
: ͵
: 
*********************************/
void LPUART_LPUTXD_Write(uint32_t SetValue)
{
	LPUART->LPUTXD = SetValue;
}


/*********************************
LPUART ɱ־⺯
ܣⷢɱ־ǷλλʹTCΪɼ־
: 
: 01
*********************************/
FlagStatus LPUART_LPUSTA_TC_Chk(void)
{
	if (LPUART->LPUSTA & LPUART_LPUSTA_TC_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
LPUART buffձ־λ⺯
ܣⷢbuffǷΪ
: 
:  0: 
       1:
*********************************/
FlagStatus LPUART_LPUSTA_TXE_Chk(void)
{
	if (LPUART->LPUSTA & LPUART_LPUSTA_TXE_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
LPUART ʼλ0
ܣ־λ 0
: 
:  
*********************************/
void LPUART_LPUSTA_START_Clr(void)
{
	LPUART->LPUSTA = LPUART_LPUSTA_START_Msk;
}

/*********************************
LPUART ʼλ⺯
ܣǷյʼλ
: 
:  0: û⵽
       1:  ⵽ʼλ
*********************************/
FlagStatus LPUART_LPUSTA_START_Chk(void)
{
	if (LPUART->LPUSTA & LPUART_LPUSTA_START_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
LPUART Уλ־0
ܣУλ0
: 
:  
*********************************/
void LPUART_LPUSTA_PERR_Clr(void)
{
	LPUART->LPUSTA = LPUART_LPUSTA_PERR_Msk;
}

/*********************************
LPUART  Уλ⺯
ܣУ־Ƿλ
: 
:  0: ûУ
       1:  У
*********************************/
FlagStatus LPUART_LPUSTA_PERR_Chk(void)
{
	if (LPUART->LPUSTA & LPUART_LPUSTA_PERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
LPUART  ֡ʽ־0
ܣ֡ʽ0
: 
:  
*********************************/
void LPUART_LPUSTA_FERR_Clr(void)
{
	LPUART->LPUSTA = LPUART_LPUSTA_FERR_Msk;
}

/*********************************
LPUART  ֡ʽ־λ⺯
ܣ֡ʽ־Ƿλ
: 
:  0: û֡ʽ
       1:  ֡ʽ
*********************************/
FlagStatus LPUART_LPUSTA_FERR_Chk(void)
{
	if (LPUART->LPUSTA & LPUART_LPUSTA_FERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
LPUART  ջ־λ0
ܣջ0
: 
:  
*********************************/
void LPUART_LPUSTA_RXOV_Clr(void)
{
	LPUART->LPUSTA = LPUART_LPUSTA_RXOV_Msk;
}

/*********************************
LPUART  ջ־λ⺯
: ջ־λǷλ
: 
:  0: ûнջ
       1:  нջ
*********************************/
FlagStatus LPUART_LPUSTA_RXOV_Chk(void)
{
	if (LPUART->LPUSTA & LPUART_LPUSTA_RXOV_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
LPUART  ջ־λ0
:  ջ־0
: 
:  
*********************************/

void LPUART_LPUSTA_RXF_Clr(void)
{
	LPUART->LPUSTA = LPUART_LPUSTA_RXF_Msk;
}

/*********************************
LPUART  ջ־λ⺯
: ջ־λǷλ
: 
:  0: ջû
       1:  ջ
*********************************/
FlagStatus LPUART_LPUSTA_RXF_Chk(void)
{
	if (LPUART->LPUSTA & LPUART_LPUSTA_RXF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
LPUART ƥ־0
: 
:  
*********************************/
void LPUART_LPUSTA_MATCH_Clr(void)
{
	LPUART->LPUSTA = LPUART_LPUSTA_MATCH_Msk;
}

/*********************************
LPUART ƥ־λ⺯
: 
:  1ƥ
       0ƥ
*********************************/
FlagStatus LPUART_LPUSTA_MATCH_Chk(void)
{
	if (LPUART->LPUSTA & LPUART_LPUSTA_MATCH_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
LPUART ݷͼȡʹܺ
: 0ȡĬϣ
      1ȡ
:  
*********************************/
void LPUART_LPUCON_TXPOL_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPUART->LPUCON |= (LPUART_LPUCON_TXPOL_Msk);
	}
	else
	{
		LPUART->LPUCON &= ~(LPUART_LPUCON_TXPOL_Msk);
	}
}

/*********************************
LPUART ݷͼȡ״̬⺯
: 
:  0ȡ
       1ȡ
*********************************/
FunState LPUART_LPUCON_TXPOL_Getable(void)
{
	if (LPUART->LPUCON & (LPUART_LPUCON_TXPOL_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
LPUART жʹܺ
:   0ֹ
        1ʹ
:   
*********************************/
void LPUART_LPUCON_TCIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPUART->LPUCON |= (LPUART_LPUCON_TCIE_Msk);
	}
	else
	{
		LPUART->LPUCON &= ~(LPUART_LPUCON_TCIE_Msk);
	}
}

/*********************************
LPUART жʹ״̬ȡ
:   
:   0:ֹ
        1ʹ
*********************************/
FunState LPUART_LPUCON_TCIE_Getable(void)
{
	if (LPUART->LPUCON & (LPUART_LPUCON_TCIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
LPUART  bufferжʹܺ
:   0ֹ
        1ʹ
:   
*********************************/
void LPUART_LPUCON_TXIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPUART->LPUCON |= (LPUART_LPUCON_TXIE_Msk);
	}
	else
	{
		LPUART->LPUCON &= ~(LPUART_LPUCON_TXIE_Msk);
	}
}

/*********************************
LPUART  bufferжʹ״̬ȡ
:   
:   0ֹ
        1ʹ
*********************************/
FunState LPUART_LPUCON_TXIE_Getable(void)
{
	if (LPUART->LPUCON & (LPUART_LPUCON_TXIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
LPUART  ½زʹ32K
:   0ֹ
        1ʹ
:   
*********************************/
void LPUART_LPUCON_NEDET_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPUART->LPUCON |= (LPUART_LPUCON_NEDET_Msk);
	}
	else
	{
		LPUART->LPUCON &= ~(LPUART_LPUCON_NEDET_Msk);
	}
}
/*********************************
LPUART  ½زʹ32K״̬ȡ
:  
:   0ֹ
        1ʹ
*********************************/
FunState LPUART_LPUCON_NEDET_Getable(void)
{
	if (LPUART->LPUCON & (LPUART_LPUCON_NEDET_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
LPUART  ֡żУλ
:   0û
        1
:   
*********************************/
void LPUART_LPUCON_PAREN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPUART->LPUCON |= (LPUART_LPUCON_PAREN_Msk);
	}
	else
	{
		LPUART->LPUCON &= ~(LPUART_LPUCON_PAREN_Msk);
	}
}

/*********************************
LPUART  ֡żУ״̬ȡ
:   
:   0żУ
        1żУ
*********************************/
FunState LPUART_LPUCON_PAREN_Getable(void)
{
	if (LPUART->LPUCON & (LPUART_LPUCON_PAREN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
LPUART  ֡żУ麯
:   LPUART_LPUCON_PTYP_EVENżУ
        LPUART_LPUCON_PTYP_ODDУ
:   
*********************************/
void LPUART_LPUCON_PTYP_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPUART->LPUCON;
	tmpreg &= ~(LPUART_LPUCON_PTYP_Msk);
	tmpreg |= SetValue;
	LPUART->LPUCON = tmpreg;
}

/*********************************
LPUART  ֡żУ״̬ȡ
:   
:   LPUART_LPUCON_PTYP_EVENżУ
        LPUART_LPUCON_PTYP_ODDУ
*********************************/
uint32_t LPUART_LPUCON_PTYP_Get(void)
{
	return (LPUART->LPUCON & LPUART_LPUCON_PTYP_Msk);
}

/*********************************
LPUART   ֹͣλú
:    LPUART_LPUCON_SL_1BIT1bit
         LPUART_LPUCON_SL_2BIT: 2bit
:   
*********************************/
void LPUART_LPUCON_SL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPUART->LPUCON;
	tmpreg &= ~(LPUART_LPUCON_SL_Msk);
	tmpreg |= SetValue;
	LPUART->LPUCON = tmpreg;
}

/*********************************
LPUART   ֹͣλ״̬ȡ
:    
:    LPUART_LPUCON_SL_1BIT1bit
         LPUART_LPUCON_SL_2BIT: 2bit
*********************************/
uint32_t LPUART_LPUCON_SL_Get(void)
{
	return (LPUART->LPUCON & LPUART_LPUCON_SL_Msk);
}

/*********************************
LPUART   ݳú
:    LPUART_LPUCON_DL_8BIT8bit
         LPUART_LPUCON_DL_7BIT: 7bit
:    
*********************************/
void LPUART_LPUCON_DL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPUART->LPUCON;
	tmpreg &= ~(LPUART_LPUCON_DL_Msk);
	tmpreg |= SetValue;
	LPUART->LPUCON = tmpreg;
}

/*********************************
LPUART   ݳ״̬ȡ
:    
:    LPUART_LPUCON_DL_8BIT8bit
         LPUART_LPUCON_DL_7BIT: 7bit
*********************************/
uint32_t LPUART_LPUCON_DL_Get(void)
{
	return (LPUART->LPUCON & LPUART_LPUCON_DL_Msk);
}

/*********************************
LPUART   ռȡú
:    0ȡ
         1ȡ
:    
*********************************/
void LPUART_LPUCON_RXPOL_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPUART->LPUCON |= (LPUART_LPUCON_RXPOL_Msk);
	}
	else
	{
		LPUART->LPUCON &= ~(LPUART_LPUCON_RXPOL_Msk);
	}
}

/*********************************
LPUART   ռȡ״̬ȡ
:    
:    0ȡ
         1ȡ
*********************************/
FunState LPUART_LPUCON_RXPOL_Getable(void)
{
	if (LPUART->LPUCON & (LPUART_LPUCON_RXPOL_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
LPUART   жʹܺ
:    0ֹ
         1ʹ
:    
*********************************/
void LPUART_LPUCON_ERRIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPUART->LPUCON |= (LPUART_LPUCON_ERRIE_Msk);
	}
	else
	{
		LPUART->LPUCON &= ~(LPUART_LPUCON_ERRIE_Msk);
	}
}

/*********************************
LPUART   жʹ״̬ȡ
:    
:    0ֹ
         1ʹ
*********************************/
FunState LPUART_LPUCON_ERRIE_Getable(void)
{
	if (LPUART->LPUCON & (LPUART_LPUCON_ERRIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
LPUART   жʹܺ
:    0ֹ
         1ʹ
:    
*********************************/
void LPUART_LPUCON_RXIE_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPUART->LPUCON |= (LPUART_LPUCON_RXIE_Msk);
	}
	else
	{
		LPUART->LPUCON &= ~(LPUART_LPUCON_RXIE_Msk);
	}
}

/*********************************
LPUART   жʹ״̬ȡ
:    
:    0ֹ
         1ʹ
*********************************/
FunState LPUART_LPUCON_RXIE_Getable(void)
{
	if (LPUART->LPUCON & (LPUART_LPUCON_RXIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
LPUART  ж¼úڿƺ¼CPUṩж 
:    00STARTλ
         011byteݽ
         10ƥ
         11RXD½ػ

*********************************/
void LPUART_LPUCON_RXEV_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPUART->LPUCON;
	tmpreg &= ~(LPUART_LPUCON_RXEV_Msk);
	tmpreg |= SetValue;
	LPUART->LPUCON = tmpreg;
}

/*********************************
LPUART  ж¼ú״̬ȡ
:    
   00STARTλ
         011byteݽ
         10ƥ
         11RXD½ػ
*********************************/
uint32_t LPUART_LPUCON_RXEV_Get(void)
{
	return (LPUART->LPUCON & LPUART_LPUCON_RXEV_Msk);
}

/*********************************
LPUART  жϱ־0
:    
   
*********************************/
void LPUART_LPUIF_TC_IF_Clr(void)
{
	LPUART->LPUIF = LPUART_LPUIF_TC_IF_Msk;
}

/*********************************
LPUART  жϱ־λ״̬⺯
:    
   0ж
         1һ֡ݺж
*********************************/
FlagStatus LPUART_LPUIF_TC_IF_Chk(void)
{
	if (LPUART->LPUIF & LPUART_LPUIF_TC_IF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
LPUART  bufferжϱ־λ0
:    
   
*********************************/
void LPUART_LPUIF_TXIF_Clr(void)
{
	LPUART->LPUIF = LPUART_LPUIF_TXIF_Msk;
}

/*********************************
LPUART  bufferжϱ־λ⺯
:    
   0ж
         1bufferպж
*********************************/
FlagStatus LPUART_LPUIF_TXIF_Chk(void)
{
	if (LPUART->LPUIF & LPUART_LPUIF_TXIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
LPUART  RXD½жϱ־λ0
:    
   
*********************************/
void LPUART_LPUIF_RXNEGIF_Clr(void)
{
	LPUART->LPUIF = LPUART_LPUIF_RXNEGIF_Msk;
}

/*********************************
LPUART  RXD½жϱ־λ״̬⺯
:   
  0жϲ
        1жϲ
*********************************/
FlagStatus LPUART_LPUIF_RXNEGIF_Chk(void)
{
	if (LPUART->LPUIF & LPUART_LPUIF_RXNEGIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
LPUART  жϱ־λ0
:   
  
*********************************/
void LPUART_LPUIF_RXIF_Clr(void)
{
	LPUART->LPUIF = LPUART_LPUIF_RXIF_Msk;
}

/*********************************
LPUART  жϱ־λ⺯
:   
  0жϲ
        1һ֡ݺж
*********************************/
FlagStatus LPUART_LPUIF_RXIF_Chk(void)
{
	if (LPUART->LPUIF & LPUART_LPUIF_RXIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*********************************
LPUART  ú
:   0009600
        0014800
        0102400
        0111200
        100600
        101/110/111300
  
*********************************/
void LPUART_LPUBAUD_BAUD_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = LPUART->LPUBAUD;
	tmpreg &= ~(LPUART_LPUBAUD_BAUD_Msk);
	tmpreg |= SetValue;
	LPUART->LPUBAUD = tmpreg;
}

/*********************************
LPUART  ״̬ȡ
:   
  0009600
        0014800
        0102400
        0111200
        100600
        101/110/111300
*********************************/
uint32_t LPUART_LPUBAUD_BAUD_Get(void)
{
	return (LPUART->LPUBAUD & LPUART_LPUBAUD_BAUD_Msk);
}

/*********************************
LPUART  ʹú
:   0رշ
        1򿪷
  
*********************************/
void LPUART_LPUEN_TXEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPUART->LPUEN |= (LPUART_LPUEN_TXEN_Msk);
    while(((LPUART->LPUEN)&LPUART_LPUEN_TXEN_Msk)==0); //Ĵģ鲻ͬȷѾдĴֹдbitʱǵ
	}
	else
	{
		LPUART->LPUEN &= ~(LPUART_LPUEN_TXEN_Msk);
    while(((LPUART->LPUEN)&LPUART_LPUEN_TXEN_Msk)!=0);
	}
}

/*********************************
LPUART  ʹ״̬ȡ
:   
  0رշ
        1򿪷
*********************************/
FunState LPUART_LPUEN_TXEN_Getable(void)
{
	if (LPUART->LPUEN & (LPUART_LPUEN_TXEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
LPUART  ʹú
:   0رս
        1򿪽
  
*********************************/
void LPUART_LPUEN_RXEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		LPUART->LPUEN |= (LPUART_LPUEN_RXEN_Msk);
    while(((LPUART->LPUEN)&LPUART_LPUEN_RXEN_Msk)==0);//Ĵģ鲻ͬȷѾдĴֹдbitʱǵ
	}
	else
	{
		LPUART->LPUEN &= ~(LPUART_LPUEN_RXEN_Msk);
    while(((LPUART->LPUEN)&LPUART_LPUEN_RXEN_Msk)!=0);
	}
}

/*********************************
LPUART  ʹ״̬ȡ
:   
  0رս
        1򿪽
*********************************/
FunState LPUART_LPUEN_RXEN_Getable(void)
{
	if (LPUART->LPUEN & (LPUART_LPUEN_RXEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*********************************
LPUART  ƥúҪRXEVΪ10Ч
:   ƥ
  
*********************************/
void LPUART_COMPARE_Write(uint32_t SetValue)
{
	LPUART->COMPARE = SetValue;
}

/*********************************
LPUART  ƥݺ
:   
  ƥ
*********************************/
uint32_t LPUART_COMPARE_Read(void)
{
	return (LPUART->COMPARE);
}

/*********************************
LPUART  ÿbitĵƿźź
:   12bit
        9600LPUART_MCTL_FOR9600BPS
        4800LPUART_MCTL_FOR4800BPS
        2400LPUART_MCTL_FOR2400BPS
        1200LPUART_MCTL_FOR1200BPS
        600LPUART_MCTL_FOR600BPS
        300LPUART_MCTL_FOR300BPS
  
*********************************/
void LPUART_MCTL_Write(uint32_t SetValue)
{
	LPUART->MCTL = SetValue;
}

/*********************************
LPUART  ÿbitĵƿźŶȡ
:   
  12bit
*********************************/
uint32_t LPUART_MCTL_Read(void)
{
	return (LPUART->MCTL);
}

/*********************************
LPUART  Ĵʼ
:   
  
*********************************/
void LPUART_Deinit(void)
{
	//LPUART->LPURXD = ;
	//LPUART->LPUTXD = ;
	//LPUART->LPUSTA = 0x000000C0;
	LPUART->LPUCON = 0x00000000;
	//LPUART->LPUIF = ;
	LPUART->LPUBAUD = 0x00000000;
	LPUART->LPUEN = 0x00000000;
	LPUART->COMPARE = 0x00000000;
	LPUART->MCTL = 0x00000000;
}
//Code_End

/*********************************
LPUART  ʼ 
:  
  
*********************************/
void LPUART_Init(LPUART_InitTypeDef* para)
{
	LPUART_LPUBAUD_BAUD_Set(para->LPUBAUD);		//ʿ
	LPUART_LPUEN_TXEN_Setable(para->TXEN);		//ʹ
	LPUART_LPUEN_RXEN_Setable(para->RXEN);		//ʹ
	LPUART_COMPARE_Write(para->COMPARE);		//ƥĴ
	LPUART_MCTL_Write(para->MCTL);				//ƿƼĴ
	
	LPUART_LPUCON_SL_Set(para->SL);				//ֹͣλ
	LPUART_LPUCON_DL_Set(para->DL);				//ݳ
	LPUART_LPUCON_PAREN_Setable(para->PAREN);	//Уλʹ
	LPUART_LPUCON_PTYP_Set(para->PTYP);			//Уλ
	
	LPUART_LPUCON_RXEV_Set(para->RXEV);		//ж¼
	LPUART_LPUCON_TCIE_Setable(para->TCIE);		//жʹ
	LPUART_LPUCON_TXIE_Setable(para->TXIE);		//bufferжʹ
	LPUART_LPUCON_RXIE_Setable(para->RXIE);		//жʹ
	LPUART_LPUCON_TXPOL_Setable(para->TXPOL);		//ݷͼȡʹ
	LPUART_LPUCON_RXPOL_Setable(para->RXPOL);		//ݽռȡ
	
	LPUART_LPUCON_NEDET_Setable(para->NEDET);		//½ؼʹ
	LPUART_LPUCON_ERRIE_Setable(para->ERRIE);		//жʹ
}

/*********************************
LPUART 򵥲ʼ 
:  
  
*********************************/
void LPUART_SInit(LPUART_SInitTypeDef* para)
{
	LPUART_InitTypeDef para2;	
		
	switch(para->BaudRate)
	{
		case 9600:
			para2.LPUBAUD = LPUART_LPUBAUD_BAUD_9600BPS;
			para2.MCTL = LPUART_MCTL_FOR9600BPS;
			break;

		case 4800:
			para2.LPUBAUD = LPUART_LPUBAUD_BAUD_4800BPS;
			para2.MCTL = LPUART_MCTL_FOR4800BPS;
			break;

		case 2400:
			para2.LPUBAUD = LPUART_LPUBAUD_BAUD_2400BPS;
			para2.MCTL = LPUART_MCTL_FOR2400BPS;
			break;
		
		case 1200:
			para2.LPUBAUD = LPUART_LPUBAUD_BAUD_1200BPS;
			para2.MCTL = LPUART_MCTL_FOR1200BPS;
			break;
		
		case 600:
			para2.LPUBAUD = LPUART_LPUBAUD_BAUD_600BPS;
			para2.MCTL = LPUART_MCTL_FOR600BPS;
			break;
		
		case 300:
			para2.LPUBAUD = LPUART_LPUBAUD_BAUD_300BPS;
			para2.MCTL = LPUART_MCTL_FOR300BPS;
			break;
		
		default:
			para2.LPUBAUD = LPUART_LPUBAUD_BAUD_9600BPS;
			para2.MCTL = LPUART_MCTL_FOR9600BPS;
			break;
	}

	para2.TXEN = DISABLE;
	para2.RXEN = DISABLE;
	para2.COMPARE = 0;
	
	//ֹͣλ
	if(OneBit == para->StopBit)
	{
		para2.SL = LPUART_LPUCON_SL_1BIT;
	}
	else
	{
		para2.SL = LPUART_LPUCON_SL_2BIT;
	}
	//λ
	if(Eight8Bit == para->DataBit)
	{
		para2.DL = LPUART_LPUCON_DL_8BIT;
	}
	else
	{
		para2.DL = LPUART_LPUCON_DL_7BIT;
	}
	
	//Уλ
	if(NONE == para->ParityBit)
	{
		para2.PAREN = DISABLE;
		para2.PTYP = LPUART_LPUCON_PTYP_EVEN;
	}
	else
	{
		para2.PAREN = ENABLE;
		if(EVEN == para->ParityBit)
		{
			para2.PTYP = LPUART_LPUCON_PTYP_EVEN;
		}
		else
		{
			para2.PTYP = LPUART_LPUCON_PTYP_ODD;
		}
	}
	
	para2.RXEV =LPUART_LPUCON_RXEV_MATCH;		//ж¼
	para2.TCIE = DISABLE;		//жʹ
	para2.TXIE = DISABLE;		//bufferжʹ
	para2.RXIE = DISABLE;		//жʹ
	para2.TXPOL = DISABLE;		//ݷͼȡʹ
	para2.RXPOL = DISABLE;		//ݽռȡ
	para2.NEDET = DISABLE;		//½ؼʹ
	para2.ERRIE = DISABLE;		//жʹ	
	
	LPUART_Init(&para2);
}

/******END OF FILE****/

