/**
  ******************************************************************************
  * @file    fm33g0xx_rtc.c
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of RTC peripheral:
  *
*/

/* Includes ------------------------------------------------------------------*/
#include "fm33g0xx_rtc.h"  

/** @addtogroup fm33g0xx_StdPeriph_Driver
  * @{
  */

/** @defgroup RTC 
  * @brief RCC driver modules
  * @{
  */ 

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/************************************************************************************
RTCдʹܼĴ غ 
:ǷCPURTCBCDʱĴдֵ
:д0xACACACAC  , CPURTCBCDʱĴдֵ, RTCWE1
	     д벻Ϊ0xACACACACֵ,   ָд,RTCWE0

**************************************************************************************/
void RTC_RTCWE_Write(uint32_t SetValue)
{
	RTC->RTCWE = (SetValue);
}

/********************************
BCDʱʱд뺯
:дʱֵ
:ʱֵ,BCDʽ

********************************/
void RTC_BCDSEC_Write(uint32_t SetValue)
{
	RTC->BCDSEC = (SetValue & RTC_BCDSEC_BCDSEC_Msk);
}
/********************************
BCDʱʱȡ
:ȡʱֵ
:ʱʽBCD

********************************/
uint32_t RTC_BCDSEC_Read(void)
{
	return (RTC->BCDSEC & RTC_BCDSEC_BCDSEC_Msk);
}
/********************************
BCDʱʱд뺯
:дʱֵ
:ʱֵ,BCDʽ

********************************/
void RTC_BCDMIN_Write(uint32_t SetValue)
{
	RTC->BCDMIN = (SetValue & RTC_BCDMIN_BCDMIN_Msk);
}
/********************************
BCDʱʱȡ
:ȡʱֵ
:ʱʽBCD

********************************/
uint32_t RTC_BCDMIN_Read(void)
{
	return (RTC->BCDMIN & RTC_BCDMIN_BCDMIN_Msk);
}

/********************************
BCDʱСʱʱд뺯
:дСʱʱֵ
:Сʱʱֵ,BCDʽ

********************************/
void RTC_BCDHOUR_Write(uint32_t SetValue)
{
	RTC->BCDHOUR = (SetValue & RTC_BCDHOUR_BCDHOUR_Msk);
}
/********************************
BCDʱСʱʱȡ
:ȡСʱʱֵ
:СʱʱʽBCD

********************************/
uint32_t RTC_BCDHOUR_Read(void)
{
	return (RTC->BCDHOUR & RTC_BCDHOUR_BCDHOUR_Msk);
}

/* BCDʱĴ غ */
void RTC_BCDDATE_Write(uint32_t SetValue)
{
	RTC->BCDDATE = (SetValue & RTC_BCDDATE_BCDDATE_Msk);
}

uint32_t RTC_BCDDATE_Read(void)
{
	return (RTC->BCDDATE & RTC_BCDDATE_BCDDATE_Msk);
}

/* BCDʱڼĴ غ */
void RTC_BCDWEEK_Write(uint32_t SetValue)
{
	RTC->BCDWEEK = (SetValue & RTC_BCDWEEK_BCDWEEK_Msk);
}

uint32_t RTC_BCDWEEK_Read(void)
{
	return (RTC->BCDWEEK & RTC_BCDWEEK_BCDWEEK_Msk);
}

/********************************
BCDʱʱд뺯
:дʱֵ
:ʱֵ,BCDʽ

********************************/
void RTC_BCDMONTH_Write(uint32_t SetValue)
{
	RTC->BCDMONTH = (SetValue & RTC_BCDMONTH_BCDMONTH_Msk);
}
/********************************
BCDʱʱȡ
:ȡʱֵ
:ʱʽBCD

********************************/
uint32_t RTC_BCDMONTH_Read(void)
{
	return (RTC->BCDMONTH & RTC_BCDMONTH_BCDMONTH_Msk);
}


/********************************
BCDʱʱд뺯
:дʱֵ
:ʱֵ,BCDʽ

********************************/
void RTC_BCDYEAR_Write(uint32_t SetValue)
{
	RTC->BCDYEAR = (SetValue & RTC_BCDYEAR_BCDYEAR_Msk);
}
/********************************
BCDʱʱȡ
:ȡʱֵ
:ʱʽBCD

********************************/
uint32_t RTC_BCDYEAR_Read(void)
{
	return (RTC->BCDYEAR & RTC_BCDYEAR_BCDYEAR_Msk);
}


/********************************
Сʱú
:Сʱֵ
:Сʱ

********************************/
void RTC_ALARM_ALARMHOUR_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = RTC->ALARM;
	tmpreg &= ~(RTC_ALARM_ALARMHOUR_Msk);
	tmpreg |= (SetValue & RTC_ALARM_ALARMHOUR_Msk);
	RTC->ALARM = tmpreg;
}
/********************************
Сʱȡ
:ȡСʱֵ
:ȡСʱ

********************************/
uint32_t RTC_ALARM_ALARMHOUR_Get(void)
{
	return (RTC->ALARM & RTC_ALARM_ALARMHOUR_Msk);
}

/********************************
ӷú
:ӷֵ
:ӷ

********************************/
void RTC_ALARM_ALARMMIN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = RTC->ALARM;
	tmpreg &= ~(RTC_ALARM_ALARMMIN_Msk);
	tmpreg |= (SetValue & RTC_ALARM_ALARMMIN_Msk);
	RTC->ALARM = tmpreg;
}
/********************************
ӷӶȡ
:ȡֵ
:ȡ

********************************/
uint32_t RTC_ALARM_ALARMMIN_Get(void)
{
	return (RTC->ALARM & RTC_ALARM_ALARMMIN_Msk);
}

/********************************
ú
:ֵ
:

********************************/
void RTC_ALARM_ALARMSEC_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = RTC->ALARM;
	tmpreg &= ~(RTC_ALARM_ALARMSEC_Msk);
	tmpreg |= (SetValue & RTC_ALARM_ALARMSEC_Msk);
	RTC->ALARM = tmpreg;
}
/********************************
ȡ
:ȡֵ
:ȡ

********************************/
uint32_t RTC_ALARM_ALARMSEC_Get(void)
{
	return (RTC->ALARM & RTC_ALARM_ALARMSEC_Msk);
}

/********************************
Ƶźѡ
:Ƶźѡ
:źѡ

********************************/
void RTC_FSEL_FSEL_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = RTC->FSEL;
	tmpreg &= ~(RTC_FSEL_FSEL_Msk);
	tmpreg |= (SetValue & RTC_FSEL_FSEL_Msk);
	RTC->FSEL = tmpreg;
}
/********************************
źŵĴŻȡ
:źŵĴŻȡ
:źѡ

********************************/
uint32_t RTC_FSEL_FSEL_Get(void)
{
	return (RTC->FSEL & RTC_FSEL_FSEL_Msk);
}

/********************************
ʱֵ
:ʱֵʱ׼ȷ
:ʱֵ

********************************/
void RTC_ADJUST_Write(uint32_t SetValue)
{
	RTC->ADJUST = (SetValue & RTC_ADJUST_ADJUST_Msk);
}
/********************************
ʱֵȡ
:ʱֵĶȡ
:ʱֵ

********************************/
uint32_t RTC_ADJUST_Read(void)
{
	return (RTC->ADJUST & RTC_ADJUST_ADJUST_Msk);
}

/********************************
ʱֵ
:ʱֵķ
:	RTC_ADSIGN_ADSIGN_PLUSʾӼֵ
	RTC_ADSIGN_ADSIGN_MINUSʾټֵ


********************************/
void RTC_ADSIGN_ADSIGN_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = RTC->ADSIGN;
	tmpreg &= ~(RTC_ADSIGN_ADSIGN_Msk);
	tmpreg |= (SetValue & RTC_ADSIGN_ADSIGN_Msk);
	RTC->ADSIGN = tmpreg;
}
/********************************
ʱֵȡ
:ʱֵķȡ
:	0ʾӼֵ
	1ʾټֵ
********************************/
uint32_t RTC_ADSIGN_ADSIGN_Get(void)
{
	return (RTC->ADSIGN & RTC_ADSIGN_ADSIGN_Msk);
}

/********************************
УʹܺʹPLḶ
:УĹʹ
:	0ʾֹУ
	1ʾʹУ

********************************/
void RTC_PR1SEN_PR1SEN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RTC->PR1SEN |= (RTC_PR1SEN_PR1SEN_Msk);
	}
	else
	{
		RTC->PR1SEN &= ~(RTC_PR1SEN_PR1SEN_Msk);
	}
}
/********************************
ȡУʹ״̬
:ȡУĹʹܵ״̬
:	ʹ״̬
		0ʾֹУ
		1ʾʹУ
********************************/
FunState RTC_PR1SEN_PR1SEN_Getable(void)
{
	if (RTC->PR1SEN & (RTC_PR1SEN_PR1SEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
úʹPLḶ
:úֵ
:	ֵ(256HzΪڼ3.9ms )

********************************/
void RTC_MSECCNT_Write(uint32_t SetValue)
{
	RTC->MSECCNT = (SetValue & RTC_MSECCNT_MSCNT_Msk);
}
/********************************
ȡֵʹPLḶ
:ȡֵ
:	ֵ

********************************/
uint32_t RTC_MSECCNT_Read(void)
{
	return (RTC->MSECCNT & RTC_MSECCNT_MSCNT_Msk);
}

/********************************
PB5ʱʹܺ
:PB5ʱʹܣ޸λֵϵгʼ
:	1ʱ
	0رʱ

********************************/
void RTC_STAMPEN_STAMP1EN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RTC->STAMPEN |= (RTC_STAMPEN_STAMP1EN_Msk);
	}
	else
	{
		RTC->STAMPEN &= ~(RTC_STAMPEN_STAMP1EN_Msk);
	}
}
/********************************
ȡPB5ʱʹ״̬
:ȡPB5ʱʹ״̬
:	1ʱ
	0رʱ
********************************/
FunState RTC_STAMPEN_STAMP1EN_Getable(void)
{
	if (RTC->STAMPEN & (RTC_STAMPEN_STAMP1EN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
PB4ʱʹܺ
:PB4ʱʹܣ޸λֵϵгʼ
:	1ʱ
	0رʱ

********************************/
void RTC_STAMPEN_STAMP0EN_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RTC->STAMPEN |= (RTC_STAMPEN_STAMP0EN_Msk);
	}
	else
	{
		RTC->STAMPEN &= ~(RTC_STAMPEN_STAMP0EN_Msk);
	}
}
/********************************
ȡPB4ʱʹ״̬
:ȡPB4ʱʹ״̬
:	1ʱ
	0رʱ

********************************/
FunState RTC_STAMPEN_STAMP0EN_Getable(void)
{
	if (RTC->STAMPEN & (RTC_STAMPEN_STAMP0EN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
ȡPB4ʱʱݺ
:ȡPB4ʱʱ
:	PB4غ洢BCDʱ

********************************/
uint32_t RTC_CLKSTAMP0R_Read(void)
{
	return (RTC->CLKSTAMP0R);
}

/********************************
ȡPB4ʱݺ
:ȡPB4ʱ
:	PB4غ洢BCD

********************************/
uint32_t RTC_CALSTAMP0R_Read(void)
{
	return (RTC->CALSTAMP0R);
}


/********************************
ȡPB4ʱʱݺ
:ȡPB4ʱʱ
:	PB4غ洢BCDʱ

********************************/
uint32_t RTC_CLKSTAMP0F_Read(void)
{
	return (RTC->CLKSTAMP0F);
}

/********************************
ȡPB4ʱݺ
:ȡPB4ʱ
:	PB4غ洢BCD

********************************/
uint32_t RTC_CALSTAMP0F_Read(void)
{
	return (RTC->CALSTAMP0F);
}

/********************************
ȡPB5ʱʱݺ
:ȡPB5ʱʱ
:	PB5غ洢BCDʱ

********************************/
uint32_t RTC_CLKSTAMP1R_Read(void)
{
	return (RTC->CLKSTAMP1R);
}
/********************************
ȡPB5ʱݺ
:ȡPB5ʱ
:	PB5غ洢BCD

********************************/
uint32_t RTC_CALSTAMP1R_Read(void)
{
	return (RTC->CALSTAMP1R);
}

/********************************
ȡPB5ʱʱݺ
:ȡPB5ʱʱ
:	PB5غ洢BCDʱ

********************************/
uint32_t RTC_CLKSTAMP1F_Read(void)
{
	return (RTC->CLKSTAMP1F);
}
/********************************
ȡPB5ʱݺ
:ȡPB5ʱ
:	PB5غ洢BCD

********************************/
uint32_t RTC_CALSTAMP1F_Read(void)
{
	return (RTC->CALSTAMP1F);
}

/********************************
RTCмĴ㺯
:RTCмĴ(Ĭֵ)
********************************/
void RTC_Deinit(void)
{
	RTC->RTCWE = 0x00000000;
	RTC->RTCIE = 0x00000000;
	//RTC->RTCIF = ;
	//RTC->BCDSEC = ;
	//RTC->BCDMIN = ;
	//RTC->BCDHOUR = ;
	//RTC->BCDDATE = ;
	//RTC->BCDWEEK = ;
	//RTC->BCDMONTH = ;
	//RTC->BCDYEAR = ;
	RTC->ALARM = 0x00000000;
	RTC->FSEL = 0x00000000;
	//RTC->ADJUST = ;
	//RTC->ADSIGN = ;
	RTC->PR1SEN = 0x00000000;
	//RTC->MSECCNT = ;
	RTC->STAMPEN = 0x00000000;
	RTC->CLKSTAMP0R = 0x00000000;
	RTC->CALSTAMP0R = 0x00000000;
	RTC->CLKSTAMP0F = 0x00000000;
	RTC->CALSTAMP0F = 0x00000000;
	RTC->CLKSTAMP1R = 0x00000000;
	RTC->CALSTAMP1R = 0x00000000;
	RTC->CLKSTAMP1F = 0x00000000;
	RTC->CALSTAMP1F = 0x00000000;
  RTC->AUTOCAL = 0x00000000;
//  RTC->ADOFFSET = 0x00000000;
  RTC->CALSTEP = 0x00000000;
}
//Code_End

/********************************
RTCжʹܺ
:RTCжʹ
룺
      һʹ״̬
      һRTCҪĹܵжʹ
********************************/
void RTC_RTCIE_SetableEx(FunState NewState, uint32_t ie_def)
{
	if (NewState == ENABLE)
	{
		RTC->RTCIE |= (ie_def);
	}
	else
	{
		RTC->RTCIE &= ~(ie_def);
	}
}

/********************************
ȡRTCҪĹܵжʹ״̬
:ȡRTCҪĹܵжʹ״̬
жʹ״̬
		
********************************/
FunState RTC_RTCIE_GetableEx(uint32_t ie_def)
{
	if (RTC->RTCIE & (ie_def))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/********************************
RTCжϱ־
:RTCжϱ־
룺ҪʹõRTCжϵжϱ־
		
********************************/
void RTC_RTCIF_ClrEx(uint32_t if_def)
{
	RTC->RTCIF = (if_def);
}
/********************************
ȡʹõRTCжϱ־״̬
:ȡRTCжϱ־״̬
ȡʹõRTCжϱ־״̬
		
********************************/
FlagStatus RTC_RTCIF_ChkEx(uint32_t if_def)
{
	if (RTC->RTCIF & (if_def))
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
 RTCʱ亯
:ʱ䣬룬֣ʱ죬£꣬ܣBCDʽ
룺Ҫõʱ
		
********************************/
void RTC_TimeDate_SetEx(RTC_TimeDateTypeDef* para)
{
	RTC_BCDSEC_Write((uint32_t)para->Second);
	RTC_BCDMIN_Write((uint32_t)para->Minute);
	RTC_BCDHOUR_Write((uint32_t)para->Hour);
	RTC_BCDDATE_Write((uint32_t)para->Date);
	RTC_BCDMONTH_Write((uint32_t)para->Month);
	RTC_BCDYEAR_Write((uint32_t)para->Year);
	RTC_BCDWEEK_Write((uint32_t)para->Week);	
}

/********************************
 RTCȡʱ亯
:ȡʱ䣬룬֣ʱ죬£꣬ܣBCDʽ
ȡǰʱ䣬Ϊ
		
********************************/
void RTC_TimeDate_GetEx(RTC_TimeDateTypeDef* para)
{
	para->Second = RTC_BCDSEC_Read();
	para->Minute = RTC_BCDMIN_Read();
	para->Hour = RTC_BCDHOUR_Read();
	para->Date = RTC_BCDDATE_Read();
	para->Month = RTC_BCDMONTH_Read();
	para->Year = RTC_BCDYEAR_Read();
	para->Week = RTC_BCDWEEK_Read();	
}

/********************************
 RTCʱ亯
:ʱ䣬룬֣ʱ
룺Ҫõʱ
		
********************************/
void RTC_AlarmTime_SetEx(RTC_AlarmTmieTypeDef* para)
{
	RTC_ALARM_ALARMSEC_Set(((uint32_t)para->Second<<RTC_ALARM_ALARMSEC_Pos));
	RTC_ALARM_ALARMMIN_Set(((uint32_t)para->Minute<<RTC_ALARM_ALARMMIN_Pos));
	RTC_ALARM_ALARMHOUR_Set(((uint32_t)para->Hour<<RTC_ALARM_ALARMHOUR_Pos));
}


/********************************
 ȡRTCʱ亯
:ȡʱ䣬룬֣ʱ
ȡʱ䣬Ϊ
		
********************************/
void RTC_AlarmTime_GetEx(RTC_AlarmTmieTypeDef* para)
{
	para->Second = (RTC_ALARM_ALARMSEC_Get())>>RTC_ALARM_ALARMSEC_Pos;
	para->Minute = (RTC_ALARM_ALARMMIN_Get())>>RTC_ALARM_ALARMMIN_Pos;
	para->Hour = (RTC_ALARM_ALARMHOUR_Get())>>RTC_ALARM_ALARMHOUR_Pos;
}	
	

/********************************
 ȡʱݺ
:ȡʱ
ȡʱݣΪ
		
********************************/
void RTC_CLKSTAMPxx_GetEx(uint8_t StampType_def, RTC_StampTmieTypeDef* para)
{
	uint8_t i;
	__IO uint32_t *p_reg = 0;
	p_reg = &(RTC->CLKSTAMP0R);
	
	if(StampType_def <= 3)
	{
		for(i=0; i<StampType_def*2; i++)
		{
			p_reg++;
		}
		para->Second = 0xFF&(p_reg[0]>>0);
		para->Minute = 0xFF&(p_reg[0]>>8);
		para->Hour = 0xFF&(p_reg[0]>>16);
		para->Date = 0xFF&(p_reg[1]>>0);
		para->Month = 0xFF&(p_reg[1]>>16);
		para->Year = 0xFF&(p_reg[1]>>24);
		para->Week = 0xFF&(p_reg[1]>>8);
	}
}

/********************************
Զ²ʹܺ
:Զ²ʹ
:	0ֹԶ²
	    1ʹԶ²

********************************/
void RTC_AUTOCAL_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		RTC->AUTOCAL |= (RTC_AUTOCAL_ACALEN_Msk);
	}
	else
	{
		RTC->AUTOCAL &= ~(RTC_AUTOCAL_ACALEN_Msk);
	}
}

/********************************
ȡRTCԶ²ʹ״̬
:ȡRTCǷԶ²
:ENABLE Զ²
		
********************************/
FunState RTC_AUTOCAL_Getable(void)
{
	if (RTC->AUTOCAL & (RTC_AUTOCAL_ACALEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
дRTC Զ²ֵ
:дRTC Զ²ֵ
룺RTCֵ
		
********************************/
void RTC_ADOFFSET_Write(uint32_t SetValue)
{
	RTC->ADOFFSET = (SetValue&RTC_ADOFFSET_ADOFFSET_Msk);
}

/********************************
RTCԶ²ֵ
:RTCԶ²ֵ
룺
RTCԶ²ֵ
		
********************************/
uint32_t RTC_ADOFFSET_Read(void)
{
	return ((RTC->ADOFFSET)&RTC_ADOFFSET_ADOFFSET_Msk);
}

/********************************
RTCСУú
:RTCСУ
룺0 0.0238
      1 0.119

		
********************************/
void RTC_CALSTEP_SET(uint32_t SetValue)
{
  if(SetValue==RTC_CALSTEP_CALSTEP0P119)
  {
    RTC->CALSTEP=RTC_CALSTEP_CALSTEP0P119;
  }
  else
  {
    RTC->CALSTEP=RTC_CALSTEP_CALSTEP0P238;
  }
}

/********************************
ȡRTCСУ
:ȡRTCСУ
:0 0.238
     1 0.119
********************************/
FunState RTC_CALSTEP_Get(void)
{
	if (RTC->CALSTEP & (RTC_CALSTEP_CALSTEP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
ȡRTCԶ²״̬
:ȡRTCԶ²BUSYλ
:0 RTCδռADCԶ²
     1 RTCռADCԶ²
********************************/
FunState RTC_CALBUSY_Get(void)
{
	if((RTC->CALBUSY) & RTC_CALBUSY_AUCALBUSY_Msk)
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
RTCڼֵ
:RTCڼֵ
룺
RTCڼֵ
		
********************************/
uint32_t RTC_ADJCNT_Read(void)
{
	return (RTC->ADJCNT & RTC_ADJCNT_ADJCNT_Msk);
}

/********************************
RTCԶ¶Ȳֵ
:ȡRTCǰõԶ²ֵ
룺
ǰԶ¶ȲУֵ		
********************************/
uint32_t RTC_ACALADJ_Read(void)
{
	return (RTC->ACALADJ & RTC_ACALADJ_AUADJUST_Msk);
}

/********************************
дRTCݼĴ
:дRTCݼĴ
룺RTCļ
		
********************************/
void RTC_BKREG_Write(uint32_t* prog_data)
{
  uint32_t i;
  for(i=0;i<128;i++)
  {
    RTC->RTCBKREG[i]=prog_data[i];
  }
  
}
/********************************
 RTC ʱӾȲ
:RTC ʱӾȲ
룺floatͲppm
		
********************************/
void RTC_Trim_Proc(float err_ppm)
{
	float Rtcadj;
  if(RTC_CALSTEP_Get()) 
  {
    Rtcadj = err_ppm*8.388608;//0.119ppm
  }
  else
  {
    Rtcadj = err_ppm*4.194304;//0.238ppm
  }
		
	if( Rtcadj >= 0 ) 
	{
		RTC_ADJUST_Write((uint32_t)(Rtcadj+0.5));
		RTC_ADSIGN_ADSIGN_Set(RTC_ADSIGN_ADSIGN_PLUS);
	}			
	else              
	{
		RTC_ADJUST_Write((uint32_t)((Rtcadj-0.5)*-1.0));
		RTC_ADSIGN_ADSIGN_Set(RTC_ADSIGN_ADSIGN_MINUS);
	}    
}

/******END OF FILE****/




