/**
  ******************************************************************************
  * @file    fm33g0xx_scu.c
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of the system control unit (scu) peripheral:
  *
*/

/* Includes ------------------------------------------------------------------*/
#include "fm33g0xx_scu.h" 

/** @addtogroup fm33g0xx_StdPeriph_Driver
  * @{
  */

/** @defgroup SCU 
  * @brief SCU driver modules
  * @{
  */ 

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/


/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/** @defgroup SCU_Private_Functions
  * @{
  */
	
/********************************
Debug״̬ET4ʹܿƺ
:Debug״̬ET4ʹ
:ʹ״̬
********************************/
void SCU_MCUDBGCR_DBG_ET4_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		SCU->MCUDBGCR |= (SCU_MCUDBGCR_DBG_ET4_STOP_Msk);
	}
	else
	{
		SCU->MCUDBGCR &= ~(SCU_MCUDBGCR_DBG_ET4_STOP_Msk);
	}
}
/********************************
ȡDebug״̬ET4ʹܿƺ
:ȡDebug״̬ET4ʹ״̬
:ʹ״̬
********************************/
FunState SCU_MCUDBGCR_DBG_ET4_STOP_Getable(void)
{
	if (SCU->MCUDBGCR & (SCU_MCUDBGCR_DBG_ET4_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
Debug״̬ET3ʹܿƺ
:Debug״̬ET3ʹ
:ʹ״̬
********************************/
void SCU_MCUDBGCR_DBG_ET3_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		SCU->MCUDBGCR |= (SCU_MCUDBGCR_DBG_ET3_STOP_Msk);
	}
	else
	{
		SCU->MCUDBGCR &= ~(SCU_MCUDBGCR_DBG_ET3_STOP_Msk);
	}
}
/********************************
ȡDebug״̬ET3ʹܿƺ
:ȡDebug״̬ET3ʹ״̬
:ʹ״̬
********************************/
FunState SCU_MCUDBGCR_DBG_ET3_STOP_Getable(void)
{
	if (SCU->MCUDBGCR & (SCU_MCUDBGCR_DBG_ET3_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
Debug״̬ET2ʹܿƺ
:Debug״̬ET2ʹ
:ʹ״̬
********************************/
void SCU_MCUDBGCR_DBG_ET2_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		SCU->MCUDBGCR |= (SCU_MCUDBGCR_DBG_ET2_STOP_Msk);
	}
	else
	{
		SCU->MCUDBGCR &= ~(SCU_MCUDBGCR_DBG_ET2_STOP_Msk);
	}
}
/********************************
ȡDebug״̬ET2ʹܿƺ
:ȡDebug״̬ET2ʹ״̬
:ʹ״̬
********************************/
FunState SCU_MCUDBGCR_DBG_ET2_STOP_Getable(void)
{
	if (SCU->MCUDBGCR & (SCU_MCUDBGCR_DBG_ET2_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
Debug״̬ET1ʹܿƺ
:Debug״̬ET1ʹ
:ʹ״̬
********************************/
void SCU_MCUDBGCR_DBG_ET1_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		SCU->MCUDBGCR |= (SCU_MCUDBGCR_DBG_ET1_STOP_Msk);
	}
	else
	{
		SCU->MCUDBGCR &= ~(SCU_MCUDBGCR_DBG_ET1_STOP_Msk);
	}
}
/********************************
ȡDebug״̬ET1ʹܿƺ
:ȡDebug״̬ET1ʹ״̬
:ʹ״̬
********************************/
FunState SCU_MCUDBGCR_DBG_ET1_STOP_Getable(void)
{
	if (SCU->MCUDBGCR & (SCU_MCUDBGCR_DBG_ET1_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/********************************
Debug״̬BT2ʹܿƺ
:Debug״̬BT2ʹ
:ʹ״̬
********************************/
void SCU_MCUDBGCR_DBG_BT2_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		SCU->MCUDBGCR |= (SCU_MCUDBGCR_DBG_BT2_STOP_Msk);
	}
	else
	{
		SCU->MCUDBGCR &= ~(SCU_MCUDBGCR_DBG_BT2_STOP_Msk);
	}
}
/********************************
ȡDebug״̬BT2ʹܿƺ
:ȡDebug״̬BT2ʹ״̬
:ʹ״̬
********************************/
FunState SCU_MCUDBGCR_DBG_BT2_STOP_Getable(void)
{
	if (SCU->MCUDBGCR & (SCU_MCUDBGCR_DBG_BT2_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
Debug״̬BT1ʹܿƺ
:Debug״̬BT1ʹ
:ʹ״̬
********************************/
void SCU_MCUDBGCR_DBG_BT1_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		SCU->MCUDBGCR |= (SCU_MCUDBGCR_DBG_BT1_STOP_Msk);
	}
	else
	{
		SCU->MCUDBGCR &= ~(SCU_MCUDBGCR_DBG_BT1_STOP_Msk);
	}
}
/********************************
ȡDebug״̬BT1ʹܿƺ
:ȡDebug״̬BT1ʹ״̬
:ʹ״̬
********************************/
FunState SCU_MCUDBGCR_DBG_BT1_STOP_Getable(void)
{
	if (SCU->MCUDBGCR & (SCU_MCUDBGCR_DBG_BT1_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
Debug״̬WWDTʹܿƺ
:Debug״̬WWDTʹ
:ʹ״̬
********************************/
void SCU_MCUDBGCR_DBG_WWDT_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		SCU->MCUDBGCR |= (SCU_MCUDBGCR_DBG_WWDT_STOP_Msk);
	}
	else
	{
		SCU->MCUDBGCR &= ~(SCU_MCUDBGCR_DBG_WWDT_STOP_Msk);
	}
}
/********************************
ȡDebug״̬WWDTʹܿƺ
:ȡDebug״̬WWDTʹ״̬
:ʹ״̬
********************************/
FunState SCU_MCUDBGCR_DBG_WWDT_STOP_Getable(void)
{
	if (SCU->MCUDBGCR & (SCU_MCUDBGCR_DBG_WWDT_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
Debug״̬IWDTʹܿƺ
:Debug״̬IWDTʹ
:ʹ״̬
********************************/
void SCU_MCUDBGCR_DBG_IWDT_STOP_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		SCU->MCUDBGCR |= (SCU_MCUDBGCR_DBG_IWDT_STOP_Msk);
	}
	else
	{
		SCU->MCUDBGCR &= ~(SCU_MCUDBGCR_DBG_IWDT_STOP_Msk);
	}
}
/********************************
ȡDebug״̬IWDTʹܿƺ
:ȡDebug״̬IWDTʹ״̬
:ʹ״̬
********************************/
FunState SCU_MCUDBGCR_DBG_IWDT_STOP_Getable(void)
{
	if (SCU->MCUDBGCR & (SCU_MCUDBGCR_DBG_IWDT_STOP_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
ַǶʴ־
:ַǶʴ־
********************************/
void SCU_HDFFLAG_DABORT_ADDR_FLAG_Clr(void)
{
	SCU->HDFFLAG = SCU_HDFFLAG_DABORT_ADDR_FLAG_Msk;
}

FlagStatus SCU_HDFFLAG_DABORT_ADDR_FLAG_Chk(void)
{
	if (SCU->HDFFLAG & SCU_HDFFLAG_DABORT_ADDR_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}
/********************************
ȡַǶʴ־
:ȡַǶʴ־
:ַǶʴ־
********************************/
void SCU_HDFFLAG_DABORT_RESP_FLAG_Clr(void)
{
	SCU->HDFFLAG = SCU_HDFFLAG_DABORT_RESP_FLAG_Msk;
}

/********************************
Ƿַʴ־
:Ƿַʴ־
********************************/
FlagStatus SCU_HDFFLAG_DABORT_RESP_FLAG_Chk(void)
{
	if (SCU->HDFFLAG & SCU_HDFFLAG_DABORT_RESP_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
ȡǷַʴ־
:ȡǷַʴ־־
:Ƿַʴ־־
********************************/
void SCU_HDFFLAG_SVCUNDEF_FLAG_Clr(void)
{
	SCU->HDFFLAG = SCU_HDFFLAG_SVCUNDEF_FLAG_Msk;
}
/********************************
ȡSVC instructionsδ־
:ȡSVC instructionsδ־
:SVC instructionsδ־
********************************/
FlagStatus SCU_HDFFLAG_SVCUNDEF_FLAG_Chk(void)
{
	if (SCU->HDFFLAG & SCU_HDFFLAG_SVCUNDEF_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
ִBKPTָ־
:ִBKPTָ־
********************************/
void SCU_HDFFLAG_BKPT_FLAG_Clr(void)
{
	SCU->HDFFLAG = SCU_HDFFLAG_BKPT_FLAG_Msk;
}
/********************************
ȡִBKPTָ־
:ȡִBKPTָ־
:ִBKPTָı־
********************************/
FlagStatus SCU_HDFFLAG_BKPT_FLAG_Chk(void)
{
	if (SCU->HDFFLAG & SCU_HDFFLAG_BKPT_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
Thumb-State־
:Thumb-State־
********************************/
void SCU_HDFFLAG_TBIT_FLAG_Clr(void)
{
	SCU->HDFFLAG = SCU_HDFFLAG_TBIT_FLAG_Msk;
}

/********************************
ȡThumb-State־
:ȡThumb-State־
:Thumb-Stateı־
********************************/
FlagStatus SCU_HDFFLAG_TBIT_FLAG_Chk(void)
{
	if (SCU->HDFFLAG & SCU_HDFFLAG_TBIT_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
ָ־
:ָ־
********************************/
void SCU_HDFFLAG_SPECIAL_OP_FLAG_Clr(void)
{
	SCU->HDFFLAG = SCU_HDFFLAG_SPECIAL_OP_FLAG_Msk;
}
/********************************
ȡָ־
:ȡָ־
:ָı־
********************************/
FlagStatus SCU_HDFFLAG_SPECIAL_OP_FLAG_Chk(void)
{
	if (SCU->HDFFLAG & SCU_HDFFLAG_SPECIAL_OP_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
hardfault־λ
:hardfaultı־λ
********************************/
void SCU_HDFFLAG_HDF_REQUEST_FLAG_Clr(void)
{
	SCU->HDFFLAG = SCU_HDFFLAG_HDF_REQUEST_FLAG_Msk;
}
/********************************
ȡhardfault־λ
:ȡhardfault־λ
:hardfaultı־λ
********************************/
FlagStatus SCU_HDFFLAG_HDF_REQUEST_FLAG_Chk(void)
{
	if (SCU->HDFFLAG & SCU_HDFFLAG_HDF_REQUEST_FLAG_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}
/********************************
SCUʼȱʡ
:SCUʼȱʡ
********************************/
void SCU_Deinit(void)
{
	SCU->MCUDBGCR = 0x00003F03;
	SCU->HDFFLAG = 0x00000000;
}
//Code_End


/******END OF FILE****/



