/**
  ******************************************************************************
  * @file    fm33g0xx_spi.c
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of SPI:           
  *           
  ******************************************************************************  
  */ 

/* Includes ------------------------------------------------------------------*/ 

#include "fm33g0xx_spi.h" 
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/********************************
MasterMISOźŵĲλõ
:MasterMISOźŵĲλõڸͨʱPCBӳ
룺λõ߼ֵ
1ӳٰSCK
0
********************************/
void SPIx_SPICR1_MSPA_Set(SPIx_Type* SPIx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = SPIx->SPICR1;
	tmpreg &= ~(SPIx_SPICR1_MSPA_Msk);
	tmpreg |= (SetValue & SPIx_SPICR1_MSPA_Msk);
	SPIx->SPICR1 = tmpreg;
}
/********************************
ȡMasterMISOźŵĲλõ
:ȡλõ߼ֵ
λõ߼ֵ
1ӳٰSCK
0
********************************/
uint32_t SPIx_SPICR1_MSPA_Get(SPIx_Type* SPIx)
{
	return (SPIx->SPICR1 & SPIx_SPICR1_MSPA_Msk);
}

/********************************
Slave MISOλõ
:Slave MISOλõ
룺Slave MISOλõ߼ֵ
1ǰSCKڷ
0
********************************/
void SPIx_SPICR1_SSPA_Set(SPIx_Type* SPIx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = SPIx->SPICR1;
	tmpreg &= ~(SPIx_SPICR1_SSPA_Msk);
	tmpreg |= (SetValue & SPIx_SPICR1_SSPA_Msk);
	SPIx->SPICR1 = tmpreg;
}
/********************************
ȡSlave MISOλõ
:ȡSlave MISOλõ߼ֵ
Slave MISOλõ߼ֵ
1ǰSCKڷ
0
********************************/
uint32_t SPIx_SPICR1_SSPA_Get(SPIx_Type* SPIx)
{
	return (SPIx->SPICR1 & SPIx_SPICR1_SSPA_Msk);
}

/********************************
 MASTER/SLAVEģʽѡ
: MASTER/SLAVEģʽѡ
룺 MASTER/SLAVEģʽѡ߼ֵ
1Masterģʽ
0Slaveģʽ
********************************/
void SPIx_SPICR1_MM_Set(SPIx_Type* SPIx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = SPIx->SPICR1;
	tmpreg &= ~(SPIx_SPICR1_MM_Msk);
	tmpreg |= (SetValue & SPIx_SPICR1_MM_Msk);
	SPIx->SPICR1 = tmpreg;
}
/********************************
 ȡMASTER/SLAVEģʽѡ
: ȡMASTER/SLAVEģʽ
 MASTER/SLAVEģʽ߼ֵ
1Masterģʽ
0Slaveģʽ
********************************/
uint32_t SPIx_SPICR1_MM_Get(SPIx_Type* SPIx)
{
	return (SPIx->SPICR1 & SPIx_SPICR1_MM_Msk);
}
/********************************
 MasterģʽüSCK cycleֵ
: SCK cycleWAITֵ
룺  SCK cycleWAITֵ
********************************/
void SPIx_SPICR1_WAIT_Set(SPIx_Type* SPIx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = SPIx->SPICR1;
	tmpreg &= ~(SPIx_SPICR1_WAIT_Msk);
	tmpreg |= (SetValue & SPIx_SPICR1_WAIT_Msk);
	SPIx->SPICR1 = tmpreg;
}
/********************************
 ȡMasterģʽüSCK cycleֵ
: ȡõSCK cycleWAITֵ
  SCK cycleWAITֵ
********************************/
uint32_t SPIx_SPICR1_WAIT_Get(SPIx_Type* SPIx)
{
	return (SPIx->SPICR1 & SPIx_SPICR1_WAIT_Msk);
}

/********************************
 MASTERģʽú
: MASTERģʽʵ
룺   MASTERģʽʵֵfAHBCLKķƵ
********************************/
void SPIx_SPICR1_BAUD_Set(SPIx_Type* SPIx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = SPIx->SPICR1;
	tmpreg &= ~(SPIx_SPICR1_BAUD_Msk);
	tmpreg |= (SetValue & SPIx_SPICR1_BAUD_Msk);
	SPIx->SPICR1 = tmpreg;
}
/********************************
 ȡMASTERģʽõֵ
: ȡMASTERģʽʵ
  ģʽʵãfAHBCLKķƵ
********************************/
uint32_t SPIx_SPICR1_BAUD_Get(SPIx_Type* SPIx)
{
	return (SPIx->SPICR1 & SPIx_SPICR1_BAUD_Msk);
}

/********************************
 ֡ʽú
: ֡ʽ
룺֡ʽ
0ȷMSB
1ȷLSB 
********************************/
void SPIx_SPICR1_LSBF_Set(SPIx_Type* SPIx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = SPIx->SPICR1;
	tmpreg &= ~(SPIx_SPICR1_LSBF_Msk);
	tmpreg |= (SetValue & SPIx_SPICR1_LSBF_Msk);
	SPIx->SPICR1 = tmpreg;
}
/********************************
 ȡ֡ʽõĺ
: öȡ֡ʽ
  ֡ʽ
0ȷMSB
1ȷLSB
********************************/
uint32_t SPIx_SPICR1_LSBF_Get(SPIx_Type* SPIx)
{
	return (SPIx->SPICR1 & SPIx_SPICR1_LSBF_Msk);
}

/********************************
 ʱӼѡ
: ʱӼ
룺ʱӼԵ
1ʱֹͣڸߵƽ
0ʱֹͣڵ͵ƽ
********************************/
void SPIx_SPICR1_CPHOL_Set(SPIx_Type* SPIx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = SPIx->SPICR1;
	tmpreg &= ~(SPIx_SPICR1_CPHOL_Msk);
	tmpreg |= (SetValue & SPIx_SPICR1_CPHOL_Msk);
	SPIx->SPICR1 = tmpreg;
}
/********************************
 ȡʱӼѡĺ
: ȡʱӼ
ȡʱӼԵ
1ʱֹͣڸߵƽ
0ʱֹͣڵ͵ƽ
********************************/
uint32_t SPIx_SPICR1_CPHOL_Get(SPIx_Type* SPIx)
{
	return (SPIx->SPICR1 & SPIx_SPICR1_CPHOL_Msk);
}

/********************************/
/* ʱλѡ غ */
void SPIx_SPICR1_CPHA_Set(SPIx_Type* SPIx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = SPIx->SPICR1;
	tmpreg &= ~(SPIx_SPICR1_CPHA_Msk);
	tmpreg |= (SetValue & SPIx_SPICR1_CPHA_Msk);
	SPIx->SPICR1 = tmpreg;
}
/********************************
 ȡʱλѡ
: ȡʱλѡ
ȡʱλѡ
1ڶʱӱǵһ׽
0һʱӱǵһ׽
********************************/
uint32_t SPIx_SPICR1_CPHA_Get(SPIx_Type* SPIx)
{
	return (SPIx->SPICR1 & SPIx_SPICR1_CPHA_Msk);
}


/********************************
Slaveܽ˲ʹܣSSN/SCK/MOSI
: Slaveܽ˲ʹܣSSN/SCK/MOSIĿرչ
룺 Slaveܽ˲ʹ
1ʹ4ns˲
0˲
********************************/
void SPIx_SPICR2_FLTEN_Setable(SPIx_Type* SPIx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		SPIx->SPICR2 |= (SPIx_SPICR2_FLTEN_Msk);
	}
	else
	{
		SPIx->SPICR2 &= ~(SPIx_SPICR2_FLTEN_Msk);
	}
}
/********************************
ȡSlaveܽ˲ʹܣSSN/SCK/MOSI
: ȡSlaveܽ˲ʹܣSSN/SCK/MOSI״̬
 Slaveܽ˲ʹܵ״̬
1ʹ4ns˲
0˲
********************************/
FunState SPIx_SPICR2_FLTEN_Getable(SPIx_Type* SPIx)
{
	if (SPIx->SPICR2 & (SPIx_SPICR2_FLTEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/********************************
MasterģʽSSNģʽѡ
: MasterģʽSSNģʽѡ
룺 MasterģʽSSNģʽѡ
1ÿ8bitMasterSSNάָߵƽʱWAITĴ
0ÿ8bitMasterSSNΪ
********************************/
void SPIx_SPICR2_SSNM_Set(SPIx_Type* SPIx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = SPIx->SPICR2;
	tmpreg &= ~(SPIx_SPICR2_SSNM_Msk);
	tmpreg |= (SetValue & SPIx_SPICR2_SSNM_Msk);
	SPIx->SPICR2 = tmpreg;
}
/********************************
ȡMasterģʽSSNģʽѡ
: MasterģʽSSNģʽѡ
룺 MasterģʽSSNģʽѡ
1ÿ8bitMasterSSNάָߵƽʱWAITĴ
0ÿ8bitMasterSSNΪ
********************************/
uint32_t SPIx_SPICR2_SSNM_Get(SPIx_Type* SPIx)
{
	return (SPIx->SPICR2 & SPIx_SPICR2_SSNM_Msk);
}

/********************************
TXONLYӲԶյʹܺ
: TXONLYӲԶյʹܿر
룺 TXONLYӲԶյʹ״̬
1TXONLYӲԶЧʹTXO󣬵ȴϺӲ
0رTXONLYӲԶ
********************************/
void SPIx_SPICR2_TXO_AC_Set(SPIx_Type* SPIx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = SPIx->SPICR2;
	tmpreg &= ~(SPIx_SPICR2_TXO_AC_Msk);
	tmpreg |= (SetValue & SPIx_SPICR2_TXO_AC_Msk);
	SPIx->SPICR2 = tmpreg;
}
/********************************
ȡTXONLYӲԶյʹ״̬ĺ
: ȡTXONLYӲԶյʹ״̬
 ȡTXONLYӲԶյʹ״̬
1TXONLYӲԶЧʹTXO󣬵ȴϺӲ
0رTXONLYӲԶ
********************************/
uint32_t SPIx_SPICR2_TXO_AC_Get(SPIx_Type* SPIx)
{
	return (SPIx->SPICR2 & SPIx_SPICR2_TXO_AC_Msk);
}

/********************************
TTXONLYλú
: TTXONLYλ
룺 TTXONLYλ
1Masterĵģʽ
0رյģʽ
********************************/
void SPIx_SPICR2_TXO_Setable(SPIx_Type* SPIx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		SPIx->SPICR2 |= (SPIx_SPICR2_TXO_Msk);
	}
	else
	{
		SPIx->SPICR2 &= ~(SPIx_SPICR2_TXO_Msk);
	}
}
/********************************
ȡTTXONLYλú
: ȡTTXONLYλ
 TTXONLYλ
1Masterĵģʽ
0رյģʽ
********************************/
FunState SPIx_SPICR2_TXO_Getable(SPIx_Type* SPIx)
{
	if (SPIx->SPICR2 & (SPIx_SPICR2_TXO_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
MasterģʽSSNƽ
: SSNƽ
룺 SSNƽ
1SSNߵƽ
0SSN͵ƽ
********************************/
void SPIx_SPICR2_SSN_Set(SPIx_Type* SPIx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = SPIx->SPICR2;
	tmpreg &= ~(SPIx_SPICR2_SSN_Msk);
	tmpreg |= (SetValue & SPIx_SPICR2_SSN_Msk);
	SPIx->SPICR2 = tmpreg;
}
/********************************
ȡMasterģʽSSNƽ
: ȡSSNƽ
룺 SSNƽ
1SSNߵƽ
0SSN͵ƽ
********************************/
uint32_t SPIx_SPICR2_SSN_Get(SPIx_Type* SPIx)
{
	return (SPIx->SPICR2 & SPIx_SPICR2_SSN_Msk);
}

/********************************
MasterģʽSSNĿƷʽ
: SSNĿƷʽ
룺 SSNĿƷʽ
1MasterģʽSSN
0MasterģʽSSNӲԶ
********************************/
void SPIx_SPICR2_SSNSEN_Set(SPIx_Type* SPIx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = SPIx->SPICR2;
	tmpreg &= ~(SPIx_SPICR2_SSNSEN_Msk);
	tmpreg |= (SetValue & SPIx_SPICR2_SSNSEN_Msk);
	SPIx->SPICR2 = tmpreg;
}
/********************************
ȡMasterģʽSSNĿƷʽ
: ȡSSNĿƷʽ
 SSNĿƷʽ
1MasterģʽSSN
0MasterģʽSSNӲԶ
********************************/
uint32_t SPIx_SPICR2_SSNSEN_Get(SPIx_Type* SPIx)
{
	return (SPIx->SPICR2 & SPIx_SPICR2_SSNSEN_Msk);
}

/********************************
SPIʹܺ
: SPIʹܵ
룺 SPIʹ
1ʹSPI
0رSPIշͽջ
********************************/
void SPIx_SPICR2_SPIEN_Setable(SPIx_Type* SPIx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		SPIx->SPICR2 |= (SPIx_SPICR2_SPIEN_Msk);
	}
	else
	{
		SPIx->SPICR2 &= ~(SPIx_SPICR2_SPIEN_Msk);
	}
}
/********************************
ȡSPIʹܺ
: ȡSPIʹܵ
 SPIʹ
1ʹSPI
0رSPIշͽջ
********************************/
FunState SPIx_SPICR2_SPIEN_Getable(SPIx_Type* SPIx)
{
	if (SPIx->SPICR2 & (SPIx_SPICR2_SPIEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
BUFFER
: BUFFER
********************************/
void SPIx_SPICR3_TXBFC_Clr(SPIx_Type* SPIx)
{
	SPIx->SPICR3 = SPIx_SPICR3_TXBFC_Msk;
}
/********************************
BUFFER
: BUFFER
********************************/
void SPIx_SPICR3_RXBFC_Clr(SPIx_Type* SPIx)
{
	SPIx->SPICR3 = SPIx_SPICR3_RXBFC_Msk;
}
/********************************
ģʽĺ
: ģʽ
********************************/
void SPIx_SPICR3_MERRC_Clr(SPIx_Type* SPIx)
{
	SPIx->SPICR3 = SPIx_SPICR3_MERRC_Msk;
}

/********************************
ģʽĺ
: ģʽ
********************************/
void SPIx_SPICR3_SERRC_Clr(SPIx_Type* SPIx)
{
	SPIx->SPICR3 = SPIx_SPICR3_SERRC_Msk;
}
/********************************
HSPIжʹܺ
: HSPIжʹܵ
룺 HSPIжʹ
********************************/
void SPIx_SPIIE_ERRIE_Setable(SPIx_Type* SPIx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		SPIx->SPIIE |= (SPIx_SPIIE_ERRIE_Msk);
	}
	else
	{
		SPIx->SPIIE &= ~(SPIx_SPIIE_ERRIE_Msk);
	}
}
/********************************
ȡHSPIжʹܺ
: ȡHSPIжʹܵ
 ȡHSPIжʹ
********************************/
FunState SPIx_SPIIE_ERRIE_Getable(SPIx_Type* SPIx)
{
	if (SPIx->SPIIE & (SPIx_SPIIE_ERRIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
жʹܺ
: жʹܵ
룺 жʹ
********************************/
void SPIx_SPIIE_TXIE_Setable(SPIx_Type* SPIx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		SPIx->SPIIE |= (SPIx_SPIIE_TXIE_Msk);
	}
	else
	{
		SPIx->SPIIE &= ~(SPIx_SPIIE_TXIE_Msk);
	}
}
/********************************
ȡжʹܺ
: ȡжʹܵ
 жʹ
********************************/
FunState SPIx_SPIIE_TXIE_Getable(SPIx_Type* SPIx)
{
	if (SPIx->SPIIE & (SPIx_SPIIE_TXIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
жʹܺ
: жʹܵ
룺 жʹ
********************************/
void SPIx_SPIIE_RXIE_Setable(SPIx_Type* SPIx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		SPIx->SPIIE |= (SPIx_SPIIE_RXIE_Msk);
	}
	else
	{
		SPIx->SPIIE &= ~(SPIx_SPIIE_RXIE_Msk);
	}
}

/********************************
ȡжʹܺ
: ȡжʹܵ
 жʹ
********************************/
FunState SPIx_SPIIE_RXIE_Getable(SPIx_Type* SPIx)
{
	if (SPIx->SPIIE & (SPIx_SPIIE_RXIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
Master Error־
: ȡMaster Error־
 Master Error־
********************************/
FlagStatus SPIx_SPIIF_MERR_Chk(SPIx_Type* SPIx)
{
	if (SPIx->SPIIF & SPIx_SPIIF_MERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}
/********************************
Slave Error־
: ȡSlave Error־
 Slave Error־
********************************/
FlagStatus SPIx_SPIIF_SERR_Chk(SPIx_Type* SPIx)
{
	if (SPIx->SPIIF & SPIx_SPIIF_SERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
ջ־
: ջ־
룺 ջ־
********************************/
void SPIx_SPIIF_RXCOL_Clr(SPIx_Type* SPIx)
{
	SPIx->SPIIF = SPIx_SPIIF_RXCOL_Msk;
}
/********************************
ȡջ־
: ȡջ־
 ջ־
********************************/
FlagStatus SPIx_SPIIF_RXCOL_Chk(SPIx_Type* SPIx)
{
	if (SPIx->SPIIF & SPIx_SPIIF_RXCOL_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
ͻ־
: ͻ־
룺 ͻ־
********************************/
void SPIx_SPIIF_TXCOL_Clr(SPIx_Type* SPIx)
{
	SPIx->SPIIF = SPIx_SPIIF_TXCOL_Msk;
}
/********************************
ȡͻ־
: ȡͻ־
 ͻ־
********************************/
FlagStatus SPIx_SPIIF_TXCOL_Chk(SPIx_Type* SPIx)
{
	if (SPIx->SPIIF & SPIx_SPIIF_TXCOL_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
ȡSPIб־
: ȡSPIб־
 SPIб־
********************************/
FlagStatus SPIx_SPIIF_BUSY_Chk(SPIx_Type* SPIx)
{
	if (SPIx->SPIIF & SPIx_SPIIF_BUSY_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
ȡTX Buffer Empty־λ
: ȡTX Buffer Empty־λ
 TX Buffer Empty־λ
********************************/
FlagStatus SPIx_SPIIF_TXBE_Chk(SPIx_Type* SPIx)
{
	if (SPIx->SPIIF & SPIx_SPIIF_TXBE_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}


/********************************
ȡRX Buffer Full־λ
: ȡRX Buffer Full־λ
 RX Buffer Full־λ
********************************/
FlagStatus SPIx_SPIIF_RXBF_Chk(SPIx_Type* SPIx)
{
	if (SPIx->SPIIF & SPIx_SPIIF_RXBF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
SPIͻ溯
: дSPIͻ
룺 SPIͻ
********************************/
void SPIx_SPITXBUF_Write(SPIx_Type* SPIx, uint32_t SetValue)
{
	SPIx->SPITXBUF = (SetValue & SPIx_SPITXBUF_TXBUF_Msk);
}
/********************************
ȡSPIͻ溯
: ȡSPIͻֵ
 SPIͻֵ
********************************/
uint32_t SPIx_SPITXBUF_Read(SPIx_Type* SPIx)
{
	return (SPIx->SPITXBUF & SPIx_SPITXBUF_TXBUF_Msk);
}

/********************************
SPIջ溯
: дSPIջ
룺 SPIջ
********************************/
void SPIx_SPIRXBUF_Write(SPIx_Type* SPIx, uint32_t SetValue)
{
	SPIx->SPIRXBUF = (SetValue & SPIx_SPIRXBUF_RXBUF_Msk);
}
/********************************
ȡSPIջ溯
: ȡSPIջֵ
 SPIջֵ
********************************/
uint32_t SPIx_SPIRXBUF_Read(SPIx_Type* SPIx)
{
	return (SPIx->SPIRXBUF & SPIx_SPIRXBUF_RXBUF_Msk);
}
/********************************
SPIȱʡú
:SPIȱʡ
********************************/
void SPIx_Deinit(SPIx_Type* SPIx)
{
	SPIx->SPICR1 = 0x00000108;
	SPIx->SPICR2 = 0x00000054;
	SPIx->SPICR3 = 0x00000000;
	SPIx->SPIIE = 0x00000000;
	//SPIx->SPIIF = 0x00000002;
	//SPIx->SPITXBUF = 0x00000000;
	//SPIx->SPIRXBUF = 0x00000000;
}
//Code_End



/********************************
 SPIģʽʼ
:  SPIģʽʼ
룺 SPIģʽĳʼ
********************************/
void SPI_Master_Init(SPIx_Type* SPIx, SPI_Master_SInitTypeDef* para)
{
	SPI_Master_InitTypeDef init_para;

	SPIx_Deinit(SPIx);

	init_para.MSPA = SPIx_SPICR1_MSPA_NORMAL;
	init_para.WAIT = SPIx_SPICR1_WAIT_WAIT_1;
	init_para.BAUD_RATE = para->BAUD_RATE;
	init_para.LSBF = para->LSBF;
	init_para.CPHOL = para->CPHOL;
	init_para.CPHA = para->CPHA;
	init_para.SSNM = para->SSNM;
	init_para.TXO = DISABLE;
	init_para.TXO_AC = SPIx_SPICR2_TXO_AC_CLR_AT_CLOSE;
	init_para.SSNSEN = para->SSNSEN;

	init_para.SPIEN = DISABLE;
	init_para.ERRIE = DISABLE;
	init_para.TXIE = DISABLE;
	init_para.RXIE = DISABLE;
	
	SPIx_SPICR1_MSPA_Set(SPIx, init_para.MSPA);
	SPIx_SPICR1_WAIT_Set(SPIx, init_para.WAIT);
	SPIx_SPICR1_BAUD_Set(SPIx, init_para.BAUD_RATE);
	SPIx_SPICR1_LSBF_Set(SPIx, init_para.LSBF);
	SPIx_SPICR1_CPHOL_Set(SPIx, init_para.CPHOL);
	SPIx_SPICR1_CPHA_Set(SPIx, init_para.CPHA);
	SPIx_SPICR2_SSNM_Set(SPIx, init_para.SSNM);
	SPIx_SPICR2_TXO_Setable(SPIx, init_para.TXO);
	SPIx_SPICR2_TXO_AC_Set(SPIx, init_para.TXO_AC);
	SPIx_SPICR2_SSNSEN_Set(SPIx, init_para.SSNSEN);

	SPIx_SPICR1_MM_Set(SPIx, SPIx_SPICR1_MM_MASTER);//óģʽ
}

/********************************
 SPIģʽʼ
:  SPIģʽʼ
룺 SPIģʽĳʼ
********************************/
void SPI_Slave_Init(SPIx_Type* SPIx, SPI_Slave_SInitTypeDef* para)
{
	SPI_Slave_InitTypeDef init_para;

	SPIx_Deinit(SPIx);

	init_para.SSPA = SPIx_SPICR1_SSPA_NORMAL;
	init_para.FLTEN = ENABLE;
	init_para.LSBF = para->LSBF;
	init_para.CPHOL = para->CPHOL;
	init_para.CPHA = para->CPHA;
	init_para.TXO = DISABLE;
	init_para.TXO_AC = SPIx_SPICR2_TXO_AC_CLR_AT_CLOSE;

	init_para.SPIEN = DISABLE;
	init_para.ERRIE = DISABLE;
	init_para.TXIE = DISABLE;
	init_para.RXIE = DISABLE;
	
	SPIx_SPICR1_SSPA_Set(SPIx, init_para.SSPA);
	SPIx_SPICR2_FLTEN_Setable(SPIx, init_para.FLTEN);
	SPIx_SPICR1_LSBF_Set(SPIx, init_para.LSBF);
	SPIx_SPICR1_CPHOL_Set(SPIx, init_para.CPHOL);
	SPIx_SPICR1_CPHA_Set(SPIx, init_para.CPHA);
	SPIx_SPICR2_TXO_Setable(SPIx, init_para.TXO);
	SPIx_SPICR2_TXO_AC_Set(SPIx, init_para.TXO_AC);

	SPIx_SPICR1_MM_Set(SPIx, SPIx_SPICR1_MM_SLAVE);//óɴģʽ
}


/********************************
 SPISSNõƽ͵ĺ
********************************/
void SPI_SSN_Set_Low(SPIx_Type* SPIx)//
{
	SPIx_SPICR2_SSN_Set(SPIx, SPIx_SPICR2_SSN_LOW);//SSNź
}
/********************************
 SPISSNõƽߵĺ
********************************/
void SPI_SSN_Set_High(SPIx_Type* SPIx)//
{
	SPIx_SPICR2_SSN_Set(SPIx, SPIx_SPICR2_SSN_HIGH);//SSNź
}
/********************************
 SPIһֽڵĺ
ܣSPIһֽ
SPIֽ
********************************/
uint8_t SPI_Recv_Byte(SPIx_Type* SPIx)//SPIһֽ
{
	return SPIx_SPIRXBUF_Read(SPIx);
}
/********************************
 SPIһֽڵĺ
ܣSPIһֽ
룺SPIҪ͵ֽ
********************************/
void SPI_Send_Byte(SPIx_Type* SPIx, uint8_t data)//SPIһֽ
{
	SPIx_SPITXBUF_Write(SPIx, data);
}
/********************************
 SPIͲһֽڵĺ
ܣSPIͺͽһֽ
룺SPIҪ͵ֽڣSPIֽ
********************************/
uint8_t SPI_RW_Byte(SPIx_Type* SPIx, uint8_t data)//SPIͲһֽ
{
  unsigned char rx_data;
	uint32_t Temp32;
	uint32_t i;
	
	Temp32 = SPIx_SPICR1_BAUD_Get(SPIx);
	Temp32 = Temp32>>SPIx_SPICR1_BAUD_Pos;
	Temp32 = 0x1U<<(Temp32+1);
	Temp32 = Temp32*8;
	
    for(i=0; i<Temp32; i++)
    {
    	if (SPIx_SPIIF_TXBE_Chk(SPIx) == SET)
		{
			break;
		}		
    }
    SPI_Send_Byte(SPIx, data);

    for(i=0; i<Temp32; i++)
    {
    	if (SPIx_SPIIF_RXBF_Chk(SPIx) == SET)
        {
            break;
        }
    }
    rx_data = SPI_Recv_Byte(SPIx);
    return rx_data;
}

//Code_End

/******END OF FILE****/

