/**
  ******************************************************************************
  * @file    fm33g0xx_u7816.c
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of....:
  *
*/
/* Includes ------------------------------------------------------------------*/

#include "FM33g0XX_u7816.h" 



/*******************************************
U7816x_U7816CTRL_TXEN_Setable
ܣ U7816ͨʹܿ
U7816xU78160U78161
          NewState:ENABLEDISABLE

*******************************************/
void U7816x_U7816CTRL_TXEN_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816CTRL |= (U7816x_U7816CTRL_TXEN_Msk);
	}
	else
	{
		U7816x->U7816CTRL &= ~(U7816x_U7816CTRL_TXEN_Msk);
	}
}

/*******************************************
U7816x_U7816CTRL_TXEN_Getable
ܣ ȡU7816ͨʹܿ״̬
U7816xU78160U78161
ENABLEDISABLE
*******************************************/
FunState U7816x_U7816CTRL_TXEN_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816CTRL & (U7816x_U7816CTRL_TXEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*******************************************
U7816x_U7816CTRL_RXEN_Setable
ܣ U7816ͨʹܿ
U7816xU78160U78161
          NewState:ENABLEDISABLE

*******************************************/
void U7816x_U7816CTRL_RXEN_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816CTRL |= (U7816x_U7816CTRL_RXEN_Msk);
	}
	else
	{
		U7816x->U7816CTRL &= ~(U7816x_U7816CTRL_RXEN_Msk);
	}
}

/*******************************************
U7816x_U7816CTRL_RXEN_Getable
ܣ ȡU7816ͨʹܿ״̬
U7816xU78160U78161
ENABLEDISABLE
*******************************************/
FunState U7816x_U7816CTRL_RXEN_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816CTRL & (U7816x_U7816CTRL_RXEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*******************************************
U7816x_U7816CTRL_CKOEN_Setable
ܣ U7816ʱCLKʹܿ 
U7816xU78160U78161
          NewState:ENABLEDISABLE

*******************************************/
void U7816x_U7816CTRL_CKOEN_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816CTRL |= (U7816x_U7816CTRL_CKOEN_Msk);
	}
	else
	{
		U7816x->U7816CTRL &= ~(U7816x_U7816CTRL_CKOEN_Msk);
	}
}

/*******************************************
U7816x_U7816CTRL_CKOEN_Getable
ܣ ȡU7816ʱCLKʹܿ״̬
U7816xU78160U78161
ENABLEDISABLE
*******************************************/
FunState U7816x_U7816CTRL_CKOEN_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816CTRL & (U7816x_U7816CTRL_CKOEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/*******************************************
U7816x_U7816CTRL_HPUAT_Setable
ܣ U7816ͨݷǿԶЧ  
U7816xU78160U78161
          NewState:ENABLEDISABLE

*******************************************/
void U7816x_U7816CTRL_HPUAT_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816CTRL |= (U7816x_U7816CTRL_HPUAT_Msk);
	}
	else
	{
		U7816x->U7816CTRL &= ~(U7816x_U7816CTRL_HPUAT_Msk);
	}
}

/*******************************************
U7816x_U7816CTRL_HPUAT_Getable
ܣ ȡU7816ͨݷǿԶЧ״̬  
U7816xU78160U78161
ENABLEDISABLE
*******************************************/
FunState U7816x_U7816CTRL_HPUAT_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816CTRL & (U7816x_U7816CTRL_HPUAT_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*******************************************
U7816x_U7816CTRL_HPUEN_Setable
ܣU7816ͨǿʹܿ 
U7816xU78160U78161
          NewState:ENABLEDISABLE

*******************************************/
void U7816x_U7816CTRL_HPUEN_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816CTRL |= (U7816x_U7816CTRL_HPUEN_Msk);
	}
	else
	{
		U7816x->U7816CTRL &= ~(U7816x_U7816CTRL_HPUEN_Msk);
	}
}

/*******************************************
U7816x_U7816CTRL_HPUEN_Getable
ܣȡU7816ͨǿʹܿ״̬ 
U7816xU78160U78161
ENABLEDISABLE
*******************************************/
FunState U7816x_U7816CTRL_HPUEN_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816CTRL & (U7816x_U7816CTRL_HPUEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*******************************************
U7816x_U7816FRC_ERSW_Set
:ERROR SIGNALѡ
U7816xU78160U78161
          SetValueU7816x_U7816FRC_ERSW_1ETUU7816x_U7816FRC_ERSW_1P5ETUU7816x_U7816FRC_ERSW_2ETU

*******************************************/
void U7816x_U7816FRC_ERSW_Set(U7816x_Type* U7816x, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = U7816x->U7816FRC;
	tmpreg &= ~(U7816x_U7816FRC_ERSW_Msk);
	tmpreg |= (SetValue & U7816x_U7816FRC_ERSW_Msk);
	U7816x->U7816FRC = tmpreg;
}

/*******************************************
U7816x_U7816FRC_ERSW_Get
: ȡERROR SIGNALѡ
U7816xU78160U78161
U7816x_U7816FRC_ERSW_1ETUU7816x_U7816FRC_ERSW_1P5ETUU7816x_U7816FRC_ERSW_2ETU
*******************************************/
uint32_t U7816x_U7816FRC_ERSW_Get(U7816x_Type* U7816x)
{
	return (U7816x->U7816FRC & U7816x_U7816FRC_ERSW_Msk);
}


/*******************************************
U7816x_U7816FRC_ERSGD_Set
: ERROR SIGNALGUARDTIMEѡ񣨽ڷʱЧ 
U7816xU78160U78161
          SetValueUU7816x_U7816FRC_ERSGD_1PETUU7816x_U7816FRC_ERSGD_2PETU
:
*******************************************/
void U7816x_U7816FRC_ERSGD_Set(U7816x_Type* U7816x, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = U7816x->U7816FRC;
	tmpreg &= ~(U7816x_U7816FRC_ERSGD_Msk);
	tmpreg |= (SetValue & U7816x_U7816FRC_ERSGD_Msk);
	U7816x->U7816FRC = tmpreg;
}

/*******************************************
U7816x_U7816FRC_ERSGD_Get
: ȡERROR SIGNALGUARDTIMEѡ 
U7816xU78160U78161
:U7816x_U7816FRC_ERSGD_1PETUU7816x_U7816FRC_ERSGD_2PETU
*******************************************/
uint32_t U7816x_U7816FRC_ERSGD_Get(U7816x_Type* U7816x)
{
	return (U7816x->U7816FRC & U7816x_U7816FRC_ERSGD_Msk);
}

/*******************************************
U7816x_U7816FRC_BGTEN_Setable
:BGTblock guard time
U7816xU78160U78161
          NewStateENABLEDISABLE
:
*******************************************/
void U7816x_U7816FRC_BGTEN_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816FRC |= (U7816x_U7816FRC_BGTEN_Msk);
	}
	else
	{
		U7816x->U7816FRC &= ~(U7816x_U7816FRC_BGTEN_Msk);
	}
}

/*******************************************
U7816x_U7816FRC_BGTEN_Getable
:ȡBGTblock guard time
U7816xU78160U78161
:ENABLEDISABLE
*******************************************/
FunState U7816x_U7816FRC_BGTEN_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816FRC & (U7816x_U7816FRC_BGTEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*******************************************
U7816x_U7816FRC_REP_T_Set
:ƽżУʱԶط 
U7816xU78160U78161
          SetValue:U7816x_U7816FRC_REP_T_1TIMEU7816x_U7816FRC_REP_T_3TIME
:
*******************************************/
void U7816x_U7816FRC_REP_T_Set(U7816x_Type* U7816x, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = U7816x->U7816FRC;
	tmpreg &= ~(U7816x_U7816FRC_REP_T_Msk);
	tmpreg |= (SetValue & U7816x_U7816FRC_REP_T_Msk);
	U7816x->U7816FRC = tmpreg;
}

/*******************************************
U7816x_U7816FRC_REP_T_Get
:ȡżУʱԶط 
U7816xU78160U78161
:U7816x_U7816FRC_REP_T_1TIMEU7816x_U7816FRC_REP_T_3TIME
*******************************************/
uint32_t U7816x_U7816FRC_REP_T_Get(U7816x_Type* U7816x)
{
	return (U7816x->U7816FRC & U7816x_U7816FRC_REP_T_Msk);
}


/*******************************************
U7816x_U7816FRC_PAR_Set
:żУѡ 
U7816xU78160U78161
          SetValue:U7816x_U7816FRC_PAR_EVENU7816x_U7816FRC_PAR_ODDUU7816x_U7816FRC_PAR_ALWAYS1UU7816x_U7816FRC_PAR_NONE
:
*******************************************/
void U7816x_U7816FRC_PAR_Set(U7816x_Type* U7816x, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = U7816x->U7816FRC;
	tmpreg &= ~(U7816x_U7816FRC_PAR_Msk);
	tmpreg |= (SetValue & U7816x_U7816FRC_PAR_Msk);
	U7816x->U7816FRC = tmpreg;
}

/*******************************************
U7816x_U7816FRC_PAR_Get
:ȡżУѡ 
U7816xU78160U78161
:U7816x_U7816FRC_PAR_EVENU7816x_U7816FRC_PAR_ODDUU7816x_U7816FRC_PAR_ALWAYS1UU7816x_U7816FRC_PAR_NONE
*******************************************/
uint32_t U7816x_U7816FRC_PAR_Get(U7816x_Type* U7816x)
{
	return (U7816x->U7816FRC & U7816x_U7816FRC_PAR_Msk);
}

/*******************************************
U7816x_U7816FRC_FREN_Setable
:Guard TimeȿλʱϸЭ2etu
U7816xU78160U78161
          NewStateENABLEDISABLE
:
*******************************************/
void U7816x_U7816FRC_FREN_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816FRC |= (U7816x_U7816FRC_FREN_Msk);
	}
	else
	{
		U7816x->U7816FRC &= ~(U7816x_U7816FRC_FREN_Msk);
	}
}

/*******************************************
U7816x_U7816FRC_FREN_Getable
:ȡGuard Timeȿλ
U7816xU78160U78161
:ENABLEDISABLE
*******************************************/
FunState U7816x_U7816FRC_FREN_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816FRC & (U7816x_U7816FRC_FREN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*******************************************
U7816x_U7816FRC_TREPEN_Setable
:żУĴʽѡ 
U7816xU78160U78161
          NewStateENABLEDISABLE
:
*******************************************/
void U7816x_U7816FRC_TREPEN_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816FRC |= (U7816x_U7816FRC_TREPEN_Msk);
	}
	else
	{
		U7816x->U7816FRC &= ~(U7816x_U7816FRC_TREPEN_Msk);
	}
}
/*******************************************
U7816x_U7816FRC_TREPEN_Getable
:ȡżУĴʽѡ 
U7816xU78160U78161
:ENABLEDISABLE
*******************************************/
FunState U7816x_U7816FRC_TREPEN_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816FRC & (U7816x_U7816FRC_TREPEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*******************************************
U7816x_U7816FRC_RREPEN_Setable
:żУĴʽѡ 
U7816xU78160U78161
          NewStateENABLEDISABLE
:
*******************************************/
void U7816x_U7816FRC_RREPEN_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816FRC |= (U7816x_U7816FRC_RREPEN_Msk);
	}
	else
	{
		U7816x->U7816FRC &= ~(U7816x_U7816FRC_RREPEN_Msk);
	}
}

/*******************************************
U7816x_U7816FRC_RREPEN_Getable
:ȡżУĴʽѡ 
U7816xU78160U78161
:ENABLEDISABLE
*******************************************/
FunState U7816x_U7816FRC_RREPEN_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816FRC & (U7816x_U7816FRC_RREPEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*******************************************
U7816x_U7816FRC_DICONV_Setable
:ʹ 
U7816xU78160U78161
          NewStateENABLEDISABLE
:
*******************************************/
void U7816x_U7816FRC_DICONV_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816FRC |= (U7816x_U7816FRC_DICONV_Msk);
	}
	else
	{
		U7816x->U7816FRC &= ~(U7816x_U7816FRC_DICONV_Msk);
	}
}

/*******************************************
U7816x_U7816FRC_DICONV_Getable
:ȡ״̬ 
U7816xU78160U78161
:ENABLEDISABLE
*******************************************/
FunState U7816x_U7816FRC_DICONV_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816FRC & (U7816x_U7816FRC_DICONV_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*******************************************
U7816x_U7816EGT_Write
:ʱEGTʱ䣨ETUΪλ 
U7816xU78160U78161
          SetValueʱ
:
*******************************************/
void U7816x_U7816EGT_Write(U7816x_Type* U7816x, uint32_t SetValue)
{
	U7816x->U7816EGT = (SetValue & U7816x_U7816EGT_TXEGT_Msk);
}

/*******************************************
U7816x_U7816EGT_Read
:ȡʱEGTʱ
U7816xU78160U78161
:EGTĴֵ
*******************************************/
uint32_t U7816x_U7816EGT_Read(U7816x_Type* U7816x)
{
	return (U7816x->U7816EGT & U7816x_U7816EGT_TXEGT_Msk);
}

/*******************************************
U7816x_U7816CLKDIV_Write
:U7816ʱƵƼĴ
U7816xU78160U78161
          SetValueƵֵ
:
*******************************************/
void U7816x_U7816CLKDIV_Write(U7816x_Type* U7816x, uint32_t SetValue)
{
	U7816x->U7816CLKDIV = (SetValue & U7816x_U7816CLKDIV_CLKDIV_Msk);
}

/*******************************************
U7816x_U7816CLKDIV_Read
:ȡU7816ʱƵƼĴֵ
U7816xU78160U78161
:CLKDIVĴֵ
*******************************************/
uint32_t U7816x_U7816CLKDIV_Read(U7816x_Type* U7816x)
{
	return (U7816x->U7816CLKDIV & U7816x_U7816CLKDIV_CLKDIV_Msk);
}

/*******************************************
U7816x_U7816PDIV_Write
:U7816ԤƵƼĴ7816ͨŷƵȣʣ
U7816xU78160U78161
SetValue:ԤƵֵ
:
*******************************************/
void U7816x_U7816PDIV_Write(U7816x_Type* U7816x, uint32_t SetValue)
{
	U7816x->U7816PDIV = (SetValue & U7816x_U7816PDIV_PDIV_Msk);
}

/*******************************************
U7816x_U7816PDIV_Read
:ȡU7816ԤƵƼĴֵ
U7816xU78160U78161
:PDIVĴֵ
*******************************************/
uint32_t U7816x_U7816PDIV_Read(U7816x_Type* U7816x)
{
	return (U7816x->U7816PDIV & U7816x_U7816PDIV_PDIV_Msk);
}

/*******************************************
U7816x_U7816RXBUF_Read
:U7816ݽջĴ
U7816xU78160U78161
:ֵ
*******************************************/
uint32_t U7816x_U7816RXBUF_Read(U7816x_Type* U7816x)
{
	return (U7816x->U7816RXBUF & U7816x_U7816RXBUF_RXBUF_Msk);
}

/*******************************************
U7816x_U7816TXBUF_Write
:U7816ݷ
U7816xU78160U78161
          SetValue
:
*******************************************/
void U7816x_U7816TXBUF_Write(U7816x_Type* U7816x, uint32_t SetValue)
{
	U7816x->U7816TXBUF = (SetValue & U7816x_U7816TXBUF_TXBUF_Msk);
}

/*******************************************
U7816x_U7816IE_RXIE_Setable
:ݽжʹλӦRX_FLAGжϱ־λ 
U7816xU78160U78161
          NewStateENABLEDISABLE
:
*******************************************/
void U7816x_U7816IE_RXIE_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816IE |= (U7816x_U7816IE_RXIE_Msk);
	}
	else
	{
		U7816x->U7816IE &= ~(U7816x_U7816IE_RXIE_Msk);
	}
}

/*******************************************
U7816x_U7816IE_RXIE_Getable
:ȡݽжʹλ״̬
U7816xU78160U78161         
:ENABLEDISABLE
*******************************************/
FunState U7816x_U7816IE_RXIE_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816IE & (U7816x_U7816IE_RXIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*******************************************
U7816x_U7816IE_TXIE_Setable
:ݷжʹλӦTX_FLAGжϱ־λ
U7816xU78160U78161
          NewStateENABLEDISABLE
:
*******************************************/
void U7816x_U7816IE_TXIE_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816IE |= (U7816x_U7816IE_TXIE_Msk);
	}
	else
	{
		U7816x->U7816IE &= ~(U7816x_U7816IE_TXIE_Msk);
	}
}
/*******************************************
U7816x_U7816IE_TXIE_Getable
:ȡݷжʹλ
U7816xU78160U78161        
:ENABLEDISABLE
*******************************************/
FunState U7816x_U7816IE_TXIE_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816IE & (U7816x_U7816IE_TXIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*******************************************
U7816x_U7816IE_LSIE_Setable
:·״̬жʹλӦERROR_FLAGжϱ־λ
U7816xU78160U78161
          NewStateENABLEDISABLE
:
*******************************************/
void U7816x_U7816IE_LSIE_Setable(U7816x_Type* U7816x, FunState NewState)
{
	if (NewState == ENABLE)
	{
		U7816x->U7816IE |= (U7816x_U7816IE_LSIE_Msk);
	}
	else
	{
		U7816x->U7816IE &= ~(U7816x_U7816IE_LSIE_Msk);
	}
}
/*******************************************
U7816x_U7816IE_LSIE_Getable
:ȡ·״̬жʹλ
U7816xU78160U78161        
:ENABLEDISABLE
*******************************************/
FunState U7816x_U7816IE_LSIE_Getable(U7816x_Type* U7816x)
{
	if (U7816x->U7816IE & (U7816x_U7816IE_LSIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/*******************************************
U7816x_U7816IF_ERRIF_Chk
:ȡжϱ־
U7816xU78160U78161
:SETRESET
*******************************************/
FlagStatus U7816x_U7816IF_ERRIF_Chk(U7816x_Type* U7816x)
{
	if (U7816x->U7816IF & U7816x_U7816IF_ERRIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*******************************************
U7816x_U7816IF_TXIF_Chk
:ѯͻձ־ 
U7816xU78160U78161
:SETRESET
*******************************************/
FlagStatus U7816x_U7816IF_TXIF_Chk(U7816x_Type* U7816x)
{
	if (U7816x->U7816IF & U7816x_U7816IF_TXIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*******************************************
U7816x_U7816IF_RXIF_Chk
:ѯɱ־
U7816xU78160U78161
:SETRESET
*******************************************/
FlagStatus U7816x_U7816IF_RXIF_Chk(U7816x_Type* U7816x)
{
	if (U7816x->U7816IF & U7816x_U7816IF_RXIF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*******************************************
U7816x_U7816ERR_TPARERR_Clr
:żУ־λ
U7816xU78160U78161
: 
*******************************************/
void U7816x_U7816ERR_TPARERR_Clr(U7816x_Type* U7816x)
{
	U7816x->U7816ERR = U7816x_U7816ERR_TPARERR_Msk;
}

/*******************************************
U7816x_U7816ERR_TPARERR_Chk
:ѯżУ־λ
U7816xU78160U78161
: SETRESET 
*******************************************/
FlagStatus U7816x_U7816ERR_TPARERR_Chk(U7816x_Type* U7816x)
{
	if (U7816x->U7816ERR & U7816x_U7816ERR_TPARERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*******************************************
U7816x_U7816ERR_RPARERR_Clr
:żУ־λ
U7816xU78160U78161
: 
*******************************************/
void U7816x_U7816ERR_RPARERR_Clr(U7816x_Type* U7816x)
{
	U7816x->U7816ERR = U7816x_U7816ERR_RPARERR_Msk;
}

/*******************************************
U7816x_U7816ERR_RPARERR_Chk
:ѯżУ־λ
U7816xU78160U78161
: SETRESET 
*******************************************/
FlagStatus U7816x_U7816ERR_RPARERR_Chk(U7816x_Type* U7816x)
{
	if (U7816x->U7816ERR & U7816x_U7816ERR_RPARERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*******************************************
U7816x_U7816ERR_FRERR_Clr
:֡ʽ־λ
U7816xU78160U78161
: 
*******************************************/
void U7816x_U7816ERR_FRERR_Clr(U7816x_Type* U7816x)
{
	U7816x->U7816ERR = U7816x_U7816ERR_FRERR_Msk;
}
/*******************************************
U7816x_U7816ERR_FRERR_Chk
:ѯ֡ʽ־λ
U7816xU78160U78161
: SETRESET 
*******************************************/
FlagStatus U7816x_U7816ERR_FRERR_Chk(U7816x_Type* U7816x)
{
	if (U7816x->U7816ERR & U7816x_U7816ERR_FRERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*******************************************
U7816x_U7816ERR_OVERR_Clr
:־λ
U7816xU78160U78161
: 
*******************************************/
void U7816x_U7816ERR_OVERR_Clr(U7816x_Type* U7816x)
{
	U7816x->U7816ERR = U7816x_U7816ERR_OVERR_Msk;
}
/*******************************************
U7816x_U7816ERR_OVERR_Chk
:ѯ־λ
U7816xU78160U78161
: SETRESET 
*******************************************/
FlagStatus U7816x_U7816ERR_OVERR_Chk(U7816x_Type* U7816x)
{
	if (U7816x->U7816ERR & U7816x_U7816ERR_OVERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}


/*******************************************
U7816x_U7816STA_WAIT_RPT_Chk
: U7816ӿڷ˴źţڵȴԷط.״̬뷢ʹź״̬ʱλȡ״̬λ
U7816xU78160U78161
: SET RESET
*******************************************/
FlagStatus U7816x_U7816STA_WAIT_RPT_Chk(U7816x_Type* U7816x)
{
	if (U7816x->U7816STA & U7816x_U7816STA_WAIT_RPT_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*******************************************
U7816x_U7816STA_TXBUSY_Chk
: ȡæ־
U7816xU78160U78161
: SET RESET
*******************************************/
FlagStatus U7816x_U7816STA_TXBUSY_Chk(U7816x_Type* U7816x)
{
	if (U7816x->U7816STA & U7816x_U7816STA_TXBUSY_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*******************************************
U7816x_U7816STA_RXBUSY_Chk
: ȡæ־
U7816xU78160U78161
: SET RESET
*******************************************/
FlagStatus U7816x_U7816STA_RXBUSY_Chk(U7816x_Type* U7816x)
{
	if (U7816x->U7816STA & U7816x_U7816STA_RXBUSY_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/*******************************************
U7816x_Deinit
: U7816ģĴָλֵ
U7816xU78160U78161
: 
*******************************************/
void U7816x_Deinit(U7816x_Type* U7816x)
{
	U7816x->U7816CTRL = 0x00000000;
	U7816x->U7816FRC = 0x00000006;
	U7816x->U7816EGT = 0x00000000;
	U7816x->U7816CLKDIV = 0x00000003;
	U7816x->U7816PDIV = 0x00000173;
	//U7816x->U7816RXBUF = ;
	//U7816x->U7816TXBUF = ;
	U7816x->U7816IE = 0x00000000;
	//U7816x->U7816IF = 0x00000002;
	//U7816x->U7816ERR = 0x00000000;
	//U7816x->U7816STA = 0x00000000;
}
//Code_End


/* U7816ʼ */
/*******************************************
U7816_Init
: U7816ʼ
U7816xU78160U78161
          paraU7816_InitTypeDef
: 
*******************************************/
void U7816_Init(U7816x_Type* U7816x, U7816_InitTypeDef* para)
{
	U7816x_U7816CTRL_TXEN_Setable(U7816x, para->TXEN);		//ʹ
	U7816x_U7816CTRL_RXEN_Setable(U7816x, para->RXEN);		//ʹ
	U7816x_U7816CTRL_CKOEN_Setable(U7816x, para->CKOEN);		//U7816ʱCLKʹܿ
	U7816x_U7816CTRL_HPUAT_Setable(U7816x, para->HPUAT);		//U7816ͨݷǿԶЧ
	U7816x_U7816CTRL_HPUEN_Setable(U7816x, para->HPUEN);		//U7816ͨǿʹܿ
	
	U7816x_U7816FRC_ERSW_Set(U7816x, para->ERSW);		//ERROR SIGNALѡ
	U7816x_U7816FRC_ERSGD_Set(U7816x, para->ERSGD);		//ERROR SIGNALGUARDTIMEѡ񣨽ڷʱЧ
	U7816x_U7816FRC_BGTEN_Setable(U7816x, para->BGTEN);		//BGTblock guard time
	U7816x_U7816FRC_REP_T_Set(U7816x, para->REP_T);		//ƽżУʱԶط
	U7816x_U7816FRC_PAR_Set(U7816x, para->PAR);		//żУѡ
	U7816x_U7816FRC_FREN_Setable(U7816x, para->FREN);		//Guard TimeȿλʱϸЭ2etu
	U7816x_U7816FRC_TREPEN_Setable(U7816x, para->TREPEN);		//żУĴʽѡ
	U7816x_U7816FRC_RREPEN_Setable(U7816x, para->RREPEN);		//żУĴʽѡ
	U7816x_U7816FRC_DICONV_Setable(U7816x, para->DICONV);		//ʹ
	
	U7816x_U7816EGT_Write(U7816x, para->TXEGT);		//ʱEGTʱ䣨ETUΪλ
	U7816x_U7816CLKDIV_Write(U7816x, para->CLKDIV);		//U7816ʱƵƼĴ
	U7816x_U7816PDIV_Write(U7816x, para->PDIV);		//U7816ԤƵƼĴ7816ͨŷƵȣʣ
	
	U7816x_U7816IE_RXIE_Setable(U7816x, para->RXIE);		//ݽжʹλӦRX_FLAGжϱ־λ
	U7816x_U7816IE_TXIE_Setable(U7816x, para->TXIE);		//ݷжʹλӦTX_FLAGжϱ־λ
	U7816x_U7816IE_LSIE_Setable(U7816x, para->LSIE);		//·״̬жʹλӦERROR_FLAGжϱ־λ
}

/******END OF FILE****/
