/**
  ******************************************************************************
  * @file    fm33g0xx_uart.c
  * @author  FM33g0xx Application Team
  * @version V0.3.00G
  * @date    08-31-2018
  * @brief   This file provides firmware functions to manage the following 
  *          functionalities of the Universal synchronous asynchronous receiver
  *          transmitter (UART):           
  *           
  ******************************************************************************  
  */ 

/* Includes ------------------------------------------------------------------*/
#include "fm33g0xx_uart.h" 
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/




/********************************
Ʒݼѡ
:Ʒݼѡ
:ƺƷʱļѡ
********************************/
void UART_IRCON_IRFLAG_Setable(FunState NewState)
{
	if (NewState == ENABLE)
	{
		UART->IRCON |= (UART_IRCON_IRFLAG_Msk);
	}
	else
	{
		UART->IRCON &= ~(UART_IRCON_IRFLAG_Msk);
	}
}
/********************************
ȡƷݼѡ
:ȡƷݼѡ
:ƺƷʱļѡ
********************************/
FunState UART_IRCON_IRFLAG_Getable(void)
{
	if (UART->IRCON & (UART_IRCON_IRFLAG_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/********************************
ռձȵƲú
:ռձȵƲ
:ռձȵƲ
********************************/
void UART_IRCON_TH_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = UART->IRCON;
	tmpreg &= ~(UART_IRCON_TH_Msk);
	tmpreg |= (SetValue & UART_IRCON_TH_Msk);
	UART->IRCON = tmpreg;
}
/********************************
ȡռձȵƲ
:ȡռձȵƲ
:ռձȵƲ
********************************/
uint32_t UART_IRCON_TH_Get(void)
{
	return (UART->IRCON & UART_IRCON_TH_Msk);
}

/********************************
Ƶú
:Ƶʵ
:Ƶ
********************************/
void UART_IRCON_TZBRG_Set(uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = UART->IRCON;
	tmpreg &= ~(UART_IRCON_TZBRG_Msk);
	tmpreg |= (SetValue & UART_IRCON_TZBRG_Msk);
	UART->IRCON = tmpreg;
}

/********************************
ȡƵú
:ȡƵʵ
:Ƶ
********************************/
uint32_t UART_IRCON_TZBRG_Get(void)
{
	return (UART->IRCON & UART_IRCON_TZBRG_Msk);
}

/********************************
ģʽѡλú
:ģʽѡλ
:ģʽѡλ
00 = 8λݣżУ飻
01 = 8λݣżУ飻
10 = 8λݣУ顣
11 = 9λݣ żУ飻
********************************/
void UARTx_RXSTA_PDSEL_Set(UARTx_Type* UARTx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = UARTx->RXSTA;
	tmpreg &= ~(UARTx_RXSTA_PDSEL_Msk);
	tmpreg |= (SetValue & UARTx_RXSTA_PDSEL_Msk);
	UARTx->RXSTA = tmpreg;
}

/********************************
ȡģʽѡλú
:ȡģʽѡλ
:ģʽѡλ
00 = 8λݣżУ飻
01 = 8λݣżУ飻
10 = 8λݣУ顣
11 = 9λݣ żУ飻
********************************/
uint32_t UARTx_RXSTA_PDSEL_Get(UARTx_Type* UARTx)
{
	return (UARTx->RXSTA & UARTx_RXSTA_PDSEL_Msk);
}

/********************************
жλú
:жλ
:жλ
żУ֡ʽ
********************************/
void UARTx_RXSTA_ERRIE_Setable(UARTx_Type* UARTx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		UARTx->RXSTA |= (UARTx_RXSTA_ERRIE_Msk);
	}
	else
	{
		UARTx->RXSTA &= ~(UARTx_RXSTA_ERRIE_Msk);
	}
}
/********************************
ȡжλú
:ȡжλ
:жλ
żУ֡ʽ
********************************/
FunState UARTx_RXSTA_ERRIE_Getable(UARTx_Type* UARTx)
{
	if (UARTx->RXSTA & (UARTx_RXSTA_ERRIE_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}
/********************************
ģʹλú
:ģʹλ
:ģʹλ
1 = ʹܽģ飻
0 = ֹģ飬ģ鱻λ
********************************/
void UARTx_RXSTA_RXEN_Setable(UARTx_Type* UARTx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		UARTx->RXSTA |= (UARTx_RXSTA_RXEN_Msk);
	}
	else
	{
		UARTx->RXSTA &= ~(UARTx_RXSTA_RXEN_Msk);
	}
}

/********************************
ȡģʹλú
:ȡģʹλ
:ģʹλ
1 = ʹܽģ飻
0 = ֹģ飬ģ鱻λ
********************************/
FunState UARTx_RXSTA_RXEN_Getable(UARTx_Type* UARTx)
{
	if (UARTx->RXSTA & (UARTx_RXSTA_RXEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
żУ־λú
:żУ־λ
:żУ־λ
1 = У
0 = У
********************************/
void UARTx_RXSTA_PERR_Clr(UARTx_Type* UARTx)
{
	UARTx->RXSTA &= ~(UARTx_RXSTA_PERR_Msk);
}

/********************************
ȡżУ־λú
:ȡżУ־λ
:żУ־λ
1 = У
0 = У
********************************/
FlagStatus UARTx_RXSTA_PERR_Chk(UARTx_Type* UARTx)
{
	if (UARTx->RXSTA & UARTx_RXSTA_PERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
֡ʽ־λú
:֡ʽ־λ
:֡ʽ־λ
1 = ֡ʽ
0 = ֡ʽ
********************************/
void UARTx_RXSTA_FERR_Clr(UARTx_Type* UARTx)
{
	UARTx->RXSTA &= ~(UARTx_RXSTA_FERR_Msk);
}
/********************************
ȡ֡ʽ־λú
:ȡ֡ʽ־λ
:֡ʽ־λ
1 = ֡ʽ
0 = ֡ʽ
********************************/
FlagStatus UARTx_RXSTA_FERR_Chk(UARTx_Type* UARTx)
{
	if (UARTx->RXSTA & UARTx_RXSTA_FERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}
/********************************
־λú
:־λ
:־λ
1 = 
0 = 
********************************/
void UARTx_RXSTA_OERR_Clr(UARTx_Type* UARTx)
{
	UARTx->RXSTA &= ~(UARTx_RXSTA_OERR_Msk);
}
/********************************
ȡ־λú
:ȡ־λ
:־λ
1 = 
0 = 
********************************/
FlagStatus UARTx_RXSTA_OERR_Chk(UARTx_Type* UARTx)
{
	if (UARTx->RXSTA & UARTx_RXSTA_OERR_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
ȡݵĵ9λ
:ȡݵĵ9λ
:ݵĵ9λ
********************************/
FlagStatus UARTx_RXSTA_RX9D_Chk(UARTx_Type* UARTx)
{
	if (UARTx->RXSTA & UARTx_RXSTA_RX9D_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
ֹͣλѡλú
:ֹͣλѡλ
:ֹͣλѡλ
1 = ֹͣλΪ2λ
0 = ֹͣλΪ1λ
********************************/
void UARTx_TXSTA_STOPSEL_Set(UARTx_Type* UARTx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = UARTx->TXSTA;
	tmpreg &= ~(UARTx_TXSTA_STOPSEL_Msk);
	tmpreg |= (SetValue & UARTx_TXSTA_STOPSEL_Msk);
	UARTx->TXSTA = tmpreg;
}
/********************************
ȡֹͣλѡλú
:ȡֹͣλѡλ
:ֹͣλѡλ
1 = ֹͣλΪ2λ
0 = ֹͣλΪ1λ
********************************/
uint32_t UARTx_TXSTA_STOPSEL_Get(UARTx_Type* UARTx)
{
	return (UARTx->TXSTA & UARTx_TXSTA_STOPSEL_Msk);
}

/********************************
жѡλú
:жѡλ
:жѡλ
1 = λĴղжϣ
0 = ͻղжϡ
********************************/
void UARTx_TXSTA_TXIS_Set(UARTx_Type* UARTx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = UARTx->TXSTA;
	tmpreg &= ~(UARTx_TXSTA_TXIS_Msk);
	tmpreg |= (SetValue & UARTx_TXSTA_TXIS_Msk);
	UARTx->TXSTA = tmpreg;
}
/********************************
ȡжѡλú
:ȡжѡλ
:жѡλ
1 = λĴղжϣ
0 = ͻղжϡ
********************************/
uint32_t UARTx_TXSTA_TXIS_Get(UARTx_Type* UARTx)
{
	return (UARTx->TXSTA & UARTx_TXSTA_TXIS_Msk);
}

/********************************
ģʹλú
:ģʹλ
:ģʹλ
1 = ʹܷģ飻
0 = ֹģ飬ģ鱻λ
********************************/
void UARTx_TXSTA_TXEN_Setable(UARTx_Type* UARTx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		UARTx->TXSTA |= (UARTx_TXSTA_TXEN_Msk);
	}
	else
	{
		UARTx->TXSTA &= ~(UARTx_TXSTA_TXEN_Msk);
	}
}
/********************************
ȡģʹλú
:ȡģʹλ
:ģʹλ
1 = ʹܷģ飻
0 = ֹģ飬ģ鱻λ
********************************/
FunState UARTx_TXSTA_TXEN_Getable(UARTx_Type* UARTx)
{
	if (UARTx->TXSTA & (UARTx_TXSTA_TXEN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
ͺʹλú
:ͺʹλ
:ͺʹλ
1 = ʹܷͺƣ
0 = ֹͺơ
********************************/
void UARTx_TXSTA_IREN_Setable(UARTx_Type* UARTx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		UARTx->TXSTA |= (UARTx_TXSTA_IREN_Msk);
	}
	else
	{
		UARTx->TXSTA &= ~(UARTx_TXSTA_IREN_Msk);
	}
}
/********************************
ȡͺʹλú
:ȡͺʹλ
:ͺʹλ
1 = ʹܷͺƣ
0 = ֹͺơ
********************************/
FunState UARTx_TXSTA_IREN_Getable(UARTx_Type* UARTx)
{
	if (UARTx->TXSTA & (UARTx_TXSTA_IREN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/********************************
÷ݵĵ9λ
:÷ݵĵ9λ
:ݵĵ9λ
********************************/
void UARTx_TXSTA_TX9D_Set(UARTx_Type* UARTx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = UARTx->TXSTA;
	tmpreg &= ~(UARTx_TXSTA_TX9D_Msk);
	tmpreg |= (SetValue & UARTx_TXSTA_TX9D_Msk);
	UARTx->TXSTA = tmpreg;
}

/********************************
ȡݻĴ
:ȡݻĴ
:ݻĴֵ
********************************/
uint32_t UARTx_RXREG_Read(UARTx_Type* UARTx)
{
	return (UARTx->RXREG & UARTx_RXREG_RXREG_Msk);
}

/********************************
д뷢ݻĴ
:д뷢ݻĴֵ
:Ҫ͵ֵ
********************************/
void UARTx_TXREG_Write(UARTx_Type* UARTx, uint32_t SetValue)
{
	UARTx->TXREG = (SetValue & UARTx_TXREG_TXREG_Msk);
}

/********************************
д벨ʲĴ
:д벨
:ҪõĲ
********************************/
void UARTx_SPBRG_Write(UARTx_Type* UARTx, uint32_t SetValue)
{
	UARTx->SPBRG = (SetValue & UARTx_SPBRG_SPBRG_Msk);
}
/********************************
ȡʲĴ
:ȡ
:
********************************/
uint32_t UARTx_SPBRG_Read(UARTx_Type* UARTx)
{
	return (UARTx->SPBRG & UARTx_SPBRG_SPBRG_Msk);
}

/********************************
жѡλú
:жѡλ 
:жѡλ 
11 = ж
10 = TXBUFղж
01 = TXBUFλĴղж
00 =TXISжڷͻջλĴʱ
********************************/
void UARTx_TXBUFSTA_TX_INTSEL_Set(UARTx_Type* UARTx, uint32_t SetValue)
{
	uint32_t tmpreg;
	tmpreg = UARTx->TXBUFSTA;
	tmpreg &= ~(UARTx_TXBUFSTA_TX_INTSEL_Msk);
	tmpreg |= (SetValue & UARTx_TXBUFSTA_TX_INTSEL_Msk);
	UARTx->TXBUFSTA = tmpreg;
}
/********************************
ȡжѡλú
:ȡжѡλ
:жѡλ 
11 = ж
10 = TXBUFղж
01 = TXBUFλĴղж
00 =TXISжڷͻջλĴʱ
********************************/
uint32_t UARTx_TXBUFSTA_TX_INTSEL_Get(UARTx_Type* UARTx)
{
	return (UARTx->TXBUFSTA & UARTx_TXBUFSTA_TX_INTSEL_Msk);
}

/********************************
ȡTXBUF״̬λú
:ȡTXBUF״̬λ
:TXBUF״̬λ 
1 = TXBUF
0 = TXBUF
********************************/
FlagStatus UARTx_TXBUFSTA_TXFF_Chk(UARTx_Type* UARTx)
{
	if (UARTx->TXBUFSTA & UARTx_TXBUFSTA_TXFF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}


/********************************
ȡRXBUF״̬λú
:ȡRXBUF״̬λ
:RXBUF״̬λ 
1 = RXBUF1ݣ
0 = RXBUFգ
********************************/
FlagStatus UARTx_RXBUFSTA_RXFF_Chk(UARTx_Type* UARTx)
{
	if (UARTx->RXBUFSTA & UARTx_RXBUFSTA_RXFF_Msk)
	{
		return SET;
	}
	else
	{
		return RESET;
	}
}

/********************************
շ7bitʹ(PDSEL)ú
:շ7bitʹ(PDSEL)
:շ7bitʹ(PDSEL) 
1 = շ7λ֡ʽΪ7λλ+STOP
շΪRXREG/TXREG[6:0]
0 = շ
********************************/
void UARTx_RTXCON_RTX7EN_Setable(UARTx_Type* UARTx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		UARTx->RTXCON |= (UARTx_RTXCON_RTX7EN_Msk);
	}
	else
	{
		UARTx->RTXCON &= ~(UARTx_RTXCON_RTX7EN_Msk);
	}
}
/********************************
ȡշ7bitʹ(PDSEL)ú
:ȡշ7bitʹ(PDSEL)
:շ7bitʹ(PDSEL) 
1 = շ7λ֡ʽΪ7λλ+STOP
շΪRXREG/TXREG[6:0]
0 = շ
********************************/
FunState UARTx_RTXCON_RTX7EN_Getable(UARTx_Type* UARTx)
{
	if (UARTx->RTXCON & (UARTx_RTXCON_RTX7EN_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}


/********************************
ȡλú
:ȡλ
:ȡλ 
1 = ȡ
0 = ݲȡ
********************************/
void UARTx_RTXCON_RXDFLAG_Setable(UARTx_Type* UARTx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		UARTx->RTXCON |= (UARTx_RTXCON_RXDFLAG_Msk);
	}
	else
	{
		UARTx->RTXCON &= ~(UARTx_RTXCON_RXDFLAG_Msk);
	}
}
/********************************
ȡȡλú
:ȡȡλ
:ȡλ 
1 = ȡ
0 = ݲȡ
********************************/
FunState UARTx_RTXCON_RXDFLAG_Getable(UARTx_Type* UARTx)
{
	if (UARTx->RTXCON & (UARTx_RTXCON_RXDFLAG_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
ȡλú
:ȡλ
:ȡλ 
1 = ȡƿʱȡЧ
ͼΣ
0 = ݲȡ
********************************/
void UARTx_RTXCON_TXDFLAG_Setable(UARTx_Type* UARTx, FunState NewState)
{
	if (NewState == ENABLE)
	{
		UARTx->RTXCON |= (UARTx_RTXCON_TXDFLAG_Msk);
	}
	else
	{
		UARTx->RTXCON &= ~(UARTx_RTXCON_TXDFLAG_Msk);
	}
}

/********************************
ȡȡλú
:ȡȡλ
:ȡλ 
1 = ȡƿʱȡЧ
ͼΣ
0 = ݲȡ
********************************/
FunState UARTx_RTXCON_TXDFLAG_Getable(UARTx_Type* UARTx)
{
	if (UARTx->RTXCON & (UARTx_RTXCON_TXDFLAG_Msk))
	{
		return ENABLE;
	}
	else
	{
		return DISABLE;
	}
}

/********************************
ȱʡú
:ȱʡ
********************************/
void UART_Deinit(void)
{
	UART->UARTIE = 0x00000000;
	//UART->UARTIF = ;
	UART->IRCON = 0x000000D2;
}
/********************************
ȱʡú
:ȱʡ
룺ں
********************************/
void UARTx_Deinit(UARTx_Type* UARTx)
{
	UARTx->RXSTA = 0x00000000;
	UARTx->TXSTA = 0x00000002;
	//UARTx->RXREG = ;
	//UARTx->TXREG = ;
	UARTx->SPBRG = 0x00000341;
	UARTx->TXBUFSTA = 0x00000000;
	UARTx->RXBUFSTA = 0x00000040;
	UARTx->RTXCON = 0x00000000;
}
//Code_End


/********************************
дȱʡú
:ȱʡ
********************************/
void UART_All_Deinit(void)
{
	UART_Deinit();
	UARTx_Deinit(UART0);
	UARTx_Deinit(UART1);
	UARTx_Deinit(UART2);
	UARTx_Deinit(UART3);
	UARTx_Deinit(UART4);
	UARTx_Deinit(UART5);
}


/********************************
uart   жʹú
:uart   жʹ
룺ںţжʹܣ״̬
********************************/
void UART_UARTIE_RxTxIE_SetableEx(UARTx_Type* UARTx, UART_IntTypeDef IntType, FunState NewState)
{
	uint32_t shiftbit;
	
	shiftbit = ((uint32_t)UARTx - UART0_BASE)>>4;
	
	if( RxInt == IntType)
	{
		shiftbit = shiftbit + 1;
	}

	if( ENABLE == NewState )
	{
		UART->UARTIE |= 0x00000001<<shiftbit;
	}
	else
	{
		UART->UARTIE &= ~(0x00000001<<shiftbit);
	}
}


/********************************
uart   жʹܶȡ
:ȡuart   жʹ
ںţжʹ״̬
********************************/
FunState UART_UARTIE_RxTxIE_GetableEx(UARTx_Type* UARTx, UART_IntTypeDef IntType)
{
	FunState tmpstate;
	uint32_t shiftbit;
	
	shiftbit = ((uint32_t)UARTx - UART0_BASE)>>4;
	
	if( RxInt == IntType)
	{
		shiftbit = shiftbit + 1;
	}

	if(UART->UARTIE & (0x00000001<<shiftbit))
	{
		tmpstate = ENABLE;
	}
	else
	{
		tmpstate = DISABLE;
	}
	
	return tmpstate;
}

/********************************
	uart  жϱ־㺯
	жϱ־ ֻ ͨrxreg
	жϱ־ͨдtxregtxifд1
********************************/
void UART_UARTIF_RxTxIF_ClrEx(UARTx_Type* UARTx)
{
	uint32_t shiftbit;
	
	shiftbit = ((uint32_t)UARTx - UART0_BASE)>>4;
	
	UART->UARTIF = 0x00000001<<shiftbit;
}

/********************************
uart   жϱ־ȡ
:ȡuart   жϱ־
ںţжϱ־
********************************/
FlagStatus UART_UARTIF_RxTxIF_ChkEx(UARTx_Type* UARTx, UART_IntTypeDef IntType)
{
	FlagStatus tmpstate;
	uint32_t shiftbit;
	
	shiftbit = ((uint32_t)UARTx - UART0_BASE)>>4;
	
	if( RxInt == IntType)
	{
		shiftbit = shiftbit + 1;
	}

	if(UART->UARTIF & (0x00000001<<shiftbit))
	{
		tmpstate = SET;
	}
	else
	{
		tmpstate = RESET;
	}
	
	return tmpstate;
}

/********************************
Ƶռձú
:Ƶռձú
룺Ƶռձ
********************************/
void UART_IRModulation_Init( uint32_t ModuFreq, uint8_t ModuDutyCycle, uint32_t APBClk )
{
	uint32_t tempTZBRG, tempTH;
	
	if((ModuFreq > 0)&&(APBClk >= ModuFreq)&&(ModuDutyCycle < 100))
	{
		tempTZBRG = (uint32_t)((float)APBClk/(float)ModuFreq + 0.5) - 1;
		UART_IRCON_TZBRG_Set((tempTZBRG&UART_IRCON_TZBRG_Msk)<<UART_IRCON_TZBRG_Pos);//Ƶ
		
		if((tempTZBRG>>4) != 0)
		{
			
			tempTH = (uint32_t)(((float)ModuDutyCycle/100.0)*((float)(tempTZBRG + 1)/(float)(tempTZBRG>>4)) + 0.5);
		}
		else
		{
			tempTH = (uint32_t)(((float)ModuDutyCycle/100.0)*(float)(tempTZBRG + 1) + 0.5);
			
		}
		UART_IRCON_TH_Set((tempTH<<UART_IRCON_TH_Pos)&UART_IRCON_TH_Msk);//ռձ
	}
}

/********************************
UARTʼ
:UARTʼ
룺ں 
********************************/
void UART_Init(UARTx_Type* UARTx, UART_InitTypeDef* para)
{
	UARTx_SPBRG_Write(UARTx, para->SPBRG);		//ʲĴ

	UARTx_RXSTA_PDSEL_Set(UARTx, para->PDSEL);		//ģʽѡ00 = 8λݣżУ飻01 = 8λݣżУ飻10 = 8λݣУ顣11 = 9λݣ żУ飻
	UARTx_RTXCON_RTX7EN_Setable(UARTx, para->RTX7EN);		//շ7bitʹ(PDSEL)
	
	UARTx_TXSTA_STOPSEL_Set(UARTx, para->STOPSEL);	//ֹͣλѡ
	
	UARTx_RXSTA_ERRIE_Setable(UARTx, para->ERRIE);		//жʹܿ
	UARTx_TXSTA_TXIS_Set(UARTx, para->TXIS);		//TX_INTSEL=0ʱжѡλ
	UARTx_TXBUFSTA_TX_INTSEL_Set(UARTx, para->TX_INTSEL);	//жѡλ

	UART_UARTIE_RxTxIE_SetableEx(UARTx, RxInt, para->RXIE);		//ж
	UART_UARTIE_RxTxIE_SetableEx(UARTx, TxInt, para->TXIE);		//ж
	
	UARTx_RTXCON_RXDFLAG_Setable(UARTx, para->RXDFLAG);	//ȡλ
	UARTx_RTXCON_TXDFLAG_Setable(UARTx, para->TXDFLAG);	//ȡλ

	UARTx_RXSTA_RXEN_Setable(UARTx, para->RXEN);		//ģʹܿ
	UARTx_TXSTA_TXEN_Setable(UARTx, para->TXEN);		//ģʹܿ
	UARTx_TXSTA_IREN_Setable(UARTx, para->IREN);		//ͺʹλ
}

/********************************
uartʼĴֵ㺯
:uart
룺uartʣƵ
********************************/
uint32_t UART_BaudREGCalc(uint32_t BaudRate, uint32_t APBClk)
{
	uint32_t tmpSPBRG;
	float tmpfloat;
	
	tmpfloat = (float)APBClk/(float)BaudRate;
	
	if(tmpfloat > 1)
	{
		tmpSPBRG = (uint32_t)(tmpfloat - 1.0 + 0.5);
	}
	else
	{
		tmpSPBRG = 0;
	}
	
	return tmpSPBRG;
}

/********************************
UART򵥲ʼ
:UART򵥲ʼ
룺ں 
********************************/
void UART_SInit(UARTx_Type* UARTx, UART_SInitTypeDef* para, uint32_t APBClk)
{
	UART_InitTypeDef para2;
		
	para2.SPBRG = UART_BaudREGCalc(para->BaudRate, APBClk);
		
	para2.RTX7EN = DISABLE;
	if(Eight8Bit == para->DataBit)
	{
		if(EVEN == para->ParityBit)
		{
			para2.PDSEL = UARTx_RXSTA_PDSEL_8BIT_EVEN;//8bitżУ
		}
		else if(ODD == para->ParityBit)
		{
			para2.PDSEL = UARTx_RXSTA_PDSEL_8BIT_ODD;//8bitУ
		}
		else
		{
			para2.PDSEL = UARTx_RXSTA_PDSEL_8BIT_NONE;//8bitУ
		}
	}
	else if(Nine9Bit == para->DataBit)
	{
		para2.PDSEL = UARTx_RXSTA_PDSEL_9BIT_NONE;//9bitݽ֧Уģʽ
	}
	else
	{
		para2.PDSEL = UARTx_RXSTA_PDSEL_8BIT_NONE;//7bitûֱӸ
		para2.RTX7EN = ENABLE;//շ7bitʹ(PDSEL)
	}
	
	if(OneBit == para->StopBit)
	{
		para2.STOPSEL = UARTx_TXSTA_STOPSEL_1STOPBIT;
	}
	else
	{
		para2.STOPSEL = UARTx_TXSTA_STOPSEL_2STOPBIT;
	}
	
	para2.RXIE = DISABLE;		//رսж
	para2.TXIE = DISABLE;		//رշж
	para2.ERRIE = DISABLE;		//رմж

	para2.TXIS = UARTx_TXSTA_TXIS_SHIFTEMPTY;		//TX_INTSEL=0ʱжѡλ
	para2.TX_INTSEL = UARTx_TXBUFSTA_TX_INTSEL_BYTXIS;	//жѡλ	
	
	para2.RXDFLAG = DISABLE;	//رսȡλ
	para2.TXDFLAG = DISABLE;	//رշȡλ

	para2.RXEN = DISABLE;		//رսģʹܿ
	para2.TXEN = DISABLE;		//رշģʹܿ
	para2.IREN = DISABLE;		//رշͺʹλ
	
	UART_Init(UARTx, &para2);
}

/******END OF FILE****/

